* Nu * assemblierbar mit dem quanta-gst-macro-assembler zum sinclair QL *
 NOLIST
* F6 aus: flp1_forth_asm - .hpr'93 Copyright .hpr 1996, beim autor:
* .hpr: h.-peter recktenwald, albestr. 21, d-12159 berlin.
* May noncommercially be used according to the GNU Free Software License.
* Zum nichtkommerziellen Gebrauch im Rahmen der vom Autor des F6 ins Deutsche
* bertragenen und als "GNU-G_txt" beigefgten GNU-Lizenz fr Freie Software.

 section   Forth
 pagelen   20000

.debug setstr {} {} {no}
.vers  setstr {8.00} 1.3.1995 - 7.7.95
.vers  setstr {8.12}
* 8:1.9.96 modified for ans feasibility - 10:17.10.96 12:1.11.96

* secondary control job bounds
* TSTJBOT begin of controlled area
* TSTJNX  more restrictive
* TSTJTOP end

* Registers
*os setstr d6 ;(n.i.) bank offset rel(a6)
up setstr d7 ;user pointer, needing offset by a6
w  setstr a2 ;parameter field pointer
nx setstr a3 ;jump address to leave assembler
ip setstr a4 ;forth next instruction pointer
rp setstr a7 ;return stack pointer
bp setstr a6 ;base ptr
sp setstr a5 ;forth stack ptr, parm in/out

* $80 name flag bit
* $40 precedence bit
* $20 smudge bit
* $C2 <del> char

cfname equ 38      max chars of a filename (+ count.w = 40) f/n
cfhead equ 64      fileheader length     b/hed
cbsec  equ 512     bytes/disksector      b/sec
cbalc  equ cbsec*3 allocation unit       b/alc
cadrv  equ 480     a.units/drive         a/drv   2cons
cafre  equ 480     a.units free          a/fre   2cons
cdwpt  equ 0       write protect flag    d/wpt
cdnum  equ 1       drive nr              d/num
ssize  equ 64                            b/buf
cscr   equ 1024            chars/screen  c/scr
nbuf   equ cscr/ssize      :=16
bmag   equ (ssize+4)*nbuf  buffer space
uarea  equ 256             user area
tibrp  equ $440            combined tib & return stack
rpmin  equ $40             initial min for rp vs cmd stg

pvi setnum  0

* vocabularies
vocnfa  equ  $81a0 1st (dummy) entry
voc     setstr fth current vocabulary
lastvoc setstr Z+$8000  voc-link
fthlk   setstr Z+$8000  4th
fplk    setstr Z+$8000  fp
hidnlk  setstr Z+$8000  hidden
qdoslk  setstr Z+$8000  qdos
edilk   setstr Z+$8000  editor
piflk   setstr Z+$8000  pointer-i.f.
rootlk  setstr Z+$8000  base
asmlk   setstr Z+$8000  assembler
ph setstr tstjtop

* assembler macros

create MACRO Xn Xa vf vn
k setstr [voc]
 ifstr {[vf]} <> {V:} goto nov
voc setstr {[vn]}
nov maclab
t setstr {[.ucase(Xn)]}
l setnum [.len(t)]
s setnum [l]-1
  dcb.b  (*+1+[l]-Z)&1+1,[pvi]![l]
b setnum $5B!$80
 ifstr {[.left(t,1)]} <> {`} goto ord
 ifnum [s] = 0 goto singb
t setstr {[.right(t,[s])]}
b setnum $5b
singb maclab
  dc.b [b]
 ifnum [s] = 0 goto dclfa
s setnum [s]-1
ord MACLAB
  dc.b '[.left(t,[s])]','[.right(t,1)]'!$80
dclfa MACLAB
  dc.w [[voc]lk]-Z
[.lab] dc.w [Xa]-Z
ph setstr [.lab]
[voc]lk setstr [.lab]-[l]-3
lastlk setstr [[voc]lk]
pvi setnum $80
voc setstr [k]
 ENDM

string MACRO A B
g setstr {'[a]'}
 ifnum   [.nparms] < 2 GOTO stg
 ifstr   {[b]}   <> CR GOTO stg
g setstr {[g],10}
stg maclab
[.lab] dc.w e[.l]-*-2
    dc.b [g]
e[.l] ds.b 0
      ds.w 0
 ENDM

defuser MACRO n v d
[.lab] create {[N]} douser {[v]} {[d]}
        dc.w   [.ud]
u[.lab] equ    [.ud]
.ud  setnum [.ud]+2
 ENDM


* standard layout for QDOS

go      bra.s   install -
        dc.l '[.vers]'
        dc.w $4afb
        dc.w 2,'F6'
install lea     mty(pc),a3
mtyn    move.w  (a3)+,d0
        beq.s   mtyr
        st      -2(a3,d0.w)
        bra.s   mtyn    -
mtyr    lea     thntry(pc),a3
        trap    #0
        moveq   #0,d0
        move.l  d0,(a3)
        trap    #1
        lea     mtinftab(pc),a2
        movem.l d1/d2/a0,(a2) safety
        move.l  d1,d2   self
        moveq   #2,d0   mt_jinf
        trap    #1
        lea     refclon(pc),a2
        move.l  d0,(a2)
        bne.s   notqf   ?
        move.l  d2,d4   owner
        move.l  d2,d1
        moveq   #2,d0
        trap    #1
        move.l  d0,(a2)
        bne.s   notqf   ? no job
        lea     go(pc),a1
        moveq   #2,d0
tqfclon cmp.l   (a1)+,(a0)+
        dbne    d0,tqfclon ?
        bne.s   notqf   ? no f6-clone
        move.l  d3,d2   owner pri.
        move.l  d4,d1
        moveq   #11,d0  mt_prior
        trap    #1      a0 := owner jdt
        move.l  d0,(a2)
        bne.s   notqf   ? kaputt
        move.l  88(a0),(a2) store refadr
notqf   movem.l mtinftab(pc),d1/d2/a0
        move.l  $b8(a0),d0
        ble.s   thg_nix ? no things
thg_fnd move.l  d0,a2
        asr.l   #1,d0
        bls.s   thg_nix ?
        bmi.s   thg_nix ?
        move.l  (a2),d0
        bne.s   thg_fnd ?
        lea     $2a(a2),a1
        tst.b   (a1)+
        bne.s   thg_nix ? len
        lea     thgnam+1(pc),a0
        moveq   #5,d0
thg_nam cmp.b   (a1)+,(a0)+
        dbne    d0,thg_nam
        bne.s   thg_nix ?
        move.l  16(a2),a1
        cmp.l   #'THG%',(a1)+
        bne.s   thg_nix ?
        moveq   #-1,d0
        cmp.l   (a1)+,d0
        bne.s   thg_nix ?
        move.l  (a1),a4 th.entry
        move.l  a4,(a3)+ into 4th-vari
        and.w   #$dfff,sr
        lea     hotnam(pc),a0
        moveq   #0,d2   no parm
        moveq   #127,d3 try
        moveq   #$28,d0 th.uthg
        jsr     (a4)    >
        bne.s   hot_fnd ? not useable
        move.l  a1,(a3) hk.thing to 4th-vari
        moveq   #$29,d0 th.fthg
        jsr     (a4)
        bra.s   hot_fnd -
thg_nix and.w   #$dfff,sr
hot_fnd moveq   #0,d7
        move.w  (a7)+,d7
        bgt.s   pif_chn ?
        jsr     iowdw(pc)
        bne     jobremv ?
        moveq   #1,d7
        move.l  a0,-(a7)
pif_chn move.l  (a7),a0
        moveq   #0,d3
        moveq   #14,d0  sd.cure
        trap    #3
        moveq   #112,d0 io.pinf
        trap    #3
        lea     wmanvec(pc),a2
        move.l  d0,(a2)
        bmi.s   pif_nvc ? pif not present
        move.l  a1,(a2) wman entry
        lea     4+syscreen(pc),a1 initial sizes
        pea     pif_fnd(pc)
        jmp     pifoutl(pc)     > (waiting!)
pif_nvc lea     pifv-2(pc),a1   else empty
        move.w  #pifv-4-Z,(a1)  pif voc.
pif_fnd moveq   #-1,d3
        moveq   #32,d0  sd.clear (fehler bei outl in smsq)
        trap    #3
        lea     insxtp(pc),a2
        lea     winhnd(pc),a1
        move.l  a0,d1
        moveq   #9,d0   sd.extop
        trap    #3      > a1 4th table
        moveq   #0,d0
        trap    #1      qdos-data
        swap    d2
        move.b  d2,d0
        lsl.w   #8,d0
        move.b  #'.',d2 clear the 'nation'
        swap    d2
        cmp.l   #'1.10',d2
        smi     d0
        seq     d4      ? JS
        neg.b   d0      hi.w (emu 255) / 0 any / 1 pre-JS
        bne     nemu    ? pre-JS
        move.l  124(a0),d3 sv.chtop
        move.l  d3,a2
        lsr.b   #1,d3
        bcs.s   ckjsrom ? again
        cmp.l   #'JSL1',$46(a2)
        seq     d0      lo.w 0 any / 255 minerva-flag
        beq.s   nmirom  ? minerva
ckjsrom swap    d0
        move.l  104(a0),a1
        move.l  (a1),a1
        move.l  88(a1),a1
        cmp.l   #'SBAS',-(a1)
        seq     d0
        add.b   d0,d0   flag -2 bei qxl
        beq.s   ckjxql  ? nicht smsq
        moveq   #30,d6
        and.b   $a7(a0),d6
        sub.b   #10,d6
        beq.s   ckjqhw  ? ql-hardware
        subq.b  #2,d6
ckjqhw  seq     d6
        add.b   d6,d0   -3 bei QL mit smsq
        bne.s   ckjxql  ?
        not.b   d4
        bne.s   nemu    ? no JS
        tst.b   $a1(a0)
        sne     d0
ckjxql  ext.w   d0      proc-flag
        bne.s   nemu    ? qxl or 68010+ of atari-ql
        trap    #0      (supv)
        move.w  d0,a2
        addq.l  #8,a2
        move.l  (a2),-(A7)
        pea     (a2)
        move.l  sp,d6
        pea     berr(pc)
        move.l  (sp),(a2)
        cmp.l   (sp)+,(a2)+
        bne.s   berr    ? QL if no soft-rom
        move.w  d0,a2
        move.l  #$fc0000,a4
        cmp.l   (a2)+,(a4)+
        bne.s   berr    ?
        cmp.l   (a2)+,(a4)+
        seq     d0
berr    move.l  d6,sp
        move.l  (sp)+,a2
        move.l  (sp)+,(a2)
        and.w   #$dfff,sr (usr)
nemu    swap    d0
nmirom  lea     procftab(pc),a2
        move.l  (a7),a1
        lea     sys(pc),a3
        sub.w   #sys-Z,a3
        movem.l d0/d1/d2/a0/a1/a3,(a2) emu/miflg job romver sys dft.chan 4thbase
jdtput  moveq   #8,d0   mt.susjb
        moveq   #0,d3   no wait
        move.l  d3,a1   no flag
        trap    #1
        move.l  a0,-(a2) put jdt into 4th-vari
        move.l  d1,d2
        moveq   #(43+16+80+jobunlend-jobunl+timemend-timem)>>3,d1
        lsl.w   #3,d1
        moveq   #24,d0    alchp
        trap    #1
        move.l  d0,d3
        bne     jobremv   ? leave if err.om
* dummy heap-mem to safely removing the timer interrupt w. the f6-job
        move.l  a0,a1           keep mem base in a0
        move.w  #$4879,(a1)+   00:pea
        move.w  $c2,a2
        move.l  -12(a0),d0      cpl: pea {close-entry}
        beq.s   hep_adr         ? qxl special...
        move.l  d0,a2          02:close-adr
        move.l  12(a2),a2       {close-entry} set to mm_rechp
hep_adr move.l  a2,(a1)+
        move.w  #$4ef9,(a1)+   06:jmp
        pea     (a1)            tos{ptr to addr of new close-routine
        addq.l  #4,a1          08:adr
        move.l  a0,(a1)+       12:new "close" entry
        move.l  a0,-12(a0)      virtual handler addr a1 is now mem+12 = a0+12
        pea     (a1)            tos:{timelinkptr {closeaddr
        addq.l  #4,a1           16:adr timelink
        move.l  d2,(a1)+        20:owner-id
        lea     timadr(pc),a2
        lea     timem(pc),a0
        move.l  a0,(a2)         addr to increment
        lea     timelk+4(pc),a2
        pea     timer(pc)
        move.l  (a7)+,(a2)       poll-routine into linkfield
        pea     timelk-timem(a1) tos{poll-link {timeaddr {destaddr
        moveq   #(timemend-timem)/2-1,d0
timr    move.w  (a0)+,(a1)+     24:+ timer
        dbra    d0,timr
        move.l  a1,a2           save heap-ptr
        move.l  (a7),a0         tos:{poll-link { {
        moveq   #28,d0          mt_lpoll
        trap    #1
        move.l  (a7)+,a1        poll-link {timeaddr destaddr
        move.l  (a7)+,a0        timelinkaddr {destaddr
        move.l  a1,(a0)         linkaddr into heapmem
        move.l  (a7)+,a1        destaddr tos{
        move.l  a2,(a1)         adr jobunl
        move.l  a2,a1           heap-ptr back
        moveq   #(jobunlend-jobunl)/2,d0
        lea     jobunl(pc),a2
jrmov   move.w  (a2)+,(a1)+     xx:jobunl
        dbra    d0,jrmov
        bsr     retrap          >trap redirection table to a1)+
        move.l  a7,a4           init 4th
        bsr     winoutl         >
        movem.l (a7),d0-d1/d3-d6/a0-a4
        lsl.l   #2,d7
        add.l   d7,a7           top of channels
        lea     -16*4(a7),a5    channel table base
        subq.l  #4,d7           did we just have one channel?
        cmp.w   #4,d7
        bgt.s   notone          ?
        beq.s   twoch
        move.l  d0,d1           out-cons := in-cons
        addq.l  #4,d7
twoch   move.l  d1,d3           work := out-cons
        addq.l  #4,d7           and pretend it was there all along
notone  addq.l  #4*2,d7         put back and include channel 2
        moveq   #-1,d2          channel 2 is initially closed (?printer)
        movem.l d0-d6/a0-a4,(a5) set down what seems to be going
        add.l   a5,d7
        move.l  sp,a2           ptr to command strng
chclear move.l  d2,-(a7)        set remaining channels closed
        cmp.l   sp,d7
        bne.s   chclear         ?
* ggf. history einrichten
        move.l  (a5),a0
        bsr     hiss    >
        bgt.s   chchis  ?
        move.l  (a5),d3 ;;
        lea     hisnam(pc),a0
        moveq   #-1,d1
        moveq   #1,d0
        trap    #2
*
chchis  move.l  a5,a0           {limit} data top
        moveq   #-18,d0         err.ov
* 4th-regs: {d6[os]} d7[up] a2[w] a3[nx] a4[ip] a5[sp] a6[bp] a7[rp]
        lea     sys(pc),[bp]
        sub.w   #sys-Z,[bp]     Z=sys+8000 disp into 64K-system
        sub.l   [bp],a5
        move.w  a5,limit+2-Z([bp]) datatop rel(a6) to limit
        lea     -bmag(a5),a1       buffer space
        move.w  a1,first+2-Z([bp])        bot
        move.w  a1,prev+2-Z([bp])
        move.w  a1,use+2-Z([bp])
        move.l  a1,a5
        sub.w   nuser+2-Z([bp]),a5 u0 & r0
        move.l  a5,[up]
        lea     -tibrp(a5),a7   tib
        move.l  a7,a1           s0
        movem.L [up]/a1/a5,oup-Z([bp])
        move.w  a7,otib-Z([bp])
        add.l   [bp],a5  prepare true rp
        add.l   [bp],a7  s0
        moveq   #0,d0
        move.l  a0,d1    {limit}
        sub.l   a7,d1
        lsr.l   #2,d1
        subq.w  #1,d1
        ble     jobremv
btclr   move.l  d0,-(a0)
        dbra    d1,btclr datatop
        move.l  a7,a1    s0 = tib
* fetch EX-command strg to tib for immediate execution
        move.w  (a2)+,d2 command stg
        move.w  #tibrp-rpmin-2,d0
        cmp.w   d0,d2
        bls.s   cmdmov  ? stg within limits
        move.w  d0,d2
cmdtib  move.b  (a2)+,(a1)+
cmdmov  dbra    d2,cmdtib
        move.w  a1,d2
        sub.w   a7,d2
        move.w  d2,uspan([bp],[up].l)
        sf      (a1)+
        sf      (a1)
        exg     a5,a7
        jmp     inicold(pc)

iowdw   bsr.s   opncon  >
        beq.s   iow_ret ?
        bsr.s   windft  >
opncon  lea     syscreen(pc),a1
        move.w  $c6,a2
        jsr     (a2)    > ut.con
        move.l  d0,d3
iow_ret rts

windft  moveq   #0,d2
        lea     syscreen+8(pc),a1
        move.l  d2,(a1)
        move.l  #$02000100,-(a1)
        move.l  sysvari(pc),a0
        move.l  120(a0),a0
        move.l  4(a0),a0
        move.l  16(a0),d1
        move.w  #1,d1
        move.l  d1,a0
        moveq   #108,d0  io.flim
        trap    #3
        move.l  d0,d3
        beq.s   wft_ret
        not.l   d0
wft_ret rts

winoutl lea     wdw_siz(pc),a2
        move.w  d7,d5
        dbmi    d5,wochan
        rts
wochan  sub.w   #12,a7
wolop   move.l  (a4)+,d0
        ble.s   wonxt   ? don't link qdos-channel 0
        move.l  d0,a0
        move.l  a7,a1
        moveq   #-1,d3  try always
        moveq   #9,d0   sd.extop
        trap    #3      init a pif channel
        pea     -12(a1)  (this is for "ptr_pif" which also
        cmp.l   (a7)+,a7 (would work w. a buried window
        bne.s   wonxt   ?
        bsr.s   pifwsav
wonxt   dbra    d5,wolop
        add.w   #12,a7
        rts

pifwsav moveq   #0,d1
        move.l  d1,a1
        moveq   #126,d0 iop.wsav
        trap    #3
        lea     4(a7),a1
pifoutl moveq   #-1,d3
        moveq   #2,d2
        moveq   #0,d1
        moveq   #122,d0 iop.outl
        trap    #3
        addq.l  #1,d0
        rts

insxtp  move.w  d1,d3           keep for pex-channel
        lsl.w   #2,d1           id => disp
        move.l  120(a6),a2      qdos
        move.l  (a2),a4         cdt 0
        move.l  4(a4),a5
        move.l  a5,(a1)+        hnd into 4th-vari
        move.l  196-24(a5),d0   pt.ptrok-ch.lio points to the pif ok-code
        lea     24(a3),a4       own hnd
        move.l  a4,(a1)+        q.cdt 0
        move.l  a0,d2           parm-cdt
        lea     0(a2,d1.w),a4   table
        sub.l   (a4),d2         qdos-cdt
        move.l  d2,(a1)+        pif-disp or zero
        movem.l $68(a5),d4/d5
        add.l   d5,d4
        move.l  d5,(a1)+        disp i/o-queue to cdt
        move.l  d4,(a1)+        pif dummy queue
        move.l  d0,a2           pex switching
        asr.l   #1,d0
        bls.s   winxtp
        bmi.s   winxtp
        cmp.l   #'PIF'<<8,-(a2) check pex-flag
        bne.s   winxtp
        move.b  #1,8(a2,d3.w)   'peon' 1st channel
winxtp  moveq   #0,d0
        rts

adrer   equ  0
illeg   equ  4
chk     equ 12

cton    dc.w  -1 flag set on aerr entry
tvtregs dcb.l 22,0

* in:  a1 new table address
retrap  addq.l  #8,a1
        move.l  a1,a2
        moveq   #18,d0
        lea     go(pc),a6
        lea     rtecode(pc),a0  nur rte bei leerer tabelle
rteins  move.l  a0,(a2)+
        dbra    d0,rteins
* insert new routines
        lea     n_adrer(pc),a0  1st routine
        move.l  a0,(a1)
        lea     n_chk(pc),a0
        move.l  a0,chk-adrer(a1)
        move.l  mtinftab(pc),d1 current job
        moveq   #7,d0
        trap    #1
        rts

n_chk   move.w  (a7),-([sp])   to replace qdos trap #0
        bset    #5,(a7)        ret supervisor
        rte

* 68000, 68008, 68040 ok (qxl)
n_adrer move.w  procftab(pc),-(a7)
        addq.l  #2,a7
        bpl.s   proc00          ? 6800x
        tas     8(a7)           soft re-run
        move.l  10(a7),-(a7)    stack-typ & error address & extra status
        move.l  10(a7),-(a7)
proc00  move.l  a0,-(a7)
        lea     cton+1(pc),a0
        sf      (a0)+           flag error source
        movem.l d0-d7/a0-a6,(a0)
        movem.l (a7)+,d3/d4/d5  A0 & aerr-extra
        move.l  d3,32(a0)       A0
        movem.l -2(a7),d1/d2    xxSR & PC
        ext.l   d1
        move.l  usp,a1
        move.l  a1,d0
        movem.l d0-d2/d4/d5,60(a0) USP xxSR PC extra 2.l
        lea     next(pc),[nx]
        and.b   #-2,d0
        move.l  d0,a1
        move.l  a1,usp
        movem.l (a0),d0-d7/a0/a1
        pea     adrcold(pc)
        bne.s   adrrcld         ? cold if rp error
        pea     ([bp])
        lea     sys(pc),[bp]
        sub.w   #sys-Z,[bp]
        cmp.l   (a7)+,[bp]
        bne.s   adrrcld         ? cold if baseptr lost
        addq.l  #4,sp           drop cold
        pea     adrwarm(pc)     push warm
adrrcld move.l  (a7)+,2(a7)     move routine to rte-posn
        bclr    #5,(a7)         back to user state
rtecode rte

adrwarm bsr     adrregs
        lea     0([bp],a1.l),[rp]
        bsr     adrmon  >
        moveq   #27,d0  message
        jmp     cputerr(pc)

* +++ keyboard monitor +++

Cfbrky  move.l  poll(pc),d0
        bgt.s   breaky  ? start already found
        bsr.s   kyfind  >
        bne.s   fbk_nnw ? extension code missing
breaky  move.w  vbreak-Z([bp]),d1 key
        bmi.s   fbk_ncl ? nothing to clear
        moveq   #-1,d2  clear
        bsr.s   keydef  >
fbk_ncl move.w  ([sp])+,d1
        move.w  d1,vbreak-Z([bp])
        bmi.s   fbk_nnw ? no new key
        moveq   #0,d2   set
m setstr d6/a3-a5
keydef  movem.l [m],-(a7)
        move.l  mtinftab-Z([bp]),d4
        move.l  poll(pc),a0
        jsr     (a0)    >
        movem.l (a7)+,[m]
fbk_nnw rts

* RET: d0 ernum =/= 0 no job-keys
*      a1 <pkeyq> a2 call to <keylink>
* NDERT: d0 d1 a0 a1 a2
kyfind  move.l  pkeyq(pc),d0
        move.l  d0,a1   i/o queue
        ble.s   kyftst  ? none
        move.l  poll(pc),d0 ptr to code <keylink>
        move.l  d0,a0
        bgt.s   kyfset  ? ptrs already set
kyftst  move.l  sysvari(pc),a0 sysvari holen
        move.l  $3c(a0),a0     sv.plist
        moveq   #-7,d0
fkypol  move.l  (a0),d1 1st poll-int.
        beq.s   keypol  ? found
        move.l  d1,a0
        ror.b   #1,d1
        bcc.s   fkypol  ? more
        bra.s   kyfret  - 'mi' bei fehler
keypol  addq.l  #4,a0
        move.l  (a0),d1 ptr zum aufruf
        move.l  d1,a2
        ror.l   #1,d1
        bls.s   kyfret  ? 'le' ist was faul
        move.l  -(a2),d1
        cmp.l   klkys(pc),d1
        bne.s   kyfret  ? marke fehlt
        moveq   #-(poll-pkeyq),d1 ptr zur queueadresse
        add.l   (a0),d1
        ble.s   kyfret  ? nix
        move.l  d1,a1
        lea     polblk-pkeyq(a1),a2
        sub.w   (a2),a2
        lea     pkeyq(pc),a0
        move.l  a1,(a0) <pkeyq> ptr
        move.l  -(a2),d1
        ble.s   kyfret ? nix
        move.l  d1,a2
        ror.b   #1,d1
        bmi.s   kyfret  ? error
        moveq   #-1,d1
        cmp.l   -(a2),d1
        bne.s   kyfret  ? nicht basis-backlink
        sub.w   -(a2),a2 codierungsroutine
        lea     poll(pc),a0
        move.l  a2,(a0) <keylink> routine
kyfset  moveq   #0,d0
kyfret  tst.l   d0
        rts

insky   move.l  pkeyq(pc),d1
        ble.s   ninsky ? no key-poll
        move.l  d1,a2
        move.l  (a2),d1
        ble.s   ninsky ? not valid
        moveq   #-7,d0
        cmp.l   mtinftab(pc),d1
        bne.s   ninsjb ? other job
        move.w  -(a2),d1 key
        bpl.s   ninsjb ? not valid
        moveq   #0,d0
        move.w  d0,(a2) invalidate this keypress
ninsjb  tst.l   d0
ninsky  rts

**
m setstr {d0-d4/d6/d7/a0/a2/a3}
* REIN: d5.w break-key code
* RAUS: d5.l +ve no / -ve break w. d5.w +ve no / -ve altkey
*       a1 xx/next/warm a4 xx/quit/quit  sonstnix
*(supv & locked int)(this routine must not change the processor mode)
tbreak  movem.l [m],-(a7)
        move.w  d5,d1
        bmi     nxkbr   ? ohne break-test gleich raus
        moveq   #0,d5
        move.b  d1,d5   hi.bit flag
        move.l  sysvari(pc),a0
        move.l  $4c(a0),d7 current keyboard queue
        bsr.s   insky   >
        bne.s   nopol   ? keine anzapf-poll
        moveq   #-1,d3  altkey flag
        cmp.b   d1,d3   flag
        bne.s   txbaky  ? prfen wenn nicht -1
nopol   move.l  d7,d2
        moveq   #0,d3
        move.l  d2,a2
        asr.l   #1,d2
        bls.s   jlkbr   ? not an address
        bmi.s   jmkbr   ? same
        move.l  winhnd(pc),a0
        lea     -104+4(a2),a3   JS+ disp to hnd
        sub.l   pifdsp(pc),a3   pif cdt-disp
        move.l  mtinftab(pc),d2 f6 job-id
        cmp.l   (a3)+,a0
        beq.s   nxochn  ? window channel
        cmp.l   (a3)+,a0  pre-JS
        bne.s   nxtpif  ? not a window
nxochn  cmp.l   (a3)+,d2
        beq.s   nxbpts  ? own window
* a2 not an own i/o queue, try pif queue redirection:
        move.l  pifdsp(pc),d0
        bgt.s   nxtpif  ? pif present
        move.b  emuflag(pc),d0
        addq.b  #1,d0
        bne.s   nxkbr ? not atari-ql
* job-zuordnung durch fensterstapel:
* pt_head  $68 kopf prim.wd.-liste = oberes i/o-fenster pos. sd_prwlt der cdt
nxtpif  moveq   #-44+8,d0 ptr to owner-id re sd_prwlt
        add.l   $68-$18(a0),d0  pt_head
jmkbr   bmi.s   nxkbr   ? not initiated
        move.l  d0,a3
        asr.l   #1,d0
jlkbr   bls.s   nxkbr   ? address error
        cmp.l   (a3),d2
        bne.s   nxkbr   ? other memory
nxbpts  movem.l 8(a2),d4/d6 save ptrs
        tst.l   d3
        bne.s   txbaky  ?
        move.w  226,a0  io.qout
        jsr     (a0)    >
        bmi.s   nxnbr   ? nix
        not.b   d1
        bne.s   txbnky  ? no altkey
        not.w   d3      flag altkey
        jsr     (a0)    >
        bmi.s   nxnbr   ?
        not.b   d1
        beq.s   nxnbr   ?
txbnky  not.b   d1
txbaky  move.b  d5,d3
        sub.b   d1,d3
        bne.s   nxqrst  ? restore ptrs
        lea     quit+2(pc),[ip]
        lea     origin+4(pc),a1 warmstart
        moveq   #-1,d5  flag break
        move.w  d3,d5   flag altkey
        bmi.s   nxkbr   ?   {warm}
        lea     next(pc),a1 {quit}
        bra.s   nxkbr   - queue empty
nxqrst  tst.l   d3      source flag
        bmi.s   nxkbr   ? keybd int.
nxnbr   movem.l d4/d6,8(a2) rst ptr
nxkbr   movem.l (a7)+,[m]
        rts

* "address error" - error routines
adrregs trap    #0      system stack should be safe
        jsr     calwarm(pc)
        lea     0([bp],a0.l),[sp]
        and.w   #$dfff,sr
        rts

* "fatal error" - might be a last chance,
* at least to checking the offending registers
adrcold bsr.s   adrregs
        lea     0([bp],a1.l),[rp]
        bsr.s   adrmon  >
        lea     colder(pc),a1   warning message
        jmp     aercold(pc)

* display regs after trapped address error
adrmon  lea     tvtregs-1(pc),a2
        tas     (a2)+
        bne.s   arrret  ? not an exeption trap call
        moveq   #6,d6
        bsr.s   adrrout >print d0-d7
        moveq   #6,d6
        bsr.s   adrrout >a0-a7
        moveq   #2,d6
adrrout moveq   #10,d1  <regs) and sr,pc,aerr-extra
        bsr.s   arrbyt  >
adrrlop move.l  (a2)+,d2
        bsr.s   arrnum  >
        dbra    d6,adrrlop
        move.l  (a2)+,d2
arrnum  bsr.s   arrval
        moveq   #' ',d1
        bra.s   arrbyt  -
arrval  move.l  deftch(pc),a0
        moveq   #1,d3
        moveq   #6,d4
arrdlp  bsr.s   arrdig
        dbra    d4,arrdlp
arrdig  rol.l   #4,d2
        moveq   #15,d1
        and.b   d2,d1
        eor.b   d1,d2
        move.b  arrtab(pc,d1.w),d1
arrbyt  moveq   #5,d0
        trap    #3
arrret  rts
arrtab dc.b '0123456789abcdef'

Xcache  move.l  sysvari-Z([bp]),a0
        moveq   #0,d0
        move.b  200(a0),d0
        and.b   202(a0),d0
        sne     d0
        neg.b   d0
        move.w  d0,-([sp])
        jmp ([nx])

* extop wdw-parm to mem (a1)+ : sizes origin border.col .wdt
wdw_siz lea     24(a0),a2 ptr auf sd.xymin
        move.l  (a2)+,d6  xmin|ymin
        move.l  (a2)+,d4  xsiz|ysiz
        move.l  (a2),d3   borwd|xxx & ptr auf xypos
        move.w  (a2),d3
        add.w   d3,d3
        move.l  d3,d2
        swap    d2        2*b|1*b
        sub.l   d2,d6     b>xmin
        add.l   d2,d2     4*bwd.x/2*bwd.y
        add.l   d2,d4
        move.l  d4,(a1)+  b>x/ysize    xw/yw :  8/10
        move.l  d6,(a1)+  b>x/ymin     x0/y0 : 12/14
        move.w  70(a0),d3 bcolr           bc : 16
        swap    d3
        move.l  d3,(a1)+  borwd           bw : 18
        moveq   #0,d0
        rts

* -- install 

* wmov (16-bit-)vari im datenstack
; grenzwerte aus flim
XM equ 0  max breite
YM equ 2  max hhe
XO equ 4  min x-ursprung
YO equ 6  min y
; arbeitswerte aus hit-area
XW equ 8  breite
YW equ 10 hhe
X0 equ 12 links
Y0 equ 14 oben
; border aus cdt
BC equ 16 farbe
; min. fenstergre aus cdt   ; => primrfenster
* ;=> cx(a1): d1:outsiz d5:outmax d6:xydisp d7:xdisp a2:outorg
CX equ 20 curwdt+4*border      => breit outl
CY equ 22 curhgt+2*border      => hoch  outl
; aktualisierte amx. werte
WL equ 24 aktuell max ursprung => rechts max
WA equ 26 links & oben         => unten max
; anfangsmae zur endjustage
WO equ 36 ursprung in border   => outorgx|y
; aus sd.pxenq
WC equ 52 cursor
wmx equ 56 ende fensterdaten

SM equ wmx  -ve pixelstufung
SV equ sm+2 +ve
SW equ sv+2 keyrow verzgerung

mbrd  equ sw+2
mblen equ 12 : 0/2:ursprung 4/6:mae 8:borwd 10:dummy(bcolr)

mlen   equ mbrd+16*mblen+8 bereichsgre & reserve
winc   equ 1  stufung der ursprungs-/ma-vernderung
wdel   equ 1  min. keyrow-verzgerung

contab dc.w 3
       dc.b 'scr' hilfsfenster
       ds.w 0

* extop: anfangsdaten nach 8(a1)+ bringen
wdw_prm lea     mbrd(a1),a4
        move.b  17(a0),(a4)+
        spl     (a4)+       -ve bei secundrfenster
        move.l  (a1)+,d5    max breite/hhe xm/ym von flim
        move.l  (a1)+,d7    min ursprung    xo/yo
        bsr     wdw_siz > d2:4*b|2*b d3:bc|bw d4:xw|yw d6:x0|y0 a1:CX a2:borwd>
        move.l  d2,d3       border*xx sichern
        add.l   6(a2),d2    curs.mae von sd.xinc/yinc
        move.l  d2,(a1)+    b>x/yinc        cx/cy : 20 /22
        sub.l   d4,d5       max ursprung in primr-outline
        add.l   d7,d5       mit outline-ursprung
        move.l  d5,(a1)+    b>maxorg        wl/wa : 24/26
        move.l  d4,(a1)+    b>maxsiz        ww/wh : 28/30
        move.l  -(a2),(a1)+ ws: mae und
        move.l  -(a2),(a1)+ wo: ursprung ohne border zur justage
        move.l  d4,(a1)+    hs: copie mae mit border
        move.l  d6,(a1)+    ho: dto ursprung
        move.l  d3,(a1)+    bb: 4*b|2*b border zum rechnen
        moveq   #0,d0
        rts

* fenstermae und border holen
wdwbrdx movem.l 24(a0),d1/d2/d3
        move.w  70(a0),d3
        movem.l d1-d3,(a1)
        moveq   #0,d1
        moveq   #0,d0
        rts
* extop fr primrfenster zum justieren zugehriger secundrfenster
wmvpwdx moveq   #-2,d0
        tst.b   17(a0)
        bpl.s   wmpret  ? nicht primrfenster
        movem.w wo(a1),d4/d5 wdw-x/yorg alt
        movem.w 24(a0),d6/d7            neu
        sub.w   d4,d6   xdisp
        sub.w   d5,d7   ydisp
        swap    d6
        move.w  d7,d6
        move.l  d6,d7   ww : d6 : xdisp|ydisp
        clr.w   d7      ws : d7 : xdisp|0000
        movem.l -16(a0),d5/a2 outl siz/org neu  => wo : a2 : outl origin
        move.l  d5,d1   => cx : d1   : outl mae
        add.l   a2,d5   => wl : d5   : grenzen rechts & unten
        movem.l d1/d5/d6/d7/a2,cx(a1)
* cx(a1): d1:outsiz d5:outmax d6:xydisp d7:xdisp a2:outorg
        moveq   #0,d0
wmpret  rts

* secundr- innerhalb primrfenster justieren
* REIN: d1:sec.wd-daten a1:memptr  RAUS: d1:bcolr|borwd a1)+ wdef-parm
wmvjstx moveq   #-2,d0  err.nj
        tst.b   17(a0)
        bmi.s   wmpret  ? nicht secundrfenster
        move.l  d1,a2
        move.l  mtinftab(pc),d1 : job-id
        move.l  a0,a4
        sub.l   pifdsp(pc),a4
        cmp.l   8(a4),d1
        bne.s   wmjret  ? fremder besitzer
* cx(a1): d3:outsiz d5:outmax d6:xydisp d7:xdisp a4:outorg
        movem.l cx(a1),d3/d5/d6/d7/a4
        movem.l (a2),d1/d2/a5 ursprung & mae & borwd|bcolr
        move.l  a5,d4
        move.l  d4,d0
        swap    d0
        add.w   d0,d0
        move.w  d0,d4
        swap    d4
        add.l   d4,d4   4*b|2*b
* d3:breit|hoch d4:4b|2b.neu d5:max rechts|unten  d6:xdisp|ydisp  d7:xdisp|0
* a4:hitorg     a5:borwd|xx
        move.l  38(a0),d0 wdt|hgt cursor
        add.l   d4,d0   min. wdw in cursorgre
        add.l   d4,d2   aktuelle mae mit border
        lsr.l   #1,d4   2*b|1*b
        sub.l   d4,d1   aktueller ursprung ohne border
        sub.w   d0,d5   untere grenze fr neuen ursprung
        move.l  a4,d4   outl-org
        add.w   d6,d1   ydisp
        blt.s   wmjxom  ? min bei yo -ve
        cmp.w   d4,d1   outl-org
        bge.s   wmjcxo  ? obere grenze passt
wmjxom  move.w  d4,d1   outl-org oberer-ursprung
wmjcxo  cmp.w   d5,d1   yorg-unten
        ble.s   wmjyo   ? passt
        move.w  d5,d1   max.
wmjyo   move.w  d1,d4   x|y
        add.l   d7,d1   xdisp
        blt.s   wmjyom  ? min bei xo -ve
        cmp.l   d4,d1   hitorg
        bge.s   wmjcyo  ? linke grenze passt
wmjyom  move.l  d4,d1   outl-org min. linker ursprung
* d3:breit|hoch  d4:4b|2b  d5:max rechts|unten  d6:xdisp|ydisp  d7:xdisp|0
* a4:hitorg      a5:borwd|xx
wmjcyo  cmp.w   d3,d2
        ble.s   wmjcys  ? hhe passt
        move.w  d3,d2
        move.w  a4,d1
wmjcys  move.w  d2,d3   gltige hhe
        cmp.l   d3,d2
        ble.s   wmjxs   ? breite passt
        move.l  d3,d2
        move.l  a4,d0
        move.w  d1,d0
        move.l  d0,d1
wmjxs   move.l  d2,(a1)+
        move.l  d1,(a1)+
        move.l  a5,d1     borwd
        move.w  70(a0),d1 bcolr
        moveq   #0,d0
wmjret  rts

* trap-aufrufe
outl3w  lea     xw(a4),a1
outl3   moveq   #0,d2
        move.l  d7,d0     13 wdef oder 122 outl
        moveq   #0,d1
tp3w    trap    #3
        not.l   d0
        beq.s   tp3_ret
        not.w   d0
tp3_ret rts

* secundrfenster: mit maen aus hits/hito innerhalb flim verndern
* primrfenster nach <enter>
* dto. und fenster als neue outline, secundrfenster mitgenommen
gowmov  moveq   #-7,d0      <wmov entry
        move.l  d0,qf.error-Z([bp])
        sub.l   a1,a1
        moveq   #8,d0       mt_susjb
        move.l  mtinftab(pc),d1
        moveq   #20,d3      wait to key de-bouncing
        trap    #1
        jsr     isopenc(pc)
        tst.w   ([sp])+
        bne.s   wmv_och ? own channel
wmv_jnx jmp ([nx])
wmv_och move.l  d3,d0
        ble.s   wmv_jnx ? not open
        move.l  d3,a0                window
        move.l  mtinftab-Z([bp]),d1  job
        movem.l d6/d7/a3-a5,-(a7) d1:job-id d4:kanal-id a0:sys a1(a6):parmptr
        lea     -mlen([sp]),a4 wmov-daten und 16*borwd
        move.w  #-winc,sm(a4)
        move.w  #winc,sv(a4)
        move.w  #wdel,sw(a4)
        move.l  a0,a5           a5:hauptfenster
        move.l  d1,d5           job sichern
        moveq   #122,d7         outl code vorbereiten
        moveq   #8,d2           k.wake
        moveq   #124,d0         pick
        moveq   #-1,d3          warten
        trap    #3              job holen
        moveq   #108,d0         flim
        moveq   #0,d2
        move.l  a4,a1
        bsr.s   tp3w            >
        lea     contab(pc),a0   a0:hilfsfenster
        move.l  d5,d1           job
        moveq   #0,d3           open einfach
        moveq   #1,d0           open berhaupt
        trap    #2
        tst.l   d0
        bne     wmv_ret         ? err.om
        moveq   #-1,d3          warten
        moveq   #41,d0          sd.setin
        moveq   #0,d1           nur zur
        trap    #3              pif-anmeldung
        move.l  a0,d4           d4:hilfsfenster
        move.l  a5,a0           a0:hauptfenster
        lea     wc-4(a4),a1     fr cursorposn
        moveq   #10,d0          sd.pxenq
        bsr     tp3w            >
        move.l  a4,a1           ablage
        lea     wdw_prm(pc),a2  fensterdaten
        moveq   #9,d0           sd.extop
        bsr     tp3w            >
wmj_clo bne     clos            ?
        move.l  d4,a0           : hilfsfenster
        moveq   #126,d0         wsav
        moveq   #0,d1
        move.l  d1,a1
        bsr     tp3w            >
        bne.s   wmj_clo         ?
        bsr     outl3w          > d7:neues fenster fixiert
        bne.s   wmj_clo ?
        move.l  a5,a0           :hauptfenster
* ursprung, mae & borwd der secundrfenster
        jsr     wcollect(pc)    > mae einsammeln
        lea     xm(a4),a1       uere grenzen
        bsr     outl3          > d7:outl ganzer bildschirm
        bne.s   wmj_clo ?
        moveq   #13,d7          wdef statt outl
        bsr     outl3w          >
        bne.s   wmj_clo
        moveq   #122,d7         outl wieder outl
        move.l  d4,a0           :hilfsfenster
        moveq   #127,d0         wrst
        moveq   #0,d2
        move.l  d2,a1
        trap    #3              fensterinhalt erneuern
        moveq   #0,d1           rel. ursprung
        move.l  d1,-(a7)
        move.l  xw(a4),d2       format
        move.l  d2,-(a7)
        move.l  d1,a2           ohne adresse
        move.l  sp,a1
        moveq   #109,d0         svpw
        trap    #3              bild sichern
        addq.l  #8,sp
        tst.l   d0
        bne.s   wmj_clo         ? err.om
        move.l  d1,a2           bildadresse
        move.l  xw(a4),d6       maximalmae sichern
        bsr.s   wsel           >>> fenster schubsen
        move.l  a0,d4           :hilfsfenster-id sichern
        move.l  a5,a0           a0:hauptfenster
        bsr     outl3w          > wdef nach esc, sonst outline neu
        move.l  xw(a4),d2       aktuelle breite
        bsr.s   wszs            > gegen maximum
        swap    d2
        move.l  d2,d6           breite als curs.max.
        moveq   #110,d0         rspw
        moveq   #0,d2           mem auflsen
        move.l  d2,-(a7)        ursprung
        move.l  d1,-(a7)        format ganzes fenster
        moveq   #0,d1           rel. im ursprung
        move.l  sp,a1           (a2 von svpw)
        trap    #3
        addq.l  #8,sp
        pea     wmv_rcp(pc)     hilfskanal zu, secundrfenster justieren
        movem.w bc(a4),d1/d2
wsl_sbd moveq   #-1,d3
wsl_brd moveq   #12,d0          bordr
        trap    #3
        rts

xbrd    st      d1
        moveq   #1,d2
        bra.s   wsl_brd

wsl_xit moveq   #0,d1
        moveq   #0,d2
        bra.s   wsl_sbd

wszs    bsr.s   wmin
        swap    d2
        swap    d6
wmin    move.w  d2,d1
        cmp.w   d6,d1
        bls.s   min_ret
        move.w  d6,d1
min_ret swap    d1
        rts

kynix   addq.l  #4,sp           <falsche taste
        and.w   #$dfff,sr       user
wsel    moveq   #1,d3
        bsr.s   xbrd            > border markieren
rosel   moveq   #1,d0           keyrow 1
        bsr.s   kyro            > fragen
        moveq   #%11010110,d4   <spc> und cursor-maske
        and.b   d5,d4           {s<en}
        rol.b   #2,d5           "<" im sign-bit
        beq.s   rosel           ? keine taste
        asr.b   #3,d5           ENTER   (dann nur: lsr.b #1)
        bcs.s   wsl_xit         ? fertig mit neuer outline
        asr.b   #3,d5
        bcs.s   kquit           ? ESC
        bpl.s   nwdf            ? oder "<" (weil meine esc-taste kaputt ist)
kquit   moveq   #13,d7          wdef
        bra.s   wsl_xit         new sizes, old outline
nwdf    moveq   #7,d0
        bsr.s   kyro            >
        lsr.b   #1,d5
        subx.w  d2,d2           SHIFT
        move.b  d4,d2           %ssssssss.0db0.r0ul
        beq.s   rosel           ?
        and.b   #3,d5           step-multiplikator
        trap    #0              supv
        move.l  a4,a3           mem
        lea     curtab(pc),a1   table of actions
        moveq   #17,d0
kytab   move.l  (a1)+,d1
        cmp.w   d1,d2
        dbeq    d0,kytab
        swap    d1
        move.w  sv(a3),d2
        jsr     -4(a1,d1.w)     > action
        and.w   #$dfff,sr
        moveq   #-1,d3
        moveq   #12,d0          bordr
        moveq   #0,d1
        moveq   #0,d2           wegnehmen
        trap    #3
        bsr     outl3w          > outline erneuern
        bne.s   rosel
        movem.l xm(a4),d0/d1/d2/d5 xm xo xw x0
        sub.l   d2,d0
        add.l   d1,d0           xm-xw+xo
        sub.l   d5,d1
        movem.l d0/d1,wl(a4)    max ursprung & mae erneuert
        bra.s   wsel            und mit border weiter

* REIN: d0 keyrow a0 aktueller con-kanal
* RAUS: d5.b code VERDIRBT: d1 ERHLT: d4 d6 d7 a0 a2 a4-a6
* darf nur im USER-mode aufgerufen werden.
kyro    lsl.w   #8,d0           keyrow
        addq.b  #2,d0           ipc-kommando
        movem.l d0/d7/a0/a3,-(a7)
        move.l  #$09010000,-(a7)
        trap    #0              (supv)
        moveq   #0,d0
        trap    #1
        move.l  usp,a3
        moveq   #17,d0
        trap    #1
        move.w  d1,d5
        move.l  76(a0),d7       sv_keyq
        ble.s   kyrnky          ? none
        move.l  d7,a0           i/o-queue
        lsr.b   #1,d7
        bcs.s   kyrnky          ?adressenfehler
        add.w   #12,a0
        move.l  (a0),-(a0)      clear
kyrnky  and.w   #$dfff,sr
        addq.l  #8,sp
        movem.l (a7)+,d7/a0/a3
        rts

curtab  dc.w wm-*,2     ursprung
        dc.w hm-*,4   
        dc.w wp-*,16  
        dc.w hp-*,$80 
        dc.w bm-*,$ff02  begrenzung
        dc.w am-*,$ff04
        dc.w bp-*,$ff10
        dc.w ap-*,$ff80
        dc.w wmm-*,6     dto., diagonal
        dc.w wpm-*,20
        dc.w wmp-*,$82
        dc.w wpp-*,$90
        dc.w bmm-*,$ff06
        dc.w bpm-*,$ff14
        dc.w bmp-*,$ff82
        dc.w bpp-*,$ff90
        dc.w cu-*,$40    winzfenster
        dc.w kynix-*     rest

* ursprung links
wm      move.w  sm(a3),d2 left
wp      lsl.w   d5,d2
        lea     x0(a3),a1 right
        add.w   (a1),d2   num
        move.w  xo(a3),d1 min l
        move.w  wl(a3),d0 max
        bra.s   wwithin

* ursprung oben & diagonal
wpm     bsr.s   wp
        bra.s   hm
wmm     bsr.s   wm
hm      move.w  sm(a3),d2 up
        bra.s   ckh
wpp     bsr.s   wp
        bra.s   hp
wmp     bsr.s   wm
hp      move.w  sv(a3),d2 down
ckh     lsl.w   d5,d2
        lea     y0(a3),a1
        add.w   (a1),d2
        move.w  yo(a3),d1 min top
        move.w  wa(a3),d0 max
        bra.s   wwithin

* grenze rechts
bm      move.w  sm(a3),d2 left
bp      lsl.w   d5,d2
        lea     xw(a3),a1 right
        add.w   (a1),d2
        move.w  cx(a3),d1 min = cursor size
        move.w  xm(a3),d0 limit width
        sub.w   x0(a3),d0 origin
        add.w   xo(a3),d0 min left
        bra.s   wwithin

* grenze unten & diagonal
bpm     bsr.s   bp
        bra.s   am
bmm     bsr.s   bm
am      move.w  sm(a3),d2 up
        bra.s   cka
bpp     bsr.s   bp
        bra.s   ap
bmp     bsr.s   bm
ap      move.w  sv(a3),d2 down
cka     lsl.w   d5,d2
        lea     yw(a3),a1
        add.w   (a1),d2
        move.w  cy(a3),d1 min = cursor size
        move.w  ym(a3),d0 max height
        sub.w   y0(a3),d0 origin
        add.w   yo(a3),d0 min. top
* d2 auf bereich d1 bis d0 justiert in (a1) ablegen
wwithin tst.w   d2
        bpl.s   valin     ?
        clr.w   d2        don't wrap
valin   cmp.w   d2,d0     d0:max d1:min d2:num - ret:d0 { d1<=d2<=d0 }
        bls.s   wwput     ? max <= num
        move.w  d2,d0     n1
        cmp.w   d2,d1                                                         
        bls.s   wwput     ? min <= num
        move.w  d1,d0     min
wwput   move.w  d0,(a1)
        rts

* schrupf-fenster im cursorformat
cu      move.l  cx(a3),xw(a3)
        rts

* alle f6-fensterdaten einsammeln
wcollect movem.l d7/a0/a4,-(sp)
        move.l  [bp],a3
        add.w   climit-Z([bp]),a3
        moveq   #15,d6  #chans-1
        moveq   #-1,d3
        add.w   #mbrd,a4
        lea     wdwbrdx(pc),a2  fensterdaten holen
wco_lop move.l  a4,a1
        move.l  (a3)+,d0
        ble.s   wco_err ? kein kanal
        cmp.l   d0,d4
        beq.s   wco_err ? hilfskanal
        move.l  d0,a0
        moveq   #-1,d1
        moveq   #9,d0
        trap    #3
        addq.l  #1,d0
        bmi.s   wco_err ?
        tst.l   d1
        beq.s   wco_nxt ?
wco_err st      (a4)
wco_nxt add.w   #mblen,a4
        dbra    d6,wco_lop
        movem.l (sp)+,d7/a0/a4
        rts

* secundrfenster justieren
wmv_rcp move.l  a5,a0   hauptfenster
        lea     wmvpwdx(pc),a2
        move.l  a4,a1   datenptr
        moveq   #0,d1   kontrolle
        moveq   #-1,d3
        moveq   #9,d0   extop
        trap    #3
        addq.l  #1,d0
        bmi.s   clos    ? falscher besitzerjob (oder sonstwas)
        tst.l   d1
        ble.s   clos    ? extop nicht ausgefhrt
        moveq   #-1,d3
        move.l  [bp],a3
        add.w   climit-Z([bp]),a3
        moveq   #15,d6  #chans-1
        move.l  a4,d7
        add.w   #mbrd,a4
wmvjlop move.l  (a3)+,d0
        ble.s   wmvjnxc ? kein kanal
        cmp.l   d0,a5
        beq.s   wmvjnxc ? wmov-fenster
        cmp.l   d0,d4
        beq.s   wmvjnxc ? hilfskanal
        move.l  d0,a0
        move.l  d7,a1   wdef-daten
        tst.b   (a4)    alte daten
        bmi.s   wmvjnxc ? nicht fenster
        lea     wmvjstx(pc),a2 justagedaten holen
        move.l  a4,d1   kontrolle
        moveq   #9,d0   extop
        trap    #3
        addq.l  #1,d0
        bmi.s   wmvjnxc ? irgendwas falsch
        cmp.l   a4,d1
        beq.s   wmvjnxc ? nicht ausgefhrt
        move.l  d1,d5   borwd|bcolr
        move.l  d7,a1   daten
        move.l  d1,d2
        swap    d2
        moveq   #13,d0
        trap    #3
        tst.l   d0
        beq.s   wmvjnxc
        moveq   #122,d0 io_outl
        moveq   #0,d1
        moveq   #2,d2   iop..mov
        trap    #3
        move.l  d5,d1
        move.l  d1,d2
        swap    d2
        moveq   #12,d0 sd_bordr
        trap    #3
wmvjnxc add.w   #mblen,a4
        dbra    d6,wmvjlop
        move.l  d7,a4
        move.l  wc(a4),d2 curs x/y
        move.l  d2,d1
        swap    d1
        move.l  a5,a0
        moveq   #23,d0  sd_pixp
        trap    #3
* close aux. window
clos    move.l  d0,d7
        move.l  d4,a0   hilfsfenster
        moveq   #2,d0   schlieen
        trap    #2
        move.l  d7,d0
wmv_ret move.l  d0,qf.error-Z([bp])
        movem.l (a7)+,d6/d7/a3-a5
        pea     ([nx])
        jmp     jqesc(pc)

* +++ edline for expect

qxp     move.l  (a7)+,[nx]
        move.w  ([sp])+,d0
        move.w  d0,uspan([bp],[up].l)
        move.l  [bp],a0
        add.w   ([sp])+,a0
        subq.w  #1,d0
        bmi.s   qxpr
        lea     -2(a0),a1
qxpm    move.b  (a0)+,(a1)+
        dbra    d0,qxpm
        move.b  #' ',(a1)+
        sf      (a1)
qxpr    jmp ([nx])

* kbd editting to substitute expect
Xqexpect neg.w  ([sp])     erase buffer area
        lea     qxp(pc),[nx]
Xedline clr.w   -([sp])    in-cons (-ve len to erase the buffer area)
        jsr     cdashwd(pc) > a0: id
        tst.w   ([sp])+
        movem.w ([sp])+,d2/a2 maxcount buffer
        bne.s   edlstg    ? window
        lea     2(a2),a1
        jsr     jexpect(pc) >
        addq.w  #1,d3
        ble.s   expnul    ?
        sub.l   [bp],a1
        sub.w   d1,a1
        subq.w  #2,a1
        move.w  a1,-([sp])
        move.w  d1,-([sp])
        jmp ([nx])
expnul  clr.w   -([sp])
        jmp ([nx])

edlstg  moveq   #0,d4
        move.w  d2,d3
        bpl.s   edlbuf ?
        neg.w   d3
        move.w  d3,d2
        lea     0([bp],a2.w),a1
edlcbf  move.b  d4,(a1)+  clr buffer & count.w
        dbra    d3,edlcbf
edlbuf  move.b  1([bp],a2.w),d4
        sf      0([bp],a2.w)
        movem.l d6/d7/a3,-(a7) regs
        lea     2(a6,a2.w),a2 1st char ptr
        subq.l  #8,[sp]
        move.l  [sp],a1   window data
        moveq   #-1,d3    no timeout
        move.w  d2,d7     buf.len
        cmp.w   d2,d4
        ble.s   edlen     ? stg fits
        move.w  d4,d7     max($len,buffer)
edlen   addq.w  #1,d7     + cursor
        moveq   #-1,d6    max.timo hi.w
        move.w  d3,d6     & std timo
        moveq   #11,d0    sd.chenq
        pea     edl_tim(pc) exit on timeout
        bsr.s   edl_qtrp  trap rel(a6)
        move.l  d6,d3     timeout back
        move.l  4([sp]),d5
edl_lerr moveq  #0,d6     start/error w. cursor at end of stg
edl_lop bsr.s   edl_cur   go to curpos
        move.w  d4,d2     len=num of bytes
        lea     0(a2,d4.w),a1
        move.b  #32,(a1)
        move.l  a2,a1     strg
        moveq   #7,d0     < io.sstrg  d2.count d3.timo a0.id   a1.buffer
        bsr.s   edl_qtrp  > d1.sent   d2.cons  d3.cons a0.cons a1.updt
        moveq   #32,d1
        moveq   #5,d0     io.sbyte
        bsr.s   edl_qtrp
        moveq   #19,d0    sd.pcol
        bsr.s   edl_qtrp
        move.w  d4,d1     e.o.l.
        swap    d1        packed posn
        cmp.b   #198,d6   cur up
        bne.s   edl_acur  ? not (this works w. minerva only)
        pea     edl_lerr(pc) on error retry
        bsr.s   edl_cur   > go to start o.l.
        addq.l  #4,a7     drop error entry
        moveq   #0,d1     to start of stg
edl_acur cmp.w  d7,d4
        ble.s   edl_ale
        move.w  d7,d4
edl_ale move.w d4,d1     len
        lea     0(a2,d4.w),a1  last char
        move.w  d7,d2     max.len
        swap    d3        max.timo
        moveq   #4,d0     io.edlin < d1.hi,lo cursor,len d2.w.buflen a1.e.o.l
        trap    #3                 < & d3.timo a0.id
        addq.l  #1,d0     > d1.l.updt d2.cons d3.cons a0.cons a1.updt
        bgt.s   edl_nde   ? last char
        bne.s   edl_nxt   ? not <break>
        moveq   #15,d0    sd.curen
        bsr.s   edl_qtrp
        moveq   #4,d0     err.nc restored
edl_xit subq.l  #5,d0
        rts               => edl_tim

edl_cur move.w  d5,d2     row
        swap    d5
        move.w  d5,d1     col
        swap    d5
        moveq   #16,d0    sd.pos
        bra.s   edl_qtrp  - trap#3

edl_nxt addq.l  #4,d0     err.bo if e.o.l.
        bne.s   edl_xit   ?
edl_neu move.w  d1,d4
        subq.w  #1,d4     new len
        swap    d3        min timo
        bra.s   edl_lop

* general trap-call, on err ret one level back
edl_qtrp trap   #3
        not.l   d0
        bmi.s   edl_qrt   ? ok
        addq.l  #4,a7
edl_qrt not.l   d0
        rts

edl_nde moveq   #-10,d6
        add.b   -(a1),d6  <enter>
        bne.s   edl_neu   ? new input
        addq.l  #4,a7     drop error return
        sf      (a1)
        subq.w  #1,d7
        subq.w  #1,d1     limiting char
        bpl.s   edl_ret   ? stg not empty
        moveq   #0,d4     (auch nicht leerer)
edl_tim move.w  d4,d1     <on timeout)
edl_ret sub.w   d1,d7
        bra.s   edl_rmd   -
edl_rml sf      (a1)+
edl_rmd dbra    d7,edl_rml ?
        addq.l  #8,[sp]
        move.b  d1,-1(a2)
        sub.l   [bp],a2
        move.w  a2,-([sp])
        move.w  d1,-([sp])
        movem.l (a7)+,d6/d7/a3
        jmp ([nx])

* --

Xkeyrow move.w  ([sp])+,d0
        lsl.w   #8,d0
        addq.b  #2,d0
        move.w  d0,-([sp])
        clr.l   -([sp])
        move.w  #$0901,-([sp])
        move.l  [sp],d1
        chk     -$8000([bp]),d0
        sub.l   [bp],d1
        move.w  d1,-([sp])
        moveq   #0,d0
        trap    #1
        bsr.s   Cipcom >
        move.l  76(a0),d1
        ble.s   kyronky ? no keyqueue
        move.l  d1,a0
        ror.b   #1,d1
        bcs.s   kyronky ? aerr
        add.w   #12,a0
        move.l  (a0),-(a0)
kyronky move.w  ([sp])+,8([sp])
        move.w  ([sp]),sr
        addq.l  #8,[sp]
        jmp ([nx])

Xbell   pea     Xdrop(pc)   {7}
        lea     pieps-Z([bp]),[w]
        sub.l   [bp],[w]
        move.w  [w],-([sp])
Cipcom  movem.l d5/d7/a3,-(a7)
        move.l  [bp],a3
        add.w   ([sp])+,a3
        moveq   #17,d0
        trap    #1
        movem.l (a7)+,d5/d7/a3
        move.w  d1,-([sp])
        sf      ([sp])
        rts

* -- 2ndary job --

* areae of non executable code
bkjaql  dc.l 0,$28,$60,$120,$18000,$19000,$20000,$28180,-1
bkjaqx  dc.l $680,$689,$96a,$96d,-1
bkjpc   move.l  (a0)+,d3
        bmi.s   bkjpr   ? adr1 > pc >= adr2
        move.l  (a0)+,d1
        cmp.l   d3,d2   lower bound
        bcs.s   bkjpc   ? pc < adr1
        cmp.l   d1,d2   upper bound
        bcc.s   bkjpc   ? pc >= adr2
        moveq   #1,d1   adr1 <= pc < adr2
bkjpr   rts
* job zur adressenkontrolle & breaktasten-abfrage
breakjob moveq  #-1,d1  selbst
        moveq   #1,d3   kurze
        moveq   #8,d0   pause
        sub.l   a1,a1   ohne flag
        trap    #1
        move.l  jdttab(pc),a0
        lea     sys(pc),a6     bp
        sub.w   #sys-Z,a6   up a0 a1 a2 nx ip sp bp rp sr&pc
        movem.l $20+4*7(a0),d0/d1/d2/d3/d4/d5/d6/d7/a1/a2/a5
        move.l  a5,d2
        move.w  a2,d2
        swap    d2      d2:=pc
        move.l  a1,a5   a5:=rp
        move.l  d7,a2   a2:=bp
        lea     quit+2(pc),a4 IP
        lea     docold(pc),a1 PC cold restart
        lea     bkjaql(pc),a0
        bsr.s   bkjpc   > valid address area
        bgt.s   bkjqxc  ? cold restart
        move.b  emuflag(pc),d3
        addq.b  #2,d3
        bne.s   bkjnqx  ? no qxl-system
        lea     bkjaqx(pc),a0
        bsr.s   bkjpc   >
        bgt.s   bkjqxc  ? cold
bkjnqx  moveq   #0,d7   ernum
        lea     tstjtop(pc),a0  hi bound
        cmp.l   a0,d2
        bpl.s   bkjkyq  ? PC above control area
        lea     tstjbot(pc),a0  lo bound
        cmp.l   a0,d2
        bmi.s   bkjkyq  ? PC below control area
        lea     next(pc),a0
        move.l  a0,d3
        lea     tstjnx(pc),a0 inner bound
        cmp.l   a0,d2
        bcs.s   bkjnnx  ? PC below inner control area
        cmp.l   d3,d4
        bne.s   bkjrgs  ? cold if nx lost
        cmp.l   a6,a2
        bne.s   bkjrgs  ? or baseptr
bkjnnx  move.l  d0,d1
        lea     adrwarm(pc),a1 address error warmstart
bkjqxc  ror.b   #1,d1
        bcs.s   bkjrgs  ? if up odd
        ror.b   #1,d5
        bcs.s   bkjrgs  ? or ip
        ror.b   #1,d6
        bcs.s   bkjrgs  ? or sp
        move.l  a5,d1
        ror.b   #1,d1
        bcs.s   bkjrgs  ? or rp
bkjkyq  move.w  vbreak(pc),d5
        bmi.s   bkjjbk  ? kein tastaturabbruch
        trap    #0
        move.w  sr,-(sp)
        or.w    #$0200,sr
        jsr     tbreak(pc) >
        and.b   #$df,(sp)
        move.w  (sp)+,sr
        swap    d5
        not.w   d5
bkjjbk  bne.s   bkjret
bkjrgs  move.l  a1,a2
        lea     tvtregs(pc),a1
        movem.l d0-d7/a0-a7,(a1)  up pc a2 nx ip sp       bp rp
*                              d0/d1/d2/d3/d4/d5/d6/d7/a1/a2/a5
        sub.l   a1,a1
        move.l  mtinftab(pc),d1
        moveq   #-1,d3
        moveq   #8,d0
        trap    #1      lock f6-job
        move.l  a4,$20+4*8+4*4(a0)   ip=jobA4 quit/xx
        move.l  a6,$20+4*8+4*6(a0)   bp jobA6
        move.l  a2,$62(a0)           pc jobPC next/docold/adrwarm
        bclr    #5,$60(a0)           sr jobSR user-mode
        clr.w   vprev+2-Z(a6)        (update) sperren
        moveq   #9,d0   un-lock
        trap    #1
bkjret  jmp     breakjob(pc)

* kontrolljob installieren
instbjob moveq  #1,d0   cjob
        moveq   #-1,d1
        moveq   #20,d2
        moveq   #120,d3
        sub.l   a1,a1
        trap    #1
        tst.l   d0
        bne.s   ibjerr  ?
        move.w  #$4ef9,(a0)+
        lea     breakjob(pc),a1
        move.l  a1,(a0)+
        move.w  #$4afb,(a0)+
        move.l  d0,(a0) kein name
        moveq   #10,d0  activ
        moveq   #1,d2
        moveq   #0,d3
        trap    #1
        moveq   #9,d0   wait
        moveq   #127,d3 initiierung abwarten
        sub.l   a1,a1
        trap    #1
ibjerr  rts

* -- F6 entry --

utmtext move.w  $0d0,a2
        move.l  deftch(pc),a0
        jsr     (a2)    >
        moveq   #32,d1
        moveq   #5,d0
        trap    #3
        rts

* fetch (cold) last <bs> up s0 r0 tib width warning fence dp voc-link
*         as    d0  d1  d2  d3 up  a0   a1   a2     a3    a4  a5
inicold bsr.s   instbjob >
        lea     versad(pc),a1   version message
        bsr.s   utmtext >
        lea     tcpums(pc),a1   timer message
aercold ;<"address error" exception entry
        bsr.s   utmtext >
        bsr.s   calwarm >
        moveq   #0,d6         clear disp to base ptr
        move.L  odp-Z([bp]),d0
        move.L  d0,udp-2([bp],[up].l)
        jsr     Csetexb(pc) >
docold  trap    #0          safely..
        and.w   #$dfff,sr       ..always (usr)
        bsr.s   calwarm                    > restore ptr's
        lea     0([bp],a0.l),[sp]          & datastack
        lea     0([bp],a1.l),[rp]          & retnstack
        jsr     itimecal(pc)               cpu timing
        move.w  #forthv-2-Z,d6
        move.w  d6,ucontext([bp],[up].l) forth
        move.w  d6,ucurrent([bp],[up].l) definitions
        moveq   #0,d6                    clear disp to base ptr
        jsr     Cretexb(pc)              >      :   a0   a0 a1  a1    a2
* init: last bschar u0.l s0.l r0.l tib width warning fence dp.l voclink os-l
        movem.l ofnc(pc),a0/a1/a2
        movem.l a0-a2,ufence([bp],[up].l)    d1:=up
        st      upromptq([bp],[up].l)        prompt on
        move.w  #ctt-Z,uocc4th([bp],[up].l)  ctrl.table
        move.l  bank-Z([bp]),d6            current base segment
        move.l  d6,usysos([bp],[up].l)     os restored to the base system
* fetch (warm) last <bs>  up.l  s0.l r0.l tib width warning fence dp
*         as    d0.  d0. [up].l a0.l a1.l a2.  a2.
dowarm  trap    #0
        and.w   #$dfff,sr
        pea     next(pc)
calwarm lea     sys(pc),[bp]               get safe
        sub.w   #-$8000,[bp]               new basereg
        clr.w   vprev+2-Z([bp])            (update) sperren
        clr.w   quadf-Z([bp])              normale zahlen
        movem.l olast(pc),d0/[up]/a0-a2    re-initiate system ptrs
        move.w  #-1,utimo([bp],[up].l)     i/o-wait
        movem.l d0/[up]/a0-a2,ulast([bp],[up].l) last.bs.up.s0.r0.tib.width
        move.w  #task+2-Z,udds([bp],[up].l) <with-vorgabe
        move.w  ouup(pc),uup([bp],[up].l)  user-'here'
        move.w  #'  ',unumfil([bp],[up].l) .r leading chr
        lea     abort+2(pc),[ip]           jmp into abort
        lea     next(pc),[nx]
        rts

Cclose  move.w  ([sp])+,d3
        beq.s   noclos  ? in-cons
        jsr     mkchp(pc) >
        moveq   #-1,d1  (also for open)
        move.l  d3,d0
        bmi.s   noclose
        move.l  d1,(a2) clear id
        moveq   #2,d0   io.close
        cmp.w   d3,d0
        bge.s   noclos  ? ignore -ve and prevent closeing QDOS 0-2
clcch   moveq   #15,d2  #chans-1
clchk   cmp.l   (a0)+,d3
        dbeq    d2,clchk
        bne.s   tstclos
        add.b   usriow-Z([bp]),d2
        cmp.b   #15,d2
        bne.s   noclose
        move.l  d1,-(a0) close duplicate workchannel
        bra.s   clcch
tstclos movem.l mtinftab-Z([bp]),d1/a0/a1
        move.l  d3,a0
        lsl.w   #2,d3
        move.l  120(a1),a1
        move.l  0(a1,d3.w),a1
        move.l  a1,d3
        ble.s   noclos  ? no address
        lsr.w   #1,d3
        bcs.s   noclos  ? zero or odd
        cmp.l   8(a1),d1
        bne.s   noclos  ? not an own channel
        trap    #2
noclos  moveq   #0,d0   <extop from: dashwindow
noclose rts

Xfoplk  move.w  ([sp])+,d1
        move.l  ([sp])+,d2
        move.w  d1,-([sp])
        move.l  d1,-([sp]) -rot
        move.b  usriow-Z([bp]),-([sp])
        sf      -([sp])
Xlopen  move.w  ([sp])+,d3 (name link-id chan.no.)
        jsr     mkchp(pc) >a2 := chp
        moveq   #-1,d1
        bra.s   lopn_nt
Xfop    move.l  ([sp])+,d0 ptr & open-code
        swap    d0
        move.l  d0,-([sp])
        move.b  usriow-Z([bp]),-([sp]) work
        sf      -([sp])
Xopen   move.w  ([sp]),-([sp])
        clr.w   2([sp]) ( name.adr d.acs.code chan.no - d.ernum ) sets d1:=-1
        bsr.s   Cclose  >
lopn_nt moveq   #-3,d0
        move.l  ([sp])+,d3 open-typ/link-id ( name.adr d.chan.id - d.ernum
        move.l  [bp],a0
        add.w   ([sp])+,a0 name ptr.
        bmi.s   opnerr  ? kanal-fehler bei lopen
        moveq   #1,d0   io.open
        trap    #2
opnerr  move.l  d0,qf.error-Z([bp])
        move.l  d0,-([sp])
        bne.s   opnjnx  ?
        move.l  a0,(a2)
        moveq   #39,d0  sd.setpa (pif)
        moveq   #0,d1
        moveq   #1,d3
        trap    #3
opnjnx  jmp ([nx])

Csysmsg move.w  ([sp]),d0
err_ql  add.w   d0,d0
        bpl.s   err_sys ? 4th system msg
        cmp.w   #-54,d0
        blt.s   err_nms ? msg#
        move.l  sysvari-Z([bp]),a1
        move.l  330(a1),a1
        tst.b   emuflag-Z([bp])
        ble.s   err_njm  ?
        cmp.w   #-44,d0
        bgt.s   err_jm
        moveq   #-30,d0
err_jm  move.w  #$3894,a1 JM messagetable
        addq.w  #2,d0
err_njm neg.w   d0
        add.w   0(a1,d0.w),a1
        bra.s   err_out -
err_sys cmp.w   #64,d0
        bgt.s   err_noms ? msg#
        move.w  e(pc,d0.w),d0
        beq.s   err_noms ? msg#
        bmi.s   err_ql   ? qdos
        subq.w  #1,d0
        beq     outcpu   ? .cpu
        lea     1+e(pc,d0.w),a1
err_out moveq   #127,d2
        and.w   (a1),d2  len
        cmp.w   (a1)+,d2
        bne.s   err_noms ? erroneous adr
        sub.l   [bp],a1  adr => ptr
        clr.w   ([sp])   clear flag
        jsr     tprompt(pc)
        beq.s   err_msg  ?
        moveq   #4!3,d0
err_msg jmp     msgtype(pc)
err_nms neg.w   ([sp])
err_noms jmp ([nx])     :HIER: (identisch ab anfang)

* message: ptr < 0 qdos-msg. by ut.err : = 0 by num  : > 0 own text
e dc.w -19,mptyad-e,-3,adrsad-e,-8,hovfad-e,-11   0-6
  dc.w sovfad-e,-16,colder-e,0,0,0,0,0,1,versad-e 7-16
  dc.w compad-e,execad-e,-21,nfinad-e       17-20
  dc.w fncdad-e,loadad-e,edisad-e,vocsad-e
  dc.w tcpums-e,exvcad-e,trapad-e,0,0,0,0,0 25-32
mptyad string {empty stack}                 :  1
adrsad string {addressing mode}             :  3
hovfad string {digit storage ovf}           :  5
sovfad string {stack overflow}              :  7
colder string {fatal error - don''t retry!} :  9
versad string {[.vers] F6 (C) .hpr''[.date]} : 16
compad string {compilation only}            : 17
execad string {executing only}              : 18
nfinad string {definition not finished}     : 20
fncdad string {protected dictionary}        : 21
loadad string {use only when loading}       : 22
edisad string {off working area}            : 23
vocsad string {?vocabulary}                 : 24
tcpums string {- mpu effective timing: }    : 25
exvcad string {execution vector undef''d}   : 26
trapad string {system address error}        : 27
thgnam string {THING}
hotnam string {HOTKEY}
memnam string {mem}
hisnam string {his_80}
hissnm string {his_s}

Cexbrac moveq   #%11000000,d0
        move.w  ustate([bp],[up].l),d1
        beq.s   goXcarb             ? interpreting
        bpl     Xqexec              ? not compiling to execute
        moveq   #5,d1               start execution of compiled words
        add.L   udp-2([bp],[up].l),d1
        and.w   #-2,d1
        move.L  d1,udp-2([bp],[up].l)   compiling:
        move.w  #retexb-Z,-4([bp],d1.L) restore dp and last
        move.w  #semis-Z,-2([bp],d1.L)  terminate dummy colon-definition
        move.L  uhead-2([bp],[up].l),[w] pfa
        add.l   [bp],[w]            address
        jmp     docolon(pc)         execute
goXcarb bsr.s   Csetexb             prepare compiling for direct execution
        addq.L  #2,udp-2([bp],[up].l)
        move.w  #lbrac-Z,0([bp],d1.L) cpl state to executing
        move.w  d0,ustate([bp],[up].l)
        jmp ([nx])

Cretexb move.w  utail([bp],[up].l),ulast([bp],[up].l)
        move.L  uhead-2([bp],[up].l),udp-2([bp],[up].l)
        rts

Csetexb move.w ulast([bp],[up].l),utail([bp],[up].l)
        moveq   #1,d1
        add.L   udp-2([bp],[up].l),d1
        and.w   #-2,d1
        move.L  d1,uhead-2([bp],[up].l)
        move.L  d1,udp-2([bp],[up].l)
        rts

* calc. sign d0.w for d5 * d4, set d4 & d5 to abs
qml_sgd move.l  d5,d0
        bpl.s   qsg_d5p
        neg.l   d5
qsg_d5p eor.l   d4,d0
        smi     d0
        ext.w   d0
        tst.l   d4
        bpl.s   qsg_pve
        neg.l   d4
qsg_pve bsr.s   qml_cal
        eor.b   d3,d0
        beq.s   qsg_pos
        neg.l   d2
        negx.l  d4
qsg_pos rts

* unsigned 64-bit-product d2|d4 := d4 * d5 & d3 ovf, d0(sgn) unchanged
* IN: d4 d5       OUT: d2 d3 d4      CHG: d1 - d5
qml_cal move.w  d4,d1   md.l
        move.w  d4,d2   md.l
        mulu    d5,d2   p.ll              mt.l*md.l
        swap    d5      mt.h
        mulu    d5,d1   p.hl         mt.h*md.l
        swap    d4      md.h
        move.w  d4,d3   md.h
        mulu    d5,d4   p.hh      mt.h*md.h
        swap    d5      mt.l
        mulu    d5,d3   p.lh         mt.l*md.h
        swap    d2      p.ll.h
        add.w   d2,d1   p.ll.h+p.hl.h =: p.l.h
        moveq   #0,d5
        addx.l  d5,d4   p.hh+cy
        add.l   d3,d1   p.lh+p.l
        move.w  d1,d2   p.lh+p.l.h
        swap    d2      p.lo
        addx.w  d5,d5   fetch arithmetic cy
        swap    d1      p.hl.h
        addx.w  d1,d4   p.hh+cy
        swap    d4      p.hh.h
        addx.w  d5,d4   p.hh.h+cy
        svs     d3      ovf.hi
        roxl.b  #1,d3   accumulate ovf to last cy
        ext.w   d3
        ext.l   d3      flag any error
        swap    d4      p.hi
        rts

Xfnt    jsr     Ccdt(pc)        d2:pif d3:id a0:cdt
        tst.w   ([sp])+
        move.l  ([sp])+,a2      cdt
        ble.s   fntrrt          ? no window
        add.w   d2,a2           cdt wdw.parm
        move.l  d3,a0          id
        move.w  ([sp]),d3
        move.l  #$fff4fff0,-([sp])  top -12 min -16
        jsr     Cwithin(pc)     > (d0/d1/d2/d4)
        cmp.w   ([sp]),d3
        bne.s   fntrom          ? back to standard
        jsr     cmemvec(pc)     >
        move.l  ([sp])+,d0
        bmi.s   fntxit          ?
        move.l  d0,a0           fount baseaddr.
        movem.l 42(a2),d2/a1    current founts
        move.w  (a0)+,d1        2nd ptr
        beq.s   fnt1st          ? missing
        move.w  d1,d0           1st ptr
        not.w   d0
        beq.s   fntput          ? missing
        ror.w   #1,d0
        bcc.s   fntxit          ? error
        lea     -2(a0,d1.w),a1  2nd new
fnt1st  move.w  (a0),d1
        not.w   d1
        beq.s   fntput
        move.l  a0,d2           1st new
fntput  movem.l d2/a1,42(a2)
        jmp ([nx])
fntrrt  addq.l  #2,[sp]
fntxit  jmp ([nx])

fntrom  sub.l   a1,a1
        move.l  a1,a2
        moveq   #1,d3
        moveq   #37,d0
        trap    #3
        bra.s   fntrrt

Xflit   addq.l  #6,[ip]         <fp lit
        move.l  [ip],[w]
        move.l  -([w]),-([sp])
        move.w  -([w]),-([sp])
        jmp ([nx])

Ccndtof moveq   #2,d1           < $>f
Cjcndtof movem.l d6/d7/a3/a4,-(a7)
        move.l  d1,a0
        add.w   ([sp])+,a0      strg
        moveq   #0,d7
        move.b  -1([bp],a0.w),d7 buf.end
        move.w  d7,d0
        subq.w  #1,d0
        bmi.s   cnnum           ? no strg
        add.l   a0,d7
        lea     0([bp],a0.l),a1
        moveq   #',',d1
cndp    cmp.b   (a1)+,d1
        dbeq    d0,cndp
        bne.s   cnndp           ?
        addq.b  #2,-(a1)        convert ',' to '.'
cnndp   move.l  [sp],a1
        sub.l   [bp],a1         result
        subq.l  #6,[sp]         buffer
        move.w  $100,a2         cn.dtof
        jsr     (a2)            >
        bne.s   cnerr
        cmp.b   #'%',0([bp],a0.l)
        bne.s   cnnum           ? no %
        clr.w   -([sp])         f.p. 100
        move.l  #$08076400,-([sp])
        subq.l  #6,a1
        moveq   #16,d0          ri.div
        move.w  284,a2          ri.exec
        jsr     (a2)            > num. => percent
        beq.s   cnerr           ? ok
        addq.l  #6,[sp]
cnerr   addq.l  #6,[sp]
cnnum   movem.l (a7)+,d6/d7/a3/a4
        move.w  d0,cfperr-Z([bp])
        bne.s   cnret           ? ok
        and.b   #15,([sp])
        move.w  #-2,udpl([bp],[up].l)
cnret   rts

Xfmdiv  lea     muldivtab-Z([bp]),a2 */ (fp)
        sub.l   [bp],a2
        move.l  [sp],a0
        sub.l   [bp],a0
        moveq   #0,d0
        bra.s   XriXd0  -

Xfplds  moveq #20,d0            +- (fp)
        tst.w   ([sp])+
        bmi.s   XriXd0  -
        jmp ([nx])

Xrivec  move.w  ([sp])+,d0
        bge.s   XriXd0
        movem.w ([sp])+,a0/a2
* ! entry w. proc.flags set by opcode in D0
* D0=0 ri.execb w. A2:=op.table(bp) A0:=variptr(bp)
XriXd0  movem.l d6/d7/a3/a4,-(a7) <ri.vec)
        move.w  a2,a3   ptr to opcode list for ri.execb
        move.w  $11c,a2 ri.exec
        bne.s   rixex   ? sing opcode
        move.w  $11e,a2 ri.execb
rixex   move.w  a0,a4   ptr to ri.variable area(a6)
        add.l   [bp],a3
        moveq   #0,d7
        btst    d7,d0
        beq.s   rixstd  ? not a minerva special code
        and.b   miflag-Z([bp]),d0 mask
        beq.s   rixmir  ? no minerva
rixstd  move.l  [bp],d6 save BP
        add.l   [bp],a4 abs addr
        move.l  [sp],a6 prevent JS rom error at ATAN
        sub.l   [bp],a4 variptr rel A6
        move.l  d7,a1   stack safely within 15bit bounds
        jsr     (a2)    > qdos calculate
        add.l   a6,a1   adjusted stackptr
        move.l  d6,[bp] restore BP
rixnmi  movem.l (a7)+,d6/d7/a3/a4
        move.w  d0,cfperr-Z([bp])
        bne.s   rixer   ? on err leave SP as it is
        move.l  a1,[sp]
        and.b   #15,([sp]) ..fail safe
rixer   jmp ([nx])
rixmir  moveq   #-19,d0 err.ni
        bra.s   rixnmi  -

Xqflt   move.l  ([sp])+,d5 : q>f
        moveq   #-1,d2
        bra.s   XXcqflt

Xfsing  move.w  ([sp])+,a0 : s>f
        move.l  a0,-([sp])
CXflong moveq   #0,d5      : d>f
        moveq   #0,d2
XXcqflt move.l  ([sp])+,d3 < 32bit to f.p.
        moveq   #$3f,d0
        move.l  d5,d4     lo.val
        bne.s   cfnh      ? 64bit or zero
        and.l   d3,d2
        bmi.s   cfnh      ? 64bit hi.zero lo. 32nd set
        moveq   #$1f,d0   else 32
        exg     d5,d3
cfnh    move.l  d3,d2
        or.l    d5,d2
        beq.s   cfnk      ? null
cfne    add.l   d3,d3
        addx.l  d5,d5
        dbvs    d0,cfne
        roxr.l  #1,d5
        move.w  #$0800,d4 exp. null
        move.b  d0,d4
cfnk    move.l  d5,-([sp])
        move.w  d4,-([sp])
        jmp ([nx])

Xfpq    moveq   #63,d2  : f>q
        bra.s   lfltnt
XXlflt  moveq   #31,d2  : f>d
lfltnt  or.w    #$0800,d2
        moveq   #0,d5   lo.l of quad
        moveq   #0,d1
        moveq   #0,d0
        move.w  ([sp])+,d0
        move.l  ([sp])+,d4
        beq.s   clfn      ? zero
        smi     d1        sign
        move.l  d4,d3     mnt
        moveq   #0,d4
        addq.b  #1,d1     0:-ve 1:+ve for exp.adjustmt
        sub.w   d1,d0
        cmp.w   #$0800,d0
        blt.s   clfn      ? zero if < 1
        lsl.l   d1,d3     mnt sign-adjusted
        move.l  d3,d4     saved
        move.w  d2,d3     max. exp
        sub.w   d0,d3
        bgt.s   clfc      ? valid
        beq.s   clfn      ? exp 0 equal to zero
        moveq   #-1,d0 l<i
        moveq   #1,d4     set
        ror.l   #1,d4     +/- ovf
        sub.l   d1,d4     $80000000 min .. max $7fffffff
        sub.l   d1,d5      00000000             ffffffff
        bra.s   clfn      - ret limit
clfc    tst.b   d1        sign
        beq.s   clfmn     ? -ve
        bra.s   clfsn
clfs    lsr.l   #1,d4
        roxr.l  #1,d5
clfsn   dbra    d3,clfs
clfn    lsl.b   #2,d2
        bpl.s   clfdbl
        move.l  d5,-([sp])
clfdbl  move.l  d4,-([sp])
        jmp ([nx])
clfm    asr.l   #1,d4
        roxr.l  #1,d5
clfmn   dbra    d3,clfm
        bra.s   clfn      -ve

* {tl=} 1.dptr 1.len 2.dptr 2.len -- f
Xlstgcmp move.w ([sp])+,d1
        move.l  ([sp])+,a1
        move.w  ([sp])+,d3
        move.l  ([sp])+,a0
        bra.s   stgcntr
* {t=} 1.strg 1.len 2.strg 2.len
m setstr d6/d7/a3/a4
Xstgcmp movem.w ([sp])+,d1/d2/d3/d4
        lea     0([bp],d4.w),a0 1.stg
        lea     0([bp],d2.w),a1 2.stg
stgcntr movem.l [m],-(a7)
        move.w  d3,d0   2l 2s 1l 1s
        sub.w   d1,d0   1.len - 2.len
        move.w  d0,-([sp])
        bpl.s   stgone  ? 1l > 2l
        exg     d1,d3
stgone  move.w  pjokerq+2-Z([bp]),d2 joker 2.stg
        move.w  pwcardq+2-Z([bp]),d7 wildcard
        moveq   #-1,d6  wc-flag
        move.w  d1,d6   ur-lnge
        moveq   #0,d4
        move.b  3+pupperq-Z([bp]),d4 case mask
        bra.s   stgilp  -
stgwcd  lea     1(a0),a2
        move.l  a1,a3   $ gesucht
        move.l  d6,d0
        clr.w   d0
        move.l  d1,d6   hi.w=0 marke & rest
        ble.s   stgxit  ? wc am schlu
        tst.l   d0
        bmi.s   stgilp  ? beim 1. mal
stglop  move.w  d4,d0
        and.b   (a0)+,d0 1.
        move.w  d4,d5
        and.b   (a1)+,d5 2.
        sub.w   d5,d0   signflag erzeugen
        beq.s   stgnlp  ? passt
        cmp.w   d2,d5
        beq.s   stgilp  ? joker
        move.b  -1(a1),d5
        cmp.w   d7,d5   wc
        beq.s   stgwcd  ?
        tst.l   d6      oder schlu
        bmi.s   stgxit  ? =/= ohne wc
        move.l  a2,a0
        move.l  a3,a1   alte suche
        move.w  d6,d1
        addq.l  #1,a2
        subq.w  #1,([sp])
        bmi.s   stgfnd  ? schlu
stgilp  moveq   #0,d0   marke & flags
stgnlp  dbne    d1,stglop
        beq.s   stgfnd  ? 1 = 2
stgxit  ext.w   d0
        move.w  d0,([sp])
stgfnd  movem.l (a7)+,[m]
        jmp     Xsgn(pc) - lnge letztes kriterium

Xdashtx move.w  2([sp]),-([sp]) -text / w=
        bsr.s   Cmatch  > memptr len stgptr count
        neg.b   d5
        ext.w   d5
        move.l  d5,([sp])
stgeqx  addq.l  #2,[sp]
        jmp ([nx])

Xstgeq  move.l  ([sp])+,a0 s= memaddr
        moveq   #0,d0
        move.w  ([sp]),d0  maxlen
        pea     stgeqx(pc) |> drop disp
        bra.s   slongnt    >

Cmatchl moveq   #0,d0      s==
        move.w  ([sp])+,d0 maxlen
        move.l  ([sp])+,a0 memadr
slongnt moveq   #0,d5
        move.w  ([sp])+,d5 stgcount
        move.l  ([sp])+,a2 stgadr
        move.w  ([sp])+,d3 joker
        bra.s   dstxntr

Cmatch  moveq   #0,d5      <-text) entrypoint
        move.w  ([sp])+,d5 stgcount
        move.l  [bp],a2
        add.w   ([sp])+,a2 stgptr
        moveq   #0,d0
        move.w  ([sp])+,d0 maxlen
        move.l  [bp],a0
        add.w   ([sp])+,a0 memptr
        move.w  pjokerq+2-Z([bp]),d3  joker
* entry from {s=} & {s==}: d0.w maxlen d3.w joker d5.w stglen a0 memadr a2 stgadr
dstxntr move.b  3+pupperq-Z([bp]),d1 mask case sensitive or not
        move.l  d7,-(a7)   save up
        move.l  d6,-(a7)   & os
        pea     (a0)       & memadr
        moveq   #0,d2      "not found"
        cmp.w   d5,d0      exit if
        bcs.s   matchlen   ? count > max mem
        move.w  d5,-([rp])
        beq.s   matchfnd   ? zero length "found"
        moveq   #0,d7      clear for joker compare
        subq.w  #1,d0      maxlen
        subq.w  #1,d5      stg
        swap    d5         keep stg count
        move.w  d0,d5      put mem count
        move.w  d0,([rp])
        move.l  a0,d6      keep bottom
        subq.l  #1,d6      prepare
matchlp addq.l  #1,d6      nxt
        move.l  d6,a0      mem
        move.l  d5,d0
        swap    d0         stg count
        move.l  a2,a1      stg
matcmp  move.b  (a0)+,d4   mem
        move.b  (a1)+,d7
        cmp.w   d3,d7      joker
        beq.s   matchgo    ? set
        eor.b   d7,d4
        and.b   d1,d4
matchgo dbne    d0,matcmp  stg
        dbeq    d5,matchlp mem
matchfnd seq    d2
        neg.b   d2         flg
        sub.w   ([rp])+,d5 stg comparison
        seq     d5         for -text
        moveq   #0,d0
matchlen add.l  a0,d0
        sub.l   (a7)+,d0   disp
        move.l  (a7)+,d6   os back
        move.l  (a7)+,d7   up
        move.w  d2,-([sp])
        move.w  d0,-([sp])
        rts

Xquery  move.w  utib([bp],[up].l),a1
        move.w  vtibmax-Z([bp]),d2
        subq.w  #2,d2
        pea     Crvtmax(pc) <>
        bra.s   jexpect     -
Cexpect movem.w ([sp])+,d2/a1   (adr maxcnt --)
jexpect lea     utimo([bp],[up].l),a0 <edline)
        move.w  (a0),-([sp])
        move.w  #-1,(a0)
        moveq   #2<<3!4!2,d0    io.fline wait stdin
        jsr     iocomm(pc)      > no {out} counting
        beq.s   expa1ok         ? timeout or no.err
        addq.l  #1,a1
        subq.w  #4,d0           err.bo
        beq.s   expa1ok         ? valid
        bsr.s   experr          > restore i/o
expa1ok sf      (a1)
        sf      -(a1)
        move.w  d1,uspan([bp],[up].l) f.83 compatibility
exprtim move.w  ([sp])+,utimo([bp],[up].l)
        rts

experr  move.l  a1,-(A7)
        move.w  d1,-(A7)
        lea     dfdxper-Z([bp]),[w]
        lea     Cdefer(pc),a0
expajer jsr     (a0)    > restore i/o
        move.w  (A7)+,d1
        move.l  (A7)+,a1
        rts

* restore in-cons & empty tib
Cexper  lea     stdio-Z([bp]),a0
        sf      (a0)+           reset in-cons
        move.b  #1,(a0)              out-cons
        move.l  [bp],a0
        add.w   climit-Z([bp]),a0
        move.l  deftch-Z([bp]),(a0)
        move.l  (a0)+,(a0)      to default channel
        st      upromptq([bp],[up].l) kbd prompt
        rts

Xrbyw  ;; move.l  ([sp]),d2
       ;; move.w  ([sp])+,d2 flag ( 0/1 )
        moveq   #0,d1
        move.l  ([sp]),d1 ;;move.w  ([sp])+,d1       (use @ ) =: block
        move.w  #$42<<3!4!0/2,d0 fs.posab wait dr0
        asl.w   #2,d1            block.b14->X
        addx.w  d0,d0            if bit 14 was set, change to dr1
        lsr.w   #2,d1
        mulu    cbbybuf-Z([bp]),d1
        bsr     iocomm  >        fyleptr to fpos (d2:=0 on err)
       ;; move.w  ([sp])+,a1 r/w ptr
        beq.s   rwcnt   ok or err.nc
        cmp.w   #-15,d3 err.bp ;;
        beq.s   rwcnt   ? vielleicht SER
        cmp.w   #-10,d3 err.ef
        bne.s   rwdrr   ?
        tst.w ([sp]) ;;swap    d2
       ;; bne.s   rwnext  ? don't fstrg past eof
rwcnt   movem.w ([sp])+,d2/d3/a1 ;;
        bne.s   rwnext  ? don't fstrg past eof
        moveq   #7,d0   io.sstrg
        lsr.b   d2,d0   if flag was 1, convert to 3=io.fstrg
        bcs.s   rwstrg  ?
        tst.w   vprev+2-Z([bp]) flag ;,
        beq.s   rwnext  ? don't update
rwstrg  move.w  cbbybuf-Z([bp]),d2
        moveq   #-1,d3
        bsr     trap3   >
        beq.s   rwnext  ?
        cmp.w   #-10,d3
rwtst   bne.s   rwerr   ? <ert) ? ok or err.nc
rwnext  jmp ([nx])

rwdrr   addq.l  #6,[sp]
rwerr   move.l  d3,d0
        lea     2([bp]),[ip]
        add.w   vquit-Z([bp]),[ip]
        moveq   #1,d3
        pea     ([nx])    <r/w
        jsr     mkchp(pc) > ch.id
        move.l  D3,a0
        move.w  $CC,a2
        jmp (a2) ut.err

Cdashtrailing moveq #32,d2
        move.w  ([sp]),d1
        lea     1([bp],d1.w),a0
        add.w   2([sp]),a0
        ble.s   dashtnxt    ?
        cmp.b   #10,-(a0)
        beq.s   dashtnx     ? drop <nl> from file input
        subq.w  #1,d1
dashtlop cmp.b  -(a0),d2
dashtnx dbcs    d1,dashtlop ? drop trailing blanks and ctrl's
        addq.w  #1,d1
        move.w  d1,([sp])
        move.l  a0,d0
        sub.l   [bp],d0 fr l<i
dashtnxt jmp ([nx])

Xishis  jsr     cdashwd(pc) > a0:=ch-id
        ble.s   hisnfd  ? kein fensterkanal ret -1
        bsr.s   hiss    >
hisfd   move.w  d0,([sp])
        bmi.s   hisfr   ? device-fehler
        subq.l  #1,d0   his-oke-code
        beq.s   hisjnx  ? ret 1, sonst 0
hisfr   sub.w   d0,([sp])
hisnfd  subq.w  #1,([sp])
hisjnx  jmp ([nx])

hiss    moveq   #1,d0
        move.l  a0,d3
        lea     hissnm(pc),a0
        moveq   #-1,d1
        trap    #2
        asr.l   #1,d0
        bne.s   hissr   ?
        moveq   #2,d0
        trap    #2
        moveq   #-19,d0
hissr   move.l  d3,a0
        rts

m setstr d1/d2/d3/a0/a1/a2
thuse   movem.l [m],-(sp)
        lea     hotnam(pc),a0   name
        move.l  mtinftab(pc),d1 job
        move.l  thntry(pc),a1
        moveq   #127,d3
        moveq   #$28,d0 th.use
        jsr     (a1)    >
        movem.l (sp)+,[m]
        tst.l   d0
        rts

* fetch ptr from stack; hk.vec in d3.w - ret a0 hk.vec a3 hk.link d5 xx
hbfvec  move.w  ([sp])+,d2
        move.w  ([sp]),d5  stg ptr for hot@
        move.w  ([sp])+,a1 (usage blk)
        add.l   [bp],a1 ptr
        move.l  a1,a2   copy for char. move
        move.l  (a7)+,-([sp])
        movem.l d6/d7/a3/a4/a6,-(a7)
        move.l  ([sp])+,-(a7)
        move.l  hkthg-Z([bp]),d4
        ble.s   hvc_nvc ? no hotkeys
        move.l  d4,a3
        ror.w   #1,d4
        bcs.s   hvc_nvc ? no address (Cy & N)
        move.l  0(a3,d3.w),a0 hk-vector (hk.gtbuf hk.sstbf hk.set)
        bsr.s   thuse   >
        not.l   d0
        bmi.s   hvc_oke ?
hvc_nvc moveq   #0,d0
hvc_oke rts

Chbfs   moveq   #$2c,d3 hot! ( ptr count -- err:tf | oke:ff )
        bsr.s   hbfvec  >
        beq.s   hbf_nus ? nicht in betrieb
        jsr     (a0)    >
        tst.l   d0
        beq.s   hbf_nix ? oke
        moveq   #1,d0
        bra.s   hbf_nix -

hbf_nbf move.w  d5,-([sp]) ptr
hbf_nus move.w  d0,-([sp]) leer
        bra.s   hbf_ret -

Chbff   moveq   #$30,d3 hot@ ( pt num -- ff | ptr count )
        bsr.s   hbfvec  > d0 err d4  a0 hk.vec a1/a2 ptr a3 hk.link
        beq.s   hbf_nbf ? no hotkeys
        move.w  d2,d4
hbf_get move.b  d4,d0   0 actual, -ve previous
        smi     d0      0 / -1
        jsr     (a0)    > strg to/from a1)+, len d2.w
        addq.b  #1,d4
        bmi.s   hbf_get ? fetch nxt $
        moveq   #0,d0
        tst.w   d2
        ble.s   hbf_stg ?  $ empty or erroneus length
        move.w  d2,d0
        subq.w  #1,d2
hbf_sto move.b  (a1)+,(a2)+
        dbra    d2,hbf_sto
        cmp.b   #10,-(a2)
        bne.s   hbf_stg    ? no <nl>
        add.w   d2,d0
hbf_stg move.w  d5,-([sp]) stg ptr
hbf_nix move.w  d0,-([sp]) ff or stg len
        move.l  mtinftab(pc),d1
        lea     hotnam(pc),a0
        move.l  thntry(pc),a4
        move.l  hkthg(pc),a1 linkage
        moveq   #$29,d0 th.fthg
        jsr     (a4)
hbf_ret movem.l (a7)+,d6/d7/a3/a4/a6
        jmp ([nx])

Cmode   move.w  #29,-([sp]) ( n1 n2 -- n3 n4 ) n1/n3 resolution n2/n4 display
        bsr.s   Cmemvec >
        pea     (A3)    for mt.dmode
        lea     modecal(pc),a1
        move.l  ([sp])+,d0
        ble.s   jmode ?
        move.l  d0,a2
        lsr.w   #1,d0
        bcs.s   jmode ?
        exg     a1,a2
jmode   jsr     (a1)
        move.l  (A7)+,A3
        jmp     ([nx])

modecal moveq   #-1,d1
        moveq   #-1,d2
        bsr.s   jdmode  >
        move.l  ([sp])+,d4
        bsr.s   cdmode  >
        move.l  d4,([sp])
        rts
cdmode  move.w  ([sp])+,d2
        move.w  ([sp])+,d1
jdmode  moveq   #16,d0  mt.dmode (might corrupt A3)
        trap    #1
        moveq   #0,d0
        move.b  d2,d0
        move.w  d0,-([sp])
        move.b  d1,d0
        move.w  d0,-([sp])
        rts

Cmemvec moveq   #-1,d3
        move.w  ([sp])+,d3
        swap    d3
        lea     memnam(pc),a0
        moveq   #-1,d1
        moveq   #1,d0
        trap    #2
        move.l  d0,-([sp])
        bgt.s   mmvret  ?
        bne.s   mmverr  ?
        moveq   #2,d0
        trap    #2
mmverr  st      ([sp])  -ve on error
mmvret  rts

* cache control for the qxl
Xdcache moveq   #0,d1
        move.w  ([w])+,d1
        bpl.s   ddcache ?
        tst.w   ([sp])+
        beq.s   cdcache ?
        moveq   #0,d1
cdcache addq.w  #1,d1
ddcache moveq   #47,d0  sms.cach
        trap    #1
        move.w  d0,-([sp])
        jmp     ([nx])

Xlngb   moveq   #-7,d0
        move.l  sysvari-Z([bp]),a0
        tst.l   $180(a0)        (sv.lng)
        beq.s   bsret           ? no lightning
        move.w  ([w])+,-([sp])
Xbasic  moveq   #-1,d3          <basic
        move.w  ([sp])+,a1      name
        trap    #0
        move.w  sr,-(a7)        save int's
        movem.l d5-d7/a3/a4/a6,-(a7)
        move.l  sysvari-Z([bp]),a0
        move.l  $68(a0),a0
        move.l  (a0),a0
        move.l  64+4*6(a0),d6   jobA6 1st basic cdt
        sub.l   [bp],d6         disp to ref.     D6+org.A6=dest.A6
        bsr.s   chknam          > (d6=>d3)
        bne.s   bscerr          ?
        rol.l   #8,d5           use-byte
        move.l  4(a0,a6.l),d1   call
        lea     d1lq-Z([bp]),a2
        move.l  d3,a1
        movem.l d1/d5/a0/a1,(a2) store call-address/use.b/n.t.ptr/disp to bp
        bmi.s   bscerr          ? addr not valid
        subq.b  #8,d5
        bne.s   bscerr          ? not a proc
        move.l  d1,a2
        lsr.l   #1,d1
        bls.s   bscerr          ? zero or odd
        tst.w   d0
        bmi.s   bscerr          ? not found
        move.l  [sp],-(a7)      save data stack
        move.l  sysvari-Z([bp]),a0 ( lng might have a
        move.l  $180(a0),a0        ( bug at: clr.w $1aa(a0)
        add.l   d3,[bp]         dest.A6
        sub.l   d3,[sp]         org.A5 rel dest.A6
        move.l  [sp],a3         parameter fetching
        move.l  [sp],a1         pretend ri-stack
        moveq   #0,d7           (safety)
        or.w    #$0200,sr       (usr) & lock interrupts
        and.w   #$dfff,sr
        jsr     (a2)            >
        trap    #0              back to stored regs
        move.l  (a7),a1
        addq.l  #4,a7
        move.l  a1,[sp]
bscerr  movem.l (a7)+,d5-d7/a3/a4/a6
        and.b   #$df,(a7)       user
        move.w  (a7)+,sr        back
bsret   move.w  d0,-([sp])
        jmp ([nx])

* taken from the "IO2" toolkit
m setstr d2/d6/d7/a4
chknam  move.w  sr,d0
        trap    #0
        move.w  d0,-(sp)
        movem.l [m],-(sp)
        swap    d5
        moveq   #-1,d0
        add.l   a6,a1
        move.l  a6,d3
        add.l   d6,a6
        move.w  (a1),d1
        add.w   d1,d0
        blt.s   ckn_2
        lea     2(a1),a3
        moveq   #'(',d4
ckn_3   cmp.b  (a3)+,d4
        dbeq    d0,ckn_3
        not.w   d0
        add.w   d1,d0
        swap    d1
        move.w  d0,d1
        clr.w   d0
        movem.l 24(a6),d2/d4/d7
        btst    d0,d2
        bne.s   ckn_4
        btst    d0,d4
        bne.s   ckn_4
        btst    d0,d7
        bne.s   ckn_4
        addq.l  #2,d2
        lea     -8(a6,d2.l),a0
        sub.l   d2,d4
        lsr.l   #3,d4
        move.w  d4,d6
        swap    d4
        move.w  d6,d4
        add.l   a6,d7
        moveq   #-33,d6
ckn_5   move.l  d7,a2
        addq.l  #8,a0
        add.w   (a0),a2
        cmp.b   (a2)+,d1
ckn_6   dbeq    d4,ckn_5
        bne.s   ckn_4
        move.w  d1,d0
        subq.w  #1,d0
        lea     2(a1),a3
ckn_7   move.b  (a2)+,d2
        move.b  (a3)+,d5
        eor.b   d5,d2
        and.b   d6,d2
        dbne    d0,ckn_7
        bne.s   ckn_6
        sub.w   d1,a2
        subq.l  #1,a2
        sub.l   d3,a2
        move.w  -(a0),d5
        sub.l   d3,a0
ckn_4   swap    d1
        not.w   d0
        beq.s   ckn_8
ckn_2   moveq   #-7,d0
ckn_8   move.w  d4,d6
        swap    d4
        bmi.s   ckn_9
        sub.w   d6,d4
ckn_9   exg     d3,a6
        moveq   #-1,d2
        cmp.l   4(sp),d2
        beq.s   ckn_1
        sub.l   a6,a1
ckn_1   sub.l   a6,d3
        addq.w  #1,d1
        and.w   #-2,d1
        swap    d5
        movem.l (sp)+,[m]
        move.w  (sp)+,sr
        tst.w   d0
        rts

Cftd    and.b   #15,([sp]) safe exponent  f>$
        move.l  [sp],a1 num.
        sub.l   [bp],a1
        move.L  udp-2([bp],[up].l),a0  $ to here
        movem.l d7/a0/a3/a4/a5,-(a7)   up a0 nx ip sp
        move.w  $F0,a2  cn.ftod
        jsr     (a2)    >
* geht immer! drum qdos hier ohne fehlermeldung
        moveq   #0,d2   (fr fdot)
        move.w  d2,cfperr-Z([bp])
        lea     0([bp],a1.l),a2
        movem.l (a7)+,d7/a1/a3/a4/a5
        move.l  a2,[sp]
        move.b  #32,0([bp],a0.l)
        sub.l   a1,a0
        move.w  a1,-([sp]) ptr
        move.w  a0,-([sp]) len
        move.l  a1,d0   for l<i
        rts

Xfdot   bsr.s   Cftd    >       \.
        move.l  d2,d0
        bne     goXqerr ? err
        move.l  a0,d0   len
        ble.s   fdtjnx  ? err
        addq.w  #1,([sp])
        add.l   a0,a1   end
        move.b  #' ',0([bp],a1.l)
        lea     dfdtype(pc),[w]
        jmp     dodefer(pc)
fdtjnx  jmp ([nx])

Ctimecal bsr.s Ctical  > d2:=(timem)
        move.l  d0,-([sp])
        moveq   #30,d3  div
        move.w  procftab(pc),d0
        bmi.s   itiqxl  ? qxl & 68010+
        not.b   d0
        beq.s   itiemu  ? emu & 68000
        moveq   #54,d2  mul
        swap    d0
        cmp.w   #12,d0  < 8 mcs
        bmi.s   itimul  ? not GC
itiemu  sub.w   #35,d0  < 22 mcs
        bmi.s   itical  ? GC & 68000
itiqxl  moveq   #0,d0   <qxl or 23+ mcs
        moveq   #24,d2  mul
itimul  move.l  d2,-([sp])
        move.l  d3,-([sp])
itical  move.w  d0,-([sp]) */-flag
        rts

Ctical  trap    #0      supv
        lea     timem(pc),a0
        moveq   #0,d0   count
        moveq   #-51,d1 1 sec.
        move.l  (a0),d2
        sub.l   d1,d2
        move.l  d1,(a0)
ti_cal0 tst.l   (a0)
        bne.s   ti_cal0 ? waiting for smsq
        move.l  d1,(a0)
ti_cal1 cmp.l   (a0),d1 expecting nxt tick
        beq.s   ti_cal1 ? to calibrating
ti_cal2 addq.l  #1,d0   08 12 cycles 68000+ 68008
        tst.l   (a0)    12 24
        bmi.s   ti_cal2 10 18 / 08 12
        move.l  d0,d1
        add.l   d0,d0
        add.l   d1,d0   #cycles/10/sec for the 68000 cpu
        move.l  d2,(a0)+
        move.l  d0,(a0)
        and.w   #$dfff,sr user
        rts

* job-remove qdos-call unlinks the timer interrupts
m setstr d0/d1/d2/d3/d4/a0/a1/a2/a3/a4 ; d0/a0/a1 gengt
jobunl  movem.l [m],-(a7)
        move.l  16+16(a0),a0
        moveq   #29,d0  rpoll
        trap    #1
        movem.l (a7)+,[m]
        rts
jobunlend

Cxsavsto move.w ulast([bp],[up].l),d0 last & fence
        move.w  d0,olast-Z([bp])
        moveq   #0,d1
        move.L  udp-2([bp],[up].l),d1   here (codespace)
        move.w  uvocdashlk([bp],[up].l),d2
        move.w  uup([bp],[up].l),d3
        lea     ofnc(pc),a0
        move.w  d0,(a0)+        last => fence
        move.l  d1,(a0)+        here => dp
        move.w  d2,(a0)+        voc-link
        move.w  d3,(a0)         usertop
        lea     vquit(pc),a0
        cmp.w   #quit-Z,(a0)
        bne.s   savnq           ? new quit
        move.w  #loadquit-Z,(a0)
savnq   lea     tical(pc),a0                                          
        move.l  (a0),-([sp])    save timecount                        
        clr.l   (a0)            cleared for new start                 
        sub.l   [bp],a0                                               
        move.w  a0,-([sp])      to restore timecount                  
        lea     go(pc),a2       job base
        move.l  [bp],a0         disp to job base
        add.w   d1,a0
        sub.l   a2,a0
        lea     savehead(pc),a1                                       
        move.l  a0,(a1)         flen                                  
        neg.w   d1
        sub.w   #(4*16+8)!$8000,d1
        move.w  dspc+2-Z([bp]),d2
        cmp.w   d2,d1
        bls.s   savnd           ? no reduced dataspace
        move.w  d2,d1
savnd   move.w  d1,8(a1)        dataspace
        move.l  a2,-([sp])      jobbaseptr                            
        move.l  a0,-([sp])      flen (codespace)
        sub.l   [bp],a1
        move.w  a1,-([sp])      savehead
        jmp ([nx])

Csavwdw lea     syscreen(pc),a1
        move.w  ([sp])+,d2      pifdisp or 0
        move.l  ([sp])+,a0      cdt
        bmi.s   swwjnx
        add.w   d2,a0           parameterbase
        move.b  $47(a0),(a1)+   border colour
        move.w  $20(a0),d0
        move.b  d0,(a1)+        border width
        sf      (a1)+
        move.b  $46(a0),(a1)+   ink
        tst.w   d2
        bne.s   pifswdw         ? p.e.-controlled window
        move.w  d0,d1
        add.w   d0,d0           border x-pix.
        swap    d0
        move.w  d1,d0                  y-pix.
        move.l  $1c(a0),d1      window sizes
        add.l   d0,d1
        add.l   d0,d1           + double border
        move.l  d1,(a1)+
        move.l  $18(a0),d1      origin
        sub.l   d0,d1           -border
        move.l  d1,(a1)
swwjnx  jmp ([nx])
pifswdw move.l  -$10(a0),(a1)+  sd.outs window sizes
        move.l  -$0c(a0),(a1)   sd.outo origin
        jmp ([nx])

putnul  clr.w   -([sp])
        jmp ([nx])

CXqesc  bsr.s   jqesc   <?esc
        cmp.w   #27,d1
        beq     equset
        add.w   d1,d1
        beq.s   putnul
        move.w  #27,-([sp])
        pea     Xeq(pc)
        pea     Xd1ret(pc)
        bra.s   jxkey

Xkey    pea     Xd1put(pc) (-- key | -ALTkey | $8000 timout | $8001 error)
        bra.s   jxkey

xkyerr  move.w  #$8000,d1
        not.l   d3
        beq.s   xkyret  ? err.nc
        jsr     experr(pc) > restore i/o
        addq.w  #1,d1   any other error
xkyret  rts

Xqkey   pea     Xd1put(pc)      <?key {key} w. zero timeout
jqesc   pea     exprtim(pc)     <?esc)
        lea     utimo([bp],[up].l),a0
        move.w  (a0),-([sp])
        clr.w   (a0)
jxkey   moveq   #$e<<3!4!2,d0   <key) io.cursen wait stdin
        jsr     iocomm(pc)      >
        moveq   #1<<3!4!2,d0    io.fbyte wait stdin
        moveq   #-1,d2
        not.w   d2
xkyalt  jsr     iocomm(pc)      > (d3 ernum d2.l:=0 on error)
        tst.l   d2
        beq.s   xkyerr          ? any err.
        move.b  d1,d2
        not.b   d1
        bne.s   xkyput          ? no alt-key
        not.w   d2
        bpl.s   xkyerr          ? 2nd ALT
        moveq   #1<<3!0!2,d0    io.fbyte nowait stdin
        bra.s   xkyalt          fetch key value after ALT
xkyput  move.w  d2,d1
        bpl.s   xkyret
        neg.b   d1
        rts

Xdonul  bsr.s   Cnxblk  > blk+
        tst.w   ([sp])+
        bgt.s   dnljnx  ? nxt blck
        move.l  [bp],[ip] semis
        add.w   ([rp])+,[ip] tib or
        beq     Xqexec  ? new screen
dnljnx  jmp ([nx])

Cnxblk  move.w  #-1,-([sp]) ( -- f ( -1:tib 0:new screen +ve:nxt blck
        move.w  ublk([bp],[up].l),d0
        beq.s   nxitib     ? t.i.b. input
        addq.w  #1,d0       nxt blk
        move.w  d0,ublk([bp],[up].l)
        ext.l   d0
        divu    cbbyscr-Z([bp]),d0
        swap    d0
        move.w  d0,([sp])   blk no. in current screen
nxitib  clr.w   uin([bp],[up].l)
        rts

Xdstrip tst.w   ([sp])+
        beq     Xdrop
Xxstrip jsr     ccdt(pc)
        tst.w   ([sp])+
        move.l  ([sp])+,a0
        ble.s   xstnxt
        add.w   d2,a0
        movem.l $3a(a0),d0/d1/d2/d3
        exg     d0,d1
        move.b  d2,d4
        rol.l   #8,d3
        move.b  d3,d2
        move.b  d4,d3
        ror.l   #8,d3
        movem.l d0/d1/d2/d3,$3a(a0)
xstnxt  jmp ([nx])

Xiprt   lea     usriup-Z([bp]),a0
        bra.s   chkchn
Xisc    lea     dr0ch-Z([bp]),a0
chkchn  move.w  ([sp]),d2       keep the no.
        moveq   #-6,d3
        bsr.s   chidcal
        exg     d3,d0
        bmi     goXqerr ? chan. not open
        addq.l  #4,[sp]
        move.b  d2,(a0)
        jmp ([nx])

Cwkid   bsr     cdftcal >
chidcal bsr.s   chncal  >
        subq.l  #2,[sp]
        move.l  0([bp],d0.w),([sp])
        rts

chncal  move.w  ([sp])+,d0
        lsl.w   #2,d0
        add.w   climit-Z([bp]),d0
        move.w  d0,-([sp])
        rts

Xchx    bsr.s   chncal  >
        move.l  [bp],a0
        add.w   ([sp])+,a0 chp1
        bsr.s   chncal  >
        move.l  [bp],a1
        add.w   ([sp])+,a1 chp2
        move.l  (a0),d0
        move.l  (a1),(a0)
        move.l  d0,(a1)
        jmp     ([nx])

Xichn   move.w  ([sp]),-([rp]) : is-chan
        bsr     Cclose  > close
        bsr.s   Cwkid   > work-id
        move.w  ([rp])+,-([sp]) r>
Xsetc   bsr.s   chncal  > chp : set-chan
        move.l  [bp],a0   2!a
        add.w   ([sp])+,a0
        move.l  ([sp])+,(a0)
        jmp     ([nx])
Xtowk   bsr.s   chidcal > : to-work
Xswk    bsr     cdftcal > : set-work
        bra.s   Xsetc   -
Xtoch   move.w  ([sp])+,-([rp])
        bsr.s   chidcal >
        move.w  ([rp])+,-([sp])
        bra.s   Xsetc   -

Cisochc bsr.s   isopenc   a0 cdt
        beq.s   isocret   ? not open
        move.l  8(a0),d0
        cmp.l   mtinftab(pc),d0
        beq.s   isocret
        clr.w   ([sp])
isocret rts

isopenc move.w  ([sp]),d3
        clr.w   ([sp])
        jsr     mkchp(pc) > a0 cdt, d3 chan
        ble.s   isopenf   ? zero or not opened
        bsr.s   chkopn    >
        bne.s   isopenf   ? channel lost
        move.w  #1,([sp])
isopenf tst.w   ([sp])
        rts

Cdashwd bsr.s   isopenc   > f: 0 not a window, 1 std. >1 pif-window
        ble.s   dswnxt    ? not open or qdos-channel 0
        move.l  (a2),a0
        lea     noclos(pc),a2
        moveq   #9,d0     extop
        moveq   #0,d3
        trap    #3
        not.l   d0
        ble.s   dswnwd    ? window
        clr.w   ([sp])
        rts
dswnwd  move.w  pifdsp+2-Z([bp]),d0
        add.w   d0,([sp])
dswnxt  rts

chkopn  move.l  sysvari-Z([bp]),a0
        cmp.w   114(a0),d3 sv.chmax
        bhi.s   chkoret   ? wrong num
        move.l  d3,d1
        lsl.w   #2,d1
        move.l  120(a0),a0 sv.chbas
        add.w   d1,a0
        swap    d1
        move.l  (a0),a0
        cmp.w   16(a0),d1
chkoret rts

Ccdt    bsr     chidcal >
        moveq   #-1,d0  prepare "no channel"
        move.l  ([sp]),d3
        bsr.s   chkopn  >
        bne.s   cdtret  ? id no longer exist
        move.l  4(a0),d1  handler
        lea     pifdsp+4-Z([bp]),a1
        move.l  -(a1),d2  pif-dsp
        cmp.l   -(a1),d1
        beq.s   pifcdt   ? window
        cmp.l   -(a1),d1
        bne.s   cdtpush  ? not a window
pifcdt  move.w  d2,d0
cdtpush addq.w  #1,d0
        move.l  a0,([sp]) (d2: pif  d3: id)
cdtret  move.w  d0,-([sp])
        rts

Xnewch  moveq   #9,d1  protect in-cons, out-cons, print, work screen & file
        moveq   #0,d0  ff on full table
nxtnch  move.w  d1,d2
        lsl.w   #2,d2
        add.w   climit-Z([bp]),d2
        move.w  16([bp],d2.w),d2
        dbmi    d1,nxtnch
        bpl.s   nchret  ?
        addq.b  #4,d1
        move.b  d1,d0  chan > 1
nchret  move.w  d0,-([sp])
        jmp ([nx])

* extop aus Xwsiz
wsz_dat lea     $18(a0),a2 (ret: d1 origin  a1 sizes)
        movem.l (a2)+,d1/a1 x y w h
        move.w  (a2)+,d5    b
        move.w  d5,d0
        add.w   d0,d0
        swap    d0
        move.w  d5,d0
        sub.l   d0,d1      origin
        add.l   d0,d0
        add.l   d0,a1      sizes
        move.l  usp,a2
        move.l  $26(a0),(a2) cursorsizes
        moveq   #0,d0
        rts

Xnumerr moveq   #0,d0      0 ?error <zqerror)
        bra.s   tstqerr    -
Cqqerr  move.l  ([sp]),d0
        swap    d0
        move.l  d0,([sp])
Xqerror move.w  ([sp])+,d0 code
tstqerr tst.w   ([sp])+    flag
Xqerr   bne.s   goXqerr ?
ernix   jmp ([nx])

goXqerr move.w  verror-Z([bp]),d1
        lsr.w   #1,d1
        bls.s   ernix   ? error off
cputerr move.w  d0,-([sp])
        jmp     calerr(pc)

Xqcomp  moveq   #$11,d0
        tst.w   ustate([bp],[up].l)
eqXerr  beq.s   goXqerr
        jmp ([nx])

Xqexec  moveq   #$12,d0
        tst.w   ustate([bp],[up].l)
        bra.s   Xqerr

* REIN: d2.w flag RAUS: rts / error
ccpairs cmp.w   ([sp]),d2
        bne.s   Xqpairs ? flag
ccstate tst.w   ustate([bp],[up].l)
        beq.s   Xqcomp  ? not compiling
        rts

Xqpairs moveq   #$13,d0
        cmp.w   ([sp])+,([sp])+
        bra.s   Xqerr

Xqcsp   moveq   #$14,d0
        move.l  [sp],d1
        sub.l   [bp],d1
        cmp.L   ucsp-2([bp],[up].l),d1
        bra.s   Xqerr

Xqldng moveq #$16,d0
        tst.w   ublk([bp],[up].l)
        bra.s   eqXerr

Xqstack moveq   #1,d0
        move.l  [bp],d1
        add.l   us0-2([bp],[up].l),d1
        cmp.l   [sp],d1 empty stack
        blt.s   goXqerr ?
        moveq   #7,d0
        moveq   #80,d3  protect pad & pad data
        add.w   d3,d3
        add.l   [bp],d3
        add.l   udp-2([bp],[up].l),d3
        cmp.l   [sp],d3 dictionary ptr
        bcs.s   qst_jnx ?
        bcs.s   qst_rtr probehalber (oben NOP, hier bra)
* check ovf in local dictionary
        move.l  [bp],a1
        add.w   utib([bp],[up].l),a1 a1:=tib@
        cmp.l   a1,d1
        bhi.s   goXqerr ? s0 >= tib nicht local dp
* forth.. dp] .. {sp .. s0] loc .. dp] .. [tib .. rp ..
        cmp.l   a1,d3   here-tib@
        bcc.s   goXqerr ? fehler bei here >= tib
        cmp.l   d3,d1   mit tib > s0
qst_rtr bcc.s   goXqerr ? oke bei here >= s0
qst_jnx jmp ([nx])

* ( a4.l..a0 d4.l..d0 d.call -- a4.l..a0 d4.l..d0 )
Xqcall  movem.l d6/d7/a3/a4/a6,-(a7)
        pea     4([sp])
        pea     qcret(pc)
        move.l  ([sp])+,-(a7)
        movem.l ([sp])+,d0-d4/a0-a4
        move.l  d0,d7   copy for wman subw. draw
        move.l  a3,a5
        rts
qcret   move.l  (a7)+,[sp]
        movem.l d0-d4/a0-a4,([sp])
        movem.l (a7)+,d6/d7/a3/a4/a6
        jmp ([nx])

Cdo1ptype move.w ([sp]),d1
        addq.w  #1,([sp])
        move.b  0([bp],d1.w),-([sp])
        sf      -([sp])
Xpemit  move.w  ([sp])+,d0
        cmp.w   #32,d0
        blt.s   dpeprt  ?
        cmp.w   #127,d0
        bne.s   dpenxt  ?
        blt.s   dpenxt  ?
dpeprt  moveq   #'.',d0
dpenxt  move.w  d0,-([sp])
        lea     dfdemit(pc),[w]
        jmp     dodefer(pc)

Cat     addq.l  #2,[sp]   {31/2} (col row -- f)  gotoxy
        move.l  ([sp])+,d1 col.w
        move.w  d2,-([sp]) restore flag
        move.l  d1,d2
        swap    d2        col.hi row.lo
        bra.s   cpos

* 4th & terminal emulation : { ascii / parms.in / parms.out }
Ctab   ; {18/1} ( col -- f ) goto col on current 'row'
        move.l  ([sp])+,d2 drop flag & fetch parm
        move.w  d2,d1
        swap    d2
        move.w  d2,-([sp]) restore flag
        moveq   #16,d0    sd.pos
        bra.s   curcom

Chome   moveq   #0,d1     {30}
cpos    moveq   #16,d0    sd.pos
        bra.s   ccput

Cpage   moveq   #32,d0    sd.clear {12}
        bra.s   ccput

Ccnl    moveq   #1,d2     nxt row {10}
        moveq   #5,d0     io.sbyte
curcom  add.w   urow([bp],[up].l),d2
        bpl.s   ccput
        clr.w   d2        row not -ve
ccput   move.l  d2,uout([bp],[up].l)
        lsl.w   #3,d0
        or.b    #3,d0     nowait stdout
        pea     ([nx])
        jmp     iocomm(pc)

Ccuru   moveq   #21,d0    sd.prow {11}
        move.l  uout([bp],[up].l),d2 keep col(=out)
        move.w  #-1,d2    decrement row
        bra.s   curcom

Ccurd   moveq   #22,d0    sd.nrow {24}
        moveq   #1,d2
        bra.s   curcom

Ccen    move.w  d1,d0        {14} {15}
        bra.s   curtrap

Xcurr   moveq   #20,d0             {6}
        moveq   #1,d2     nxt col
curtrap lsl.w   #3,d0
        addq.b  #3,d0     no wait stdout
        jmp     iocnext(pc)

CXpos   move.l  d2,-([sp]) {29/0/4} chenq on in-cons
        move.l  d2,-([sp])
        lea     2([sp]),a1         (-- wwd wht col row f)
        sub.l   [bp],a1
        moveq   #11,d0    sd.chenq
        bra.s   curtrap

Xqterminal moveq #$e<<3!0!2,d0  io.cursen nowait stdin
        bsr.s   iocomm          >
        moveq   #0<<3!0!2,d0    io.pend nowait stdin
        bsr.s   iocomm          >
        moveq   #1,d1
        not.l   d3              noerr or err.nc
        bhi.s   Xd1put          ? err.ef
        moveq   #0,d1
Xd1put  move.w  d1,-([sp])
xqtnxt  jmp ([nx])

CXdel   moveq   #0,d2           {127}
        bsr.s   cureocal        > cursen on stdout
        moveq   #127,d1
        addq.w  #1,d3
        bmi.s   delnwd          ? (d2=0 on err.)
        bsr.s   bsncount                ? (d2=0 on err.)
        bsr.s   bsncount        > cursor back
        moveq   #32,d1          blank
delnwd  moveq   #5<<3!0!3,d0    io.sbyte nowait stdout
        bsr.s   iocomm
bscal   moveq   #-1,d2          decrement out
bsncount move.w #19<<3!0!3,d0   sd.pcol
        bra.s   iocount - cursor back

Cbs     pea     bscal(pc)       {9}
cureocal moveq  #$e<<3!0!3,d0   io.cursen nowait stdout
        bra.s   iocomm  -

Xconstype lea   Xtwodp(pc),a0
        bsr.s   tprompt >
        beq.s   iotype  -
Xtypel  moveq   #4!3,d0
        move.w  ([sp])+,d2
        move.l  ([sp])+,a1
        sub.l   [bp],a1
        bra.s   iotypel -
*
Xtype   moveq   #4!3,d0
iotype  move.w  ([sp])+,d2
        move.w  ([sp])+,a1
iotypel ble.s   xqtnxt  ? don't send nothing nor > 32K
        move.w  #255,d3
        cmp.w   d2,d3
        bpl.s   msgtype ?
        pea     ([nx])
        move.w  d2,-(a7)
        move.w  d0,-(sp)
        move.w  d3,d2
        lea     longtpe(pc),[nx]
msgtype or.w    #7<<3,d0
iocnext pea     ([nx])
iocount add.w   d2,uout([bp],[up].l)
        bpl.s   iocomm  ?
        clr.w   uout([bp],[up].l)
iocomm  moveq   #3,d3
        and.b   d0,d3   trap#3 {k}ey {w}ait {c}hannel no.
        lea     stdio-2(pc),a0
        move.b  0(a0,d3.w),d3
        bsr.s   mkchp   >
        bmi.s   mkerr   ?
        move.l  d3,a0   id
        lsr.w   #3,d0   opcode
        subx.w  d3,d3   preset wait or not
        and.w   utimo([bp],[up].l),d3 mask in timeout
        bpl.s   trap3   ?;
        moveq   #-1,d3  ;;
trap3   add.l   [bp],a1
        pea     (a1)
        trap    #3
        move.w  d1,a1
        add.l   (a7)+,a1 err.bp screws a1, this is for 'expect'
        move.l  d0,d3
        beq.s   tp3ret  this for timeout
t3err   move.l  d3,cioerr-Z([bp])
        moveq   #0,d2   2ndary error flag
        not.l   d0      err.nc => 'eq'
tp3ret  rts
mkerr   add.l   [bp],a1
        moveq   #0,d0
        bra.s   t3err

tprompt tst.w   upromptq([bp],[up].l)
        bne.s   tpret       ?
        move.l  a0,(a7)
tpret   clr.w   -([sp])
        jsr     cdashwd(pc) > chg: d0 d1 d3 a0:id a2
        moveq   #2,d0       nowait stdin
        move.w  ([sp])+,d3  generate 'ne'
        bmi.s   tpdft       ?
        subq.w  #1,d3
        bmi.s   tpxit   ?
        moveq   #0,d3       'eq'
tpxit   rts

Xconsemit lea   Xdrop(pc),a0
        bsr.s   tprompt >
        beq.s   ioemit  ?
Xemit   moveq   #4!3,d0 wait stdout
ioemit  move.w  ([sp])+,d1
        or.w    #5<<3,d0 io.sbyte
        moveq   #1,d2
        bra.s   iocnext -

mknix   moveq   #-1,d3
        rts

tpdft   move.l  deftch(pc),a0
        rts

*REIN: d3.b chan# RAUS: d3.l ch-id a0 limit (fr close) a2 ptrch-id
mkchp   move.w  limit+2-Z([bp]),a0
        add.l   [bp],a0
        cmp.b   #15,d3  d3: (#(d3).b channel -- d.id) a2: ptr
        bhi.s   mknix   ?
        move.b  d3,iochn-Z([bp])
        lsl.w   #2,d3
        lea     0(a0,d3.w),a2
        move.l  (a2),d3 'mi' if no channel
        rts

longtpe sub.l   [bp],a1
        move.w  (a7)+,d0
        move.w  (a7)+,d2
        move.l  (a7)+,[nx]
        sub.w   #255,d2
        bvc     iotypel ?
        jmp ([nx])

Xok     lea     dfdprmp-Z([bp]),[w]
        move.w  #'  ',-([sp])
        jsr     Cdefer(pc) >
        moveq   #'',d0
        tst.w   ustate([bp],[up].l)
        seq     d1
        add.b   d1,d0
        move.w  d0,-([sp])
        lea     dfdprmp-Z([bp]),[w]
        jmp     dodefer(pc) -

Cactiv  moveq   #10,d0
        move.w  ([sp])+,d3 wait
        move.w  ([sp])+,d2 prior
        move.l  ([sp])+,d1 job
        bra.s   Xt1t    -

Xcjob   move.w  #1,-([sp]) runaddr datalen codelen owner -- job )&{a2l?}jdt
Xtrap1a move.w  ([sp])+,d0
        movem.l ([sp])+,d1/d2/d3/a1
        movem.l d1/d2/d3/a0/a1,d1lp-Z([bp])
        bra.s   xt11e
Xt12    move.w  ([sp])+,d0      <susjb jinf frjob tra prior alchp
        move.l  ([sp])+,d2      2: d2=:d3
        move.l  d2,d3
        bra.s   xt12e
Xt11    move.w  ([sp])+,d0      <reljb mode baud sclck rechp
xt12e   move.l  ([sp])+,d1      1: d1 a0
        move.l  d1,a0
        movem.l d1-d3/a0,d1lp-Z([bp])
        bra.s   xt11c
Xt10    move.w  ([sp])+,d0      <free rclck
xt11c   clr.l   a2lp-Z([bp])    a1:=0
xt11e   moveq   #-2,d1          <cjob
        and.b   d1,a1wp+3-Z([bp]) a0 always even
        and.b   d1,a2lp+3-Z([bp]) a1 also
        pea     ([nx])
        movem.l d1lp-Z([bp]),d1/d2/d3/a0/a1
Xt1t    trap    #1              <activ
        move.l  (a7)+,[nx]
        move.l  d0,qf.error-Z([bp])
        movem.l d1/d2/d3/a0/a1,d1lq-Z([bp])
        move.l  d1,-([sp])      always
        jmp ([nx])

Xsafesto ;<safe!) last @ pfa lfa fence !
        move.w  ulast([bp],[up].l),-([sp])
        lea     svsto2(pc),[nx] lfa fence !
* NDERT: d0 d1 d2 ([sp]) ERHLT: d3+ fr find etc
Xpfa    move.w  ([sp]),d0
        moveq   #$1f,d1
        and.b   0([bp],d0.w),d1 try fast pfa
        move.w  uwidth([bp],[up].l),d2
        cmp.w   d1,d2
        bmi.s   jpfa    ?
        add.w   d1,d0
        or.b    #1,d0
        tst.b   0([bp],d0.w)
        bpl.s   jpfa    ? must traverse
        addq.w  #5,d0
        move.w  d0,([sp])
        jmp ([nx])

jpfa    move.w  #1,-([sp]) <traditional pfa if word.width=/=name.len
Ctraverse move.w ([sp])+,d1
        bra.s   nfantr  -

Xnfa    subq.w  #5,([sp])
        moveq   #-1,d1
nfantr  move.w  uwidth([bp],[up].l),d2
travloop add.w  d1,([sp])
        move.w  ([sp]),d0
        tst.b   0([bp],d0.w)
        dbmi    d2,travloop ?
        jmp ([nx])

svsto2  move.w  ([sp])+,d0
        subq.w  #4,d0   lfa
        move.w  d0,ufence([bp],[up].l)
        move.w  d0,ofnc-Z([bp])
        and.b   #-2,d0
        ext.l   d0
        move.l  d0,2+ofnc-Z([bp]) dp for cold restart
        move.l  (a7)+,[nx]
        jmp ([nx])

Cfrmt   moveq   #3,d0
        bsr.s   trap2   >
        move.w  d0,-([sp])
        bne.s   fmt_nxt ?
        addq.l  #2,[sp]
        movem.w d0/d1/d2,-([sp])
fmt_nxt jmp ([nx])

Cfdel   moveq   #4,d0
trap2   move.l  [bp],a0
        add.w   ([sp])+,a0
        moveq   #-1,d1
        trap    #2
        move.l  d0,qf.error-Z([bp])
        rts

CXt30   pea     jqerr(pc) <dot30)
        move.w  ([w]),d0wp-Z([bp])
        bra.s   t3cal   -

CXt3    pea     ([nx])    ( --)
t3cal   pea     dt3ntr(pc)
t3ch    pea     chidcal(pc) <CXt3lon
        jmp     cdftcal(pc)

CXt3g   pea     ([sp])  (fn1 fn2 fn3 fn4 fn5 -- fn1 .. fn5) & {ernum}
        movem.l ([sp]),d0-d5/a0/a1
        movem.l d0-d5/a0/a1,-([sp])
        move.l  [sp],d2
        sub.l   [bp],d2
        move.w  d2,a1wp-Z([bp])
        move.w  ([w])+,d0wp-Z([bp])
        bsr.s   t3cal
        move.l  (a7)+,[sp]
        jmp ([nx])

Xdot3e  pea     ([nx])
        move.w  ([w])+,d0wp-Z([bp])
        moveq   #0,d0
        move.l  d0,d2lp-Z([bp])
        move.l  d0,-([sp]) wdw parm-space
        move.l  d0,-([sp])
        jsr     Cspsa1(pc) >
Ct3lon  bsr.s   t3ch
        move.l  ([sp])+,a0
        moveq   #-1,d4
        bra.s   dt3tnt

dt3ntr  move.l  ([sp])+,a0  < t3do
        moveq   #1,d4   set a1-flag
* entry w. flags/d4 'mi' a1.l:={a1.w|a2.w} 'eq' a1.w unsigned 'gt' a1.w signed
dt3tnt  pea     (a6)    save system base
        movem.l d1lp-Z([bp]),d1/d2
        movem.w d0wp-Z([bp]),d0/d3/a1/a2
        bgt.s   dt3sgd  ? 32K signed
        movem.l a1wp-Z([bp]),a1/a2
dt3sgd  add.l   [bp],a1
        add.l   [bp],a2
        trap    #3
        move.l  (a7)+,a6
        move.l  d1,d1lq-Z([bp])
        movem.l a1/a2,a1lq-Z([bp])
        sub.l   [bp],a2
        sub.l   [bp],a1
        movem.w a1/a2,a1wq-Z([bp])
        move.l  d0,qf.error-Z([bp])
        rts

ascih   move.l  (a7)+,[nx] <a>h)
        subq.w  #1,([sp])
        bmi.s   ascihnx
        addq.l  #2,[sp]
ascihnx jmp ([nx])

Cxqdv   move.w  ([w]),[w] fetch vector address
        move.w  ([w]),[w] qdos-vector
        bsr.s   cpad(pc)
        move.w  ([sp])+,a1
        move.l  ([sp])+,d1
        jsr     ([w])
        addq.l  #2,a1
        move.w  a1,-([sp])
        move.w  -2([bp],a1.l),-([sp])
        move.l  a1,d0
        sub.l   [bp],d0 for l<i
        jmp ([nx])

*fr <# #s SIGN #> von shpsnum
shpsign lea     shpgnum(pc),[nx] => #>
Xsign   move.l  ([sp])+,d1  sign
        move.w  ([sp])+,d0
        move.l  d1,-([sp])
        tst.w   d0
        bpl.s   signnx  ?
        moveq   #'-',d1
        bra.s   hldsign -

Xsq     move.w  ubase([bp],[up].l),-([sp])  #q
        clr.w   -([sp])
        jsr     CXuqmbym(pc) >
        movem.l ([sp])+,d0/d1/d2
        move.l  d1,-([sp])
        move.l  d0,-([sp])
        move.w  d2,-([sp])
        tst.b   ubase+1([bp],[up].l)
        bmi.s   Xhold   ?
        bsr     hascint >
Xhold   move.w  ([sp])+,d1 hold
hldsign move.L  uhld-2([bp],[up].l),d0
        subq.l  #1,d0
        move.L  d0,uhld-2([bp],[up].l)
        move.b  d1,0([bp],d0.l)
signnx  jmp ([nx])

CXqhld  moveq   #-1,d1  hld?
        moveq   #0,d0
Cqhld   move.l  uhld-2([bp],[up].l),d3
        sub.l   udp-2([bp],[up].l),d3
        subq.l  #3,d3
        bpl.s   hldpsh  ?
        moveq   #-4,d0  protect dictionary space
        move.w  d0,vftherr-Z([bp])
hldpsh  tst.w   d1
        bpl.s   hldrrt
        move.w  d0,-([sp])
hldrrt  move.l  d3,d0   l<i
        rts

Cpad    moveq   #80,d0
        add.L   udp-2([bp],[up].l),d0
        and.b   #-2,d0
        move.l  d0,d1
        move.w  d0,-([sp])
        rts

Xbddot  move.w  ([sp])+,d2      (d#)
        move.l  ([sp])+,d1
        moveq   #0,d0
        tst.w   d2
        beq.s   bdduns  ? unsigned
        move.l  d1,d0
        bpl.s   bddpve  ? +ve
        neg.l   d1
bddpve  swap    d0
bdduns  move.w  d0,-([sp])
        move.l  d1,-([sp])
        pea     ([nx])          <# #s sign #>
        lea     shpsnum(pc),[nx]
Clsharp bsr.s   cpad            <#
        addq.l  #2,[sp]         pad hld !
        moveM.l d0/D1,uhld-2([bp],[up].l)
        clr.w   vftherr-Z([bp]) 0 to 4th-err
        jmp ([nx])

shpgnum move.l  (a7)+,[nx]      von shpsign
Csharpgt addq.l #2,[sp] #>
        moveM.l  uhld-2([bp],[up].l),d0/D1
        move.w  d0,([sp])       hld @
        sub.l   d0,d1           over-
        move.w  d1,-([sp])
        jmp ([nx])

Chasci  move.w  ([sp]),d2 h>a
        bra.s   hascint

* <# #S sign #>
shpsnum lea     shpsign(pc),[nx] nach Xdsnum
Xsharps moveq   #0,d1   (test)  #s
        bsr.s   Cqhld   >to protect dictionary space
        move.l  d3,d0
        bmi.s   shpserr ? no space left
        pea     ([nx])
        lea     shplop(pc),[nx]
nxshps  bra.s   Xsharp
shplop  tst.l   ([sp])
        dbeq    d3,nxshps
        move.w  d3,d0   for l<i
        move.l  (a7)+,[nx]
        jmp ([nx])
shpserr move.l  d1,([sp]) give up
        jmp ([nx])

Xsharp  pea     Xhold(pc) (must preserve D3)
        move.w  ubase([bp],[up].l),d0
        bsr.s   mbymntr
        move.l  ([sp]),2([sp])
hascint cmp.w   #9,d2
        ble.s   shpasci
        addq.w  #7,d2
shpasci add.b   #'0',d2
        move.w  d2,([sp])
        rts

* signed ovf rmd & dqot check ( dn.dvd - n.rmd dn.ovf )
bynulov moveq   #1,d0  * 0/0=:1 +ve/0 =:+7fff.ffff * -ve/0=:-7fff.ffff
dmmulov moveq   #0,d1  *<Cdmul/Csmul> rmd and ovf to wordlength
        move.l  ([sp])+,d2  ( dn -- n.ov dn.ov )
        beq.s   bynulpsh    ?
        add.l   d2,d2       sign
        subx.l  d1,d1
        add.l   d1,d1       0 +ve     -2 -ve
        moveq   #-2,d0
        ror.l   #1,d0       7fffffff
        sub.l   d1,d0                80000001
        neg.w   d1          0           2
        add.w   #$7fff,d1   7fff     8001
bynulpsh move.w d1,-([sp])  rmd 0 or +/-7fff
        move.l  d0,-([sp])  qot 1. or +/-7fff.ffff
        rts

Cmbymod move.w  ([sp])+,d0 dvs (m/mod)
mbymntr beq.s   bynulov    ?
        moveq   #0,d1      unsigned
        move.w  ([sp])+,d1 dvd.hi
        divu    d0,d1      q.hi=d1:={rmd.hi|qot.hi}=d.hi/dvs
        move.l  d1,d2      r.hi
        move.w  ([sp])+,d2 dvd.lo
        divu    d0,d2      d.lo  d2:={r.lo|q.lo}={r.hi|d.lo}/dvs
jsdup   swap    d2
        move.l  d2,-([sp]) put r.lo & q.lo
Xd1ret  move.w  d1,-([sp]) q.hi
        rts

Csdup   move.l  ([sp])+,d2
        move.w  d2,d1
        bra.s   jsdup

Xdby    move.l  ([sp])+,d1 (dn1 dn2 -- d3q
        moveq   #0,d2
        move.l  ([sp])+,d3
        bpl.s   dbycal
        moveq   #-1,d2
dbycal  movem.l d1-d3,-([sp])
        bsr.s   CXqmbym >
        addq.l  #4,[sp] drop qot.hi
        move.l  ([sp])+,([sp]) & rmd
        jmp ([nx])

* signed quad by signed double to signed quad rmd & signed double qot
CXqmbym move.w  ([sp]),d1 sgn(dvs) : qm/mod
        bpl.s   uqbrpve
        neg.l   ([sp])
uqbrpve lea     4([sp]),[w]
        move.l  ([w])+,d0 qot
        bpl.s   uqbdpve ?
        neg.l   ([w])
        negx.l  -([w])
uqbdpve add.l   d0,d0   dvd
        subx.l  d0,d0
        add.w   d1,d1   dvs
        subx.l  d1,d1   -ve => -1
        clr.w   d0
        move.w  d0,vftherr-Z([bp])
        eor.l   d1,d0   hi.w:sgn(qot) lo.w:sgn(dvs)=:sgn(rmd)
        move.l  d0,-(a7) save sign flags
        bsr.s   CXuqmbym >d0:dvd d3:r d1:q.h d2:q.l d4.hi -ve ovf
* +/+ q+ r+ : +/- q1- rf- :: -/- q+ r- :: -/+ q1- rf+
* floor and -ve quot if -ve (dvs eor dvd) * -ve rmd if -ve dvd
        tst.l   d4
        bpl.s   uqbnov  ? ovf
        move.w  #-18,vftherr-Z([bp])
uqbnov  moveq   #0,d5
        move.l  ([rp])+,d4
        bpl.s   uqbpqt  ? +qot
        neg.l   d2
        negx.l  d1
        tst.l   d3
        beq.s   uqbprm  ? rmd 0
        subq.l  #1,d2
        subx.l  d5,d1
        sub.l   d3,d0
        move.l  d0,d3   floor rmd
uqbpqt  tst.w   d4      sgn(rmd)
        bpl.s   uqbprm  ? +ve
        neg.l   d3
uqbprm  movem.l d1-d3,([sp])
        rts

Xdbym   move.l  ([sp])+,d0
        clr.l   -([sp])         ud/mod (ud1 ud2 -- ud3r ud4q
        move.l  d0,-([sp])
Xudmbym pea     Xtwodp-Z([bp])  uq/mod (+qn1 dn2 -- d3r q4q
; uqm/mod (+qn1 udn2 -- d3r q4q
CXuqmbym movem.l d5-d7,-(a7)
        moveq   #-1,d1     rmd on ovf
        movem.l ([sp])+,d0/d3/d6 dvs dvd.h dvd.l
        tst.l   d3
        bmi.s   uqbymrs    ?dvd signbit set
        moveq   #32,d7
        moveq   #63,d4
uqbymnm cmp.l   d3,d0
        bhi.s   uqbymrg    ? oke
        add.l   d0,d0      dvs 2*
        bvc.s   uqbnxnm    ?
        bcc.s   uqbnxnm    ?
        roxr.l  #1,d0      rst dvd
        lsr.l   #1,d3
        roxr.l  #1,d6
        add.w   d7,d7
uqbnxnm dbeq    d7,uqbymnm ? normalize dvs > dvd.h
        bra.s   uqbymrs    ? ovf
uqbymrg sub.w   d7,d4
        moveq   #0,d2      qot.l clear
        moveq   #0,d1      qot.h
uqbymlp add.l   d2,d2      qot.l 2*
        addx.l  d1,d1      qot.h
        add.l   d6,d6      dvd.l 2*
        addx.l  d3,d3      dvd.h 2* + Cy
        bcc.s   uqbymhi    ? nxt digit
        roxr.l  #1,d3      restore dvd
        roxr.l  #1,d6
        lsr.l   #1,d1
        roxr.l  #1,d2      and qot
uqbymhi move.l  d3,d5      try dvd.h
        sub.l   d0,d5      dvd.h:=dvd.h-dvs
        bcs.s   uqbymcy    ? ovf
        move.l  d5,d3      updt dvd.h
        moveq   #0,d5
        addq.l  #1,d2      qot.l count
        addx.l  d5,d1      qot.h
uqbymcy dbra    d4,uqbymlp ?
        moveq   #32,d4
        sub.w   d7,d4
        bpl.s   uqbqnrm    ?
        neg.l   d4         normalize back & set hi.w flag
        lsl.l   d4,d3
        clr.w   d4
uqbqnrm lsr.l   d4,d3      adjust rmd
uqbymrs movem.l d1-d3,-([sp]) qh ql rm
        movem.l (a7)+,d5-d7
        rts

* compiling w. odd ptrs

Xcpl    bsr     ccstate  > compile
Xdcpl   tst.w   ustate([bp],[up].l) -compile
        beq.s   comjnx  ?
        move.w  ([ip])+,-([sp])
        bra.s   Xmcomma -

Cdcomma lea     rdcomma(pc),[nx]
        bra.s   Xcomma
rdcomma move.l  (a7)+,[nx]
        bra.s   Xcomma

Xhcomma addq.l  #2,ucsp-2([bp],[up].l)
        bra.s   Xmcomma -

Xzcom   move.w  #2,-([sp])
Xcfacom subq.w  #2,([sp])        \(must be kept together!)
Xmcomma addq.w  #1,cmc+2-Z([bp]) /inc commands counter
Xcomma  move.L  udp-2([bp],[up].l),d0 here
        move.l  d0,[w]          (may be odd!)
        addq.L  #2,d0                 2
        move.L  d0,udp-2([bp],[up].l) allot
        add.l   [bp],[w]
        move.b  ([sp])+,([w])+
        move.b  ([sp])+,([w])+
        tst.w   co+2-Z([bp])
        bne.s   comjnx  ? opt on
        clr.w   cmc+2-Z([bp])  off
comjnx  jmp ([nx])

Xccomma move.L  udp-2([bp],[up].l),d0 here
        addq.L  #1,d0
        move.L  d0,udp-2([bp],[up].l) allot
        move.w  ([sp])+,d1
        move.b  d1,-1([bp],d0.L)
        jmp ([nx])

* kanle

Xio     move.b  iochn-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

Xsc     move.b  dr0ch-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

Xfy     move.b  dr1ch-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

Xic     move.b  stdio-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

Xoc     move.b  stdout-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

cdftcal move.b  usriow-Z([bp]),-([sp])
        sf      -([sp])
        rts

Xprt    move.b  usriup-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

* store/fetch/plusstore w. odd stackptr

Xands   move.w  ([sp])+,a0
        add.l   [bp],a0
        move.b  ([sp])+,d3
        and.b   d3,(a0)+
        move.b  ([sp])+,d3
        and.b   d3,(a0)+
        jmp ([nx])

Xors    move.w  ([sp])+,a0
        add.l   [bp],a0
        move.b  ([sp])+,d3
        or.b    d3,(a0)+
        move.b  ([sp])+,d3
        or.b    d3,(a0)+
        jmp ([nx])

Xxors   move.w  ([sp])+,a0
        add.l   [bp],a0
        move.b  ([sp])+,d3
        eor.b   d3,(a0)+
        move.b  ([sp])+,d3
        eor.b   d3,(a0)+
        jmp ([nx])

Xcountw move.w  ([sp]),-([sp])  count-w
        addq.w  #2,2([sp])
Xfetch  lea     2([bp]),[w]     @
        add.w   ([sp])+,[w]
        subq.w  #1,d1
        move.b  -([w]),-([sp])
        move.b  -([w]),-([sp])
        jmp ([nx])

pdcount move.l  (a7)+,[nx]
        bne.s   ccjnx
        addq.l  #2,[sp]
Xcount  move.w  ([sp]),-([sp])  count
        addq.w  #1,2([sp])
Xcfetch move.w  ([sp])+,[w]     c@
        move.b  0([bp],[w].w),-([sp])
        sf      -([sp])
ccjnx   jmp ([nx])

Cdcount lea     pdcount(pc),[nx] -count
        bra.s   Xcount

Xcountl move.l  ([sp]),-([sp])  count-l
        addq.l  #1,4([sp])
Xcfetchl move.l ([sp])+,[w]     c@l
        move.b  ([w]),-([sp])
        sf     -([sp])
        jmp ([nx])

Xfsl    moveq   #5,d1           !l (fp)
        bra.s   stlntr  -
X4stol  moveq   #7,d1           4!l
        bra.s   stlntr  -
X2stol  moveq   #3,d1           2!l
        bra.s   stlntr  -
Xstorel moveq   #1,d1           !l
stlntr  move.l  ([sp])+,[w]
        bra.s   stolop  -
Xfstore moveq   #5,d1           ! (fp)
        bra.s   stontr  -
Xfours  moveq   #7,d1           4!
        bra.s   stontr  -
Xtwosto moveq   #3,d1           2!
stontr  move.w  ([sp])+,[w]
        add.l   [bp],[w]
stolop  move.b  ([sp])+,([w])+
        dbra    d1,stolop
        jmp ([nx])

Xstore  move.w  ([sp])+,[w]     !
        add.l   [bp],[w]
        move.b  ([sp])+,([w])+
        move.b  ([sp])+,([w])+
        jmp ([nx])

Xffl    moveq   #6,d1           @l (fp)
        bra.s   ftlntr  -
X4fl    moveq   #8,d1           4@l
        bra.s   ftlntr  -
X2fl    moveq   #4,d1           2@l
        bra.s   ftlntr  -
Xfetchl moveq   #2,d1           @l
ftlntr  move.l  ([sp])+,[w]
        bra.s   ftcnty  -
Xffetch moveq   #6,d1           @ (fp)
        bra.s   ftcntr  -
Xfourf  moveq   #8,d1           4@
        bra.s   ftcntr  -
Xtwof   moveq   #4,d1           2@
ftcntr  move.w  ([sp])+,[w]
        add.l   [bp],[w]
ftcnty  add.w   d1,[w]
        subq.w  #1,d1
ftclop  move.b  -([w]),-([sp])
        dbra    d1,ftclop
        jmp ([nx])

Xswapb  move.b  ([sp])+,d3
        move.b  ([sp]),-([sp])
        move.b  d3,1([sp])
        jmp ([nx])

TSTJBOT ; begin of area watched by secondary job
* where up/ip/sp/bp/rp must be even and within bounds, nx any address
*       d7 a4 a5 a6 a7

Xcsto   move.w  ([sp])+,[w]     c!
        add.l   [bp],[w]
        move.w  ([sp])+,d3
        move.b  d3,([w])+
        jmp ([nx])

Xdoff   move.w  ([sp])+,[w]     -off
        add.l   [bp],[w]
        move.b  #$80,([w])+
        sf      ([w])+
        jmp ([nx])

X2off   moveq   #2,d1           2off
        moveq   #0,d0
        bra.s   ofntr   -
Xoff    moveq   #0,d0           off
        bra.s   of1nt   -
Xon     moveq   #1,d0           on
of1nt   moveq   #0,d1
ofntr   move.l  [bp],[w]
        add.w   ([sp])+,[w]
        sf      ([w])+
offlop  move.b  d0,([w])+
        dbra    d1,offlop ?
        jmp ([nx])

Xpstol  moveq   #2,d1           +!l
        bra.s   pslntr  -
Xbpsto  moveq   #2,d1           +!
        bra.s   pswntr  -
X4pstol moveq   #8,d1           4+!l
        bra.s   pslntr  -
X4psto  moveq   #8,d1           4+!
        bra.s   pswntr  -
Xtwopstol moveq #4,d1           2+!l
pslntr  move.l ([sp])+,[w]
        bra.s   pstontr -
Xmpsto  move.l  ([sp])+,d1       m+!
        move.w  d1,-([sp])
        add.w   d1,d1
        subx.w  d1,d1
        move.l  d1,-([sp])
Xtwopsto moveq  #4,d1           2+!
pswntr  move.l  [bp],[w]
        add.w   ([sp])+,[w]
pstontr add.l   d1,[w]
        move.l  [sp],a0
        add.l   d1,a0
        move.w  d1,d0
        subq.w  #1,d0
pstlop  addx.b  -(a0),-([w])
        dbra    d0,pstlop
        subx.l  d0,d0   l<i
        add.l   d1,[sp]
        jmp ([nx])

Xqssto  moveq   #7,d3          4@!
        bra.s   sstntr  -
Xffs    moveq   #5,d3           @! (fp)
        bra.s   sstntr  -
Xdssto  moveq   #3,d3          2@!
        bra.s   sstntr  -
Xssto   moveq   #1,d3           @!
sstntr  move.w  ([sp])+,d1
        lea     0([bp],d1.w),a1
        move.w  ([sp])+,d1
        lea     0([bp],d1.w),a0
sstlop  move.b  (a0)+,(a1)+
        dbra    d3,sstlop
        jmp ([nx])
* ++++
* Cplusbuf Cblockq
*store system state left by empty
Xemptys move.w  ulast([bp],[up].l),d0   last @ dup
        move.w  d0,olast-Z([bp])        $c +origin !
        move.w  d0,-([sp])
        lea     Xpfa(pc),[w]
        jsr     Cprim(pc) >             pfa
        move.w  ([sp])+,d0
        subq.w  #4,d0                   lfa dup
        move.w  d0,ofnc-Z([bp])         $22 +origin !
        move.w  d0,ufence([bp],[up].l)  fence !
        move.l  udp-2([bp],[up].l),odp-Z([bp]) dp 2- 2@ $24 +origin 2!
        move.w  uvocdashlk([bp],[up].l),ovocl-Z([bp])
        move.w  ([rp])+,[ip]            voc-link @ $28 +origin ! ;s
        add.l   [bp],[ip] semis
        jmp ([nx])

Xascih  lea     ascih(pc),[nx] a>h
        move.w  #16,-([sp])
Xdigit  move.w  ([sp])+,d1 base
        moveq   #-'0',d0
        add.w   ([sp]),d0
        bmi.s   dig_fls ? sicher keine ziffer
        cmp.b   #9,d0   obergrenze bei ziffernzeichen
        ble.s   dig_chr ? fertig
        and.b   #-33,d0 auch kleine buchstaben gelten
        subq.b  #7,d0   ascii-sprung ausgleichen
        cmp.b   #9,d0
        ble.s   dig_fls ? chr in der lcke
dig_chr cmp.w   d1,d0
        bpl.s   dig_fls ? ziffer auerhalb des wertebereiches
        move.w  d0,([sp])
        move.w  #1,-([sp]) flag 'ne' erzeugen
        jmp ([nx])
dig_fls clr.w   ([sp])  'eq' fr milungene wandlung
        jmp ([nx])

qmpnul  addq.l  #8,[sp]    <qn*0)
qmlnul  move.l  d0,-([sp]) <0*nn)
        move.l  d0,-([sp])
        rts
qmlneg  neg.l   d1         <qn*-1)
        negx.l  d2
        subx.l  d0,d0
        move.l  d1,-([sp])
        move.l  d2,-([sp])
qmret   rts                <qn*1)
* mul quad by single
Cqmul   moveq   #0,d0
        move.w  ([sp])+,d3 mt
        beq.s   qmpnul  ? null
        cmp.w   #1,d3
        beq.s   qmret   ? mul by 1
        move.l  ([sp])+,d2 mt hi..
        move.l  ([sp])+,d1 lo quad
        move.l  d1,d0
        or.l    d2,d0
        beq.s   qmlnul  ? null
        cmp.w   #-1,d3
        beq.s   qmlneg  ? negate
        move.w  d1,d4      md.ll
        mulu    d3,d4      d4:  => p.ll
        swap    d1         md.lh
        mulu    d3,d1      d1:  => p.lh
        move.w  d2,d5      md.hl
        mulu    d3,d5      d5:  => p.hl
        swap    d2
        mulu    d3,d2      d2:  => p.hh => num{d2|d5|d1|d4}lo
        move.w  d4,-([sp])
        clr.w   d4
        swap    d4      p.ll
        add.l   d4,d1
        moveq   #0,d3
        addx.l  d3,d3
        add.l   d3,d5      Cy.l
        moveq   #0,d3
        addx.l  d3,d3
        add.l   d3,d2      Cy.h
        move.w  d1,-([sp]) p.lh
        clr.w   d1
        swap    d1
        add.l   d1,d5
        moveq   #0,d3
        addx.l  d3,d3
        add.l   d3,d2
        move.w  d5,-([sp])
        clr.w   d5
        swap    d5
        add.l   d5,d2
        subx.l  d0,d0   Cy flag l<i.hi
        move.w  d2,-([sp]) hi
        swap    d2
        move.w  d2,d0   ovf with l<i.lo
        rts

* quad d0=base d1=digit d2=dpl d4=accu.hi d5:xx a0=addr
Jqn     movem.l d0-d3,-(a7)
        move.w  d0,-([sp])  base
        bsr     Cqmul       > accu*base
        movem.l (a7)+,d0-d3
        movem.l ([sp]),d4/d5
        add.l   d1,d5   accu
        subx.l  d1,d1
        sub.l   d1,d4
        movem.l d4/d5,([sp])
        addq.w  #1,d2   'gt'
        bra.s   pnqnxd  -

; dn1 ptr1 -- dn2 ptr2 ; f.i.g. convert
Cpnumberq move.w ([sp])+,a0
        lea     1([bp],a0.w),a0 ptr to count.b
        move.l  ([sp]),d4 accu (quad  hi)
        move.w  ubase([bp],[up].l),d0
        moveq   #0,d1
        move.w  udpl([bp],[up].l),d2
        moveq   #9,d3
pnqnxd  bgt.s   pnqsng  ? double
        subq.w  #1,d2
pnqsng  move.w  #$0d0,d1 -'0'
        add.b   (a0)+,d1
        bmi.s   pnqrdy  ? ready not a digit
        cmp.b   d3,d1
        ble.s   pnqnum  ? test digit
        and.b   #-33,d1
        subq.b  #7,d1
        cmp.b   d3,d1
        ble.s   pnqrdy  ? ascii gap not a digit
pnqnum  cmp.b   d0,d1
        bpl.s   pnqrdy  ? hi ovf not a digit
        tst.b   1+quadf-Z([bp])
        bgt     Jqn     ? quad : a0:=addr
        move.l  d4,d5   accu
        swap    d5      hi.w
        mulu    d0,d5   hi.prd
        swap    d5
        clr.w   d5
        mulu    d0,d4   lo.prd
        add.l   d5,d4
        add.l   d1,d4   accumulate digit
        addq.w  #1,d2   'gt'
        bra.s   pnqnxd  -
pnqrdy  move.l  d4,([sp])  accu
        move.w  d2,udpl([bp],[up].l)
        subq.l  #1,a0
        sub.l   [bp],a0
        move.w  a0,-([sp]) ptr
        rts

Xinumq  lea     6([bp]),a0      <inum
        add.w   ucontext([bp],[up].l),a0
        move.w  (a0),-([rp])
        move.l  a0,-([rp])
        clr.w   (a0)       suppress fp conversion
        move.w  udp([bp],[up].l),-([sp])
        lea     dn-Z([bp]),[w]
        jsr     Cdefer(pc) >
        move.l  ([rp])+,a0
        move.w  ([rp])+,(a0)
        jmp     ([nx])

; ptr -- dn|fp ff | -- tf )
Cbnumq  bsr     Cascibase     >>        { char|num flag base
        move.w  ([sp])+,-([rp]) >r      push systembase
        moveq   #0,d0           ok flag
        tst.w   ([sp])+         flg
        bmi.s   m13zn           ? 0<bra    { char code
        tst.w   ([sp])+
        bne.s   m13xn           ? -branch  { integer
        moveq   #1,d1           stg.typ count.b
        bsr     Cjcndtof        > $>f
        move.w  cfperr-Z([bp]),d0 fperr
        beq.s   m13zn           0branch    { success
        clr.w   cfperr-Z([bp])
        bra.s   m13yn           branch     { no number
m13xn   move.w  ([sp])+,d1                 ptr{
        clr.l   -([sp])                    {accu
        sub.w   quadf-Z([bp]),[sp]         {quad
        clr.l   ([sp])
        moveq   #'-',d0
        sub.b   1([bp],d1.w),d0 dup 1+ c@ "-"
        move.w  d0,-([rp])      = >rr   {=/= >rr}
        bne.s   bnbpve          ? +ve
        addq.w  #1,d1           add flag{1+}
bnbpve  moveq   #-1,d0          -1 initial dpl
        move.w  d1,-([sp])              {accu ptr
m13n    move.w  d0,udpl([bp],[up].l) dpl !
        bsr     Cpnumberq       > convert
        moveq   #0,d0           ok-flag & initial dpl if double
        move.w  ([sp]),d2       dup     {accu ptr
        moveq   #' ',d1
        sub.b   0([bp],d2.w),d1 c@ bl -
        beq.s   m14n            0branch { ? ready
        add.b   #14,d1                  { "." }
        beq.s   m13n           = 0branch to fetch double
        subq.b  #2,d1                   { "," }
        beq.s   m13n           = 0branch to fetch double
        addq.l  #2,[rp]         rdrop   { drop signflag
        addq.l  #6,[sp]         fdrop   { drop d.accu & ptr
        add.w   quadf-Z([bp]),[sp]
m13yn   moveq   #1,d0           1       { error
m13zn   move.w  d0,-([sp])              {accu ff | tf
        tst.b   1+quadf-Z([bp])
        ble.s   m13nq           ? no quad
        st      udpl([bp],[up].l) dpl for quad
        and.b   #127,1+udpl([bp],[up].l)
m13nq   move.w  ([rp])+,ubase([bp],[up].l) r> base!
        rts
m14n    move.w  ([rp])+,([sp])+ drop r> {accu
        bne.s   m13zn           0branch { -branch }
        add.w   d0,d0           clear X-flag
        tst.b   1+quadf-Z([bp])
        ble.s   m14sn           ? standard
        neg.l   4([sp])         quad
m14sn   negx.l  ([sp])          minus
        bra.s   m13zn

baseasci dc.b '{''"!%#&\$'
basecode dc.b 255,12,5,6,4,2,10,8,0,16
 ds.w 0 ; ( ptr -- char/num-flg flag(-ve:char) base
Cascibase lea   1([bp]),[w]
        add.w   ([sp]),[w]
        move.b  ([w])+,d2       1st char
        move.w  ubase([bp],[up].l),d1 preset to current base
        cmp.w   #2,d1
        bpl.s   asbsval         ? 1 < base < 129
        moveq   #10,d1          decimal
asbsval move.w  d1,d0
        moveq   #basecode-baseasci-1,d3
asbscmp cmp.b   baseasci(pc,d3.w),d2
        dbeq    d3,asbscmp
        beq.s   asbsbset        ? base char found
        move.w  ucontext([bp],[up].l),d2
        tst.b   7([bp],d2.w)
        beq.s   asbsnfp         ? not fp compiling
        moveq   #0,d1
        bra.s   asbsnfp         fp-number
asbsbset move.b basecode(pc,d3.w),d1 base
        bmi.s   asbchr          ? fetch char
        addq.w  #1,([sp])       drop base-char
        move.w  d1,ubase([bp],[up].l) temp. base (coded)
        bne.s   asbsnfp         ?
        move.b  -2([w]),-([w])  prepare fp conversion
asbsnfp move.w  d1,d2           fp-flag
asbcret movem.w d0-d2,-([sp])   or ascii-char, ascii-flag, old base
        rts
asbchr  moveq   #-1,d1          ascii-flag -ve
        move.w  d1,udpl([bp],[up].l) sing
        moveq   #0,d2
        move.b  ([w])+,d2       char
        cmp.b   #3,-3([w])
        bne.s   asb1chr         ?
        lsl.w   #8,d2
        move.b  ([w])+,d2
asb1chr move.w  d2,([sp])
        bra.s   asbcret

Xskip ;(ad n chr -- ad+ n+)  fnd 1st char =/= chr, skip ctrl.chars
        move.w  ([sp])+,d2      char
        moveq   #0,d1
        move.w  ([sp])+,d1      count
        lea     -1([bp]),a0
        add.w   ([sp])+,a0      ad1
skp_rtr subq.w  #1,d1
        addq.l  #1,a0
        bmi.s   skp_nde         ? alle
skp_lop cmp.b   (a0)+,d2
        dbne    d1,skp_lop      ready if =/=
        cmp.b   #' ',-(a0)
        bcs.s   skp_rtr         ? ignore ctrl.chars
skp_nde sub.l   [bp],a0
        move.w  a0,-([sp])
        addq.w  #1,d1
        move.w  d1,-([sp])      remaining char count
        jmp ([nx])

Xscan ;(ptr1 count char -- ptr2 disp) fnd 1st char = c
        move.w  ([sp])+,d2      char
        moveq   #0,d1
        move.w  ([sp])+,d1      cnt1
        ble.s   scn_xit         ?
        subq.w  #1,d1
        move.l  [bp],a0
        add.w   ([sp])+,a0      adr1
scn_lop cmp.b   (a0)+,d2        count & compare chars
        dbeq    d1,scn_lop      until match
        addq.w  #1,d1
        bgt.s   scn_fnd         ? found
        addq.l  #1,a0           else compensate
scn_fnd subq.l  #1,a0           dbra count compensation
        sub.l   [bp],a0
        move.w  a0,-([sp])
scn_xit move.w  d1,-([sp])
        jmp ([nx])

Xpbufq  move.w  vuse-Z([bp]),d4 use @
        move.w  d4,-([rp])      >r
        move.w  d4,-([sp])      r
m31b    bsr.s   Cplusbuf        +buf
        tst.w   ([sp])+
        beq.s   m31b            0branch
        move.w  ([sp])+,vuse-Z([bp])    use !
        move.w  0([bp],d4.w),d0 r @
        bpl.s   m32b            0< 0branch
        move.w  d4,-([sp])      r
        addq.w  #2,([sp])       2+
        and.w   #$7fff,d0
        move.w  d0,-([sp])      r @ $7fff and
        clr.w   -([sp])         0
        lea     Xrbyw(pc),[w]   r/w
        jsr     Cprim(pc)      >>
m32b    move.w  ([rp])+,d4      r (=: r> )
        move.w  ([sp])+,0([bp],d4.w)    !
        move.w  d4,vprev-Z([bp])        r prev !
        addq.w  #2,d4
        move.w  d4,-([sp])      r> 2+
        jmp ([nx])

Cplusbuf moveq   #4,d0          +buf
        add.w   cbbybuf-Z([bp]),d0
        add.w   ([sp])+,d0
        cmp.w   climit-Z([bp]),d0
        bne.s   M30
        move.w  cfirst-Z([bp]),d0
M30     move.w  d0,-([sp])      buf
        sub.w   vprev-Z([bp]),d0 flg
        move.w  d0,-([sp])
        rts

Xpblockq move.w ([sp])+,d4              block no.
        add.w   uoffset([bp],[up].l),d4 offset @ +
        move.w  d4,-([rp])              >r
        move.w  vprev-Z([bp]),d1        prev @
        move.w  d1,-([sp])              dup
        move.w  0([bp],d1.w),d2         @       prev. blk. no.
        sub.w   d4,d2                   r -
        add.w   d2,d2                   dup +   mask off update-bit
        beq.s   m33b                    0branch already the prev block
m34b    bsr.s   Cplusbuf        >       +buf
        tst.w   ([sp])+                 0=      nxt block
        bne.s   m35b                    -branch is not the prev one
        move.w  ([rp]),([sp])           drop r
        lea     dfdbuffer-Z([bp]),[w]   buffer
        jsr     Cdefer(pc)      >>deferred
        move.w  ([sp]),-([sp])          dup
        move.w  ([rp]),-([sp])          r
        move.w  #1,-([sp])              1
        lea     Xrbyw(pc),[w]           r/w
        jsr     Cprim(pc)       >>
        subq.w  #2,([sp])               2-
m35b    move.w  ([sp]),d0               dup
        move.w  0([bp],d0.w),d0         @
        sub.w   ([rp]),d0               r -
        add.w   d0,d0                   dup +
        bne.s   m34b                    -branch
        move.w  ([sp]),vprev-Z([bp])    dup prev !
m33b    addq.l  #2,[rp]                 rdrop
        addq.w  #2,([sp])               2+
        jmp ([nx])

Csource move.w  ublk([bp],[up].l),d1    blk @
        beq.s   srctib                  0branch
        move.w  d1,-([sp])              blk @
        lea     dfdblock-Z([bp]),[w]    block
        jsr     Cdefer(pc)            >>
        move.w  cbbybuf-Z([bp]),-([sp]) b/buf @
        rts
srctib  move.w  utib([bp],[up].l),-([sp]) tib @
        move.w  vtibmax-Z([bp]),-([sp])   tib-max @
        subq.w  #2,([sp])                 2-
        rts

Xcommentb move.w #'))',-([sp])
          bra.s combn   -
Xcomments clr.w -([sp])
combn   pea     Xfdrop(pc)
Cpwordq bsr.s   Csource        >source
        addq.l  #2,[sp]         drop
        move.l  ([sp]),d0
        swap    d0              ptr
        add.w   uin([bp],[up].l),d0 in @ + swap
        move.l  d0,([sp])
        bsr.s   Cenclose       >ptr n1 n2 n3
        move.w  ([sp])+,d0
        add.w   d0,uin([bp],[up].l) in +!
        rts

Cword   bsr.s   Cpwordq        >(word) ptr n1 n2
        move.w  ([sp])+,d0      n2
        move.w  ([sp])+,d1      n1
        sub.w   d1,d0           over-  d0:=n2-n1
        move.L  udp-2([bp],[up].l),d2 here
        lea     0([bp],d2.L),a0
        move.b  d0,(a0)+        c!
        lea     0([bp],d1.w),a1
        add.w   ([sp])+,a1      1st char
        moveq   #' ',d3         blank
        subq.w  #1,d0
        bmi.s   wordmty         ? empty
wordnx  move.b  (a1)+,(a0)+
        dbra    d0,wordnx
wordmty move.b  d3,(a0)+        trailing delimiters
        move.b  d3,(a0)+
        rts

Xblword move.w  #'  ',-([sp])   bl
Xwordh  bsr.s   Cword           word
        move.w  d2,-([sp])      here
        jmp ([nx])

Cenclose move.w ([sp])+,d0 (c1 1st=/=char, n2 nxt chr after n1, n3:=1+n2
        move.w  ([sp]),[w] adr1 remains unchanged
        add.l   [bp],[w]
        move.w  [w],d1
        addq.w  #1,d1  adr+1
        moveq   #32,d3 ;;
        cmp.b   d0,d3
        beq.s   enskip  ?
        moveq   #0,d3  ;
*        subq.l  #1,[w]
*enwip   addq.l  #1,[w]
enskip ; cmp.b   ([w]),d3
       ; bhi.s   enwip
        cmp.b   ([w])+,d0
        beq.s   enskip ?
        move.w  [w],-([sp]) adr2 1st=/=char
        sub.w   d1,([sp]) n1:= disp adr1 to adr2 of 1st char =/= c1
enword  move.b  ([w])+,d2
        beq.s   encend ?
        cmp.b   d3,d2 ;;
        bcs.s   encend ?
        cmp.b   d2,d0
        bne.s   enword ?
encend  move.w  [w],-([sp])
        sub.w   d1,([sp]) n2:=disp to 1st = after 1st =/=
        tst.b   d2
        beq.s   encnul ? leave {x}
        addq.w  #1,[w]
encnul  sub.w   d1,[w] n3:=disp to start nxt
        move.w  [w],-([sp])
        rts

* (simulated unified) call to fs.xinf
Xxinf   bsr     t3ch    > work chan to a0
        move.l  ([sp])+,a0
        move.l  [bp],a1
        add.w   ([sp])+,a1
        move.l  a1,a2
        moveq   #15,d1
        moveq   #-1,d3
xnfclr  move.l  d3,(a2)+
        dbra    d1,xnfclr ?
        lea     2(a1),a2
        moveq   #79,d0
        trap    #3
        move.l  d0,qf.error-Z([bp])
        beq.s   xnfjnx  ? oke
        move.l  a2,a1
        moveq   #69,d0
        trap    #3
        move.l  d0,qf.error-Z([bp])
        bne.s   xnfjnx  ? nix
        move.l  a0,d3
        move.l  a1,a0
        move.l  #'    ',d2
xnfxnm  cmp.b   -(a0),d2
        beq.s   xnfxnm  ?
        addq.w  #1,a0
        sub.w   a2,a0
        move.w  a0,-(a2)
        move.l  d2,(a1)+
        move.l  d2,(a1)+
        move.w  d2,(a1)+
        lsl.w   #2,d3
        move.l  sysvari(pc),a2
        move.l  120(a2),a0
        move.l  0(a0,d3.w),a0 cdt
        moveq   #64,d2
        add.b   29(a0),d2 index to defblock
        lsl.w   #2,d2
        move.l  0(a2,d2.w),a0
        move.b  20(a0),d2 device no.
        move.l  16(a0),a0
        move.w  36(a0),(a1)+ count.w
        move.l  38(a0),(a1)+ devicename
        move.b  d2,(a1)+     & no.
        sf      (a1)+        r/w per definitionem
        move.w  #512,(a1)+   sec.len
        move.w  d0,(a1)+
        move.w  d1,(a1)+     good sec.
        move.w  d0,d1
        swap    d1
        move.l  d1,(a1)+     free
        moveq   #64,d2
        move.l  d2,(a1)+     headerlen
xnfjnx  move.w  d0,-([sp])
        jmp     ([nx])

* -- find --

Ccfind  move.w  #'  ',-([sp]) ( ptr -- ...
        bsr     Cword   >
        move.w  ([sp])+,d0
        move.w  d2,-([sp])
        move.w  0([bp],d0.w),-([sp])
Cpfindq moveq   #0,d0   <)
        moveq   #32,d4
        moveq   #26,d5
        move.w  ([sp])+,[w] top nfa
        moveq   #-1,d1
        move.w  uwidth([bp],[up].l),d3
        subq.w  #1,d3   limit of char count
        swap    d3
        bra.s   findent -
findlk  move.l  d3,d2
        swap    d2
        tst.b   (a0)
        bpl.s   fndfalse ?
        moveq   #31,d0
        and.b   (a0),d0
        beq.s   fndfalse ?
        cmp.w   d0,d2
        bge.s   fndwdt  ? width ok
        move.w  d2,d0
fndwdt  lea     1(a0,d0.w),[w] lfa
findvoc move.l  [w],d1
        ble.s   fndfalse  ? memory corrupt
        lsr.w   #1,d1
        bcs.s   fndfalse  ? no more / address err.
        add.w   d1,d1
        move.w  ([w]),[w] nfa
        cmp.w   [w],d3
        beq.s   fndfalse  ? exit searching loop
findent move.w  [w],d3
        cmp.w   #$8000,d3
        beq.s   fndfalse  ? end/empty
        add.l   [bp],[w]  top.nfa
        move.l  [w],a0
        move.w  ([sp]),a1
        add.l   [bp],a1   strg
        move.b  ([w])+,d0
        cmp.b   #$81,d0
        bne.s   fndtry    ? proceed
        cmp.b   #$a0,([w])
        bne.s   fndtry    ? more in this voc
        tst.w   v2nd+2-Z([bp])
        beq.s   fndfalse  ? no 2nd order vocsearch
        move.w  5([w]),d2 searchvoc-pfa
        lea     4([bp],d2.w),[w] ptr to last word of searchvoc
        cmp.w   #$8000,d2
        bne.s   findvoc   ? nxt voc
fndfalse clr.w  ([sp])
        rts
fndtry  moveq   #$3f,d2   mask off precedence bit
        and.b   d0,d2     smudge & count
        sub.b   (a1)+,d2  len
        bne.s   findlk  ?
findscan moveq  #127,d2
        and.b   ([w]),d2  char
        moveq   #127,d1
        and.b   (a1)+,d1
        eor.b   d2,d1
        beq.s   findchk   ? char =
        cmp.b   d4,d1     u-case
        bne.s   findlk  ? char =/=
        or.b    d1,d2
        sub.b   #'a',d2
        cmp.b   d5,d2
        bcc.s   findlk  ? > 'z'
findchk tst.b   ([w])+
        bpl.s   findscan  ? nxt char
        addq.l  #4,[w]    pfa
        sub.l   [bp],[w]
        move.w  [w],([sp])
        move.w  d0,-([sp])
        move.w  #1,-([sp])
        rts

* aufruf: >rr vqfindq (ohne header) => rdup ...
Xqfindq move.w  ([sp]),-([rp])          rdup
        move.w  ([sp])+,-([rp])         (name) >r
        move.w  nvocs+2-Z([bp]),-([rp])  #vocs >r
        pea     ucontext([bp],[up].l)   context >r
        clr.w   -([sp])                 0
qvf_lop move.l  ([rp]),[w]              context
        move.w  ([w])+,d0               @
        beq.s   qvf_xit                 ? ready
        move.l  [w],([rp])              nxt voc
        tas     6([bp],d0.w)            6+ @
        bne.s   qvf_nxt                 ? already done
        move.w  6([rp]),([sp])          name
        move.w  0([bp],d0.w),-([sp])    context @ @ ..@..
        jsr     Cpfindq(pc)             > (find)
        tst.w   ([sp])                  dup 0bra
        bne.s   qvf_xit                 ? found
qvf_nxt subq.w  #1,4([rp])
        bgt.s   qvf_lop                 +loop
qvf_xit move.w  ([sp]),-([sp])
        bne.s   qvf_ret                 -dup
        addq.l  #2,[sp]
qvf_ret addq.l  #8,[rp]                 rdrop voc.addr, count, name
        jmp ([nx])

*clear vocs' fnd-flags
Xfndclr move.l  [bp],a0
        add.w   uvocdashlk([bp],[up].l),a0
        move.w  #vocnfa,d2
fdclop  move.w  (a0),d0
        beq.s   fdcjnx  ? ready
        cmp.w   -4(a0),d2
        bne.s   fdcjnx  ? error
        sf      4(a0)
        lea     0([bp],d0.w),a0
        ror.b   #1,d0
        bcc.s   fdclop  ? nxt voc.ptr
fdcjnx  jmp ([nx])

* -- local & stack: --

Xspalc  moveq   #0,d3
        move.w  ([sp])+,d0 >loc cells
        bra.s   golntr  -
Xrsvloc move.w  ([ip])+,d0 bytes <ini-loc) lit len entry) flg no stack data
        moveq   #0,d3   flg no stack data
        lsr.w   #1,d0   cells
        bra.s   golntr  -

* init local runtime entry
Xilocal moveq   #0,d0
        moveq   #-128,d3
        move.b  ([ip])+,d0 #locs+1
        move.l  [ip],a2 indices ptr
        and.w   d0,d3   double flag
        eor.b   d3,d0   masked off, leaves no. of items
        moveq   #1,d2
        or.w    d0,d2
        add.w   d2,[ip] ip to continue
        subq.w  #1,d0   single cells
golntr  beq.s   fdcjnx  ? ret - no own locals
        move.w  d0,d2
        tst.w   d3
        beq.s   loclong
        add.w   d0,d0   doubles
loclong move.l  us0-2([bp],[up].l),a1
        move.l  a1,d4   empty stk
        add.l   [bp],d4
        sub.l   [sp],d4
        lsr.w   #1,d4   depth
        add.w   d0,d0   loc bytes
        sub.w   d0,a1   new stk bot
        move.l  a1,us0-2([bp],[up].l)
        move.l  [sp],a1 source stk bot
        sub.w   d0,[sp] new sp
        move.l  [sp],a0 destn
        bra.s   movloc
pshloc  move.w  (a1)+,(a0)+
movloc  dbra    d4,pshloc leaves a0 to store locals
        move.l  [sp],a1 data ptr
        moveq   #0,d1
        subq.w  #1,d2
        bmi.s   ilojnx  ?
        tst.l   d3 ;;
        bpl.s   iloclr ? clear empty space
        tst.w   d3
        bne.s   locdbl - doubles
locput  move.b  (a2)+,d1 index
        move.w  -2(a1,d1.w),(a0)+
        dbra    d2,locput
        add.w   d0,[sp] drop locally stored items
        jmp ([nx])
locdbl  move.b  (a2)+,d1
        add.b   d1,d1
        move.l  -4(a1,d1.w),(a0)+
        dbra    d2,locdbl
        add.w   d0,[sp] drop locally stored items
ilojnx  jmp ([nx])
iloclr  move.w  d3,(a0)+
        dbra    d2,iloclr
        jmp ([nx]) ;;

* cpl prepare local fetch tpe and index
Xclocal move.w  #'  ',-([sp])
        jsr     Cword   >
        lea     0([bp],d2.l),a0
        addq.l  #2,udp-2([bp],[up].l)
        moveq   #63,d0
        and.w   (a0),d0
        add.w   d0,d0
        moveq   #64,d1
        and.b   d0,d1
        eor.b   d1,d0
        add.b   d1,d1
        bmi.s   clsing  ? single
        move.w  #$8000,d1 flag
clsing  move.b  d0,d1
        move.w  d1,(a0)+
        move.w  ([rp])+,[ip] semis
        add.l   [bp],[ip]
        jmp ([nx])

* run fetch loc ptr
Xplocal move.l  us0-2([bp],[up].l),a0
        move.w  ([ip])+,d0
        bpl.s   plosing
        add.w   d0,d0
        subq.w  #2,d0
plosing subq.w  #2,d0
        add.w   d0,a0
        move.l  a0,d0   for l<i
        move.w  d0,-([sp])
        jmp ([nx])

* run fetch loc
Xflocal move.l  [bp],a0
        add.l   us0-2([bp],[up].l),a0
        move.w  ([ip])+,d0
        bmi.s   Xllocal
        move.w  -2(a0,d0.w),-([sp])
        jmp ([nx])
Xllocal add.w   d0,d0
        move.l  -4(a0,d0.w),-([sp])
        jmp ([nx])

* run removing loc
Xsprlc  moveq   #0,d0   loc>
        move.w  ([sp])+,d0
        add.l   d0,d0   cells
        bra.s   rmloc -
Xrlocal moveq   #0,d0
        move.w  ([ip])+,d0 loc bytes
rmloc   move.l  [bp],a0
        lea     us0-2([bp],[up].l),[w]
        add.l   ([w]),a0   loc lo & stk hi
        move.w  utib([bp],[up].l),a1
        add.l   [bp],a1    stk max.bot
        add.l   d0,a0 ;;
        cmp.l   a0,a1
        bcc.s   locmin  ? passt
        sub.l   d0,a0   ;
        move.l  a1,d0   ;move.l  [w],d0
        sub.l   a0,d0
        add.l   d0,a0   ;
locmin  add.l   d0,([w]) restore s0
        move.l  a0,a1
        sub.l   d0,a0   ;add.l   d0,a1
        move.l  a0,d1
        sub.l   [sp],d1
        Asr.L   #1,d1   stk.posten
        subq.L  #1,d1
        bmi.s   locrer  ? leer oder fehler
locrmv  move.w  -(a0),-(a1)
        dbra    d1,locrmv
locrer  move.l  a1,[sp] new tos
        jmp ([nx])

* cpl end of local area ( initptr 9 pfa -- local cpl | abort
Xelocal move.l  [sp],d0
        sub.l   [bp],d0
        cmp.l   ucsp-2([bp],[up].l),d0
        beq.s   elocnxt ? stack clear
        moveq   #19,d0
        cmp.w   #9,([sp])+
        bne     goXqerr ? out of balance
        move.l  [bp],a0
        add.w   ([sp])+,a0
        move.b  (a0),d0 cell items
        subq.b  #1,d0
        bpl.s   elosing ?
        add.b   d0,d0   doubles
elosing beq.s   elocnxt ? none
        move.l  [bp],a0
        lea     udp-2([bp],[up].l),a1
        add.l   (a1),a0
        addq.l  #4,(a1)
        move.w  #rlocal-Z,(a0)+
        add.w   d0,d0   bytes
        move.w  d0,(a0)+
elocnxt jmp ([nx])
* cpl local bereichsreservierung
Crsvloc move.w  #rsvlo-Z,-([sp])
        bra.s   jdcm -
* cpl auflsung auer der reihe
Cnlocal move.w  #rlocal-Z,-([sp]) compilierte #bytes
jdcm    jmp     Cdcomma(pc)

* {stack abcd..}
Xwstak  move.l  [w],a1                <lit-entry
        bra.s   sstack  -
Xxstak  move.l  udp-2([bp],[up].l),a1 <direct execution pxstakq
        add.l   [bp],a1 strg source
        addq.l  #2,[sp] drop count {here}
        move.w  ([rp])+,[ip] semis
        add.l   [bp],[ip]
sstack  pea     ([nx])  lo-level return
XCstak  moveq   #0,d1
        moveq   #1,d2
        moveq   #-128,d3
        move.b  (a1)+,d1
        and.w   d1,d3   double flag
        eor.b   d3,d1   masked off
        move.l  a1,a2   base indices where to copy from
        or.w    d1,d2
        add.l   a1,d2   ip to continue
        move.l  [sp],a0 monitor no. of items popped
        move.l  [sp],a1 working data pointer
        move.l  [rp],d4 to restoring when ready
        moveq   #0,d0
        tst.b   d3
        bne.s   stklong ? move doubles
        bra.s   stkplop - start collecting
* singles
stkput  move.b  (a2)+,d0  selecting index
        ble.s   stkmov  - ready to copy
        move.w  -2(a1,d0.w),-([rp])
stkplop dbra    d1,stkput
        bra.s   stkret  - ready
stkmov  ext.w   d0
        sub.w   d0,a0   dest. stackptr
        moveq   #0,d0
        subq.w  #1,d1
        bmi.s   stkret  ?
stkftch move.b  (a2)+,d0 index to selected item(s)
        move.w  -2([rp],d0.w),-(a0)
        dbra    d1,stkftch
stkret  move.l  a0,[sp] adjust datastack
        move.l  d4,[rp] restore returnstack
        rts
Xrstak  move.l  [ip],a1 <compiled runtime
        bsr.s   XCstak  >
        move.l  d2,[ip]
        jmp     ([nx])
* long
stkplng move.b  (a2)+,d0 index
        ble.s   stklmov - ready to copy
        add.b   d0,d0
        move.l  -4(a1,d0.w),-([rp])
stklong dbra    d1,stkplng
        bra.s   stkret  - ready
stklmov ext.w   d0
        sub.w   d0,a0   dest. stackptr
        moveq   #0,d0
        subq.w  #1,d1
        bmi.s   stkret  ?
stklftc move.b  (a2)+,d0 index to selected item(s)
        move.l  -4([rp],d0.w),-(a0)
        dbra    d1,stklftc
        move.l  a0,[sp] adjust datastack
        move.l  d4,[rp] restore returnstack
        rts

Xlindx  move.w  #'||',([sp])
        bsr     Cword   >
        lea     0([bp],d2.l),a0
        move.l  a0,a1
        move.l  a0,d5
        moveq   #1,d0
        add.b   (a1)+,d0
        add.l   d0,d5
        subq.b  #1,d0
        ble.s   wloci   ?
        move.l  a1,a2
        bra.s   wlocb   -
wloca   move.b  d4,(a2)+
        move.l  a2,d5
wlocb   cmp.b   (a1)+,d3
        dbne    d0,wlocb ?
        beq.s   wlocn   ?
        subq.l  #1,a1
        move.b  (a1)+,d4
        cmp.b   (a1),d3
        dbeq    d0,wloci ?
        dbne    d0,wloca ?
wlocn   move.w  a0,d0
        sub.w   d5,d0
        not.b   d0
        move.b  d0,(a0)
wloci   addq.b  #1,(a0)
        move.l  d5,a2
        move.b  #'|',(a2)
        bra.s   windx   -
* prepare for {local} & {stack} runtimes
Xsindx  tst.w   ([sp])
        beq.s   Xlindx  ?
        bsr     Cword   >       word
        lea     0([bp],d2.w),a0 strg at here
windx   moveq   #27,d3  "|"
        moveq   #1,d2
        moveq   #0,d0
        move.l  a0,a1
        move.b  (a0)+,d0 no. of chars
        moveq   #127,d1
        and.b   d0,d1
        addq.b  #2,d1
        and.b   #-2,d1
        move.w  d1,-([sp]) push len to allot
        moveq   #0,d4
        move.b  (a0),d4 long/single-flag
        bra.s   sidxnx
sidxlp  subq.w  #1,d2   count no. of selected items
        moveq   #31,d1
        and.b   (a0),d1
        cmp.w   d3,d1
        bmi.s   sidxpt  ?
        lsl.b   #2,d4
        bmi.s   sidwrd  ? singles
        moveq   #-1,d4
        tas     (a1)    flag doubles
sidwrd  move.b  d2,d1   mark end of source selection
sidxpt  add.b   d1,d1
        tst.w   d4
        bpl.s   sidsing ?
        add.b   d1,d1
sidsing or.b    (a0),d4
        move.b  d1,(a0)+
sidxnx  dbra    d0,sidxlp
        jmp     ([nx])

* call a primitive 4th word by [w], and rts
Cprim   pea     ([nx])
        lea     cpret(pc),[nx]
        jmp     ([w])
cpret   move.l  (a7)+,[nx]
        rts

* call a deferred word by [w], and rts
Cdefer  pea     ([ip])
        lea     c4thret(pc),[ip]
        jmp     dodefer(pc)

Xchnum  move.l  ([sp])+,d2 ch-num
        bra.s   nchntr  -
Xworknum moveq  #0,d2
nchntr  lea     16*4([bp]),a0 work-num
        add.w   climit-Z([bp]),a0
        lea     -13*4(a0),a1
        move.l  d2,d1
        bmi.s   wkcput     ? no ch-id
        bne.s   wkchid     ? find id
        move.l  (a1),d1
        bmi.s   wkcput     ? no workchannel
        move.l  d1,d2
wkchid  moveq   #15,d1
wkclop  cmp.l   -(a0),d2
        dbeq    d1,wkclop  ?
        cmp.l   a0,a1
        dbne    d1,wkclop
wkcput  move.w  d1,-([sp])
        jmp ([nx])

Cspsa1  move.l  [sp],a0         sp!a1
        sub.l   [bp],a0
        move.l  a0,a1wp-Z([bp])
        rts

Xcstorel move.l ([sp])+,[w]     c!l
        move.w  ([sp])+,d3
        move.b  d3,([w])+
        jmp ([nx])

Xstorea move.w  ([sp])+,[w]     !a
        add.l   [bp],[w]
        move.w  ([sp])+,([w])+
        jmp ([nx])

X2storea move.w ([sp])+,[w]     2!a
        add.l   [bp],[w]
        move.l  ([sp])+,([w])+
        jmp ([nx])

Xfetcha move.w  ([sp])+,[w]     @a
        add.l   [bp],[w]
        move.w  ([w])+,-([sp])
        jmp ([nx])

X2fetcha move.w ([sp])+,[w]     2@a
        add.l   [bp],[w]
        move.l  ([w])+,-([sp])
        jmp ([nx])

Xpstoa  move.l  [bp],[w]        +!a
        add.w   ([sp])+,[w]
        move.w  ([sp])+,d0
        add.w   ([w]),d0
        move.w  d0,([w])
        jmp ([nx])

Xf2swap movem.l ([sp])+,d3-d5   2swap (fp)
        movem.l ([sp])+,d0-d2
        movem.l d0-d5,-([sp])
        jmp ([nx])

Xfgr    move.w  ([sp])+,d1      >r (fp)
        move.l  ([sp])+,-([rp])
        move.w  d1,-([rp])
        jmp ([nx])

Xfrg    move.w  ([rp])+,d1      r> (fp)
        move.l  ([rp])+,-([sp])
        move.w  d1,-([sp])
        jmp ([nx])

Cfpick  moveq   #6,d1   <froll) pick (fp)
        muls    ([sp])+,d1
        bvs.s   fpkret  ?
        move.l  2([sp],d1.w),-([sp])
        move.w  4([sp],d1.w),-([sp])
fpkret  rts

Xfroll  bsr.s   Cfpick          roll (fp)
        bvs.s   frljnx  ?
        lea     6([sp],d1.w),a1
        asr.w   #1,d1
        bmi.s   frolb   ?
        lea     6(a1),a0
        addq.w  #2,d1
frolop  move.w  -(a1),-(a0)
        dbra    d1,frolop
Xfdrop  addq.l  #6,[sp]         drop (fp)
frljnx  jmp ([nx])
frolb   not.w   d1
        addq.l  #6,[sp]
        movem.w ([sp]),d0/d2/d3
        move.l  [sp],a1
        lea     6(a1),a0
frblop  move.w  (a0)+,(a1)+
        dbra    d1,frblop
        movem.w d0/d2/d3,(a1)
        jmp ([nx])

Xfdup   move.w  4([sp]),-([sp]) dup (fp)
        move.l  2([sp]),-([sp])
        jmp ([nx])

Xfswap  movem.w ([sp])+,d3-d5   swap (fp)
        movem.w ([sp])+,d0-d2
        movem.w d0-d5,-([sp])
        jmp ([nx])

Xfover  move.w  10([sp]),-([sp]) over (fp)
        move.l  8([sp]),-([sp])
        jmp ([nx])

Xnosearch move.w #$8000,-([sp]) nosearch
Xpsrchq move.w  ucontext([bp],[up].l),d0
        subq.w  #4,d0
        move.w  ([sp])+,d1
        cmp.w   d1,d0
        beq.s   psrcnxt ?
        move.w  d1,8([bp],d0.w)
psrcnxt jmp ([nx])

Xrvoc   lea     2+ucontext([bp],[up].l),a0
        move.w  (a0),d0
        beq.s   psrcnxt ?
        move.w  d0,-(a0)
        jmp ([nx])

Xalso   lea     ucontext([bp],[up].l),a0
        move.w  nvocs+2-Z([bp]),d1
        add.w   d1,a0
        add.w   d1,a0
        lea     2(a0),a1
        subq.w  #1,d1
alsonx  move.w  -(a0),-(a1)
        dbra    d1,alsonx
        jmp ([nx])
                                                       
Xprevious lea   ucontext([bp],[up].l),a1
        lea     2(a1),a0
        move.w  nvocs+2-Z([bp]),d1
        subq.w  #1,d1
prevnx  move.w  (a0)+,(a1)+
        dbra    d1,prevnx
        jmp ([nx])
                                                       
Xonly   lea     ucontext([bp],[up].l),a0
        move.w  nvocs+2-Z([bp]),d1
onlynx  clr.w   (a0)+
        dbra    d1,onlynx
        jmp ([nx])

xm55    bsr     Cpad    >
        move.l  ([sp])+,d0
        swap    d0
        move.l  d0,-([sp]) pad c1
Xqtext  bsr     Cword   >
        addq.w  #1,d2
        move.w  d2,-([sp]) here 1+
        bsr     Cpad    >
        addq.w  #2,([sp])  pad 2+
        moveq   #0,d0
        move.b  -1([bp],d2.w),d0
        move.w  d0,0([bp],d1.l)
        addq.w  #1,d0   convert etc.
        move.w  d0,-([sp]) len
        jmp     Xcmove(pc) -

Xwquote move.w  #'""',-([sp])
        bra.s   Xwchar  -

Xqname  move.w  #'  ',-([sp])
Xwchar  tst.w   ustate([bp],[up].l)
        beq.s   xm55    ?
        lea     udp-2([bp],[up].l),a0
        moveq   #1,d0
        add.l   (a0),d0
        and.b   #-2,d0
        addq.l  #3,d0
        move.l  d0,(a0)
        move.w  #pwquoteq-Z,-3([bp],d0.l)
        sf      -1([bp],d0.l)
        pea     (a0)
        bsr     Cword   >
        move.l  (A7)+,a0
        moveq   #0,d0
        move.w  d0,cmc+2-Z([bp])
        move.b  0([bp],d2.w),d0 here
        addq.l  #1,d0
        or.b    #1,d0
        add.l   d0,(a0)
        jmp ([nx])

Cwtxt   moveq   #2,d2
        bra.s   ctx0    -

Ctxt    moveq   #1,d2  <von Xnum)
ctx0    move.w  ([sp])+,d3  c1
        bsr     Cpad    >
        clr.w   0([bp],d0.l)
        add.w   d2,d0
        move.w  d0,([sp])
        move.w  d3,-([sp])
        move.w  d0,-([sp])
        move.w  #80,-([sp]) }pad+ c1 pad+ 80
        lea     dfxp-Z([bp]),[w]
        bsr     Cdefer(pc) > xpect
        bsr     Cenclose   > pad+ n1 n2 n3
        move.l  ([sp])+,d0 n3|n2
        move.w  ([sp])+,a1 n1
        sub.w   a1,d0      drop over - }d0:=n2-n1=len
        lea     -1([bp]),a0
        add.w   ([sp])+,a0
        move.l  a0,[w]  -> for {s#}
        move.b  d0,(a0)+   dst addr
        add.l   a0,a1      src addr
txml    move.b  (a1)+,(a0)+
        dbra    d0,txml -
        move.b  #' ',-(a0) trailing space
        rts

Xnum    move.w  #'  ',-([sp])
        bsr.s   Ctxt    >
        tst.b   ([w])
        beq.s   xnu01   ?
        sub.l   [bp],[w]
        move.w  [w],-([sp])
        bsr     Cbnumq  >
        move.w  ([sp])+,d0
        bne.s   xnu01   ? fehler
        move.w  udpl([bp],[up].l),d0
        bpl.s   xnu03   ? integer
        addq.w  #2,d0
        bne.s   xnu03   ?
        jmp ([nx])
xnu01   clr.l   -([sp])
xnu03   addq.l  #2,[sp]
        move.w  #-1,udpl([bp],[up].l)
        jmp ([nx])

Xplustext moveq #-1,d3  dummy maxlen  +text (dst src --) append text.w
snmntr  move.w  ([sp])+,a0  srce <sname entry)
        move.w  ([sp])+,a1  dest
        add.l   [bp],a1
        move.b  (a1)+,d2
        lsl.w   #8,d2
        move.b  (a1)+,d2    dest initial count
        add.l   [bp],a0
        move.b  (a0)+,d1
        lsl.w   #8,d1
        move.b  (a0)+,d1    srce additional length
        cmp.w   d1,d3
        bcc.s   ptxlen
        move.w  d3,d1
ptxlen  subq.w  #1,d1
        bmi.s   ptxnx       ? nothing to append
        moveq   #0,d0
        add.w   d0,d0
        addx.b  -(a0),-(a1)
        addx.b  -(a0),-(a1) accumulate new len
        addq.l  #2,a0       1st char to append
        lea     2(a1,d2.w),a1
ptxlop  move.b  (a0)+,(a1)+
        dbra    d1,ptxlop
ptxnx   jmp ([nx])

Xsname  movem.w ([sp])+,d2/d3/d4  s m d !name (dst max src --)
        lea     0([bp],d4.w),a0
        sf      (a0)+
        sf      (a0)
        move.w  d3,d1
        ble.s   ptxnx       ? no length
        movem.w d2/d4,-([sp]) s d
snmclr  sf      (a0)+
        dbra    d1,snmclr   clear full length
        bra.s   snmntr      - move strg

Xnumfil move.l  unumfil([bp],[up].l),d0 .(r)
        move.w  ([sp])+,d0
        sub.w   ([sp]),d0
        bra.s   nmfntr -
Xemitm  move.l  ([sp])+,d0  m-emit
        bra.s   nmfntr  -
Xspace  move.w  #1,-([sp])  space
Xspaces moveq   #' ',d0     spaces
        swap    d0
        move.w  ([sp])+,d0  count
nmfntr  subq.w  #1,d0
        bmi.s   ptxnx  ?
        move.l  d0,-([rp])
        move.w  ([rp])+,-([sp])
emmlop  move.w  ([sp]),-([sp])
        lea     dfdemit-Z([bp]),[w]
        jsr     Cdefer(pc) >
        subq.w  #1,([rp])
        bpl.s   emmlop
        addq.l  #2,[rp]
        addq.l  #2,[sp]
        jmp ([nx])

Xpsealp move.w  ([sp])+,d0      ptr to ptr to voctop
        subq.w  #2,d0           ptr to vocnfa
        move.w  d0,2([bp],d0.w) ptr to ptr to voctop
sealsem move.w  ([rp])+,[ip]    semis
        add.l   [bp],[ip]
        jmp ([nx])

Xvoca   lea     udp-2([bp],[up].l),a1
        move.l  [bp],[w]
        add.l   (a1),[w]        here
        addq.l  #8,(a1)
        move.w  #$81a0,([w])+   voc-nfa
        move.w  ucurrent([bp],[up].l),a0 current @
        subq.w  #2,a0               ( dup )
        move.w  a0,([w])+       cfa,
        subq.w  #2,a0               ( 4- )
        move.w  [w],d1
        sub.w   [bp],d1         here
        move.w  uvocdashlk([bp],[up].l),([w])+ voc-link @ ,
        move.w  d1,uvocdashlk([bp],[up].l)     voc-link !
* standard voc. extended by two cells:
        move.w  a0,([w])+       ,   ( parent voc-search )
        addq.l  #2,(a1)
        move.w  10([bp],a0.w),([w])+ copy fp-flag from parent voc.
        jmp ([nx])

XCdovoc move.w  ucontext([bp],[up].l),uocontext([bp],[up].l)
        addq.w  #2,([sp])
        move.w  ([sp])+,ucontext([bp],[up].l)
        bra.s   sealsem -

dbftst  move.l  ([sp])+,d0 bit
        move.l  ([sp])+,a0 adr
        moveq   #7,d1
        and.b   d0,d1 bit#
        lsr.l   #3,d0 byte#
        add.l   d0,a0
        moveq   #0,d0
        btst    d1,(a0)
        seq     d0
        addq.b  #1,d0 l<i
        rts

Xbft    bsr.s   dbftst  >
        move.w  d0,-([sp])
        jmp ([nx])
Xbfs    bsr.s   dbftst  >
        bset    d1,(a0)
        jmp ([nx])
Xbfc    bsr.s   dbftst  >
        bclr    d1,(a0)
        jmp ([nx])
Xbfx    bsr.s   dbftst  >
        bchg    d1,(a0)
        jmp ([nx])

Xdepth  move.L  us0-2([bp],[up].l),d1
        add.l   [bp],d1
        sub.l   [sp],d1
        asr.w   #1,d1
        move.w  d1,-([sp])
        jmp ([nx])

Xneqbra move.l  ([sp]),d0   over = IF drop ...
        cmp.w   ([sp])+,d0
        bne     Xbranch ?  leave item on tos to try again
        move.w  ([ip])+,([sp])+ drop & enter true-part
        jmp ([nx])

Xistobody move.w ([rp])+,[ip] semis
        add.l   [bp],[ip]
        move.w  ([sp])+,d0     pfa
        bra.s   btobody
Xbisq   move.w  ([ip])+,d0
        cmp.w   vdodebug-Z([bp]),d0
        bne.s   isbody
        move.w  ([ip])+,d0
isbody  addq.w  #2,d0
btobody move.w  ([sp])+,d3       new pfa/value/1st word
        lea     -2([bp],d0.w),a0 deferred cfa
        lea     istab(pc),a1
        move.w  (a0)+,d4        >body
tryis   move.l  (a1)+,d2       exec & cfa @
        beq     nodferd         ? none
        cmp.w   d4,d2
        bne.s   tryis          ? nxt
        moveq   #0,d1
        swap    d2
        jmp     -4(a1,d2.w)

Xdftcfa move.w  ([sp]),a1
        move.w  -2([bp],a1.l),d1 cfa @
        clr.w   -([sp])
        lea     istab(pc),a1
        moveq   #(dftnd-istab)/4-1,d3
dftcmp  move.l  (a1)+,d2
        cmp.w   d1,d2
        dbeq    d3,dftcmp
        bne.s   dfcjnx  ?
        addq.w  #1,([sp])
dfcjnx  jmp ([nx])

Xbasecpu lea    ubase([bp],[up].l),a0
        move.w  (a0),-([sp])
        move.w  #36,(a0)
        move.l  obasecpu-Z([bp]),-([sp])
        jmp ([nx])

Csmul   move.w  ([sp])+,a0 ( dn1 n2 -- dn3 | ovf )
        move.l  a0,-([sp])   mul duble by sing into double
Cdmul   bsr.s   dmmulcal  > signed ( d1 d2 -- d3 | ovf
        addq.l  #4,[sp]   drop hi.l
        not.l   d3        test it
        beq.s   dmulret   ? 32bit -ve
        not.l   d3
        beq.s   dmulret   ? 32bit +ve
        move.l  d3,([sp])
        jsr     dmmulov(pc) > +/- ovf
        addq.l  #2,[sp]
        move.l  d0,([sp])
dmulret rts

Xudmul  pea     Xtwodp-Z([bp])
Cudmmul lea     qml_cal(pc),[w] unsigned
        bra.s   udmmulntr

dmmulcal lea    qml_sgd(pc),[w] signed
udmmulntr move.l d4,a0
        move.l  d5,a1
        move.l  ([sp])+,d4
        move.l  ([sp]),d5
        jsr     ([w])
        move.l  d2,([sp])
        move.l  d4,-([sp])
        move.l  d4,d3
        move.l  a1,d5
        move.l  a0,d4
        rts

* => wg. monitorjobs andere exception verwenden, z.B. CHK
Xsrftc  chk     -$8000([bp]),d0
        move.w  ([sp]),sr
        jmp ([nx])

Xsrsto  trap    #0
        move.w  ([sp])+,sr
        jmp ([nx])

Xtrap0r trap    #0
        and.w   #$dfff,sr
        jmp ([nx])

Xngreatr lea    2([sp]),[w]     n>r
        bsr.s   qngtr   >
        bmi.s   ngrnxt  ?
ngtpsh  move.w  -([w]),-([rp])
        dbra    d0,ngtpsh
        move.l  a0,[sp]
ngrnxt  jmp ([nx])

Xnrgreat move.l [rp],[w] nr>
        bsr.s   qngtr   >
        bmi.s   ngrnxt  ?
nrgpop  move.w  -([w]),-([sp])
        dbra    d0,nrgpop
        move.l  a0,[rp]
        jmp ([nx])

qngtr   moveq   #0,d0
        st      d0
        and.w   ([sp])+,d0
        move.w  d0,d1
        add.w   d1,d1   count bytes
        add.w   d1,[w]
        move.l  [w],a0
        subq.w  #1,d0
        rts

qmgtr   moveq   #0,d0
        move.w  ([sp])+,d0  bytes
        move.w  ([sp])+,[w] mem
        ble.s   qmgnix  ?
        add.l   [bp],[w]
        moveq   #1,d1
        and.w   d0,d1
        add.w   d0,d1   even len
qmgnix  subq.w  #1,d0
        blt.s   qmgtrr  ? none or..
        move.w  #$1ff,d3
        cmp.w   d0,d3   ..too many
qmgtrr  rts

Xrgreatm bsr.s  qmgtr   > r>m
        blt.s   mrgjnx  ?
        move.l  [rp],a0
mrgpop  move.b  (a0)+,([w])+
        dbra    d0,mrgpop
        add.w   d1,[rp]
mrgjnx  jmp ([nx])

Xmgreatr bsr.s  qmgtr   > m>r
        blt.s   mrgjnx  ?
        sub.w   d1,[rp]
        move.l  [rp],a0
mgrpsh  move.b  ([w])+,(a0)+
        dbra    d0,mgrpsh
        jmp ([nx])

Xelse   moveq   #2,d2   else flg: 2 => -2
        bsr     tstcms  >
        addq.l  #4,(a1)
        move.w  #branch-Z,([w])+
        move.l  [w],d0
        sub.l   [bp],d0
        clr.w   ([w])+
        move.l  ([sp])+,d1
        move.w  d0,-([sp])
        move.w  #-2,-([sp])
        move.l  d1,-([sp])
Xendif  bsr     ccstate > endif flg: 2
        move.w  ([sp]),d0
        addq.w  #2,d0
        beq.s   ndfcpl  ? -ve pairs
        subq.w  #4,d0
        bne.s   Xelse   ?
ndfcpl  addq.l  #2,[sp]
Xgrs    move.w  ([sp])+,a1  >resolve  (forward)
        move.w  udp([bp],[up].l),d1 here
        bra.s   grsntr  -

Xagain  move.w  #branch-Z,d1
        moveq   #1,d2
loopnt  bsr     tstcms  >
        addq.l  #2,(a1)
        move.w  d1,([w])+
        addq.l  #2,[sp]
Xbck    move.w  ([sp])+,d1 back (resolve back)
        lea     udp-2([bp],[up].l),a0
        move.l  (a0),a1
        addq.l  #2,(a0)
grsntr  sub.w   a1,d1
        move.w  d1,0([bp],a1.w)
        clr.w   cmc+2-Z([bp])
        jmp ([nx])

Xloop   move.w  #ploopq-Z,d1
plopnt  moveq   #3,d2
        bra.s   loopnt  -
Xploop  move.w  #pplusloopq-Z,d1
        bra.s   plopnt  -

Xdox    bsr     ccstate >
        bsr     tstcmc  >
        addq.l  #2,(a1)
        move.w  #pdoq-Z,([w])+
        sub.l   [bp],[w]
        move.w  [w],-([sp])
        move.w  #3,-([sp])
        clr.w   (a0)
        jmp ([nx])

Ccseq   bsr     tstcmc  > <case?)
        addq.l  #2,(a1)
        move.w  #neqbra-Z,([w])+
        moveq   #2,d3
nxif    move.l  (a7)+,[nx]
        addq.l  #2,(a1)
        move.l  [w],d0
        sub.l   [bp],d0
        move.w  d0,-([sp])
        move.w  d3,-([sp])
        clr.w   ([w])+
        jmp ([nx])

Cwhile  moveq   #4,d3   while
        bra.s   whlntr  -

Cif     moveq   #2,d3   if  compiler flag
whlntr  bsr     ccstate >
        lea     nxif(pc),[nx]
* compress 0= IF, w/w.o preceeding 0< or 0>
Xqzeqbra move.w #zbra-Z,d1
        bsr.s   tstcmc  >
        ble.s   ifo_cma ? lit or off
        move.w  -([w]),d0
        sub.w   #zeq-Z,d0
        bne.s   ifo_q01 ?
        subq.l  #2,(a1)
        subq.w  #1,(a0)
        move.w  #nzbra-Z,d1
ifo_q01 tst.w   (a0)
        ble.s   ifo_cma ?
        lea     -2([bp]),[w]
        add.l   (a1),[w]
        cmp.w   #zlt-Z,([w])
        bne.s   ifo_q02 ?
        subq.l  #2,(a1)
        move.w  #plbra-Z,d1
        tst.w   d0
        bne.s   ifo_cma ?
        move.w  #mibra-Z,d1
        bra.s   ifo_cma -
ifo_q02 cmp.w   #zgt-Z,([w])
        bne.s   ifo_cma ?
        subq.l  #2,(a1)
        move.w  #lebra-Z,d1
        tst.w   d0
        bne.s   ifo_cma ?
        move.w  #gtbra-Z,d1
ifo_cma moveq   #0,d2
plocfa  move.w  d2,(a0)  cmc flag
        move.l  [bp],[w]
        add.l   (a1),[w] current dp
        addq.l  #2,(a1)
        move.w  d1,([w])+
plojnx  jmp ([nx])

tstcms  bsr     ccpairs >
tstcmc  lea     udp-2([bp],[up].l),a1
        lea     cmc+2-Z([bp]),a0
        move.l  [bp],[w]
        add.l   (a1),[w] dp true addr
        moveq   #1,d2   prepare cfa counter
        tst.w   co+2-Z([bp])
        bne.s   tsctst  ? opt on
        clr.w   (a0)
tsctst  tst.w   (a0)
        rts

* double primitive op:
* [ dojump Xdoopt.l Xsingle.l dosingle.w dodouble.w
noopt   jmp     0([bp],a1.l)
Xdoopt  move.l  ([w])+,a1
        tst.w   ustate([bp],[up].l)
        beq.s   noopt   ? direct single
        move.w  ([w])+,d1 dosingle
        move.w  ([w])+,d0 dodouble
        bsr.s   tstcmc  >
        ble.s   plocfa  ? lit or new cpl-segment
        bsr.s   tstopt  >
        bpl.s   plocfa  ? cpl'd or lit or debug
        cmp.w   -([w]),d1
        bne.s   plocfa  ?
        move.w  d0,d1
        subq.l  #2,(a1)
        bra.s   plocfa  -

* lit => dlit => flit : lit+ lit => lit+
Xnumopt addq.l  #2,[sp] < entry from the interpreter
Xlitopt tst.w   ustate([bp],[up].l)
        beq.s   plojnx  ?
        move.w  #lit-Z,d0
        move.w  ([sp])+,d1 new lit
        bsr.s   tstcmc  > w:=here
        bsr.s   tstopt  >
        ble.s   litcpl  ? cpl'd or no lit
        tst.w   (a0)    cmc
        bpl.s   litcpl  ?
        subq.w  #2,d3   lit+
        beq.s   ifo_cma ? lit+
        moveq   #0,d2   cmc off
        subq.w  #4,d3   dlit
        beq.s   flitcpl ? cpl flit
        move.w  -([w]),d0 old literal
        move.w  d1,([w]) replaced by new lo-word
        move.w  d0,d1
        move.w  #dlit-Z,d0
        subq.l  #2,[w]  overwrite lit
        subq.l  #2,(a1) no extra cfa
litcpl  subq.w  #2,d2   cmc bei lit: -1  dlit: -2 (flit: 0)
        addq.l  #2,(a1) advance dp for the literal
        move.w  d0,([w]) new cfa
        bra     plocfa - inst old lit to hi word

Xdliteral tst.w ustate([bp],[up].l)
        beq.s   dlitjnx ?
        bsr.s   tstcmc  >
        bgt.s   dliflt  ?
dlicpl  addq.l  #6,(a1)         advance dp to cfa & dlit
        move.w  #dlit-Z,([w])+  cfa
        move.l  ([sp])+,([w])+  double
        move.w  #-2,(a0)        flit-opt flg
dlitjnx jmp ([nx])

flitcpl move.l  -([w]),d0
        move.w  #flit-Z,-2([w])
        move.w  d1,([w])+
        addq.l  #2,(a1)
        move.l  d0,([w])+
        move.w  d2,(a0)
        jmp ([nx])

* REIN: a2 here
* RAUS: d3 'mi'/-2:any 'eq'/0:nicht optimieren (2:lit+ 4:lit 6:dlit)AND cmc<0 !
tstopt  move.l  [w],-(a7)
        subq.l  #6,[w]
        move.w  cmc+2-Z([bp]),d3
        bmi.s   tstdli  ?
        moveq   #0,d3           cmc +ve
        cmp.w   #flit-Z,-2([w])   => 0 flit
        beq.s   popopt  ?   0
        addq.l  #2,[w]
*moveq   #0,d3   < cmc +ve
        cmp.w   #compile-Z,([w])  => 0 compile
        beq.s   popopt  ?
        cmp.w   #dcompile-Z,([w]) => 0 dcompile
        beq.s   popopt  ?
        cmp.w   #dodebgb-Z,([w])+ => 0 dodebug
        beq.s   popopt  ?
        tst.w   cmc+2-Z([bp])
        blt.s   notopt  ?  -2
        moveq   #2,d3
        cmp.w   #lpl-Z,([w])      => 2 lit+
        seq     cmc+2-Z([bp])
        bra.s   tsoret  ?
tstdli  moveq   #6,d3           cmc -ve
        cmp.w   #dlit-Z,([w])+    => 6 dlit
        beq.s   retopt  ?
        moveq   #4,d3
        cmp.w   #lit-Z,([w])      => 4 lit
tsoret  beq.s   retopt  ?
notopt  moveq   #-2,d3
retopt  tst.w   d3
popopt  move.l  (a7)+,[w]
        rts

dliflt  cmp.w   #lit-Z,-4([w])
        bne.s   dlicpl  ?
        addq.l  #4,(a1)
        move.w  -([w]),d1
        move.w  #flit-Z,-2([w])
        move.l  ([sp])+,([w])+
        move.w  d1,([w])+
        clr.w   (a0)
        jmp ([nx])

Xqliteral clr.w quadf-Z([bp])
        tst.w   ustate([bp],[up].l) qlit
        beq.s   qlijnx ?
        bsr     tstcmc  >
        move.w  d2,(a0)
        moveq   #10,d2
        add.l   d2,(a1)
        move.w  #qlit-Z,([w])+
        move.l  ([sp])+,([w])+
        move.l  ([sp])+,([w])+
qlijnx  jmp ([nx])

Xsops   move.w  #semis-Z,d0 ;s => drop;s or branchback or just ;s
        moveq   #2,d1
        bsr     tstcmc  >
        ble.s   semcpl  ? locked or no code
        bsr     tstopt  >
        bpl.s   semcpl  ? cpl'd or literal
        move.w  -([w]),d3
        btst    #0,d3
        bne.s   qsops   ?
        cmp.w   #docolon-Z,0([bp],d3.w)
        bne.s   qsops   ?
        sub.l   (a1),d3
        addq.w  #2,d3
        bpl.s   qsops   ? not branching back (overflow)
        move.w  #branch-Z,([w])+
        move.w  d3,([w])+
        bra.s   sembra  -
qsops   cmp.w   #drop-Z,([w])+
        bne.s   semcpl  ?
        move.w  #drops-Z,d0
        subq.l  #2,[w]
        moveq   #0,d1
semcpl  move.w  d0,([w])+
sembra  add.l   d1,(a1) dp +!
        clr.w   (a0)    cmc  off
        clr.w   ustate([bp],[up].l) interpreting
        move.w  ucurrent([bp],[up].l),[w]
        move.w  0([bp],[w].w),a0
        and.b   #-33,0([bp],a0.w) unsmudge
semnsm  move.w  ([rp])+,[ip]
        add.l   [bp],[ip] semis
        jmp     Xqcsp(pc)

*++
Xoplus  tst.w   ustate([bp],[up].l)
        beq     Xplus   ?
        move.w  #plus-Z,d1
        bsr     tstcmc  >
        cmp.w   #-1,(a0)
        bne     plocfa  ? cpl standard +
        bsr     tstopt  >
        subq.w  #4,d3   lit
        bne     ifo_cma ?
        move.w  #lpl-Z,-4([w])
        jmp ([nx])

*++
* [convert] : interpreter entry after vocsearch
Xnumconv lea    number+2-Z([bp]),[w]
        jsr     Cdefer(pc)      >
        tst.b   1+quadf-Z([bp])
        bgt     Xqliteral       ? quad
        cmp.w   #-1,udpl([bp],[up].l)
        beq     Xnumopt         ? single
        bgt     Xdliteral       ? double
Xfliteral tst.w ustate([bp],[up].l)
        beq.s   numjnx          ? interpreting
        lea     udp-2([bp],[up].l),a1 dp
        moveq   #9,d0
        add.l   (a1),d0
        and.b   #-2,d0
        move.l  d0,(a1) safe dictionary space
        lea     -8([bp],d0.l),[w]
        move.w  #flit-Z,([w])+  fp
        move.w  ([sp])+,([w])+
        move.l  ([sp])+,([w])+
        clr.w   cmc+2-Z([bp])    opt.flg off
numjnx  jmp ([nx])

Xcmovel move.w  ([sp])+,d1
        movem.l ([sp])+,a0/a1
        bra.s jmovel

Cdomove movem.w ([sp])+,d1/a0-a1 ( from to n --- )
        add.l   [bp],a0
        add.l   [bp],a1
        bra.s   fillent -

Xcmove  movem.w ([sp])+,d1/a0/a1  cnt dst src
        add.l   [bp],a0
        add.l   [bp],a1
jmovel  lea     ccmvu(pc),[w]     a1)+ => a0)+
        cmp.l   a0,a1
        bhi.s   fillent ?
        lea     ccmvd(pc),[w]
fillent cmp.l   a0,a1
        beq.s   jwmnxt  ? same address
        subq.w  #1,d1
        bmi.s   jwmnxt  ? don't move nothing nor 32K+
        move.w  a1,d3
        move.w  a0,d2
        ror.w   #1,d3   test wether word-move would be possible
        asr.w   #7,d3
        lsr.w   #1,d2
        scs     d3      0 both even, else one odd
        tst.w   ([w])+
        move.l  ([w]),[w]
        jmp     0([bp],[w].l)

jcmvup  move.b  (a1)+,(a0)+ : cmove>
        dbra    d1,jcmvup
jwmnxt  jmp ([nx])
* move bytes top down
jwcdn   sub.w   d1,a0
        addq.l  #1,a0
        sub.w   d1,a1
        addq.l  #1,a1
        add.w   d1,d1
        addq.w  #1,d1
jcmvdn  lea     1(a0,d1.w),a0   <cmove and entrypoint of <move
        lea     1(a1,d1.w),a1
        bmi.s   jwmvdn  ? 16-bit move
lcmvdn  move.b  -(a1),-(a0)
        dbra    d1,lcmvdn
        jmp ([nx])
* move words top down
jwmvdn  tst.w   d3
        bne.s   jwcdn   ? odd pointer(s)
        lea     1(a0,d1.w),a0
        lea     1(a1,d1.w),a1
lwmvdn  move.w  -(a1),-(a0)
        dbra    d1,lwmvdn
        jmp ([nx])

Xblanks move.w  #' ',-([sp])
Xfill   movem.w ([sp])+,d0-d1/a0  ( addr n byte --- )
        subq.w  #1,d1
        bmi.s   xfilnx
        add.l   [bp],a0
xfiloop move.b  d0,(a0)+
        dbra    d1,xfiloop
xfilnx  jmp ([nx])

*load : ld1 prompt 3>r lpsto interpret 3r> ld2 ;
Xld1    move.w  ([sp]),d0
        move.w  uscr([bp],[up].l),([sp])
        move.w  d0,uscr([bp],[up].l)
        move.l  ublk([bp],[up].l),-([sp])
        mulu    cbbyscr-Z([bp]),d0
        swap    d0
        clr.w   d0
        move.l  d0,ublk([bp],[up].l)
        move.w  #':'+0,-([sp])
* empty-buffers : first limit over - erase
Xmtybfs move.w  cfirst-Z([bp]),a0
        move.w  climit-Z([bp]),d1
        sub.w   a0,d1
        move.w  a0,-([sp])
        move.w  d1,-([sp])
Xerase  clr.w   -([sp])
        bra.s   Xfill

Xld2    move.l  ([sp])+,ublk([bp],[up].l)
        move.w  ([sp])+,uscr([bp],[up].l)
        move.w  ([rp])+,[ip] semis
        add.l   [bp],[ip]
        jmp ([nx])

* emit name for id. ( ptr count -- )
XCidot  move.w  uwidth([bp],[up].l),d2
        moveq   #31,d1
        and.w   ([sp])+,d1
        cmp.w   d1,d2
        bpl.s   iddwdt
        move.w  d2,d1
iddwdt  subq.w  #1,d1
        bmi.s   iddmty  ? no name
        move.w  d1,-([rp]) count
iddllp  move.w  ([sp]),d1
        addq.w  #1,([sp])
        moveq   #127,d0
        and.b   0([bp],d1.w),d0
        cmp.w   #32,d0
        bhi.s   iddcs
        tas     d0
        bra.s   iddcse -
iddcs   cmp.w   #97,d0
        bcs.s   iddcse ?
        move.b  uchr-97(pc,d0.w),d0
iddcse  move.w  d0,-([sp])
        lea     dfdprmp(pc),[w]
        jsr     Cdefer(pc) >
        subq.w  #1,([rp])
        bpl.s   iddllp  ? more
        addq.l  #2,[rp]
iddmty  addq.l  #2,[sp]
        jmp ([nx])

uchr dc.b 'ABCDEFGHIJKLMNOPQRSTUVWXYZ{|}~'

Crvtmax move.w  uspan([bp],[up].l),untib([bp],[up].l)  ;f83
        move.w  vtibmax+2-Z([bp]),vtibmax-Z([bp])
        clr.w   uin([bp],[up].l)
        jmp ([nx])

Xwraps  bsr.s   Cwithin >
        move.w  d4,([sp])
        jmp ([nx])

Cwithin movem.w ([sp])+,d0/d1/d2 max min num
        move.w  d1,d4
        cmp.w   d2,d0
        blt.s   wput    ? max <= num
        exg     d2,d0   d0:num d2:max
        move.w  d0,d4
        cmp.w   d0,d1
        ble.s   wput    ? min <= num
        move.w  d2,d4
        move.w  d1,d0   min
wput    move.w  d0,-([sp])
        rts

Xbounds move.w ([sp])+,d1
        move.w  ([sp])+,d0
        add.w   d0,d1
        move.w  d1,-([sp])
        move.w  d0,-([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

Xwiq    subq.w  #1,([sp])
        move.w  4([sp]),d3
        bsr.s   Cwithin >
        cmp.w   ([sp])+,d3
        jmp     equset(pc)

CXalign move.w  ([sp])+,d3
        move.w  ([sp])+,d1
        lsr.w   d3,d1
        lsl.w   d3,d1
        move.w  d1,-([sp])
        jmp ([nx])

Xlatest move.w  ucurrent([bp],[up].l),[w]
        move.w  0([bp],[w].w),-([sp])
        jmp ([nx])

Xstocsp move.l  [sp],d0
        sub.l   [bp],d0
        move.L  d0,ucsp-2([bp],[up].l)
        jmp ([nx])

* case: runtime (mustn't change D2)
Xdocases move.w  ([w]),d0
        move.w  ([sp])+,d3 <(csel)  d0:max [W]:ip d3:idx
pcselntr subq.w #2,d0      <(case)  disp
        move.w  d3,d1   this for {cc-4th
        ble.s   pcsufw  ? -ve or zero
        addq.w  #2,d3   1+
        add.w   d3,d3   2*
        bmi.s   pcsofw  ? < 16383
        cmp.w   d0,d3   min
        ble.s   pcsmin  ?
pcsofw  move.w  d0,d3   ptr
pcsmin  subq.w  #4,d3   2
        bpl.s   pcsmax  ? max
pcsufw  moveq   #0,d3   min
pcsmax  lea     2([w]),a0 cfa-flag
        move.w  4([w],d3.w),[w] ptr @
        tst.w   (a0)
        beq.s   pcspush ? push a literal
        move.w  [w],d0
        cmp.w   #$8000,d0
        beq.s   nocase
        lsr.w   #1,d0   zero or odd
        bcs.s   nocase  ? not valid
        cmp.L   udp-2([bp],[up].l),[w] still in the dictionary
        blt     next1
nocase  jmp     nodferd(pc)
pcspush move.w  [w],-([sp])
        jmp ([nx])

Xdocase lea     pcselntr(pc),a0 continue executing a cfa/fetching a num
        bra.s   pcasntr

Xpasvrq lea     pasvlntr(pc),a0 continue comparing
pcasntr move.w  ([ip]),d0 max
        move.l  [ip],[w] ip
        moveq   #-2,d3  mask off the {range:-flag
        and.w   d0,d3
        add.w   d3,[ip] r+
        move.w  ([sp])+,d3 index/value
        jmp     (a0)    to find

Xdoassoc move.w ([w]),d0
        move.w  ([sp])+,d3 <asvl) (val tab maxdisp -- index)
pasvlntr add.w  d0,[w]     <asvr) >r ... r> add tablen to tabposn
        lsr.w   #1,d0      u2/
        scs     d2         range:-flag
        subq.w  #1,d0
        move.w  d0,-([sp]) store top index
        subq.w  #1,d0      2
        bmi.s   pasvmax    ? empty list (?do)
        ext.w   d2
        beq.s   pasvcmp    ? associative:
        add.w   d2,[w]     even
        cmp.w   -([w]),d3  top
        bge.s   pasvmax    ? beyond top val
prngcmp cmp.w   -([w]),d3
        dbge    d0,prngcmp signed  lo.val <= nn < hi.val
        bge.s   pasvput
        addq.w  #1,d0      adjust range index to +ve, zero if under-range
        bra.s   pasvput    -
pasvcmp cmp.w   -([w]),d3
        dbeq    d0,pasvcmp ? search
        bne.s   pasvmax    ? not found
pasvput move.w  d0,([sp])
pasvmax jmp ([nx])

qpkidx  move.w  ([sp])+,d0      4pick
        add.w   d0,d0
        smi     d1
        add.b   d1,d1
        addq.b  #1,d1
        ext.w   d1
        add.w   d1,d0
        move.w  d0,d1
        rts

Cqpick  bsr.s   qpkidx  >
        bsr.s   qpkntr  >
        move.w  d0,-([sp])
Cdpick  move.w  ([sp])+,d1      2pick
qpkntr  add.w   d1,d1   cells
        add.w   d1,d1   longs
        move.l  0([sp],d1.w),-([sp])
        rts

Cqroll  bsr.s   qpkidx  >       4roll
        move.w  d1,d2
        pea     qrlntr(pc) >
qrlntr  move.w  d2,-([sp])
Cdroll  jsr     Cdpick(pc) >    2roll
        lea     4([sp],d1.w),a1
        asr.w   #1,d1
        bmi.s   drlbck  ? roll back
        lea     4(a1),a0
        addq.w  #1,d1
drolop  move.w  -(a1),-(a0)
        dbra    d1,drolop
        addq.l  #4,[sp]
        rts
drlbck  not.w   d1
        addq.l  #4,[sp]
        move.l  ([sp]),d0
        move.l  [sp],a1
        lea     4(a1),a0
drblop  move.w  (a0)+,(a1)+
        dbra    d1,drblop
        move.l  d0,(a1)
        rts

Xddgq   move.b  ([sp]),d0       d->q
        add.b   d0,d0
        subx.l  d0,d0
        move.l  d0,-([sp])
        jmp ([nx])

Xsgn    move.w  ([sp]),-([sp])
X2sgn   moveq   #1,d0
        tst.l   ([sp])
        addq.l  #2,[sp]
        bgt.s   sgnput  ?
        beq.s   sgnret  ?
        moveq   #-1,d0
sgnput  move.w  d0,([sp])
sgnret  jmp ([nx])

X2wiq   pea     c2wqr(pc)
        subq.l  #1,([sp])
C2wi    movem.l ([sp])+,d0/d1/d2
        move.l  d1,d4
        move.l  d2,d3
        cmp.l   d2,d0   d0:max d1:min d2:num
        ble.s   twput   ? max <= num
        exg     d2,d0
        move.l  d0,d4   may be used for 2wraps
        cmp.l   d0,d1
        ble.s   twput   ? min <= num
        move.l  d2,d4
        move.l  d1,d0   min
twput   move.l  d0,-([sp])
        rts
c2wqr   moveq   #0,d1
        sub.l   ([sp])+,d3
        seq     d1
        neg.b   d1
        move.w  d1,-([sp])
        move.l  d2,d0
        jmp ([nx])

Xqzeq   clr.l   -([sp]) q0=
        clr.l   -([sp])
Xqeq    moveq   #1,d0   q=
        movem.l ([sp])+,d1/d2
        cmp.l   ([sp])+,d1
        bne.s   qeqpop
        cmp.l   ([sp]),d2
qeqpop  addq.l  #4,[sp]
        beq.s   qeqput  ?
        moveq   #0,d0
qeqput  move.w  d0,-([sp])
        jmp ([nx])

Xcds    move.w  ([sp])+,d2
        move.w  ([sp]),d3
        sub.b   d2,d3
        subx.l  d0,d0
        ext.w   d3
        move.w  d3,([sp])
        jmp ([nx])

Xcless  move.w  ([sp])+,d3
        move.w  ([sp]),d2
        sub.b   d3,d2
        subx.w  d3,d3
        neg.w   d3
        move.w  d3,([sp])
        jmp ([nx])

Xxshift moveq   #0,d3   ;
        move.w  ([sp])+,d1
*movem.w ([sp])+,d1/d3  (n1 c1 -- n2 ovf)
*tst.w   d1 (c1 +ve LSL, c1 -ve LSR)
        bpl.s   sleft   ?
        neg.w   d1
        move.w  ([sp])+,d3
        swap    d3
        ror.l   d1,d3
        swap    d3
        bra.s   spush   ?
sleft   move.w  ([sp])+,d3
        rol.l   d1,d3
spush   move.l  d3,-([sp])
        jmp ([nx])

Xndup   move.w  ([sp])+,d3
        ble.s   ndupnix ?
        subq.w  #1,d3
        move.w  d3,d1
        add.w   d3,d3
        lea     2([sp],d3.w),[w]
ndupl   move.w  -([w]),-([sp])
        dbra    d1,ndupl
ndupnix jmp ([nx])

Xwsiz   bsr     cdashwd ( chan -- y x hgt wdt tf | ff )
        tst.w   ([sp])+
        ble.s   wsz_rwd ?
        clr.l   -(a7)
        lea     wsz_dat(pc),a2
        moveq   #9,d0   extop
        moveq   #1,d3
        trap    #3
        move.l  (a7)+,d0 l<i
        beq.s   wsz_nwd ?
        move.l  d1,-([sp])
        move.l  a1,-([sp])
        swap    d0
        move.w  d0,-([sp])
        jmp ([nx])
wsz_nwd move.w  d0,-([sp])
        jmp ([nx])

* prepare {flush
Xflushdat moveq #0,d0
        move.w  climit-Z([bp]),d0
        sub.w   cfirst-Z([bp]),d0
        moveq   #4,d1
        add.w   cbbybuf-Z([bp]),d1
        divu    d1,d0
        move.w  d0,-([sp])
wsz_rwd clr.w   -([sp])
        jmp ([nx])

Xediwork moveq  #$40,d0
        and.b   uoffset([bp],[up].l),d0
        rol.b   #2,d0
        move.w  d0,-([sp])
        jmp ([nx])

Xbye    moveq   #0,d3
jobremv move.l  mtinftab(pc),d1
        moveq   #5,d0
        trap    #1
        rts

Xlpsto  move.l  [sp],d0
        sub.l   [bp],d0
        move.w  d0,clsp-Z([bp])
        jmp ([nx])

Xlspcmp move.l  [sp],d0 check items on stack when {load}ing
        sub.l   [bp],d0
        move.w  clsp-Z([bp]),-([sp])
        sub.w   d0,([sp])
        beq.s   lspnew
        move.w  ([sp]),-([sp])
lspnew  move.w  d0,clsp-Z([bp])
        jmp ([nx])

CXnswap move.w  ([sp]),d1 swap tos and nn'th item
        ble.s   xrolnxt ?
        lea     xnswapx(pc),[w]
        bra.s   xroljmp

Xroll   move.w  ([sp]),d1
        beq.s   xrolnxt ? don't roll nothing
        lea     xrolup(pc),[w]
        bpl.s   xroljmp ?
        lea     xroldn(pc),[w]
        not.w   d1
xroljmp move.w  d1,d0
        add.w   d0,d0
        lea     2([sp],d0.w),a0
        jmp     ([w])
xrolup  addq.w  #1,d1   roll bot up
        move.l  a0,a1
        move.w  (a0)+,([sp])
xrolop  move.w  -(a1),-(a0)
        dbra    d1,xrolop
xrolnxt addq.l  #2,[sp]
        jmp ([nx])

xnswapx move.l  ([sp])+,d0
        move.w  (a0),-([sp])
        move.w  d0,(a0)
        jmp ([nx])

xroldn  move.l  ([sp]),d0 roll top under
        lea     2([sp]),a0
        lea     2(a0),a1
xroldnl move.w  (a1)+,(a0)+
        dbra    d1,xroldnl
        addq.l  #2,[sp]
        move.w  d0,(a0)
        jmp ([nx])

Xmovmem move.w  ([sp])+,d2 len
        move.w  ([sp])+,d3 rep
        bmi.s   mmnxt
        subq.w  #1,d2
        bmi.s   mmnxt
        move.l  ([sp])+,a0 dst
        move.l  ([sp])+,a1 src
        chk     -$8000([bp]),d0
mmolop  move.w  d2,d1
mmilop  move.b  (a1)+,(a0)+
        dbra    d1,mmilop
        dbra    d3,mmolop
        move.w  ([sp])+,sr ;;
        move.l  a1,-([sp])
        move.l  a0,-([sp])
mmnxt   jmp ([nx])

Cmtinf  moveq   #0,d0
        trap    #1
        movem.l d1/d2/a0,-([sp])
        jmp ([nx])

Xrpstore move.l [bp],d0
        add.L   ur0-2([bp],[up].l),d0
        move.l  d0,[rp]
        jmp ([nx])

* quad

Xqswap  move.l  ([sp])+,d3 4swap
        move.l  ([sp])+,d4
        move.l  ([sp])+,d1
        move.l  ([sp])+,d2
        movem.l d1-d4,-([sp])
        jmp ([nx])

Xqult   bsr.s   Cqlt       qu<
        neg.w   d0
        bra.s   mmput(pc)

Cqlt    pea     Cqzl(pc)    q<
Cqsub   lea     8([sp]),[w] q-
        lea     8([w]),a0
        move.l  -([w]),d0
        sub.l   d0,-(a0)
        subx.l  -([w]),-(a0)
qltoi   subx.l  d0,d0   l<i
        move.l  a0,[sp]
        rts

Cqadd   lea     8([sp]),[w] q+
        lea     8([w]),a0
        move.l  -([w]),d0
        add.l   d0,-(a0)
        addx.l  -([w]),-(a0)
        bra.s   qltoi   -

Cqzl    asl.w   ([sp])+    q0<
        subx.w  d1,d1
        neg.w   d1
        addq.l  #4,[sp]
        move.w  d1,([sp])
        rts

Xqmplus move.w  ([sp])+,d0 qm+
        ext.l   d0
        smi     d1
        ext.w   d1
        ext.l   d1
        move.l  ([sp])+,d2
        add.l   ([sp])+,d0
        addx.l  d1,d2
        move.l  d0,-([sp])
        move.l  d2,-([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

Xumin   move.w  ([sp])+,d0 umin
        cmp.w   ([sp]),d0
        bcs.s   mmput
        jmp ([nx])

Xmin    move.w  ([sp])+,d0 min
        cmp.w   ([sp]),d0
        bge.s   nomin
mmput   move.w  d0,([sp])
nomin   jmp ([nx])

        clr.w   -([sp])    0max
Xmax    move.w  ([sp])+,d0 max
        cmp.w   ([sp]),d0
        bgt.s   mmput
        jmp ([nx])

Xumax   move.w  ([sp])+,d0 umax
        cmp.w   ([sp]),d0
        bhi.s   mmput
        jmp ([nx])

CXqsplus move.w  ([sp])+,a0 qsys+
        add.l   8+mtinftab-Z([bp]),a0
        move.l  a0,-([sp])
        jmp ([nx])

Xtworot move.l  ([sp])+,d2 2rot
        move.l  ([sp])+,d3
        move.l  ([sp])+,d1
        movem.l d1-d3,-([sp])
        jmp ([nx])

Xndrop  move.w  ([sp])+,d3 ndrop
        add.w   d3,d3 0,d0
        add.w   d3,[sp]
        jmp ([nx])

Xswapx  move.l  ([sp]),d3 swap
        swap    d3
        move.l  d3,([sp])
        jmp ([nx])

X2swap  move.l  ([sp])+,d3 2swap
        move.l  ([sp]),d1
        move.l  d3,([sp])
        move.l  d1,-([sp])
        jmp ([nx])

Xpick   move.w  ([sp]),d3 pick
        add.w   d3,d3
        move.w  2([sp],d3.w),([sp])
        jmp ([nx])

Xd4mul  move.l  ([sp]),d0 d4*
        lsl.l   #2,d0
        move.l  d0,([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

Xbytes  moveq   #0,d3   >|<
        move.b  ([sp]),d3
        sf      ([sp])
        move.w  d3,-([sp])
        jmp ([nx])

CXhere  move.L  udp-2([bp],[up].l),d0
        move.w  d0,-([sp])
        jmp ([nx])

Xallot  move.w  ([sp])+,d0 allot
        ext.l   d0
        add.l   d0,udp-2([bp],[up].l)
        jmp ([nx])

Xprevdef move.w uocurrent([bp],[up].l),ucurrent([bp],[up].l)
        jmp ([nx])

Xdefinitions
        move.w  ucurrent([bp],[up].l),uocurrent([bp],[up].l)
        move.w  ucontext([bp],[up].l),ucurrent([bp],[up].l)
        jmp ([nx])

Xfrot   movem.l ([sp])+,d2-d4   rot (fp)
        move.w  ([sp])+,d0
        move.l  ([sp])+,d1
        movem.l d1-d4,-([sp])
        move.w  d0,-([sp])
        jmp ([nx])

Xfdrot  move.l  ([sp])+,d4      -rot (fp)
        move.w  ([sp])+,d0    f3
        movem.l ([sp])+,d1-d3 f2 f1
        move.w  d0,-([sp])
        movem.l d1-d4,-([sp])
        jmp ([nx])

Xtoggle move.w  ([sp])+,d3    toggle
        move.w  ([sp])+,[w]
        eor.b   d3,0([bp],[w].w)
        jmp ([nx])

Xpdqteq moveq   #0,d1           (.")
        move.b  ([ip]),d1
        move.l  [ip],d0
        sub.l   [bp],d0
        addq.l  #1,d0
        move.w  d0,-([sp]) ptr
        move.w  d1,-([sp]) cnt
        or.b    #1,d1
        addq.w  #1,d1
        add.w   d1,[ip]
        lea     dfdtype(pc),[w]
        jmp     dodefer(pc)

* dup usermax < 7 ?error dup up @ max up ! constant ;code w @ up + jmp ([nx])
Xxnuser moveq   #7,d0   ernum
        lea     uup([bp],[up].l),a0
        move.w  ([sp]),d1
        bpl.s   xusidx  ? index
        move.w  (a0),d1
        move.w  d1,([sp])
        addq.w  #2,d1   next avail. user posn
xusidx  cmp.w   nuser+2-Z([bp]),d1
        bpl     goXqerr ? u.area full
        cmp.w   (a0),d1
        ble.s   xusjnx
        move.w  d1,(a0)
xusjnx  jmp ([nx])

docontinue move.l (a7)+,[ip]
        jmp ([nx])

sdoesc  jsr     dosdoes-Z([bp])
sconsc  jsr     doscons-Z([bp])

Xdoscons move.w  ([w])+,-([sp]) < (;cdoes>)
        bra.s   idc -
Xdosdoes sub.l  [bp],[w]     < (;does>)
        move.w  [w],-([sp])
idc     move.l  [ip],d0
        sub.l   [bp],d0
        move.l  ([rp])+,[ip]
        move.w  d0,-([rp])
        jmp ([nx])

Xddsgt  sub.l   [bp],[ip]     < does>
        move.w  [ip],-([rp])
        move.w  ([w])+,[ip]   cfa ptr to does>-part
        add.l   [bp],[ip]
        sub.l   [bp],[w]      push
        move.w  [w],-([sp])   pfa
        jmp ([nx])

* compiling ;does> and ;cdoes> imed
Xconsdgt move.l sconsc(pc),d2 < ;cdoes>
         moveq  #1,d3
         bra.s  doesnt -
Xexdoes  move.w udds([bp],[up].l),d3 ptr & flg
         bra.s  doexnt - after <with
Xsemidgt moveq  #1,d3
doexnt  move.l  sdoesc(pc),d2 < ;does>
doesnt  move.w  vsds+2-Z([bp]),vsds-Z([bp]) ur-aktion
        moveq   #11,d0
        add.l   udp-2([bp],[up].l),d0
        and.b   #-2,d0
        move.l  d0,udp-2([bp],[up].l)
        lea     -10([bp],d0.l),a0
        move.w  #smds-Z,(a0)+
        move.w  d0,(a0)+
        move.w  #psemicodeq-Z,(a0)+
        move.l  d2,(a0)+
        lsr.w   #1,d3
        bcs.s   doxjnx ? einfach ;does>
        add.w   d3,d3
        cmp.w   d3,d0
        bgt.s   doxins ? erbe passt
        move.w  #task+2-Z,d3
doxins  move.w  d0,udds([bp],[up].l)
        addq.l  #4,udp-2([bp],[up].l)
        move.w  #gonext-Z,(a0)+
        move.w  d3,(a0)+
doxjnx  jmp ([nx])

Ximed   moveq   #64,d0  immediate
        bra.s   imedntr
Xsmds   move.w  ([ip])+,udds([bp],[up].l)
Xunsmu  move.w  ucurrent([bp],[up].l),[w] unsmudge
        move.w  0([bp],[w].w),a0
        and.b   #-33,0([bp],a0.w)
        jmp ([nx])

Xsmudge moveq   #32,d0  smudge
imedntr move.w  ucurrent([bp],[up].l),[w]
        move.w  0([bp],[w].w),a0
        eor.b   d0,0([bp],a0.w)
        jmp ([nx])

Xwith   move.w  #xdgt-Z,vsds-Z([bp]) <with
        jmp ([nx])

Xedif   moveq   #0,d0   edif
        move.w  #scrfile-Z,d1
        move.b  dr0ch-Z([bp]),d0
        btst    #6,uoffset([bp],[up].l)
        beq.s   edfjnx  ?
        move.w  #loadfile-Z,d1
        move.b  dr1ch-Z([bp]),d0
edfjnx  move.w  d1,-([sp])
        move.w  d0,-([sp])
        jmp ([nx])

* headerless colondefn
Xnhed   tst.w   ustate([bp],[up].l)
jqexec  bne     Xqexec
        move.l  udp-2([bp],[up].l),d1
        addq.l  #1,d1
        and.b   #-2,d1
        move.w  d1,-([sp]) push cfa
        addq.l  #2,d1
        move.l  d1,udp-2([bp],[up].l)
        move.w  #docolon-Z,-2([bp],d1.w)
        move.l  [sp],d1   cpl ,
        sub.l   [bp],d1   !csp
        move.l  d1,ucsp-2([bp],[up].l)
        jmp     Xcarb(pc) ]

* create header w. name at {here
Xhead   tst.b   ustate+1([bp],[up].l)
        bne.s   jqexec  ?
        lea     udp-2([bp],[up].l),a1
        move.l  (a1),a0
        add.l   [bp],a0 here
        moveq   #31,d0
        and.b   (a0),d0 count
        beq.s   creaerr ?
        moveq   #%10100000,d2 smudge $c0
        or.b    d0,d2   nfa.b
        move.w  uwidth([bp],[up].l),d3
        cmp.w   d0,d3
        bpl.s   creawdt ? passt
        move.w  d3,d0
creawdt move.w  d0,d3   true count
        lea     1(a0,d0.w),a2 name+1
        add.l   a0,d0
        or.b    #1,d0   odd aligned
        addq.l  #5,d0   count & lfa & cfa
        move.l  d0,a0   pfa
        sub.l   [bp],d0
        move.l  d0,(a1)
        subq.l  #4,a0   lfa
        move.l  a0,a1
cncslop moveq   #$7f,d1
        and.b   -(a2),d1
        move.b  d1,-(a1)
cncup   dbra    d3,cncslop
        move.b  d2,(a1) smudge
        or.b    #-$80,-1(a0)
        move.w  ucurrent([bp],[up].l),d3
        move.l  0([bp],d3.w),(a0)+   latest ,
        sub.l   [bp],a1
        move.w  a1,ulast([bp],[up].l) nfa last !
        move.w  a1,0([bp],d3.w)      current @ !
        move.l  a0,d0
        sub.l   [bp],d0
        move.w  d0,-(a0)
Xcmcoff clr.w   cmc+2-Z([bp])
creaerr move.w  ([rp])+,[ip] semis
        add.l   [bp],[ip]
        jmp ([nx])

Xnexit  tst.w   ([sp])+
        beq.s   creaerr
        jmp ([nx])

*uchr dc.b 'ABCDEFGHIJKLMNOPQRSTUVWXYZ{|}~'

Xntry   move.l  ([sp])+,d0      entry
        moveq   #5,d2
        bsr     ccpairs >
        move.l  ([sp]),d3
        move.l  d0,([sp])
        lea     2([bp],d3.w),a0
        sub.w   udp([bp],[up].l),d3
        neg.w   d3
        bra.s   ntrybck

Xnter   bsr     ccstate >       enter
        move.w  #branch-Z,d3
        moveq   #3,d0
        lea     udp-2([bp],[up].l),a1
        add.l   (a1),d0
        and.b   #-2,d0
        move.w  d0,-([sp])
        move.w  #5,-([sp])
        addq.l  #2,d0
        move.l  d0,(a1)
        lea     -2([bp],d0.l),a0
        clr.w   (a0)
ntrybck move.w  d3,-(a0)
clrcmc  clr.w   cmc+2-Z([bp])
        jmp     ([nx])

Xqexit  move.w  #dexit-Z,d0     -exit
        bsr     tstcmc  >
        ble.s   qexcpl  ? -exit
        cmp.w   #zeq-Z,-2([w])
        bne.s   qexcpl  ?
        move.w  #nexit-Z,d0
        subq.l  #2,[w]
        subq.l  #2,(a1)
qexcpl  addq.l  #2,(a1)
        move.w  d0,([w])
        bra.s   clrcmc  -

Xpplus  move.w  ([sp])+,d0      ++
        add.w   ([sp])+,d0
        move.w  ([sp])+,d1
        addx.w  d0,d1
        subx.l  d0,d0   l<i
        move.w  d1,-([sp])
        jmp ([nx])


Xlplus  move.w  ([ip])+,-([sp]) lit+
Xplus   move.w  ([sp])+,d0      +
        add.w   d0,([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

*find max nfa less or eq ( ptr -- nfa )
Xtlfa   move.w  ([sp]),-([rp])  ptr >r
        move.w  uvocdashlk([bp],[up].l),([sp])
        moveq   #0,d4           flg
        bra.s   xtlfnt  -
* forget vocs.
xm39    move.w  #forth+6-Z,ucontext([bp],[up].l)
        move.w  0([bp],d1.w),d1
        move.w  d1,([sp])
        move.w  d1,uvocdashlk([bp],[up].l)
* entry to forget words
Xm40    moveq   #-1,d4          flag
        move.w  ([sp]),d1       ( voc-link @  ( rp: ptr
        cmp.w   ([rp]),d1       r over < 0=
        bgt.s   xm39            ? untl
xtlfnt  move.w  #$8000,d4       last -off
        lea     Xpfa(pc),[w]
        move.w  ([sp]),d3       dup (voclink)
        bra.s   xm4nd   ?
xm41    subq.w  #4,([sp])       4-  (start mit voc-link @
xm42    jsr     Cprim(pc) >
        move.w  ([sp]),d1       pfa
        move.w  -4([bp],d1.w),d1 lfa @
        move.w  d1,([sp])       dup
        cmp.w   ([rp]),d1       r
        bge.s   xm42    ?       < untl
        cmp.w   d4,d1           dup latest
        ble.s   xm4nl   ?
        move.w  d1,d4           max
xm4nl   tst.l   d4
        bpl.s   tlfnls  ?
        move.w  d1,-2([bp],d3.w) over 2- ! (new latest
tlfnls  move.w  0([bp],d3.w),d3 @
        move.w  d3,([sp])       dup
xm4nd   cmp.w   #$8000,d3       ( end of last voc
        bne.s   xm41    ?       -0= untl
xm4ctx  move.w  ([rp])+,d2      r>
        move.w  d4,([sp])       (top nfa
        tst.l   d4
        bpl.s   tlfjnx  ?       drop
        ext.l   d2
        move.l  d2,udp-2([bp],[up].l) dp !
        move.w  d4,ulast([bp],[up].l) ( last !
        move.w  ([rp])+,([sp])  drop r>
tlfjnx  jmp ([nx])

Xrot    move.l  ([sp])+,a0 rot
        move.w  ([sp])+,[w]
        move.l  a0,-([sp])
        move.w  [w],-([sp])
        jmp ([nx])

Xrplus  addq.w  #2,([rp]) r+
        move.w  ([rp]),d1
        move.w  -2([bp],d1.w),-([sp])
        jmp ([nx])

Xsover  move.l  ([sp]),d3 sover
        swap    d3
        move.l  d3,([sp])
        move.w  d3,-([sp])
        jmp ([nx])

Xabs    move.w  ([sp]),d0  abs
        bpl.s   absnx   ?
        neg.w   d0
        bpl.s   absps   ?
        moveq   #0,d0
absps   move.w  d0,([sp])
absnx   jmp     ([nx])

Xdabs   move.l  ([sp])+,d0 dabs
        bpl.s   dabsps  ?
        neg.l   d0
qabsps  bpl.s   dabsps  ?
        moveq   #0,d0     -ve 0
dabsps  move.l  d0,-([sp])
qabsnx  jmp     ([nx])

Xqabs   tst.b   ([sp])     qabs
        bpl.s   qabsnx  ?
        move.l  ([sp])+,d0
        move.l  ([sp]),d1
        neg.l   d1
        move.l  d1,([sp])
        negx.l  d0
        bra.s   qabsps  ?

* schlu von -->
Xdg01   clr.w   uin([bp],[up].l)
        addq.w  #1,uscr([bp],[up].l)
        move.w  cbbyscr-Z([bp]),d1
        add.w   d1,ublk([bp],[up].l)
        neg.w   d1
        and.w   d1,ublk([bp],[up].l)
        move.w  ([rp])+,[ip]
        add.l   [bp],[ip] semis
        jmp     ([nx])

* mul & div:

Cq4by   pea     Cq2by(pc)    q4/
Cq2by   bsr.s   Cd2by        q2/
        roxr.l  #1,d1
        move.l  d1,4([sp])
        rts
Cd4by   bsr.s   Cd2by        d4/
        bra.s   nxtby
Cd2by   movem.l ([sp]),d0/d1 d2/
nxtby   asr.l   #1,d0
        move.l  d0,([sp])
        rts

Xumul   move.w  ([sp])+,d0   u*
        mulu    ([sp])+,d0
        move.l  d0,-([sp])
        jmp ([nx])

Xmmul   move.w  ([sp])+,d0   m* <mulbymod>
        muls    ([sp])+,d0
        move.l  d0,-([sp])
        jmp ([nx])

Xmul    move.w  ([sp])+,d1   *
        mulu    ([sp])+,d1
        move.w  d1,-([sp])
        jmp ([nx])

Xuqmbymod move.l ([sp])+,-([rp]) uq*/mod
        bsr     cudmmul >
        move.l  ([rp])+,-([sp])
        jmp     Xudmbym(pc)

Xmplus  move.w  ([sp])+,a0   m+
        add.l   ([sp]),a0
        move.l  a0,([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

Xusby   move.w  ([sp]),-([sp])  u/
        clr.w   2([sp])
        pea     Xsdrop(pc)
        bra.s   Cumbym  -
Cumod   move.w  ([sp]),-([sp])  u/mod
        clr.w   2([sp])
Cumbym  move.w  ([sp])+,d1      um/mod
        beq.s   ubynul   ?  div null
        move.l  ([sp]),d0
        divu    d1,d0
ubyspt  swap    d0
ubyput  move.l  d0,([sp])
        rts

* usnigned ovf rmd & qot
ubynul  moveq   #-1,d0
        move.l  ([sp]),d1
        bne.s   ubyput  ? set ovf both r & q to unsigned max
        moveq   #1,d0   on 0/0 leave r=0 q=1
        bra.s   ubyspt

* signed ovf rmd & qot
mbynul  bsr     bynulov   * rmd 0 or +/-7fff qot 1. or +/-7fff.ffff
        move.w  ([sp])+,d0 drop qot.hi
        beq.s   mbynulret  ? r=0 q=1
        move.w  d1,([sp])  set qot to ovf
mbynulret rts

Cmulbym move.w  ([sp])+,d1   */mod
        beq.s   mbynul  ?
        move.w  ([sp])+,d0
        muls    ([sp])+,d0
        bra.s   mulbyn  -

Cmby    move.w  ([sp])+,d1   m/
bymodent beq.s  mbynul  ? <bymod
        move.l  ([sp])+,d0
mulbyn  divs    d1,d0
umbyext swap    d0
        move.l  d0,-([sp])
        rts

bymodcal movem.w ([sp])+,d1/d2  <mod   sign extend dvs
        move.l  d2,-([sp])
        tst.w   d1         test for div nul
        bra.s   bymodent

Xmod    bsr.s   bymodcal     mod
        addq.l  #2,[sp]
        jmp ([nx])

Xmulby  bsr.s   Cmulbym -    */
        move.w  ([sp])+,([sp])
        jmp ([nx])

X1off   move.w  ([sp])+,a1   1off
        sf      0([bp],a1.w)
        jmp     ([nx])

X1on    move.w  ([sp])+,a1   1on
        or.b    #1,0([bp],a1.w)
        jmp     ([nx])

Xupdate moveq   #-1,d0
        moveq   #-128,d1
        bra.s   updnt

Xupdoff moveq   #127,d0
        moveq   #0,d1
updnt   lea     vprev-Z([bp]),a1
        move.w  (a1)+,d2
        tst.w   (a1)
        beq.s   nupdt ?
        lea     0([bp],d2.w),a1
        lsr.w   #1,d2
        bls.s   nupdt ?
        and.b   d0,(a1)
        or.b    d1,(a1)
nupdt   jmp ([nx])

Xmem    move.l  [sp],d2
        sub.l   [bp],d2
        jsr     cpad(pc) >
        sub.l   d0,d2
        move.w  d2,([sp])
        move.l  d2,d0   l<i
        jmp ([nx])

Xeofq   clr.w   -([sp])      eof?
        moveq   #-10,d0
        cmp.l   qf.error-Z([bp]),d0
        beq.s   posrer  ?
        jmp ([nx])

Xeof    clr.w   -([sp])      eof ( flg = 1 bei eof
        bsr.s   Cfpos   >
        addq.l  #4,[sp]
        moveq   #-10,d2
        cmp.l   d0,d2
        bne.s   eofjnx  ?
        moveq   #0,d0
        move.l  d0,qf.error-Z([bp])
posrer  addq.w  #1,([sp])
eofjnx  jmp ([nx])

Xposab  moveq   #66,d4       posab
        bra.s   posntr  -
Xposre  moveq   #67,d4       posre
posntr  move.l  ([sp])+,d1 flg = 0 oke
        clr.w   -([sp])
        bsr.s   Cpsre   >
        addq.l  #4,[sp]
        tst.l   d0
        bne.s   posrer  -
        jmp ([nx])

Cfpos   moveq   #0,d1        fpos
        moveq   #67,d4  fs.posre
Cpsre   moveq   #0,d3
        move.b  usriow(pc),d3 work
        jsr     mkchp(pc) >
        move.l  d3,d0
        bmi.s   fpserr  ?
        move.l  d3,a0
        moveq   #-1,d3
        move.l  d4,d0
        trap    #3
fpserr  move.l  d0,qf.error-Z([bp])
        move.l  d1,d1lq-Z([bp])
        move.l  d1,-([sp]) fpos
        rts

Cpeof   bsr.s   Cfpos   >    poseof ( goto eof
        addq.l  #4,[sp] 2drop
        move.l  d1,d4   fpos
        moveq   #-1,d2
poflop  cmp.l   d1,d2
        beq.s   poftst  ? device-fehler
        move.l  d1,d2
        move.l  #32766,d1
pofpre  moveq   #67,d0  fs.posre
        trap    #3
        tst.l   d0
        beq.s   poflop  ? mehr
        move.l  d1,d2
poftst  moveq   #-10,d1
        cmp.l   d1,d0
        bne.s   pofret  ? fehler
        moveq   #0,d0
pofret  move.l  d0,qf.error-Z([bp])
        rts

Xflen   clr.l   -([sp]) ( -- dn ) flen
        bsr.s   Cpeof   >
        tst.l   d0
        bne.s   flejnx  ? fehler
        move.l  d2,([sp])
        moveq   #66,d0  posab
        move.l  d4,d1   posn
        trap    #3
flejnx  jmp ([nx])

* fp vergleichsoperationen

Xfeq    pea     Xzeq-Z([bp])
        bra.s   Cfcmp   >   =

Xfzlt   bsr.s   Cfsgn   >   0<
        neg.w   ([sp])
        bra.s   fzqntr
Xfzgt   bsr.s   Cfsgn   >   0>
        bra.s   fzqntr  -
Xfzeq   bsr.s   Cfsgn   >   0=
fzqntr  ble.s   feqeq   ?
        clr.w   ([sp])
feqeq   addq.w  #1,([sp])
        jmp ([nx])

Xflt    bsr.s   Cfcmp   >   <
        neg.w   ([sp])
        bra.s   fltest  -
Xfgt    bsr.s   Cfcmp   >   >
fltest  bge.s   fgtjnx
        clr.w   ([sp])
fgtjnx  jmp ([nx])

Cfsgn   clr.l   -([sp])     sgn
        clr.w   -([sp])
Cfcmp   moveq   #1,d5       cmp => 1:f1>f2 0:f1=f2 -1:f1<f2
        move.w  ([sp])+,d0  f2
        move.l  ([sp])+,d1
        move.w  ([sp])+,d2  f1
        move.l  ([sp])+,d3
        move.l  d5,d4   +ve result f1 > f2
        eor.l   d1,d3
        bmi.s   fcmret  ? mnt sign =/= : -ve/+ve num
        tst.l   d1
        bpl.s   fcpsve  ? beide +ve
        exg     d2,d0
fcpsve  cmp.w   d2,d0   e2-e1
        blt.s   fcpret  ? e: f1 > f2
        bgt.s   fcpfmi  ? e: f1 < f2
        eor.l   d1,d3
        cmp.l   d3,d1   m2-m1
        blt.s   fcpret  ?
        beq.s   fcpfeq  ? f1 = f2
fcpfmi  sub.w   d5,d4
fcpfeq  sub.w   d5,d4
fcpret  move.w  d4,-([sp])
        rts
fcmret  tst.l   d1
        bpl.s   fcpfmi  ?
        move.w  d4,-([sp])
        rts

ctr_emt lea     dfdemit(pc),[w]
        jmp     dodefer(pc)

doctrl  tst.b   ctflag+1-Z([bp])  <ctrlwa
        beq.s   ctrlnix ? no action
        move.w  ([ip])+,-([sp])
Xctrl   tas     ctflag-Z([bp])
        beq.s   ctr_emt ? emit true char
        move.w  ([sp]),d1
        move.b  d1,ctflag-Z([bp])
        ble.s   CTn     ? 127 < chr < 255 or chr=0
        cmp.w   #127,d1
        sne     d0
        and.b   d0,d1
        cmp.w   #32,d1
        bcc.s   CTn     ? 32 < chr < 127
        moveq   #0,d2      provide for {out}
        move.w  d2,([sp])  drop char & set flag to 'ok'
        move.w  d1,-([sp])
        lea     -2([bp]),[w]
        add.w   uocc4th([bp],[up].l),[w]
        move.w  #docases-Z+1,d3
        sub.w   ([w])+,d3
        cmp.w   2([w]),d3
        beq     Xdocases
        jmp     nodferd(pc)
CTn     move.w  #1,-([sp])
ctrlnix jmp ([nx])

* cfa table for is} & default-is} and table of is}-actions
istab   dc.w dferdfd-*,dodefer-Z
        dc.w consdfd-*,docons-Z
        dc.w consdfd-*,dovariable-Z
dftnd   dc.w twoconsdfd-*,do2cons-Z
        dc.w fconsdfd-*,dofcons-Z
        dc.w twoconsdfd-*,dovariable-Z
        dc.w userdfd-*,douser-Z
        dc.w ddgdfd-*,docases-Z
        dc.w rgasdf-*,doassoc-Z
        dc.l 0

rgasdf  moveq   #4,d0      disp to top index & flag
        neg.w   d0
        bra.s   selcse     -
ddgdfd  moveq   #-6,d0
selcse  add.w   (a0)+,d0   top index ptr & flag
        move.w  ([sp])+,d1 index
        bmi     nodferd    ? < 0
        add.w   d1,d1
        cmp.w   d1,d0
        bmi     nodferd    ? index > max
        tst.l   d0
        bpl.s   consdfd    range: or associative:
        tst.w   (a0)+      flag
        beq.s   consdfd    ? no cfa-cases
dferdfd subq.w  #2,d3      cfa
consdfd move.w  d3,0(a0,d1.w) !
        jmp ([nx])

userdfd lea     0([bp],[up].l),a1
        add.w   (a0),a1
        move.w  d3,(a1)
        jmp ([nx])

twoconsdfd move.w d3,(a0)+
        move.w  ([sp])+,(a0)
        jmp ([nx])

fconsdfd move.w d3,(a0)+
        move.l  ([sp])+,(a0)
        jmp ([nx])




* dummy <data> for altkey selection
polblk dc.w -1 ptr auf link in erste verkettungsposition
 dc.b -1 herkunftsflag bei gltigem tastencode
 dc.b -1 gelesenes zeichen
pkeyq dc.l -1 <i/o-queue>
 dc.l -1 n.i.
klkys dc.l '%LKY' <signature>
poll  dc.l -1 start of/call to <defining routine>

* locations to initially invalidate
mty  dc.w hishnd-*
     dc.w pkeyq-*
     dc.w poll-*
     dc.w thntry-*
     dc.w 0

Z equ *+$8000
 LIST
sys dc.w $8000
 [.debug]LIST
sysname  dc.w 2,'F6'
syscreen
 dc.b 2,1,0,7 farben
 dc.w 448,202,32,14 mae
qf.error dc.l 0      : $12

* 4th system vari
savehead
 dc.l dptop+Z-go file length
 dc.b 0,1 access code = 0, filetype = executeable
 dc.l dataspace,0

* a simple redirection of our channel table:
iochn   dc.b 1  current i/o            set by 'mkchp'
dr0ch   dc.b 14 dr0 r/w           screen
dr1ch   dc.b 15 dr1 save, chain   file
stdio   dc.b 0  console/std input      in-cons (chain)
stdout  dc.b 1  console/std output     out-cons
usriup  dc.b 2  user input/update file printer
usriow  dc.b 3  user io/work file      work
        ds.w 0  (align)
* Channels are set up as (id's at limit+):
*  0    : primary input: first EX chan or screen
*  1    : primary output: second or only EX chan or screen
*  2    : uncommitted
*  3-11 : may also be passed in by EX
* 12-13 : uncommitted
* 14    : Used by r/w as dr0. used for screen i/o
* 15    : Used by r/w as dr1. Also used by save.

* +origin base of fig-FORTH proper
origin  jmp     docold(pc) 0 restore all regs
        jmp     dowarm(pc) 4
obasecpu dc.l $4fe9fe22    8 ver.name (M68LR6) in radix 36
* cold/warm move the following to the user area
olast   dc.w lastop-Z 0c last name in dictionary
        dc.w $c2      0e backspace character
oup     dc.L 0,0,0    10 initial up, s0, r0 and
otib    dc.w 0        1c initial tib - filled in at prog exec
        dc.w 31       1e width   initial max width for names
        dc.w 0        20 warning 0: no disk, 1: dr0 available, -1: (abort) in use
* warm stops here
ofnc    dc.w lktop-Z  22 fence  initial fence address (lfa)
odp     dc.L dptop    24 dp=>-L initial top of dictionary
ovocl   dc.w voctop-Z 28 voc-link initial voc. link pointer
ouup    dc.w uptop    2a user top
* cold goes all the way, and also resets forth+6 from origin+$c
winhnd  dc.l 0 2c \handler to determine
        dc.l 0 30 |romhnd ..a window channel
pifdsp  dc.l 0 34 |parm-cdt displacement w. pif
 dc.l 0 38 |pif io-queue disp to cdt
 dc.l 0 3c /pif dummy queue
*
thntry  dc.l 0 40 th.entry
hkthg   dc.l 0 44 the hotkey thing
vquit   dc.w loadquit-Z (quit) initial quit-cfa
vert    dc.w -1 4a toggle ert-action
 dc.w  2 4c
vbreak  dc.w -1 4e
* end of 4th-system initable

bootfile string {flp1_forth_scr}
        dcb.b cfname+2-*+bootfile,0
loadfile string {flp2_forth_scr}
        dcb.b cfname+2-*+loadfile,0
scrfile string {flp2_fig_scr}
        dcb.b cfname+2-*+scrfile,0
prtfile string {ser1}
        dcb.b cfname+2-*+prtfile,0
dirfile string {flp2_}
        dcb.b cfname+2-*+dirfile,0
lngnam   string {_lngBAD}

jdttab   dc.l 0 base address of own job definition table
procftab dc.b 0 -1 68010+, 0 otherwise
emuflag  dc.b 0 -2 qxl, -1 emu, 1 pre-js, 0 otherwise
 dc.b 0 char of national qdos version
miflag   dc.b 0 -1 minerva (flag for ri-exec), 0 otherwise
mtinftab dc.l 0 job-id
         dc.l 0 qdosver qdos vernum (n.nn)
sysvari dc.l 0 base of system variables
deftch  dc.l 0 1st (default) channel
        dc.l 0 base address a6 = [bp]
bank    dc.l Z-Z initial link offset into (nxt) memory field
refclon dc.l 0 owner-job A6 if this is a clone
wmanvec dc.l 0 window manager vector if > 0
clsp    dc.w 0
hishnd  dc.l -1 history
quadf   dc.w 0 quad number compileflag 0/4

muldivtab dc.b 16,14,0
 ds.w 0

* +++

Xtrap0  chk     -$8000([bp]),d0
        jmp ([nx])

Xtrap0s trap   #0
        jmp ([nx])

* use:create name} docall/docallw - exec subroutine return to next
docall  pea     ([nx])
dojump  move.l  ([w])+,a1
        jmp     0([bp],a1.l)

docallw pea     ([nx])  push 'rts'-destination
        move.w  ([w])+,a1
        jmp     0([bp],a1.l)

TSTJNX
*  [nx] mustn't change & [sp] must be even

voc setstr fth

* next-entries must preserve a0, a3 and all data-regs other than d5
next0   move.w  ([ip])+,[w]  <gonext
        sub.l   [bp],[ip]
        move.w  [ip],-([rp]) push ip
        move.w  [w],[ip]
        add.l   [bp],[ip]
next    move.w  ([ip])+,[w]  <jmp [nx]
next1   add.l   [bp],[w]     <4th exec
        move.w  ([w])+,a1
        jmp     0([bp],a1.w)
Xdlit   move.l  ([ip])+,-([sp])
jnxcode jmp ([nx])

Xlit    move.w  ([ip])+,-([sp])
        jmp ([nx])

Xqlit   move.l  ([ip])+,d1
        move.l  ([ip])+,-([sp])
        move.l  d1,-([sp])
        jmp ([nx])

Xperform move.w ([sp]),[w]  @
        move.w  0([bp],[w].w),([sp])
        bra.s   Xexecute -
Xcfaexec subq.w #2,([sp])   cfa
Xexecute move.w ([sp])+,[w] exec
         bra.s  next1

Xpsemicq move.l aendcode-Z([bp]),-([sp])
         jmp ([nx])

doscons jmp     Xdoscons(pc)
dosdoes jmp     Xdosdoes(pc)

Xzdbra  tst.w   ([sp])
        beq.s   Xzbra   drop & branch if eq
        addq.l  #2,[ip] else try again
        jmp ([nx])

Xnzbra tst.w ([sp])+
        bne.s   Xbranch
        addq.l  #2,[ip]
        jmp ([nx])

Xlebra  subq.w  #1,([sp])
Xmibra  tst.w   ([sp])+
        bmi.s   Xbranch
        addq.l  #2,[ip]
        jmp ([nx])

Xszbra  move.w  ustate([bp],[up].l),-([sp])
Xzbra   tst.w   ([sp])+
        beq.s   Xbranch   ?
        addq.l  #2,[ip]
        jmp ([nx])

Xploopq moveq   #1,d0
loopcmp add.w   ([rp])+,d0
        cmp.w   ([rp]),d0
        bge.s   loopex    ?
loopon  move.w  d0,-([rp])
Xbranch add.w   ([ip]),[ip]
        jmp ([nx])

Xgtbra  subq.w  #1,([sp])
Xplbra  tst.w   ([sp])+
        bpl.s   Xbranch
        addq.l  #2,[ip]
        jmp ([nx])

Xpplopq move.w  ([sp])+,d0
        bgt.s   loopcmp   ?
        add.w   ([rp])+,d0  (also terminates 0 +loop)
        cmp.w   ([rp]),d0
        bgt.s   loopon    ?
loopex  addq.l  #2,[ip]
Xrdrop  addq.l  #2,[rp]
        jmp ([nx])

X2grr   move.l  ([sp]),-([rp])  copy and
        jmp ([nx])

X2gr    move.l  ([sp])+,-([rp]) push double
        jmp ([nx])

Xqleave move.w  ([sp])+,d0 : -leave
        beq.s   nixleave
Xleave  move.w  ([rp]),d0 keep running index
        move.w  d0,2([rp])
nixleave jmp ([nx])

Xone    move.w  #1,-([sp])
        jmp ([nx])

docand  move.w  ([w]),-([sp])
Xand    move.w  ([sp])+,d0
        and.w   d0,([sp])
        jmp ([nx])

Xtwoand move.l  ([sp])+,d0
        and.l   d0,([sp])
        jmp ([nx])

Xevup   addq.w  #1,([sp])
Xeven   and.w   #-2,([sp])
        jmp ([nx])

Xorx    move.w  ([sp])+,d0
        or.w    d0,([sp])
        jmp ([nx])

Xxor    move.w  ([sp])+,d0
        eor.w   d0,([sp])
        jmp ([nx])

qerrs   dc.w    *+2-Z
        move.w  ([rp])+,[ip]
        add.l   [bp],[ip] semis
jqerr   tst.l   qf.error-Z([bp])
        bra.s   neqset -

Xzneq   clr.w   -([sp])
Xneq    cmp.w   ([sp])+,([sp])+
neqset  sne     d0
        bra.s   zlepush

Xeq     cmp.w   ([sp])+,([sp])+
        bra.s   equset

Xdzeq   tst.l  ([sp])+
        bra.s   equset

Xmzeq   eor.b   #$80,([sp]) -0=
Xzeq    tst.w   ([sp])+      0=
equset  seq     d0
        bra.s   zlepush

Xdeq    cmp.l   ([sp])+,([sp])+
        bra.s   equset

Xdzl    move.w  ([sp])+,([sp])
Xzlt    tst.w   ([sp])+
zleset  smi     d0
zlepush neg.b   d0
        ext.w   d0
        move.w  d0,-([sp])
        jmp ([nx])

Xduless cmp.l   ([sp])+,([sp])+
        bra.s   uleset

Xuless  cmp.w   ([sp])+,([sp])+
uleset  scs     d0
        bra.s   zlepush

Xzgt    clr.w   -([sp])
Xgreat  cmp.w   ([sp])+,([sp])+
rgtset  sgt     d0
        bra.s   zlepush

Xdless  cmp.l   ([sp])+,([sp])+
        bra.s   tstless
Xless   cmp.w   ([sp])+,([sp])+
tstless slt     d0
        bra.s   zlepush

Xdugt   cmp.l   ([sp])+,([sp])+
        shi     d0
        bra.s   zlepush -

X1abs   not.w   ([sp])
        bpl.s   x1anxt  ?
Xnot    not.w   ([sp])
x1anxt  subx.l  d0,d0   l<i
        jmp ([nx])

Xplds   tst.w   ([sp])+
        bpl.s   xpret   ?
Xminus  neg.w   ([sp])
xpret   subx.l  d0,d0   l<i
        jmp ([nx])

Xsysfl  move.l  procftab-Z([bp]),-([sp])
        jmp ([nx])

Xfthid  move.l  mtinftab-Z([bp]),-([sp])
        jmp ([nx])

* error (pseudo-)constants

Xfperr  move.w  #Z-Z,-([sp])
cfperr  equ     *-2
        clr.w   cfperr-Z([bp])
        jmp ([nx])

vftherr equ *+2
Xftherr move.w  #0,-([sp])
        clr.w   vftherr-Z([bp])
        jmp ([nx])

Xioerr  move.l  #ioerr-ioerr,-([sp])
cioerr  equ     *-4
        addq.l  #2,[sp]   leave single length cons
        clr.w   2+cioerr-Z([bp])
        jmp ([nx])

Xernum  move.l  qf.error-Z([bp]),-([sp])
        clr.l   qf.error-Z([bp])
        jmp ([nx])

Xert    tst.w   vert-Z([bp]) ert
        beq.s   Xtwodp  ?
        move.l  ([sp])+,d0
        jmp     rwtst(pc)

Xfourdp addq.l  #4,[sp]      4drop
Xtwodp  addq.l  #4,[sp]      2drop
        jmp ([nx])

Xdrops  move.w  ([rp])+,[ip] drop;
        add.l   [bp],[ip]
Xdrop   addq.l  #2,[sp]      drop
        jmp ([nx])

Xdashrot move.w ([sp])+,[w]  -rot
        move.l  ([sp])+,d0
        move.w  [w],-([sp])
Xlixl   move.l  d0,-([sp])   l<i
        jmp ([nx])

Xcspsto move.L  ucsp-2([bp],[up].l),d0
        bra.s   csprpsh

Xspsto  move.L  us0-2([bp],[up].l),d0
csprpsh lea     0([bp],d0.L),[sp]
        jmp ([nx])

Xtworf  move.l  ([rp]),-([sp])  2r
        jmp ([nx])

X2rg    move.l  ([rp])+,-([sp]) 2r>
        jmp ([nx])

Xgrr    move.w  ([sp]),-([rp])  >rr
        jmp ([nx])

Xdgr    move.w  ([sp])+,-([rp]) >r >r
Xgreatr move.w  ([sp])+,-([rp]) >r
        jmp ([nx])

Xdrg    move.w  ([rp])+,-([sp]) r> r>
Xrg     move.w  ([rp])+,-([sp]) r>
        jmp ([nx])

Xdrx    move.w  ([rp]),-([sp])  r r
Xrx     move.w  ([rp]),-([sp])  r ( =:= i )
        jmp ([nx])

Xj      move.w  4([rp]),-([sp]) j
        jmp ([nx])

Xni     move.w  ([sp])+,d0   ni
        lsl.w   #2,d0
        move.w  0([rp],d0.w),d0
Xlix    move.w  d0,-([sp])
        jmp ([nx])

Xdashd  move.w  ([sp]),d0    -dup
        bne.s   Xlix    ?
        jmp ([nx])

Xover   move.w  2([sp]),-([sp]) over
        jmp ([nx])

X4dup    move.l 4([sp]),-([sp]) 4dup
Xtwoover move.l 4([sp]),-([sp]) 2over
         jmp ([nx])

Xddup   move.w  ([sp]),-([sp])  ddup
Xdup    move.w  ([sp]),-([sp])  dup
        jmp ([nx])

Xtwodup move.l  ([sp]),-([sp])  2dup
        jmp ([nx])

X2sdrop move.l  ([sp])+,([sp])  2sdrop
        jmp ([nx])

* (doctrl..)

Xplusorg add.w  #origin-Z,([sp])
         jmp ([nx])

Xcodeplus lea   go(pc),a1    code+
        bra.s   bsplsnt -
Xbaseplus move.l [bp],a1     base+
bsplsnt add.w   ([sp])+,a1
fthplnt move.l  a1,-([sp])
        jmp ([nx])

Xtfp    move.l  ([sp])+,a1
        sub.l   [bp],a1
        bra.s   fthplnt

Xtbp    move.l  [bp],d0      2base+
        bra.s   tbpntr

Xd2mul  move.l  ([sp]),-([sp])  d2*
        bra.s   Xdplus
Xo2d    move.l  4([sp]),-([sp]) 2over-
Xddash  neg.l   ([sp])          d-
Xdplus  move.l  ([sp])+,d0      d+
tbpntr  add.l   d0,([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

Xqplds  tst.w   ([sp])+      q+-
        bpl.s   qmijnx
Xqminus neg.l   4([sp])      qminus
        negx.l  ([sp])
qmijnx  subx.l  d0,d0   l<i
        jmp ([nx])

Xdplds  tst.w   ([sp])+      d+-
        bpl.s   nodminus
Xdminus neg.l   ([sp])       dminus
nodminus subx.l d0,d0   l<i
         jmp ([nx])

Xdexit  tst.w   ([sp])+      -exit
        beq.s   qsmjnx  ?
dosemis move.w  ([rp])+,[ip] ;s
        add.l   [bp],[ip]
qsmjnx  jmp ([nx])

Xcarb   move.w  #%11000000,ustate([bp],[up].l)
        jmp ([nx])

dorix   move.w  ([w])+,d0
        jmp     XriXd0(pc)

dodmpl  move.w  ([w])+,a0    intm+
        add.l   ([sp]),a0
        move.l  a0,([sp])
        jmp     ([nx])

doipl   move.w  ([w])+,d1    int+
        add.w   d1,([sp])
        jmp     ([nx])

X3mul   move.w  ([sp]),d0    3*
        pea     sixment(pc)
        bra.s   Xtwomul

X16mul   pea    Xfourmul-Z([bp])
Xfourmul pea    Xtwomul-Z([bp]) 4*
Xtwomul asl.w   ([sp])          2*
tstmul  bvc.s   tml_nvs
        bchg    #7,([sp])
tml_nvs rts

Xfourby asr.w   ([sp])       4/
Xtwoby  asr.w   ([sp])       2/
        rts

X6mul   pea     sixment(pc)  6*
        bra.s   X5mul

X10mul  pea     Xtwomul-Z([bp]) 10*
X5mul   move.w  ([sp]),d0       5*
        bsr.s   Xfourmul
sixment add.w   d0,([sp])
        bra.s   tstmul

Xbasef  move.w  ubase([bp],[up].l),-([sp])
        jmp ([nx])      base@

Xbases  move.w  ([sp])+,ubase([bp],[up].l) reset base
        jmp ([nx])      base!

Xdplf   move.w  udpl([bp],[up].l),-([sp])
        jmp ([nx])      dpl@

Xzinsto clr.w   uin([bp],[up].l)
        jmp ([nx])

Xstatef move.w  ustate([bp],[up].l),-([sp])
        jmp ([nx])      state@

Xtibf   move.w  utib([bp],[up].l),-([sp])
        jmp ([nx])      tib@

Xwaf    move.w  uwarning([bp],[up].l),-([sp])
        jmp     ([nx]) ;;

Xoverd  move.w  2([sp]),-([sp]) over-
Xdash   move.w  ([sp])+,d0      -
        sub.w   d0,([sp])
        subx.l  d0,d0   l<i
        jmp ([nx])

outcpu  move.w  d0,([sp])
        lea     dotcpu+2-Z([bp]),[w]
        jmp     docolon-Z([bp])

Xspfetch move.l [sp],[w]     sp@
         bra.s  dovariable

Xrpfetch move.l [rp],[w]     rp@
         bra.s  dovariable

Xpwquoteq move.l [ip],[w]    (")
        moveq   #1,d0
        and.w   ([ip]),d0
        add.w   ([ip])+,d0
        add.w   d0,[ip]
dovariable sub.l [bp],[w]
        move.w  [w],-([sp])
        jmp ([nx])

docolon sub.l   [bp],[ip]    :
        move.w  [ip],-([rp])
        move.l  [w],[ip]
        jmp ([nx])

dodoesg jmp Xddsgt(pc)      does>

docons  move.w ([w])+,-([sp])
        jmp ([nx])

douser  move.w  ([w])+,-([sp])
        add.w   [up],([sp])
        jmp ([nx])

do2cons move.l  ([w])+,-([sp])
dfdoff  jmp ([nx])

dodefer moveq   #0,d0
        move.l  [w],a1
trydfer move.w  (a1)+,d0 cfa
        move.w  d0,[w]
        lsr.w   #1,d0    odd
        bcs.s   dfdoff   ? don't exec
        cmp.w   #$4000,d0
        beq.s   trydnxt  ? empty exvec
        cmp.L   udp-2([bp],[up].l),[w]
        blt     next1
trydnxt not.l   d0
        bpl.s   nodferd  ? no 3rd chance
        move.w  (a1),-(a1) restore default action
        bra.s   trydfer  try 2nd

istobody dc.w dojump-Z
 dc.l Xistobody-Z mit semis!
 dc.b 4!128,4!128,'(is',')'!128,0,0
bisq dc.w dojump-Z
 dc.l Xbisq-Z

dfderr  dc.w *+2-Z
nodferd moveq   #26,d0
        jmp     goXqerr(pc)

bdeftb  dc.w *+2-Z
        lea     2([bp]),a1
        add.w   ([sp])+,a1
        move.w  (a1),-(a1)
        jmp ([nx])

dftcfa  dc.w dojump-Z
 dc.l Xdftcfa-Z

 dc.b 129,'+'!128,0,0,0,0
plus dc.w dojump-Z
 dc.l Xplus-Z

Xhex    move.w  #16,ubase([bp],[up].l)
        jmp ([nx])

Xdecimal move.w #10,ubase([bp],[up].l)
        jmp ([nx])

basecpu dc.w dojump-Z
 dc.l Xbasecpu-Z

Xsdgd   move.w  ([sp])+,[w]
        move.l  [w],-([sp])
        jmp ([nx])

Xcdgs   tst.b   1([sp]) c->s
        smi     ([sp])
        jmp ([nx])

Xcasix  move.w  d1,-([sp]) <index
        jmp ([nx])

Xby     jsr     bymodcal(pc)
Xsdrop  move.w  ([sp])+,([sp])
        jmp ([nx])

Xclosto move.w  ufence([bp],[up].l),-([sp])
Xsavsto jmp     CXsavsto(pc)

Xtical  move.l  tical-Z([bp]),-([sp])
        jmp ([nx])

Xdrzero clr.w   uoffset([bp],[up].l)
        jmp ([nx])
Xdrone  move.w  #$4000,uoffset([bp],[up].l)
        jmp ([nx])
Xblkft  move.w  ublk([bp],[up].l),-([sp])
        jmp ([nx])
Xfencef move.w  ufence([bp],[up].l),-([sp])
        jmp ([nx])
Xlastf  move.w  ulast([bp],[up].l),-([sp])
        jmp ([nx])

dofcons move.l  ([w])+,d3
        move.w  ([w])+,-([sp])
        move.l  d3,-([sp])
        bra.s   fhibyt

dofscons clr.w  -([sp])
        move.l  ([w])+,-([sp])
        bra.s   dpld2

Xf2div  subq.w  #2,([sp])
Xf2mul  addq.w  #1,([sp])
fhibyt  and.b   #15,([sp])
dpld2   move.w  #-2,udpl([bp],[up].l)
        jmp ([nx])

Xnqad   sf      1+quadf-Z([bp])
        jmp ([nx])
Xquad   move.b  #4,1+quadf-Z([bp])
        jmp ([nx])

Xlbrac  sf      ustate([bp],[up].l)
Xbrac   sf      1+ustate([bp],[up].l)
        jmp ([nx])

Xauxs   move.w  ([sp])+,aux-Z([bp])
        move.w  #aux-Z,-([sp])
        jmp ([nx])

Xd1qh   move.w  d1lq-Z([bp]),-([sp])
        jmp ([nx])
Xd1qw   move.w  d1lq+2-Z([bp]),-([sp])
        jmp ([nx])
Xa1qw   move.w  a1wq-Z([bp]),-([sp])
        jmp ([nx])
Xa1ql   move.l  a1lq-Z([bp]),-([sp])
        jmp ([nx])
Xa2ql   move.l  a2lq-Z([bp]),-([sp])
        jmp ([nx])
Xd1ls   move.l  ([sp])+,d1lp-Z([bp])
        jmp ([nx])
Xd2ls   move.l  ([sp])+,d2lp-Z([bp])
        jmp ([nx])
Xd1hs   move.w  ([sp])+,d1lp-Z([bp])
        jmp ([nx])
Xd1ws   move.w  ([sp])+,d1lp+2-Z([bp])
        jmp ([nx])
Xd2ws   move.w  ([sp])+,d2lp+2-Z([bp])
        jmp ([nx])
Xd0ws   move.w  ([sp])+,d0wp-Z([bp])
        jmp ([nx])
Xd3ws   move.w  ([sp])+,d3wp-Z([bp])
        jmp ([nx])
Xd3ts   move.w  d3wp-Z([bp]),d3wt-Z([bp])
        bra.s   Xd3ws
Xd3rs   move.w  d3wt-Z([bp]),d3wp-Z([bp])
        jmp ([nx])
Xa1ws   move.w  ([sp])+,a1wp-Z([bp])
        jmp ([nx])
Xa1ls   move.l  ([sp])+,a1wp-Z([bp])
        jmp ([nx])
Xa2ws   move.w  ([sp])+,a2wp-Z([bp])
        jmp ([nx])
Xa2ls   move.l  ([sp])+,a2lp-Z([bp])
        jmp ([nx])

Xdot30 move.l  [ip],[w]
       addq.l  #2,[ip]
Xt30   jmp     CXt30(pc)

t30lit clr.w   -([sp])                 (d1:=0)
t31lit clr.w   -([sp])                 (d1.w --)
t3llit move.l  ([sp])+,d1lp-Z([bp])    (d1.l --)
t3lit  move.w  ([w]),d0wp-Z([bp])      ( --)
Xt3    jmp     CXt3(pc)                (--)

* execute graphic op's, leaving parameters on stack
Xt3g  jmp     CXt3g(pc) (fn1 fn2 fn3 fn4 fn5 -- fn1..fn5) error code in ernum}

Xpsrc jmp  Xpsrchq(pc)
jwstak jmp Xwstak(pc)
domove jmp Cdomove(pc)

* does> d0w 0. 0. 0. d2l! sp@ a1w t3 (for window enquiries )
dot3e   jmp     Xdot3e(pc)

dofop jsr  doscons-Z([bp])
 dc.w literal-Z,qname-Z,dcompile-Z,pfopq-Z,semis-Z

calerr  jsr     idc(pc)
doerr   dc.w    error-Z,semis-Z

dot10 jsr dosdoes-Z([bp])
 dc.w fetch-Z,t10-Z,semis-Z

dot11 jsr dosdoes-Z([bp])
 dc.w fetch-Z,t11-Z,semis-Z

dot11d jsr dosdoes-Z([bp])
 dc.w fetch-Z,t11-Z,twodrop-Z,semis-Z

* does> d0w d1w d2w t3  (for just d1 and d2 parms)--)
dot32 jsr doscons-Z([bp])
 dc.w d0ws-Z,d1ws-Z,d2ws-Z,t3-Z,semis-Z

TSTJTOP ;obergrenze berwachungsjob, ab hier keine kontrolle mehr

itimecal jsr Ctimecal(pc)
         pea    ([ip])
aendcode jsr docontinue(pc)
     dc.w mibra-Z
     dc.w TI01-*,uqmbymod-Z,twoswap-Z,twodrop-Z
TI01 dc.w cflong-Z,flit-Z,$0811,$61A8,0000  100.000
     dc.w ridiv-Z,fdot-Z,pdotquoteq-Z
     dc.b 5,'mcs  '
c4thret dc.w *+2-Z
        dc.w *+2-Z
        move.l  (a7)+,[ip]
        rts

Xd1qb   move.b  d1lq+3-Z([bp]),-([sp])
        sf      -([sp])
        jmp ([nx])

voc setstr fth

pvi setnum $C0
root create {ROOT} dodoesg
 dc.w dovoc-Z,vocnfa,roottop-Z
[ph]v dc.w [lastvoc]-Z
 dc.w $8000,0
lastvoc setstr  [ph]v
rootlk setstr [lastvoc]-4

noop create {NOOP} jnxcode

pvi setnum $C0
forth create {FORTH} dodoesg V: root
 dc.w dovoc-Z  pfa   0: <=  tick..
 dc.w vocnfa   voc   2: 1st nfa $81A0
 dc.w fthtop-Z (current)cfa   (context)
[ph]v dc.w [lastvoc]-Z 6: (voc-link)adr  (voc-link) 1st=$8000
* additional
 dc.w $8000    ptr to pfa of nxt voc in search order
 dc.w 0   hi.b find flag (: 0: locked, 1: end, forth is excluded)
lastvoc setstr [ph]v

pvi setnum $C0
hidden create {HIDDEN} dodoesg
 dc.w dovoc-Z,vocnfa,hidntop-Z
[ph]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [ph]v
hidnlk setstr [lastvoc]-4

pvi setnum $C0
qdos create {QDOS} dodoesg
 dc.w dovoc-Z,vocnfa,qdostop-Z
[ph]v dc.w [lastvoc]-Z,pif+2-Z,0
lastvoc setstr  [ph]v
qdoslk setstr [lastvoc]-4

pvi setnum $C0
fp create {FP} dodoesg
 dc.w dovoc-Z,vocnfa,fptop-Z
[ph]v dc.w [lastvoc]-Z,qdos+2-Z,128 fp-flag set
lastvoc setstr  [ph]v
fplk  setstr  [lastvoc]-4

pvi setnum $C0
editor create {EDITOR} dodoesg
 dc.w dovoc-Z,vocnfa,editop-Z
[ph]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [ph]v
edilk setstr  [lastvoc]-4

pvi setnum $C0
pif create {PIF} dodoesg V: qdos
 dc.w dovoc-Z,vocnfa,piftop-Z
[ph]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [ph]v
piflk setstr  [lastvoc]-4

pvi setnum $C0
asm68 create {ASM68} dodoesg V: root
 dc.w dovoc-Z,vocnfa,asmtop-Z
[ph]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [ph]v
asmlk setstr  [lastvoc]-4

pvi setnum $C0
seal create {SEAL} docolon V: hidn
 dc.w current-Z,fetch-Z,literal-Z,dcompile-Z,psealp-Z,semis-Z

* +++ common headerless

waf dc.w dojump-Z
 dc.l Xwaf-Z warning @

flushdat dc.w dojump-Z
 dc.l Xflushdat-Z

* for w-save collect window data and store into head area
savwdw  dc.w dojump-Z  ( d.cdt pifdisp --)
 dc.l Csavwdw-Z

emptys dc.w dojump-Z store system data after empty
 dc.l Xemptys-Z mit semis!

cfacomma dc.w dojump-Z
 dc.l Xcfacom-Z
zcom dc.w dojump-Z
 dc.l Xzcom-Z
dcomma dc.w docall-Z
 dc.l Cdcomma-Z

psealp dc.w dojump-Z
 dc.l Xpsealp-Z mit semis!

savsto dc.w Xsavsto-Z ( -- d.timecount tiptr d.baseptr d.flen savptr)
closto dc.w Xclosto-Z ( -- fence d.timecount tiptr d.baseptr d.flen savptr)

* timer

ticknul create  {TI-CAL} Xtical
timecal create  {SET-CAL} docall
 dc.l Ctical-Z

time create {TICK} do2cons
timem  dc.l 0   counter (dummy data for timer setup)
tical  dc.l 0   caliber
timelk dc.l 0,0 qdos link & ptr to <timer>
timadr equ *+2  ptr from routine in heap to timem
timer   addq.l  #1,$0800000 (dummy!)
        rts
timemend

* kanle

io create {I/O} dojump current i/o-channel re by <mkchp>
 dc.l Xio-Z

screen create {SCREEN} dojump
 dc.l Xsc-Z

fyle create {FILE} dojump
 dc.l Xfy-Z

incons create {IN-CONS} dojump
 dc.l Xic-Z

outcons create {OUT-CONS} dojump
 dc.l Xoc-Z

work create {WORK} docall (-- currchan)
 dc.l cdftcal-Z

prt create {PRT} dojump
 dc.l Xprt-Z

isprt create {IS-PRT} dojump V: hidn
 dc.l Xiprt-Z

iscreen dc.w dojump-Z
 dc.l Xisc-Z

safesto create {SAFE!} docall
 dc.l Xsafesto-Z

empty create {EMPTY} docolon
CO01 dc.w lastf-Z,dup-Z,pfa-Z,wforget-Z
     dc.w fencef-Z,great-Z,nzbra-Z
     dc.w CO01-*,emptys-Z

doforget create {DOFORGET} dodefer V: hidn
     dc.w noop-Z,noop-Z      (vnfa wnfa -- vnfa wnfa)

wforget create {W-FORGET} docolon  ( pfa -- )
FG03 dc.w dup-Z,nfa-Z,fencef-Z
     dc.w great-Z,nzbra-Z
     dc.w FG02-*,drops-Z

pdforgetq dc.w docolon-Z        ( forget per $-ptr in the context-voc. only
   dc.w also-Z,also-Z,context-Z,twoplus-Z,doff-Z
   dc.w wfindq-Z,previous-Z,previous-Z
   dc.w nexit-Z,drop-Z,branch-Z
   dc.w FG03-*

pvi setnum $C0
dashforget create {-FORGET} docolon ( compileable forget, if not found do nothing )
  dc.w qname-Z,dcompile-Z,pdforgetq-Z,semis-Z

tlfa create {TOP-NFA} dojump ( ptr -- nfa ) max nfa < or = ptr
 dc.l Xtlfa-Z
dm40 dc.w dojump-Z
 dc.l Xm40-Z
forget create {FORGET} docolon
     dc.w tick-Z
FG02 dc.w nfa-Z,dup-Z,fencef-Z,less-Z
     dc.w lit-Z,$15,qerror-Z
     dc.w cache-Z,cacheoff-Z,drop-Z,greatr-Z
     dc.w greatr-Z,vocdashlk-Z,fetcha-Z
* bei nderungen <lbl> in "f6asm_scr" beachten!
     dc.w rx-Z,doforget-Z,drop-Z
     dc.w dm40-Z,dcache-Z,drops-Z

branch  create  {BRANCH}  Xbranch V: hidn

greatresolve create {>RESOLVE} dojump ;resolve forward
 dc.l Xgrs-Z
back create {BACK} dojump V: hidn
 dc.l Xbck-Z

emitm  create {EMIT-M} dojump
 dc.l Xemitm-Z ( n1 c2 -- ) n1 times emit char c2

enumfil create {.(R)} dojump ( n1 n2 -- n1) emit n2-n1 chars of (r)
 dc.l Xnumfil-Z

spaces create {SPACES} dojump
 dc.l Xspaces-Z

lesssharp create {<#} dojump
 dc.l Clsharp-Z

sharpgreat create {#>} dojump
 dc.l Csharpgt-Z

sign create {SIGN} dojump
 dc.l Xsign-Z

sharp create {#} dojump
 dc.l Xsharp-Z

sharps create  {#S} dojump
 dc.l Xsharps-Z

sq create {Q#} dojump
 dc.l Xsq-Z

bddot create {(D#)} dojump
 dc.l Xbddot-Z ( dn1 signed.flag -- adr count )

bddotr dc.w docolon-Z ;( dn1 n2.chars n3.sg.flg -- adr cnt )
  dc.w swapx-Z,greatr-Z,bddot-Z,rgreat-Z
  dc.w enumfil-Z,type-Z,semis-Z

ddotr  create  {D.R} docolon
  dc.w over-Z,bddotr-Z,semis-Z

uddotr create  {UD.R}  docolon
  dc.w zero-Z,bddotr-Z,semis-Z

ddot   create  {D.}    docolon
  dc.w zero-Z,ddotr-Z,space-Z,semis-Z

uddot  create  {UD.}   docolon
  dc.w zero-Z,uddotr-Z,space-Z,semis-Z

dotr   create  {.R} docolon
  dc.w greatr-Z,sdashgreatd-Z,rgreat-Z,ddotr-Z,semis-Z

decdot create  {#.} basedot
 dc.w 10

hexdot create {$.} basedot
  dc.w 16

dhexdot create {D$.} docolon
  dc.w basefetch-Z,hex-Z,dashrot-Z
  dc.w uddot-Z,basestore-Z,semis-Z

octdot create {&.} basedot
  dc.w 8

bindot create {%.} basedot
  dc.w 2

basedot jsr doscons-Z([bp])
  dc.w basefetch-Z,swapx-Z,basestore-Z
  dc.w swapx-Z,udot-Z,basestore-Z,semis-Z

dot create {.} docolon
  dc.w sdashgreatd-Z,ddot-Z,semis-Z

udot create {U.} docolon
  dc.w zero-Z,uddot-Z,semis-Z

quest create {?} docolon
  dc.w fetch-Z,dot-Z,semis-Z

* list context-voc, <esc> leave, any other key to halt/restart display
vlist create {VLIST} docolon V: root
     dc.w context-Z,fetcha-Z,greatr-Z
     dc.w incons-Z,chid-Z
     dc.w outcons-Z,incons-Z,tochan-Z,cbyl-Z
     dc.w incons-Z,dup-Z,towork-Z,dashwindow-Z,zbra-Z
     dc.w M52z-*,drop-Z,chenq-Z
     dc.w twoswap-Z,twodrop-Z,sdrop-Z,dashdup-Z,nzbra-Z
     dc.w M52z-*,lit-Z,130
M52z dc.w twodash-Z,rgreat-Z,zdupbra-Z
     dc.w M53x-*,fetch-Z,branch-Z
     dc.w M52x-*
M52y dc.w twodup-Z,cfetch-Z,onefand-Z
     dc.w out-Z,fetcha-Z,plus-Z,less-Z,zbra-Z
     dc.w M53-*
M52x dc.w cr-Z
M53  dc.w dup-Z,iddot-Z,pfa-Z,lfa-Z
     dc.w fetch-Z,dup-Z,fetch-Z,lit-Z,$81a0
     dc.w eq-Z,qesc-Z,nzbra-Z
     dc.w M53z-*,over-Z,mzeq-Z,orx-Z
     dc.w onedash-Z,andx-Z,dashdup-Z,nzbra-Z
     dc.w M52y-*,twodup-Z
M53z dc.w twodrop-Z
M53x dc.w drop-Z,curdis-Z,incons-Z,setchan-Z
     dc.w semis-Z

 dc.w docons-Z  \ nicht von
 dc.w tvtregs-go )open trennen!
open create  {OPEN}  dojump
 dc.l Xopen-Z (name type chan -- ernum)
openlk create {OPEN-LINK} dojump (name link.id chan -- ernum)
 dc.l Xlopen-Z
close create {CLOSE} docall
 dc.l Cclose-Z          (chan --)
ert  create  {ERT}   Xert    (d.ernum --)
perq create  {(ERT)} docons
 dc.w vert-Z

 dc.b 2,130,'s',':'!128,0,0
prstakq dc.w dojump-Z
 dc.l Xrstak-Z
pxstakq dc.w dojump-Z
 dc.l Xxstak-Z mit semis!
psindxq dc.w dojump-Z liste holen & prparieren
 dc.l Xsindx-Z
pvi setnum $C0
stack create {STACK} docolon
    dc.w statezbra-Z
    dc.w S01-*,compile-Z,prstakq-Z
S03 dc.w bl-Z
S02 dc.w psindxq-Z,allot-Z,semis-Z
S01 dc.w bl-Z,psindxq-Z,pxstakq-Z
pvi setnum $C0
wstak create {STACK:} docolon
    dc.w create-Z,smudge-Z,lit-Z,jwstak-Z
    dc.w here-Z,twodash-Z,store-Z,branch-Z
    dc.w S03-*

pvi setnum $C0
ll create {LOCAL} docolon
    dc.w spfetch-Z,csp-Z,fetch-Z
    dc.w dash-Z,zbra-Z
    dc.w L01-*,compile-Z,flocal-Z
L02 dc.w clocal-Z
L01 dc.w compile-Z,ilocal-Z
    dc.w here-Z,lit-Z,9,zero-Z,branch-Z
    dc.w S02-*
rsvlo dc.w dojump-Z local space
 dc.l Xrsvloc-Z
 dc.b 2,2!128,'l',':'!128,0,0
ilocal dc.w dojump-Z init locals
 dc.l Xilocal-Z
 dc.b 2,130,'l','@'!128,0,0
flocal dc.w dojump-Z fetch a local
 dc.l Xflocal-Z
elocal dc.w dojump-Z compile end of locals
 dc.l Xelocal-Z
clocal dc.w dojump-Z prepare index
 dc.l Xclocal-Z mit semis!
 dc.b 2,130,'''','l'!128,0,0
plocal dc.w dojump-Z
 dc.l Xplocal-Z
 dc.b 2,130,'l',';'!128,0,0
rlocal dc.w dojump-Z remove locals
 dc.l Xrlocal-Z          \nicht
pvi setnum $C0
pl create {-LOC} docolon /trennen
 dc.w compile-Z,plocal-Z,branch-Z
 dc.w L02-*
pvi setnum $C0
sl create {INI-LOC} docall V: hidn
 dc.l Crsvloc-Z
pvi setnum $C0
el create {END-LOC} docall V: hidn
 dc.l Cnlocal-Z
es create {LOC>} dojump
 dc.l Xsprlc-Z
as create {>LOC} dojump
 dc.l Xspalc-Z

pwquoteq create {(")} Xpwquoteq V: hidn

pvi setnum $C0
wchar create {TEXT} dojump (c1 -- ptr) text until char c1 to pad/codebody
 dc.l Xwchar-Z

pvi setnum $C0
wquote create {"} dojump
 dc.l Xwquote-Z

pvi setnum $C0
qname create {NAME} dojump (-- ptr) word counted strg to pad until <bl>
 dc.l Xqname-Z

qtext create {\NAME} dojump (c1 --) till char c1
 dc.l Xqtext-Z

wtxt create {W@} docall (c1 --) expect word counted text to pad until <nl> or <c1>
 dc.l Cwtxt-Z

txt create {S@} docall (c1 --) expect byte counted text to pad until <nl> or <c1>
 dc.l Ctxt-Z

num create {S#} dojump (-- nn) kbd/blk input a num from text until <nl> or <bl>
 dc.l Xnum-Z

U03 dc.w docolon-Z,bl-Z,wtxt-Z {using} runtime
    dc.w pad-Z,branch-Z
    dc.w U02-*
pvi setnum $C0
using create {USING} docolon (--) use: using {name} to open {name} as screenfile
    dc.w statezbra-Z
    dc.w U01-*,compile-Z,U03-Z,cmcoff-Z
U01 dc.w qname-Z            (ptr --) {using} runtime executive
U02 dc.w dup-Z,scrname-Z            dup (screen)
    dc.w over-Z,dup-Z,twoplus-Z     over dup 2+
    dc.w cfetch-Z,nzbra-Z        c@ 0= IF
    dc.w U04-*,drop-Z,greatr-Z,twodrop-Z  >r 2drop   (fetch default)
    dc.w rx-Z,rx-Z,rx-Z,rgreat-Z    r r r r> ENDIF
U04 dc.w fetch-Z,twoplus-Z          @ 2+
    dc.w lit-Z,40,min-Z             40 min
    dc.w cmove-Z,zero-Z             cmove 0 work
    dc.w work-Z,open-Z,zlt-Z   open 0<
    dc.w nzbra-Z                 IF error ELSE
    dc.w doerr-*,drop-Z,screen-Z    drop work
    dc.w ischan-Z,lspsto-Z,semis-Z  is-screen ENDIF

qwsav dc.w docolon-Z,incons-Z,dashwindow-Z,nexit-Z
     dc.w incons-Z,isochan-Z,nexit-Z
     dc.w incons-Z,cdt-Z,onedash-Z,dup-Z,mibra-Z
     dc.w WV02-*,fdup-Z,savwdw-Z
WV02 dc.w fdrop-Z
     dc.w semis-Z

ws create {W-SAVE} docolon save w. current in-cons window sizes
     dc.w fopoverq-Z,qqer-Z,qwsav-Z
     dc.w lastf-Z,pfa-Z,lfa-Z
     dc.w fence-Z,fencef-Z,greatr-Z,store-Z
     dc.w fyle-Z,ischan-Z,savsto-Z,heads-Z
     dc.w sdrop-Z,greatrr-Z,nzbra-Z
     dc.w SV03-*,fssave-Z
     dc.w ernum-Z,drop-Z,rdrop-Z,greatr-Z
SV03 dc.w fyle-Z,close-Z,twostore-Z
     dc.w rgreat-Z,zbra-Z
     dc.w SV04-*,pad-Z,fdel-Z
SV04 dc.w rgreat-Z,fence-Z,storea-Z
     dc.w semis-Z

* ( d.srce d.dest +count +len -- d.srce+ d.dest+ )
movmem create {MOVE-MEM} dojump
 dc.l Xmovmem-Z

* called immediately after moving code & data to the new job.
* must preserve the job-id. the jdt comes w. {a2l@}
clonejdt create {CLONE-JDT} dodefer V: hidn
     dc.w noop-Z,noop-Z

* afterwards the job-id and cdt-address may be read by {d1l@} and {a2l@}
c4th create {CLONE-4TH} docolon
     dc.w qwsav-Z           store   current window data
     dc.w closto-Z          fetch   fence d.timecount tiptr d.baseptr d.flen savptr
     dc.w zero-Z                  ...ex/ew
     dc.w bexecb-Z,twodrop-Z multitasking start the job, drop job-id
     dc.w twostore-Z        restore timecount
     dc.w fence-Z,storea-Z  restore current fenceptr
     dc.w semis-Z

bexecb create {(EXEC)} docolon V: hidn ( d.base d.flen headptr ex/ew -- d.id )
     dc.w swapx-Z
     dc.w sixplus-Z,greatr-Z   keep header=savptr + 6
     dc.w lit-Z,-4,roll-Z      ( ex/ew dbase dflen
     dc.w dzero-Z,twoover-Z    (             0. dflen
     dc.w rgreat-Z,twofetch-Z  (             0. dflen ddata
     dc.w twoswap-Z            (             0. ddata dflen
     dc.w fthid-Z              ( ex/ew dbase 0. d.data d.code d.id
     dc.w cjob-Z               (           run data code owner -- new.id
     dc.w ernum-Z,qqer-Z
     dc.w twogreatr-Z          ( ex/ew dbase        ( keep job-id
     dc.w a2ql-Z,twoswap-Z     ( ex/ew dbase djbase ( fetch jdt-ptr
     dc.w lit-Z,16384,mby-Z    move code to the jobs codespace
     dc.w greatr-Z,zdupbra-Z
     dc.w CJ01-*,zero-Z,swapx-Z,movmem-Z
CJ01 dc.w rgreat-Z,zdupbra-Z
     dc.w CJ02-*,lit-Z,16384,movmem-Z
CJ02 dc.w fourdrop-Z           drop memory ptrs
     dc.w tworgreat-Z          job-id back
     dc.w clonejdt-Z           final (user definable) action
     dc.w rot-Z                timeout
     dc.w bl-Z,swapx-Z,activ-Z activate the job, leave id
     dc.w semis-Z

bye create {BYE} dojump V: root
 dc.l Xbye-Z

* fast multiway decision by associative & cases & associative cases
* d1.w mustn't be touched because of its use in the {cc-4th}-cases

inumber create {`INUM]} dojump V: hidn
 dc.l Xinumq-Z fp conversion suppressed
*-find 0= IF inumber dpl@ 1+
*   IF drop ENDIF -1 [compile] rvoc ELSE $c0 < ENDIF
pcfafetchp dc.w docolon-Z
     dc.w dashfind-Z,nzbra-Z
     dc.w CS10-*,inumber-Z      prevent fp compiling
     dc.w dplfetch-Z,oneplus-Z,nzbra-Z
     dc.w CS11-*,drop-Z
CS11 dc.w dashone-Z,semis-Z
CS10 dc.w lit-Z,$c0,less-Z,semis-Z

* compiles: [ | max.disp | cfa.flg | num | num | ... ]
* runtime: num will be executed as a cfa if cfa.flg =/= 0
pcfacommap dc.w docolon-Z
     dc.w four-Z,here-Z,dzero-Z,dcomma-Z
CS01 dc.w pcfafetchp-Z,zdupbra-Z
     dc.w CS02-*,zlt-Z,nzbra-Z
     dc.w CS03-*,cfa-Z,rot-Z,twoplus-Z,dashrot-Z
CS03 dc.w comma-Z,branch-Z
     dc.w CS01-*
CS02 dc.w here-Z,fetch-Z,lit-Z,$13b,neq-Z,zbra-Z
     dc.w CS4-*,cfaexec-Z,branch-Z
     dc.w CS01-*
CS4  dc.w drop-Z,dup-Z,greatresolve-Z
     dc.w sover-Z,fetch-Z,eq-Z,swapx-Z
     dc.w twoplus-Z,store-Z,cmcoff-Z

casix create {#CASE} Xcasix

pvi setnum $C0
casecolon create {CASE:} docolon
     dc.w statezbra-Z
     dc.w CS0-*,compile-Z,pcasep-Z
     dc.w pcfacommap-Z,semis-Z
CS0  dc.w create-Z,pcfacommap-Z,smudge-Z
     dc.w psemicodeq-Z
docases jmp  Xdocases(pc)

* runtimes

pcasep dc.w dojump-Z
 dc.l Xdocase-Z

pasvrq dc.w dojump-Z
 dc.l Xpasvrq-Z

pasfetchq dc.w docolon-Z
     dc.w dashfind-Z,zbra-Z
     dc.w AS1-*,lit-Z,$c0,less-Z,semis-Z
AS1  dc.w inumber-Z,drop-Z,one-Z,semis-Z

pasvcommaq dc.w docolon-Z ( flg --) 0:associative 1:range
     dc.w here-Z,dup-Z,zcom-Z
AS2  dc.w pasfetchq-Z,zbra-Z   fetch pfa/number/immediate
     dc.w AS3-*,comma-Z,branch-Z compile if not an immedate word
     dc.w AS2-*
AS3  dc.w here-Z,fetch-Z,lit-Z,$13b,neq-Z,zbra-Z
     dc.w AS4-*,cfaexec-Z,branch-Z ";" end, otherwise exec
     dc.w AS2-*
AS4  dc.w drop-Z,greatresolve-Z drop pfa, resolve table len
     dc.w pstoa-Z,cmcoff-Z  mark range: or associative:

pvi setnum $C0
range create {RANGE:} docolon
     dc.w one-Z,branch-Z
     dc.w AS01-*

pvi setnum $C0
associativec create {ASSOCIATIVE:} docolon
     dc.w zero-Z
AS01 dc.w statezbra-Z
     dc.w AS0-*,compile-Z,pasvrq-Z
     dc.w pasvcommaq-Z,semis-Z
AS0  dc.w create-Z,pasvcommaq-Z,smudge-Z
     dc.w psemicodeq-Z
doassoc jmp Xdoassoc(pc)

edit create {EDIT} dodefer
     dc.w fedit-Z,fedit-Z
fedit dc.w docolon-Z,screen-Z,scrname-Z
     dc.w one-Z,work-Z,open-Z
     dc.w ert-Z,screen-Z,ischan-Z
     dc.w one-Z,load-Z,screen-Z
     dc.w close-Z,dup-Z,isopen-Z,zbra-Z
     dc.w ED01-*,iscreen-Z,zero-Z
ED01 dc.w drop-Z,edit-Z,semis-Z

* append word counted text
plustext create {+TEXT} dojump (dest source --)
 dc.l Xplustext-Z
sname create {!NAME} dojump (dest maxlen source --)
 dc.l Xsname-Z

tleq create {TL=} dojump (1.daddr 1.len ...)
 dc.l Xlstgcmp-Z
teq  create {T=} dojump (1.ptr 1.len 2.ptr 2.len -- flag:<0 0 >0
 dc.l Xstgcmp-Z

weq  create {W=} dojump (memptr memlen stgptr -- f)
 dc.l Xdashtx-Z ;4th-voc -text

voc setstr edi

flush create {FLUSH} docolon
     dc.w flushdat-Z,pdoq-Z
FH00 dc.w lit-Z,$7fff,buffer-Z,drop-Z,ploopq-Z
     dc.w FH00-*,workid-Z,edifile-Z,sdrop-Z
     dc.w towork-Z,fsflush-Z,setwork-Z,semis-Z

stringeq create {S=} dojump
 dc.l Xstgeq-Z  (joker d.stgadr count d.memadr --f) tf: stg found

matchl create {S==} docall
 dc.l Cmatchl-Z  (joker d.stgadr stgcnt d.memadr maxcnt -- f disp)

* match: tf: memptr+disp points to behind stg
match create {MATCH} docall
 dc.l Cmatch-Z   ( memptr memlen stgptr stglen -- f disp)

voc setstr fth

pfopq create {`FOP]} dodefer ( ocode ptr -- )
  dc.w bfopb-Z,bfopb-Z
bfopb dc.w dojump-Z
  dc.l Xfop-Z

pfoplkq dc.w dojump-Z
 dc.l Xfoplk-Z
pvi setnum $C0
foplk create {FOP-LINK} docolon (d.id fop-link " name" -- chan d.0 | d.ernum)
  dc.w qname-Z,dcompile-Z,pfoplkq-Z,semis-Z

pvi setnum $C0
fopenq  create  {FOPEN} dofop (use: fopen name -- d.ernum)
  dc.w 0
pvi setnum $C0
fopinq  create  {FOP-IN} dofop
  dc.w 1
pvi setnum $C0
fopnewq create  {FOP-NEW} dofop
  dc.w 2
pvi setnum $C0
fopdirq create  {FOP-DIR} dofop
  dc.w 4
pvi setnum $C0
ftest create {FTEST} docolon
  dc.w fopinq-Z,dexit-Z
  dc.w work-Z,close-Z,semis-Z

pvi setnum $C0
fdeleteq create {FDELETE} docolon
  dc.w qname-Z,dcompile-Z,fdel-Z,semis-Z

bfovd dc.w docolon-Z
 dc.w two-Z,sdup-Z,fdel-Z,pfopq-Z,semis-Z
pvi setnum $C0
fopoverq create {FOP-OVER} docolon
  dc.w qname-Z,dcompile-Z,bfovd-Z,semis-Z

pvi setnum $C0
format create {FORMAT} docolon
  dc.w qname-Z,dcompile-Z,frmt-Z,semis-Z

chid create {CH-ID} docall (ch.num -- d.channel-id)
 dc.l Chidcal-Z

chp create {CHP} docall (ch -- chan.adr)
 dc.l Chncal-Z

isochan create {IS-OCHAN} docall (ch -- ff|tf) own channels  only
 dc.l Cisochc-Z

isopen create {IS-OPEN} docall (ch -- ff | tf) tf if chan is open
 dc.l isopenc-Z

dashwindow create {-WINDOW} docall  (ch -- tf | ff if not a window)
 dc.l Cdashwd-Z

wdsize create {WD-SIZE} dojump (ch -- y x hgt wdt tf | ff if not a window)
 dc.l Xwsiz-Z

cdt create {CDT} docall V: qdos (ch -- d.cdt.adr 0/1/49| -1. -1)
 dc.l Ccdt-Z
* cdt abs long, flag 0 not a window, -1 no channel

ishis create {IS-HIS} dojump
 dc.l Xishis-Z

worknum create {WORK-NUM} dojump ( -- chan|-1) find channel no. in {work}
 dc.l Xworknum-Z
chnum create  {CH-NUM} dojump ( d.id -- chan|-1) highest num of ch-id
 dc.l Xchnum-Z

newchan create {NEW-CHAN} dojump (-- chan| ff) topmost free chan into work
 dc.l Xnewch-Z
ischan create {IS-CHAN} dojump (c1 --) store work-id to channel-ptr of c1
 dc.l Xichn-Z
towork create {TO-WORK} dojump (c1 --) put c1-id to work-channel
 dc.l Xtowk-Z
tochan create {TO-CHAN} dojump (c1 c2 --) put c1-id to c2-location
 dc.l Xtoch-Z
setchan create {SET-CHAN} dojump (dn1 c2 --) channel-id to channel pointer
 dc.l Xsetc-Z
setwork create {SET-WORK} dojump (dn1 --) set work-location to id dn
 dc.l Xswk-Z
workid create {WORK-ID} docall  (-- dn ) work id
 dc.l Cwkid-Z
xchan create {>CHAN<} dojump
 dc.l Xchx-Z

voc setstr qdos

t12 create   {TRAP1} dojump
 dc.l Xt12-Z (dn1 dn2 op -- dn1) & a1:=0 (no mt.trapv !)
activ create {ACTIV} docall
 dc.l Cactiv-Z ( d.id prior ex/ew -- d.id )
cjob create  {CJOB} dojump  (dn1 dn2 dn3 dn4 -- dn1)
 dc.l Xcjob-Z
trap1a create {TRAP1A} dojump (da1 dd3 dd2 dd1 op -- dd1)
 dc.l Xtrap1a-Z
t11  dc.w dojump-Z
 dc.l Xt11-Z (dn1 op -- dn1 f) & a1:=0
t10  dc.w dojump-Z
 dc.l Xt10-Z (op -- dn1) & a1:=0

mtfree create {FREE} dot10 (-- dn) biggest free heap
 dc.w 6
mtrclk create {RCLCK} dot10 (-- dn) date
 dc.w 19

susjb create {SUSJB}    docolon         ( d.id wait -- d.id)
 dc.w zero-Z,lit-Z,8,t12-Z,semis-Z

reljb create {RELJB} dot11 (dn -- dn) job/-1 -- id & {a2l@} jdt
 dc.w 9
mode create {MODE} dojump (dn -- dn) set mode dn.lo dn.hi - read mode d1.w, TV/monitor always zero
 dc.l Cmode-Z

baud create  {BAUD} dot11d (dn --)
 dc.w 18
sclck create {SCLCK} dot11d (dn --)
 dc.w 20
rechp create {RECHP} dot11d (dn --)
 dc.w 25

jinf create {JINF} docolon              (dn1 dn2 -- dn3 dn4 n5 dn6)
 dc.w two-Z,t12-Z,lit-Z,a1wq-Z              nxt ownr pri start
 dc.w twofetcha-Z,a1ql-Z,drop-Z
 dc.w a2ql-Z,semis-Z

dot12d jsr dosdoes-Z([bp])
 dc.w fetch-Z,t12-Z,twodrop-Z,semis-Z
frjob create {FRJOB} dot12d (dn1 dn2 --) job ernum
 dc.w 5
tra create {TRA} dot12d (dn1 dn2 --) chartab msgtab
 dc.w 36

dot12 jsr dosdoes-Z([bp])
 dc.w fetch-Z,t12-Z,a2ql-Z,semis-Z
prior create {PRIOR} dot12 (dn1 dn2 -- dn3 dn4) job pri -- id jdt
 dc.w 11
alchp create {ALCHP} dot12 (d.len d.id -- d.len d.adr)
 dc.w 24

d1ql create {D1L@} do2cons
* trap#3             trap#1    hi.w lo.w lo.b long
* trap#1 d1/d2/d3/a0/a1 => d1lq
d1lq dc.l 0  ;out;   d1      d1qh d1qw d1qb
a1wq dc.w 0  ;rel;   d2      a1qw
     dc.w 0
a1lq dc.l 0  ;abs;   d3                     a1ql
a2lq dc.l 0          a0                     a2ql
     dc.l 0  ;d2l;?  a1
d1lp dc.l 0  ; in;   d1      d1hs d1ws      d1ls
d2lp dc.l 0          d2           d2ws      d2ls
d0wp dc.w 0          d3      d0ws
d3wp dc.w -1                      d3ws
a1wp dc.w 0          a0      a1ws
a2wp dc.w 0                       a2ws
a2lp dc.l 0          a1                     a2ls
d3wt dc.w 0  ;tmp; timo
aux  dc.w 0  for docol <=> dodoes

dothree create {T3DO} dojump V: hidn ( --) on defaultvchan
 dc.l dt3ntr-Z

frmt create {FORMT} dojump (addr -- sec good f) f=ernum
 dc.l Cfrmt-Z

fdel create {DELET} docall (addr --)
 dc.l Cfdel-Z

t3do setstr {dc.w docolon-Z,auxs-Z}
t00  setstr {dc.w fetch-Z,d0ws-Z}

* does> d0w! a1w! d2l! d1l! t3 d1l@
dot33   [t3do]
t33     [t00],branch-Z          (d1l d2l a1w -- d1l)
        dc.w t33x-*
dot33l  [t3do]
        [t00],branch-Z          (d1l d2l a1l -- d1l)
        dc.w t33lx-*

dot34   [t3do]
t34     [t00],tforthplus-Z,a2ls-Z       (d1l d2l a1w a2l -- d1l)
t33x    dc.w sdashgreatd-Z,a1ls-Z
t34x    dc.w d2ls-Z,d1ls-Z,dot3lon-Z,d1ql-Z,semis-Z
dot34l  [t3do]
t34l    [t00],tforthplus-Z,a2ls-Z       (d1l d2l a1l a2l -- d1l)
t33lx   dc.w tforthplus-Z,a1ls-Z,branch-Z
        dc.w t34x-*

* does> d0w d1w! sp@ a1w t3     (for wdef, bfill)
dot3b   [t3do]                  (aux! d0w!) d1w! sp@ a1w! --)
t3b     [t00],d1ws-Z,spfetch-Z,a1ws-Z,t3-Z,fourdrop-Z,semis-Z

* does> @ d0w d3t! t3 d3r       (timo op --)
dot3t   [t3do]
        [t00],d3ts-Z,t3-Z,d3rs-Z,semis-Z

pend create {PEND} docolon      (timo -- tf|ff)(pending input|ready)
     dc.w zero-Z,dot3t-Z,qerrs-Z

binkeyq dc.w docolon-Z,one-Z,dot3t-Z,d1qb-Z,qerrs-Z
inkey create {INKEY} docolon V: fth
     dc.w work-Z,dashwindow-Z,nzbra-Z
     dc.w MI00-*,incons-Z,towork-Z
MI00 dc.w binkeyq-Z,nzbra-Z
     dc.w MI01-*,dup-Z,lit-Z,255,eq-Z,nexit-Z
     dc.w zeq-Z,binkeyq-Z,zbra-Z
     dc.w MI02-*
MI01 dc.w drop-Z,dz-Z
MI02 dc.w minus-Z,semis-Z

fbyte create {FBYTE} docolon    (-- byte f)
 dc.w dot30-Z,1
 dc.w d1qb-Z,swapx-Z,semis-Z

fline create {FLINE} docolon    (addr len -- len f)
 dc.w d2ws-Z,a1ws-Z,dot30-Z,2
 dc.w d1qw-Z,swapx-Z,semis-Z

fstrg create {FSTRG} docolon    (addr len -- f)
 dc.w d2ws-Z,a1ws-Z,dot30-Z,3,semis-Z

sbyte create {SBYTE} t31lit     (byte -- )
 dc.w 5

sstrg create {SSTRG} docolon    (addr len -- f)
 dc.w d2ws-Z,a1ws-Z
 dc.w dot30-Z,7,semis-Z

pxenq create {PXENQ} dot3e ( -- y x height width)
 dc.w 10
chenq create {CHENQ} dot3e (-- row col rows cols)
 dc.w 11

border create {BORDER} dot32 (width colour --)
 dc.w 12

wdef create {WDEF} docolon      (y x height width bwid bcol--)
 dc.w swapx-Z,d2ws-Z,lit-Z,13,dot3b-Z,semis-Z
window create {WINDOW} docolon V: fth (y x height width --)
 dc.w dzero-Z,wdef-Z,semis-Z

cursen create {CURSEN} t3lit    (--)
 dc.w 14
curdis create {CURDIS} t3lit    (--)
 dc.w 15

atc create {AT} dot32 (row col --)
 dc.w 16
tabc create {TAB} t31lit        (col --)
 dc.w 17

nl create {NL} t3lit            (--)
 dc.w 18
pcol create {PCOL} t3lit        (--)
 dc.w 19
ncol create {NCOL} t3lit        (--)
 dc.w 20
prow create {PROW} t3lit        (--)
 dc.w 21
nrow create {NROW} t3lit        (--)
 dc.w 22

pixp create {PIXP} dot32 (y x --)
 dc.w 23

scroll create {SCROLL} t31lit   (distance --)
 dc.w 24
scrtp create {SCRTP} t31lit     (distance --)
 dc.w 25
scrbt create {SCRBT} t31lit     (distance --)
 dc.w 26

pan create {PAN} t31lit         (distance --)
 dc.w 27
panln create {PANLN} t31lit     (distance --)
 dc.w 30
panrt create {PANRT} t31lit     (distance --)
 dc.w 31

cls   create {CLRSC} t3lit (--)
 dc.w 32
clrtp create {CLRTP} t3lit (--)
 dc.w 33
clrbt create {CLRBT} t3lit (--)
 dc.w 34
clrln create {CLRLN} t3lit (--)
 dc.w 35
clrrt create {CLRRT} t3lit (--)
 dc.w 36

fount create {FOUNT} docolon (1stfont 2ndfont -- f)
 dc.w a2ls-Z,a1ls-Z,lit-Z,37
 dc.w d0ws-Z,dot3lon-Z,semis-Z

recol create {RECOL} docolon    (addr --) ( 8 colour bytes at addr )
 dc.w a1ws-Z,dot30-Z,38,drops-Z

paper create {PAPER} t31lit     (colour --)
 dc.w 39
strip create {STRIP} t31lit     (colour --)
 dc.w 40
ink   create {INK}   t31lit     (colour --)
 dc.w 41
flash create {FLASH} t31lit     (boolean --)
 dc.w 42
under create {UNDER} t31lit     (boolean --)
 dc.w 43
setmd create {SETMD} t31lit     (OVER --)
 dc.w 44

csize create {CSIZE} dot32 (height width --)
 dc.w 45

bfill create {BFILL} dodoesg (y x height width colour --)
 dc.w t3b-Z,46

* fp graphic calls leave the stack data intact for further operations
point create {POINT} Xt3g       (fx fy -- fx fy)
 dc.w 48
gline create {LINE}  Xt3g       (fxs fys fxe fye -- x y x y)
 dc.w 49
arc create   {ARC}   Xt3g       (fxs fys fxe fye frc -- .. )
 dc.w 50
elips create {ELIPS} Xt3g       (fxc fyc fexc frad frad -- .. )
 dc.w 51
scale create {SCALE} Xt3g       (fsc fxc fyc -- s x y)
 dc.w 52

flood create {FLOOD} t31lit     (flag --)
 dc.w 53

gcur create {GCUR} Xt3g         (ypx xpx ygc xgc -- ..)
 dc.w 54

fscheck create {FSCHECK} Xt30    (-- f)
 dc.w 64

fsflush create {FSFLUSH} t3lit  (--)
 dc.w 65

* immediately after a pos call, d1l? will give the current position
posab create {POSAB} dojump (d.pos -- f)
 dc.l Xposab-Z
posre create {POSRE} dojump (d.disp -- f)
 dc.l Xposre-Z
eof create {EOF} dojump ( -- f ) test eof
 dc.l Xeof-Z
eofq create {EOF?} dojump
 dc.l Xeofq-Z
poseof create {POSEOF} docall ( -- ) goto eof
 dc.l Cpeof-Z
fpos create {FPOS} docall ( -- dn )
 dc.l Cfpos-Z
flen create {FLEN} dojump ( -- dn )
 dc.l Xflen-Z

mdinf create {MDINF} docolon    (ptr -- good empty f (10 bytes to addr )
 dc.w a1ws-Z,dot30-Z,69
 dc.w d1ql-Z,rot-Z,semis-Z

heads create {HEADS} docolon    (ptr -- len f (14 bytes sent from addr )
 dc.w a1ws-Z,dot30-Z,70
 dc.w d1qw-Z,swapx-Z,semis-Z
headr create {HEADR} docolon    (ptr -- len f (14 bytes read to addr )
 dc.w a1ws-Z,dot30-Z,71
 dc.w d1qw-Z,swapx-Z,semis-Z

sstrgl create {SSTRG-L} docolon (d.addr +len --)
 dc.w zero-Z,lit-Z,7,branch-Z
 dc.w FS02-*
fstrgl create {FSTRG-L} docolon (d.addr +len --)
 dc.w zero-Z,lit-Z,3,branch-Z
 dc.w FS02-*
fsload create {FSLOAD} docolon  (d.addr d.len --(load file to addr )
 dc.w lit-Z,72,branch-Z
 dc.w FS02-*
fssave create {FSSAVE} docolon  (d.addr d.len --(save to file)
 dc.w lit-Z,73
FS02 dc.w d0ws-Z,d2ls-Z,tforthplus-Z
 dc.w a1ls-Z,dot3lon-Z,semis-Z

fsrename create {FSRENAME} docolon (nameptr --)
 dc.w a1ws-Z,renm-Z,semis-Z
renm dc.w t3lit-Z,74

fstrunc create {FSTRUNC} t3lit (--)
 dc.w 75

fsmkdr create {FSMKDR} t30lit (--)
 dc.w 77

fsvers create {FSVERS} t3llit (d1.l --) read the version w. {d1l@}
 dc.w 78

xinf create {XINF} dojump
 dc.l Xxinf-Z   (addr -- f) 64(100) bytes device info to addr

voc setstr pif

qflim create {QFLIM} dot3e (-- y0 x0 height width) outline info
 dc.w 108

flim create {FLIM} docolon      (-- y x h w) default to standard screen
 dc.w work-Z,dashwindow-Z,nzbra-Z
 dc.w FL01-*,lit-Z,-6,message-Z
FL01 dc.w qflim-Z,ernum-Z,orx-Z,nexit-Z
 dc.w dzero-Z,dlit-Z,$200,$100,semis-Z

svpw create {SVPW} dodoesg  (y x 0/hgt.wdt sizes.ptr d.mem.adr -- d.sav.adr)
 dc.w t34-Z,109

rspw create {RSPW} docolon      (y x flag 0 sizes.ptr d.sav.adr --)
 dc.w lit-Z,110,dot34-Z,twodrop-Z,semis-Z

pinf create {PINF} docolon (-- d.pif-version d.wman-vector)
 dc.w lit-Z,112,d0ws-Z,dot3lon-Z,a1ql-Z,d1ql-Z,semis-Z

rptr create {RPTR} dodoesg  (y x tab(.b) 0 rcd.ptr -- y x)
 dc.w t33-Z,113

rpxl create {RPXL} docolon      (y x d2.code -- colr posn)
 dc.w zero-Z,lit-Z,114,dot33-Z,semis-Z

wblb create {WBLB} docolon      (y x d.blob.adr d.pat.adr --)
 dc.w dzero-Z,tworot-Z,tworot-Z,dot34l-Z,115,semis-Z

lblb create {LBLB} dodoesg  (y.s x.s y.e x.e d.adr1.blb d.adr2.pat --)
 dc.w t34l-Z,116

wspt create {WSPT} docolon      (y x d.adr.sprt --) draw sprite
 dc.w dzero-Z,twoswap-Z,lit-Z,118,dot33l-Z,semis-Z

spry create {SPRY} dodoesg  (y x d(.w)pix d.adr.blb d.adr.pat -- y x)
 dc.w t34l-Z,118

outl create {OUTL} docolon      (y x hgt wdt set/mov -)
 dc.w d2ws-Z,dzero-Z,d1hs-Z,lit-Z,122,dot3b-Z,semis-Z

sptr create {SPTR} docolon      (y.pix x.pix flag -- y x)
 dc.w d2ws-Z,d1ls-Z,dot30-Z,123
 dc.w drop-Z,d1ql-Z,semis-Z

ppick create {PICK-JOB} t3llit  (d.jobid --)
 dc.w 124 ;{work} must be a (dummy) valid window channel

pickforth create {PICK-4TH} docolon V: fth (--) pick current "f6"-job
 dc.w zero-Z,towork-Z,fthid-Z,ppick-Z,semis-Z

swdf create {SWDF} docolon      (d.adr --)
 dc.w lit-Z,125,branch-Z
 dc.w iopw-*

wsav create {WSAV} docolon      (d.adr d.len --)
 dc.w d1ls-Z,lit-Z,126,branch-Z
 dc.w iopw-*

wrst create {WRST} docolon      (d.adr flag --)
 dc.w d2ws-Z,lit-Z,127
iopw dc.w d0ws-Z,tforthplus-Z,a1ls-Z,dot3lon-Z,semis-Z

voc setstr qdos ** other qdos related routines

edline create {EDLINE} dojump ( ptr1 maxcount -- ptr1 count | ff)
 dc.l Xedline-Z

xstrip  create {XSTRIP} dojump
 dc.l Xxstrip-Z  (c1 --) exchange ink & strip colours
dxstrip create {-XSTRIP} dojump
 dc.l Xdstrip-Z  (c1 f --) xg if tf

voc setstr pif

hkstore create {HOT!} dojump (ptr +nn -- f) ff if successfully done
 dc.l Chbfs-Z ; strg len -- store +nn chars from ptr)+
hkfetch create {HOT@} dojump (ptr -nn -- ptr f) f>0:=len, 0 on error
 dc.l Chbff-Z ; storage hbuf.no. -- fetch chars to ptr)+

voc setstr qdos

qcall create {CALL} dojump ( d.a4 ... d.a0 d.d4 ... d.d0 d.adr -- a4 ... d0 )
 dc.l Xqcall-Z

Xqdvec jmp   Cxqdv(pc)
qddate create {D>DATE} Xqdvec ( dn1 -- ptr c2 )
 dc.w 236
qdday  create {D>DAY} Xqdvec ( dn1 -- ptr c2 )
 dc.w 238

voc setstr fth

qdates create {DATE$} docolon ( -- ptr cnt ) date$
 dc.w mtrclk-Z,qddate-Z,semis-Z

qdays  create {DAY$} docolon  ( -- ptr cnt ) day$
 dc.w mtrclk-Z,qdday-Z,semis-Z

* fetch a "MEM"-device execution vector (re "IO2" for details)
memvec create {MEMVEC} docall V: hidn ( opco -- d.adr | -ve )
 dc.l Cmemvec-Z

* execute a parameterless resident basic procedure ( try: hidden " tune" basic rvoc )
basic  create {BASIC} dojump ( ptr -- ernum ) call basicproc ptr{name}.w
 dc.l Xbasic-Z

* "_lngBAD" to (partly) cure the the poor lightning screen positioning
lngbad create {LNGBAD} dojump ( -- ernum )
 dc.l Xlngb-Z
 dc.w lngnam-Z

* selection codes for the MEM-device character founts
losc create {LOSC} docons
  dc.w -15 lo script
hisc create {HISC} docons
  dc.w -14 hi
bblu create {BBLU} docons
  dc.w -13 ibm#2
atne create {ATNE} docons
  dc.w -12 mi nerva
* activate a predefined char. fount ( code chan --)
fnt create {>FOUNT} dojump
  dc.l Xfnt-Z

wmov create {WMOV} dojump ( chan --)
 dc.l gowmov-Z

voc setstr qdos

auxs dc.w Xauxs-Z

d1qh  create {D1H@} Xd1qh
d1qw  create {D1W@} Xd1qw
d1qb  create {D1B@} Xd1qb
a1qw  create {A1W@} Xa1qw
a1ql  create {A1L@} Xa1ql
a2ql  create {A2L@} Xa2ql
d1ls  create {D1L!} Xd1ls
d2ls  create {D2L!} Xd2ls
d1hs  create {D1H!} Xd1hs
d1ws  create {D1W!} Xd1ws
d2ws  create {D2W!} Xd2ws
d0ws  create {D0W!} Xd0ws
d3ws  create {D3W!} Xd3ws
d3ts  create {D3T!} Xd3ts
d3rs  create {D3R}  Xd3rs
a1ws  create {A1W!} Xa1ws
a1ls  create {A1L!} Xa1ls
a2ws  create {A2W!} Xa2ws
a2ls  create {A2L!} Xa2ls

spsa1 create {SP!A1} docall
        dc.l Cspsa1-Z

dot30  dc.w  Xdot30-Z

t3 create {TRAP3} Xt3  ( chan# -- ) regs previously set

dot3lon dc.w docall-Z
 dc.l Ct3lon-Z

psrcq dc.w Xpsrc-Z

voc setstr root

pvi setnum $C0
vsearch create {SEARCH} docolon
 dc.w tick-Z,psrcq-Z,semis-Z

pvi setnum $C0
nosearch create {NO-SEARCH} dojump
 dc.l Xnosearch-Z

* restore 1st order search voc.
pvi setnum $C0
rvoc create {RVOC} dojump
 dc.l Xrvoc-Z

* f-83 search order words
pvi setnum $C0
also  create {ALSO} dojump
 dc.l Xalso-Z

pvi setnum $C0
previous create {PREVIOUS} dojump
 dc.l Xprevious-Z

pvi setnum $C0
only  create {ONLY} dojump
 dc.l Xonly-Z

pvi setnum $C0
assembler create {ASSEMBLER} dodefer
 dc.w asm68-Z,asm68-Z

pvi setnum $C0
qu create {QUAD} Xquad
pvi setnum $C0
nq create {NO-QUAD} Xnqad

voc setstr hidn

lit   create {LIT}  Xlit
dlit  create {DLIT} Xdlit
qlit  create {QLIT} Xqlit

statezbra dc.w Xszbra-Z
nzbra   create {-BRANCH}  Xnzbra (  0IF
mibra   create {0<BRANCH} Xmibra (    +IF
lebra   create {0-BRANCH} Xlebra ( 0>  IF
gtbra   create {0>BRANCH} Xgtbra ( 0> 0IF
plbra   create {+BRANCH}  Xplbra ( 0<  IF
zbra    create {0BRANCH}  Xzbra  (     IF
zdupbra create {?0BRANCH} Xzdbra ( -dup 0branch ...
neqbra  create {?1BRANCH} dojump
 dc.l Xneqbra-Z

pdoq    create {(DO)}   X2gr
ploopq  create {(LOOP)} Xploopq
pplusloopq create {(+LOOP)} Xpplopq

voc     setstr  fth
leave   create {LEAVE}  Xleave
qleave  create {-LEAVE} Xqleave

cfaexec dc.w Xcfaexec-Z cfa execute
execute create {EXECUTE} Xexecute  @ cfa execute
perform create {PERFORM} Xperform  for the interpreting words
pcsemiq create {`;C]} Xpsemicq

digit create  {DIGIT} dojump  ( chr base - ff | digit tf )
  dc.l Xdigit-Z

enclose create {ENCLOSE} docall (adr1 char --- adr1 n1 n2 n3)
  dc.l Cenclose-Z

* new ex.vec: index ' {word} is cc-4th :index = char, where index 0 is for <del>
* {ctrl} takes the execution from a user-vectored case:-list, re-vectoring
* could be done by setting the user-variable {cc4th}: ' newcaselist is cc4th
cc4thc create {CC-4TH} docases
ctt dc.w cc4end-*,1
  dc.w dXdel-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dcurr-Z,bell-Z 127,1-7
  dc.w dXbs-Z,dCT1-Z,dcnl-Z,dcuru-Z,dpage-Z,dCT1-Z,dcen-Z,dcen-Z  8-15
  dc.w dCT1-Z,dCT1-Z,dtab-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dXbs-Z   16-23
  dc.w dcurd-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dpos-Z,dhome-Z,dat-Z  24-31
cc4end ds.w 0 * defined: 0 6 7 8 10 11 12 14 15 18 23 24 29 30 31 127

dct1  dc.w Xnot-Z
DXdel dc.w docall-Z
 dc.l CXdel-Z
dcurr dc.w dojump-Z
 dc.l Xcurr-Z
DXbs  dc.w docall-Z
 dc.l Cbs-Z
dcnl  dc.w dojump-Z
 dc.l Ccnl-Z
dcuru dc.w dojump-Z
 dc.l Ccuru-Z
dpage dc.w dojump-Z
 dc.l Cpage-Z
dcen  dc.w dojump-Z
 dc.l Ccen-Z
dtab  dc.w dojump-Z
 dc.l Ctab-Z
dcurd dc.w dojump-Z
 dc.l Ccurd-Z
dpos  dc.w dojump-Z
 dc.l CXpos-Z
dhome dc.w dojump-Z
 dc.l Chome-Z
dat   dc.w dojump-Z
 dc.l Cat-Z
DXok  dc.w dojump-Z
 dc.l Xok-Z

pieps dc.w $0a0a,0,$0aaa,$0500,0,$0a,0,0,$0100
pctlq create {(CTL)} dovariable V: hidn
ctflag dc.w -1

ipcom  create {IPCOM} docall V: qdos
 dc.l Cipcom-Z

bell   create {BELL} dojump
 dc.l Xbell-Z

keyrow create {KEYROW} dojump
 dc.l Xkeyrow-Z

mtinf   create  {MT-INF} dojump  (-- d.svaddr d.qdosid d.jobid)
 dc.l Cmtinf-Z

cacheon create  {CACHE-ON}  dojump
 dc.l Xdcache-Z
 dc.w 1
cacheoff create {CACHE-OFF} dojump
 dc.l Xdcache-Z
 dc.w 0
cache create    {CACHE}     dojump
 dc.l Xcache-Z
dcache create   {-CACHE}    dojump
 dc.l Xdcache-Z
 dc.w -1

syst   create {SYSFLG} Xsysfl
fthid  create {4TH-ID} Xfthid (-- d.jobid)

fperr  create {FP-ERR} Xfperr
ftherr create {4TH-ERR} Xftherr
ioerr  create {IO-ERR} Xioerr
ernum  create {ERNUM} Xernum (-- d.ernum) read ernum (once) only

* ctrl : control-keys * ( n3.key -- ff | -1 :n.i. | [n1 [n2]] n3 tf :no ctrl )
ctrl   create {CTRL} dojump
 dc.l Xctrl-Z
ctrlwa dc.w dojump-Z
 dc.l doctrl-Z

Dpexp dc.w docall-Z
 dc.l Cexper-Z
Dqexpect dc.w docall-Z
 dc.l Xqexpect-Z
Dexpect dc.w docall-Z
 dc.l Cexpect-Z
Dquery dc.w dojump-Z
 dc.l Xquery-Z
Dkey   dc.w dojump-Z
 dc.l Xkey-Z
Dqkey  dc.w dojump-Z
 dc.l Xqkey-Z
Dqterminal dc.w dojump-Z
 dc.l Xqterminal-Z
Demit  dc.w dojump-Z
 dc.l Xemit-Z
Dpemit dc.w dojump-Z
 dc.l Xpemit-Z
Dtype  dc.w dojump-Z
 dc.l Xtype-Z
Dtypel dc.w dojump-Z
 dc.l Xtypel-Z
Dconsem dc.w dojump-Z
 dc.l Xconsemit-Z
Dconst dc.w dojump-Z
 dc.l Xconstype-Z

docr  dc.w docolon-Z
      dc.w ctrlwa-Z,10,drops-Z
docls dc.w docolon-Z
      dc.w ctrlwa-Z,12,drops-Z

do1ptype dc.w dojump-Z
 dc.l Cdo1ptype-Z

doptype dc.w docolon-Z,curdis-Z,zdupbra-Z
        dc.w DT01-*,zero-Z,pdoq-Z
DT02    dc.w do1ptype-Z,ploopq-Z
        dc.w DT02-*
DT01    dc.w drops-Z

ccmvu dc.w 0
      dc.l jcmvup-Z
lesscmove create {<CMOVE} domove
ccmvd dc.w 0
      dc.l jcmvdn-Z

voc setstr fth

cmovel create {CMOVE-L} dojump
 dc.l Xcmovel-Z
cmove  create {CMOVE}  dojump
 dc.l Xcmove-Z
fill   create {FILL}   dojump
 dc.l Xfill-Z
erase  create {ERASE}  dojump
 dc.l Xerase-Z
blanks create {BLANKS} dojump
 dc.l Xblanks-Z

onefand dc.w  docand-Z,$1f

qsplus create {QSYS+} dojump
 dc.l CXqsplus-Z

plusorigin create {+ORIGIN} Xplusorg boot area
codeplus create {CODE+} Xcodeplus (n1 - dn2) disp to code-base to memory address
baseplus create {BASE+} Xbaseplus (n1 - dn2) 4th-ptr to memory address
tforthplus dc.w Xtfp-Z (dn1 - dn2) memory address to d.4th-ptr
tbaseplus create {2BASE+} Xtbp

toggle create {TOGGLE} dojump
 dc.l Xtoggle-Z

dexit dc.w Xdexit-Z -exit
nexit dc.w dojump-Z 0=exit
 dc.l Xnexit-Z
sops dc.w dojump-Z
 dc.l Xsops-Z mit semis!
pvi setnum $C0
qexit create {-EXIT} dojump
 dc.l Xqexit-Z

semis create {;S} dosemis

pvi setnum $C0
semi create {;} docolon
  dc.w elocal-Z,sops-Z

twoconstant create {2CONSTANT} docolon
 dc.w twovariable-Z,usesgt-Z,do2cons-Z

constant create {CONSTANT} docolon
 dc.w create-Z,smudge-Z,comma-Z
 dc.w usesgt-Z,docons-Z

twovariable create {2VARIABLE}  docolon
 dc.w constant-Z,comma-Z
 dc.w usesgt-Z,dovariable-Z

variable create {VARIABLE} docolon
 dc.w constant-Z,usesgt-Z,dovariable-Z

user create  {USER}  docolon
 dc.w xnuser-Z
 dc.w constant-Z,usesgt-Z,douser-Z
xnuser dc.w dojump-Z
 dc.l Xxnuser-Z

* cons numbers
dzero create {0.} do2cons
     dc.l 0
zero  create {0}  docons
     dc.w 0
one   create {1}  Xone
two   create {2}  docons
     dc.w 2
three create {3}  docons
     dc.w 3
dz    create {-0} docons
     dc.w $8000
dashone create {-1} docons
     dc.w -1
bl    create {BL} docons
     dc.w 32
four   dc.w docons-Z,4

* editor cons
cbyl create {C/L}    docons
     dc.w 64
cbys create {C/SCR}  docons
     dc.w cscr

first create {FIRST}  docons
cfirst dc.w 0
limit create {LIMIT}  docons
climit dc.w 0
bbybuf create {B/BUF} docons
cbbybuf dc.w ssize
bbyscr create {B/SCR} docons
cbbyscr dc.w cscr/ssize

fbyn create {F/N}   docons
     dc.w cfname  len of filenames
bhed create {B/HED} docons
     dc.w cfhead  fileheader
bsec create {B/SEC} docons
     dc.w cbsec   bytes/disksector
balc create {B/ALC} docons
     dc.w cbalc   allocation unit
adrv create {A/DRV} do2cons
     dc.l cadrv   a.units/drive
afre create {A/FRE} do2cons
     dc.l cafre   free a.units
dwpt create {D/WPT} docons
     dc.w cdwpt   write protect flag
dnum create {D/NUM} docons
     dc.w cdnum   drive no.

chdr0 create {DR0CH}  docons
 dc.w dr0ch-Z
chdr1 create {DR1CH}  docons
 dc.w dr1ch-Z
scrname create {(SCREEN)} docons
 dc.w scrfile-Z
filname create {(FILE)} docons
 dc.w loadfile-Z
prtname create {(PRT)}  docons
 dc.w prtfile-Z
dirname create {(DIR)}  docons
 dc.w dirfile-Z
bootname create {(BOOT)} docons
 dc.w bootfile-Z

* system cons & vari

voc setstr qdos
ca1 create `jdt] docons
 dc.w jdttab-Z

voc setstr hidn
ca2 create `nul] docons
 dc.w donul-Z ; <nul> deferred action
ca3 create `NUL-PFA] docons
 dc.w vddonul-Z ; nul defer-pfa
nuser create {#USER} docons
 dc.w uarea
pquitq create {(QUIT)} docons
 dc.w vquit-Z,vquit-Z
dspc  create {DATASPACE} dovariable
 dc.w -1

voc setstr pif
ca4 create `th-entry] docons
 dc.w thntry-Z
ca5 create `wman] docons
 dc.w wmanvec-Z

voc setstr fth
nvocs create {#VOCS} docons ;max no of stacked vocs
 dc.w 16
dbon create {DB-ON} docons  ;debugging off/on
 dc.w 0,0
pupperq create {(UPPER)} docons
 dc.w -33,-33
pjokerq create {(JOKER)} docons
 dc.w -1,-1
pwcardq create {(WCARD)} docons
 dc.w -1,-1
v2nd  create {2ND-VOC} dovariable V: root
 dc.w 0
break create {BREAK} docall
 dc.l Cfbrky-Z
cmc create {CMC} docons ;commands counter
 dc.w -1
co create {OPT} dovariable
 dc.w 1

voc setstr asm
* assembler cons re A6
ca6 create {`do;does]} docons
 dc.w dosdoes-Z
ca7 create `donext] docons
 dc.w next-Z
ca8 create `docol] docons
 dc.w docolon-Z
ca9 create `dosemis] docons
 dc.w dosemis-Z
ca10 create `docall] docons
 dc.w docall-Z
ca11 create `dojump] docons
 dc.w dojump-Z
ca12 create `dodefer] docons
 dc.w dodefer-Z
ca13 create `cdefer] do2cons
 dc.l cdefer-Z
ca14 create `cprim] do2cons
 dc.l cprim-Z

voc setstr fth

ndf create {NOPDF} dodefer
 dc.w noop-Z,dzero-Z

nulpv create {+NUL} dovariable
 dc.w 0,0

.ud setnum 0
* ------- * -L longword vari to be addressed at {name} 2-.
* init: last bschar u0-l s0-l r0-l tib width warning fence dp-l voclink os.l
last      defuser   {last}   ; 0     \
bbs       defuser   {(bs)} V: hidn
.ud  setnum [.ud]+2
u0        defuser  {u0}      ; 6 -L
.ud setnum [.ud]+2
s0        defuser  {s0}      ;10 -L
.ud setnum [.ud]+2
r0        defuser   {r0}     ;14 -L
tib       defuser   {tib}    ;16
width     defuser   {width}  ;18
warning   defuser   {warning} ;20
fence     defuser   {fence}  ;22 $16
.ud  setnum [.ud]+2
dp        defuser   {dp}     ;26 -L
vocdashlk defuser {voc-link} 28       /
sysos     defuser  {os}      ;30 .L
.ud setnum [.ud]+2
* ------- *
blk       defuser   {blk}    ;34 \
in        defuser   {in}     ;36 /
lmrg      defuser   {l-mrg}  ;38  left margin (debug)
out       defuser   {out}    ;40
row       defuser   {row}    ;42 \
scr       defuser   {scr}    ;44 /
offset    defuser   {offset} ;46
state     defuser   {state}  ;48
base      defuser   {base}   ;50
dpl       defuser   {dpl}    ;52
fld       defuser   {fld}    ;54
.ud setnum [.ud]+2
csp       defuser  {csp}     ;58 -L
.ud setnum [.ud]+2
hld       defuser   {hld}    ;62 -L
.ud setnum [.ud]+4
rsharp    defuser   {r#}     ;64
span      defuser   {span}   ;66
ntib      defuser   {#tib}   ;68 f83
utail  equ [.ud]
uhead  equ [.ud]+4
.ud setnum [.ud]+6
timo      defuser   {io-time} ;76
occ4th    defuser   {cc4th}   ;78
numfil    defuser   {(r)}
promptq   defuser   {(prompt)}
up        defuser   {up}
forgetlk  defuser   {forget-lk}
.ud setnum [.ud]+2
dds       defuser   {dds} V: root ;do;does-entry
* user-space for 4 voc-vari & .vocs+1 cells depth of voc.stack
; [.ud]=.ud user-vari/vocstack bot
ocurrent  defuser   {ocurrent} V: hidn ; |
current   defuser   {current}
context   defuser   {context}
ocontext  defuser   {ocontext} V: hidn   |
 ifnum [.ud] > 126 warning [.ud]-2 usertop NOT disp(An,Xi) addressable
.ud  setnum  [.ud]+16*2+2
 ifnum [.ud]+2 > uarea warning too many user vari

xshift  create  {SHIFT} dojump
 dc.l Xxshift-Z ( n1 c1 -- n2 ovf ( c1 +ve LSL, c1 -ve LSR )

basefetch create {BASE@} Xbasef
basestore create {BASE!} Xbases

dplfetch create {DPL@} Xdplf

zeroinstore dc.w Xzinsto-Z

statefetch create {STATE@} Xstatef

tibfetch create {TIB@} Xtibf

here  create {HERE}  dojump
 dc.l CXhere-Z

allot create {ALLOT} dojump
 dc.l Xallot-Z

pvi setnum $C0
hcom  create {H,} dojump
 dc.l Xhcomma-Z
comma create {,} dojump
 dc.l Xcomma-Z
ccomma create {C,} dojump
 dc.l Xccomma-Z

lfa create {LFA} doipl
 dc.w -4
cfa create {CFA} doipl
 dc.w -2
nfa create {NFA} dojump
 dc.l Xnfa-Z
pfa create {PFA} dojump
 dc.l Xpfa-Z

traverse create {TRAVERSE} dojump
 dc.l Ctraverse-Z

latest  create {LATEST} dojump
 dc.l Xlatest-Z

storecsp create {!CSP} dojump
 dc.l Xstocsp-Z

qesc create {?ESC} dojump
 dc.l CXqesc-Z
qldng create {?LOADING} dojump
 dc.l Xqldng-Z
qstack create {?STACK} dojump
 dc.l Xqstack-Z
qcomp create {?COMP} dojump
 dc.l Xqcomp-Z
qexec create {?EXEC} dojump
 dc.l Xqexec-Z
qpairs create {?PAIRS} dojump
 dc.l Xqpairs-Z
qcsp create {?CSP} dojump
 dc.l Xqcsp-Z
qh   create {HLD?} docall (-- ff | on err:-4)
 dc.l CXqhld-Z
qerror create {?ERROR} dojump
 dc.l Xqerror-Z (f ernum -- | on error: row col)

qqer dc.w dojump-Z ( ernum flag -- error
 dc.l Cqqerr-Z

sysmsgq dc.w dojump-Z ( err.code - ff | err.code )
 dc.l Csysmsg-Z

* restore old dp and last from tail and word
 dc.b $81,'|'!$80,0,0,0,0
retexb dc.w docall-Z ;,dummy head for the debugger
 dc.l Cretexb-Z

* toggle direct execution:  | any (not defining) words ... | <enter>
pvi setnum $C0
exbrac create {|} dojump
 dc.l Cexbrac-Z

pvi setnum $C0
nhed create {H]} dojump
 dc.l Xnhed-Z   headerless

pvi setnum $C0
brac create  {`} Xbrac "Interpret-Klammer"
lbrac   dc.w Xlbrac-Z
carb create  {]} Xcarb ;"Compile-Klammer"

dcompile create {-COMPILE} dojump
 dc.l Xdcpl-Z
compile create {COMPILE} dojump
 dc.l Xcpl-Z

smudge create {SMUDGE} dojump
 dc.l Xsmudge-Z
unsmu create {UNSMUDGE} dojump
 dc.l Xunsmu-Z

psemicodeq create {(;CODE)} docolon V: hidn
     dc.w rgreat-Z
PS01 dc.w latest-Z,pfa-Z
     dc.w cfa-Z,store-Z,semis-Z

usesgt create {;USES>} docolon (;code) to disp'd address
 dc.w rgreat-Z,fetch-Z,branch-Z
 dc.w PS01-*

pvi setnum $C0
semicode create {;CODE} docolon
 dc.w qcsp-Z,compile-Z,psemicodeq-Z
 dc.w lbrac-Z,smudge-Z,assembler-Z,semis-Z

lessbuilds create {<BUILDS} docolon
 dc.w zero-Z,constant-Z,semis-Z

doesgreat create {DOES>} docolon
 dc.w rgreat-Z,latest-Z,pfa-Z
 dc.w store-Z,usesgt-Z,dodoesg-Z

pvi setnum $C0
semicdoes create {;CDOES>} dojump
 dc.l Xconsdgt-Z

gonext dc.w next0-Z fr xexdoes
pvi setnum $C0
with create {<WITH} dojump
 dc.l Xwith-Z

smds dc.w dojump-Z
 dc.l Xsmds-Z
pvi setnum $C0
sd create {;DOES>} dodefer
vsds dc.w sdgt-Z,sdgt-Z
xdgt dc.w dojump-Z nach <with in ;does>
 dc.l Xexdoes-Z
sdgt dc.w dojump-Z nach ;does> und vorgabe
 dc.l Xsemidgt-Z

pvi setnum $C0
defaultis create {DEFAULT-IS} docolon
 dc.w dashfind-Z,zbra-Z
 dc.w DI02-*,drop-Z,dftcfa-Z,nzbra-Z
 dc.w DI00-*
DI02 dc.w dfderr-Z
DI00 dc.w statezbra-Z
 dc.w DI01-*,compile-Z,lit-Z
 dc.w comma-Z,compile-Z
DI01 dc.w bdeftb-Z,semis-Z

pvi setnum $C0
is create {IS} docolon
    dc.w statezbra-Z
    dc.w I01-*,compile-Z,bisq-Z
    dc.w bcompileb-Z,cmcoff-Z
I01 dc.w tick-Z,istobody-Z

pvi setnum $C0
recurse create {RECURSE} docolon
    dc.w compile-Z,qstack-Z
    dc.w latest-Z,pfa-Z,cfacomma-Z,semis-Z

count   create {COUNT} dojump
 dc.l Xcount-Z
countw  create {COUNT-W} dojump
 dc.l Xcountw-Z
countl  create {COUNT-L} dojump
 dc.l Xcountl-Z
dashcount create {-COUNT} docall
 dc.l Cdcount-Z

pexp    create {(EXPER)} dodefer
dfdxper dc.w Dpexp-Z,Dpexp-Z
expect  create {EXPECT} dodefer
dfxp dc.w Dexpect-Z,Dexpect-Z,Dqexpect-Z
key     create {KEY}    dodefer
        dc.w Dkey-Z,Dkey-Z
qkey    create {?KEY}   dodefer
        dc.w Dqkey-Z,Dqkey-z
qterminal create {?TERMINAL} dodefer
        dc.w Dqterminal-Z,Dqterminal-Z
emit    create {EMIT}   dodefer
dfdemit dc.w Demit-Z,Demit-Z
type    create {TYPE}   dodefer
dfdtype dc.w Dtype-Z,Dtype-Z
typel   create {TYPE-L} dodefer
        dc.w Dtypel-Z,Dtypel-Z
pemit   create {PEMIT}  dodefer
        dc.w Dpemit-Z,Dpemit-Z
ptype   create {PTYPE}  dodefer
        dc.w doptype-Z,doptype-Z
prompt  create {PROMPT} dodefer
dfdprmp dc.w Dconsem-Z,Dconsem-Z
echo    create {ECHO}  dodefer
        dc.w Dconst-Z,Dconst-Z
bs      create {BS}    dodefer
        dc.w DXbs-Z,DXbs-Z
del     create  {DEL}   dodefer
        dc.w DXdel-Z,DXdel-Z
cr      create {CR}     dodefer
        dc.w docr-Z,docr-Z
clscr   create {CLS}    dodefer
        dc.w docls-Z,docls-Z
ok      create {OK}     dodefer
        dc.w DXok-Z,DXok-Z

dashprint create {-PRINT} docolon
     dc.w dashcount-Z,type-Z,semis-Z

dashtrailing create {-TRAILING} dojump ( addr n1 --- addr n2 )
 dc.l Cdashtrailing-Z

space create {SPACE} dojump
 dc.l Xspace-Z

dashcr create {-CR} docolon
  dc.w nexit-Z
  dc.w cr-Z,semis-Z

pdotquoteq create {(.")} dojump V: hidn
 dc.l Xpdqteq-Z

pvi setnum $C0
dotquote create {."} docolon
  dc.w lit-Z,'""',statezbra-Z ;;asciiquote...
  dc.w M3-*,compile-Z,pdotquoteq-Z
  dc.w wordh-Z,cfetch-Z,one-Z,orx-Z
  dc.w oneplus-Z,allot-Z,semis-Z
M3 dc.w wordh-Z,dashprint-Z,semis-Z

pvi setnum $C0
commentp create {.(} docolon
 dc.w lit-Z,$29,wordh-Z,count-Z,echo-Z,semis-Z

pvi setnum $C0
px create {(} dojump
 dc.l Xcommentb-Z

pvi setnum $C0
comments create {\} dojump
 dc.l Xcomments-Z

tibmax create {TIB-MAX} docons
vtibmax dc.w tibrp-rpmin-2,171

query create {QUERY} dodefer
 dc.w Dquery-Z,Dquery-Z

skip create {SKIP} dojump
 dc.l Xskip-Z
scan create {SCAN} dojump
 dc.l Xscan-Z

hold  create {HOLD} dojump
 dc.l Xhold-Z
pad   create {PAD} docall
 dc.l Cpad-Z

wordh dc.w dojump-Z  (word here
 dc.l Xwordh-Z
blword dc.w dojump-Z (bl word here
 dc.l Xblword-Z

source create {SOURCE} docall ;(ans)
 dc.l Csource-Z

word   create {WORD} docall
 dc.l Cword-Z

pnumq create {CONVERT} docall ( dn1 ptr1 -- dn2 ptr2
 dc.l Cpnumberq-Z

* ( adr -- dn | fp | abort )
number  create  {NUMBER} dodefer
dn dc.w cnumberc-Z,cnumberc-Z

qnumerr create {?NUMERR} dodefer V: hidn  ( flag -- flag 0 )
 dc.w zqerror-Z,zqerror-Z
zqerror dc.w dojump-Z
 dc.l Xnumerr-Z

cnumberc dc.w docolon-Z,bnumberb-Z,qnumerr-Z,semis-Z

bnumberb create {`NUMBER]} docall ;( ptr -- dn|fp ff | tf
 dc.l Cbnumq-Z

hex create {HEX} Xhex
decimal create  {DECIMAL} Xdecimal

bfindb create {`FIND]} dodefer V: hidn ( stg vocnfa - stg vocnfa )
 dc.w noop+1-Z,noop+1-Z
pfindq  create {(FIND)} docall V: hidn ( stg vocnfa - pfa count tf | stg ff )
 dc.l Cpfindq-Z

cfind create {C-FIND} docall ( ptr -- ptr2 c1 tf | ff ) -find in nfa-chain at ptr only )
 dc.l Ccfind-Z
vqfindq dc.w dojump-Z  search all stacked vocs
 dc.l Xqfindq-Z

wfindq create {W-FIND} dodefer ( ptr -- ( -find per $-ptr.w or $-ptr.b )
 dc.w pffindq-Z,pffindq-Z
pffindq dc.w docolon-Z
     dc.w count-Z,zbra-Z
     dc.w F16c-*,onedash-Z,branch-Z
     dc.w F16c-*

dashfind create {-FIND} dodefer (-- pfa ccount tf|-- ff)
 dc.w pdffind-Z,pdffind-Z
pdffind dc.w docolon-Z,blword-Z         bl word here
F16c dc.w bfindb-Z,vqfindq-Z,nzbra-Z search order stacked vocs
     dc.w F16d-*
     dc.w rx-Z,lit-Z,rootv-2-Z
     dc.w fetcha-Z,pfindq-Z             and always the root voc.
F16d dc.w fndclr-Z                      clear serch protect bits
     dc.w rdrop-Z,semis-Z

fndclr dc.w dojump-Z
 dc.l Xfndclr-Z

iddot create {ID.} docolon
  dc.w count-Z,io-Z,over-Z,lit-Z,$40
  dc.w andx-Z,twogtrr-Z,dxstrip-Z
  dc.w cidot-Z,tworgreat-Z,dxstrip-Z
  dc.w bl-Z,prompt-Z,semis-Z

cidot dc.w dojump-Z
 dc.l XCidot-Z

head dc.w dojump-Z
  dc.l Xhead-Z mit semis & ?exec
create create {CREATE} docolon
  dc.w dashfind-Z,zbra-Z
  dc.w M18c-*,waf-Z,gtbra-Z
  dc.w M18d-*,over-Z,nfa-Z,iddot-Z
  dc.w four-Z,message-Z,bl-Z,prompt-Z
M18d dc.w twodrop-Z
M18c dc.w head-Z

pvi setnum $C0
bcompileb create {`COMPILE]} docolon
  dc.w dashfind-Z,zeq-Z,zqerror-Z
  dc.w drop-Z,cfacomma-Z,cmcoff-Z

pvi setnum $C0
literal create  {LITERAL} dojump
 dc.l Xlitopt-Z

pvi setnum $C0
dltl create {DLITERAL} dojump
 dc.l Xdliteral-Z

pvi setnum $C0
qltl create {QLITERAL} dojump
 dc.l Xqliteral-Z

interpret create {INTERPRET} docolon
M22 dc.w qstack-Z,dashfind-Z,zbra-Z
    dc.w M23-*,binterpb-Z,statezbra-Z
    dc.w M22d-*,dbon-Z,zbra-Z
    dc.w M22d-*,bdebugb-Z
M22d dc.w statefetch-Z,cless-Z,zbra-Z
    dc.w M24-*,bcplb-Z
    dc.w cfacomma-Z,branch-Z
    dc.w M22-*
M24 dc.w cfaexec-Z,branch-Z
    dc.w M22-*
M23 dc.w here-Z,bconvertb-Z,branch-Z
    dc.w M22-*

voc setstr hidn

dodebgb create {(DEBUG)} dodefer
vdodebug dc.w $8001,$8001 inactive by default

pvi setnum $C0
bdebugb create {`DEBUG]} docolon
 dc.w dcompile-Z,dodebgb-Z,cmcoff-Z

bcplb create {`CPL]} dodefer
 dc.w noop-Z,noop-Z

binterpb create {`INTERPRET]} dodefer
 dc.w noop-Z,noop-Z

bconvertb create {`CONVERT]} dodefer (ptr --)
 dc.w numconv-Z,numconv-Z
numconv dc.w dojump-Z
 dc.l Xnumconv-Z

voc setstr fth
immediate create {IMMEDIATE} dojump
 dc.l Ximed-Z

* by 2 cells extended
vocabulary create {VOCABULARY} docolon
 dc.w  lessbuilds-Z,voca-Z,doesgreat-Z
dovoc  dc.w cdovoc-Z (mit semis!)
cdovoc dc.w dojump-Z
 dc.l XCdovoc-Z
voca dc.w dojump-Z
 dc.l Xvoca-Z

definitions create {DEFINITIONS} dojump V: root
 dc.l Xdefinitions-Z
prevdef create {PREVDEF} dojump V: root
 dc.l Xprevdef-Z

* initial EXecuting the job-parameter stg:
loadquit dc.w docolon-Z,forth-Z
    dc.w lit-Z,quit-Z,pquitq-Z
    dc.w storea-Z,lit-Z,16,chp-Z ;;cons16..
    dc.w dup-Z,fetcha-Z,zbra-Z
    dc.w LQ1-*,zeroinstore-Z,off-Z
    dc.w lbrac-Z,cr-Z,branch-Z
    dc.w M29x-*
LQ1 dc.w drop-Z,branch-Z
    dc.w M29y-*

quit create {QUIT} docolon
M29y dc.w trap0r-Z,zero-Z,blk-Z
    dc.w storea-Z,lbrac-Z
M29 dc.w rpstore-Z,ok-Z <outer interpreter
    dc.w query-Z  keyboard or blck input
M29x dc.w interpret-Z,branch-Z
    dc.w M29-*

mem create {MEM} dojump
 dc.l Xmem-Z

dotcpu create {.CPU} docolon
    dc.w basecpu-Z,ddot-Z,basestore-Z,semis-Z

pabortq create  {(ABORT)} dodefer V: hidn
    dc.w doabort-Z,doabort-Z

doabort dc.w docolon-Z
    dc.w trap0r-Z,atne-Z,work-Z,fnt-Z
    dc.w drzero-Z,decimal-Z,cr-Z,dotcpu-Z
    dc.w lit-Z,sysname-Z+1,count-Z,type-Z
    dc.w cr-Z,mem-Z,udot-Z,pdotquoteq-Z
    dc.b 17,'Bytes free, Job# '
    dc.w fthid-Z,dhexdot-Z,semis-Z

abort create {ABORT} docolon
    dc.w spstore-Z,pabortq-Z
    dc.w pquitq-Z,perform-Z,semis-Z

pabtqp create {(ABORT")} dodefer V: hidn
    dc.w quit-Z,quit-Z

dabtqte dc.w docolon-Z,swapx-Z,zbra-Z
    dc.w AQ01-*,dashprint-Z,space-Z,pabtqp-Z
AQ01 dc.w drops-Z

pvi setnum $C0
abtqte create {ABORT"} docolon
    dc.w wquote-Z,dcompile-Z,dabtqte-Z,semis-Z

error  create {ERROR} dodefer
verror dc.w berrorb-Z,berrorb-Z

berrorb create  {`ERROR]} docolon V: hidn
    dc.w trap0r-Z,lit-Z,27,overdash-Z,zbra-Z
    dc.w M17e-*,pickforth-Z
M17e dc.w lit-Z,vftherr-Z,onx-Z,waf-Z
    dc.w zlt-Z,zbra-Z
    dc.w M17-*
    dc.w retexb-Z,abort-Z  (end compiling state & abort)
M17 dc.w here-Z,count-Z,echo-Z
    dc.w lit-Z,'??',prompt-Z,bl-Z,prompt-Z
    dc.w message-Z,spstore-Z
    dc.w blk-Z,twofetcha-Z  leave blk & in
    dc.w pquitq-Z,perform-Z,semis-Z

cold create {COLD} docolon
    dc.w empty-Z
    dc.w *+2-Z
    dc.w *+2-Z
    jmp origin(pc)

warm create {WARM} origin+4

udmmul  create {UDM*}  docall
 dc.l Cudmmul-Z  (du1 du2 -- qu3)
dmmul   create {DM*}   docall
 dc.l dmmulcal-Z (dn1 dn2 -- qn3)
dmul    create {D*}    docall
 dc.l Cdmul-Z    (dn1 dn2 -- dn3 | ovf)
udmul   create {UD*}   dojump
 dc.l Xudmul-Z  (du1 du2 -- du3)
smul    create {S*}    docall
 dc.l Csmul-Z   (dn1 n2 -- dn3 | ovf)
umul    create {U*} dojump
 dc.l Xumul-Z (u1 u2 -- du3)
mmul    create {M*} dojump
 dc.l Xmmul-Z (n1 n2 -- dn3)
mul     create {*} dojump
 dc.l Xmul-Z  (n1 n2 -- n3)
qmul    create {QS*} docall
 dc.l Cqmul-Z ( q1 n2 -- q2 )

mplus   create  {M+} dojump
 dc.l Xmplus-Z (dn1 +n2 - dn3)
qmplus  create  {QM+} dojump
 dc.l Xqmplus-Z

qmbym   create {UQM/MOD} docall (+qn1 +dn2 - +q3r +d4q)
 dc.l CXuqmbym-Z
sqbym   create {QM/MOD} docall  (+qn1 dn2 - q3r d4q)
 dc.l CXqmbym-Z
uqbym   create {UQ/MOD} dojump (+qn1 dn2 - d3r d4q
 dc.l Xudmbym-Z
dbym    create {UD/MOD} dojump (ud1 ud2 - ud3r ud4q)
 dc.l Xdbym-Z
dby     create {D/} dojump (dn1 dn2 -- d3q)
 dc.l Xdby-Z
umbym   create {UM/MOD} docall
 dc.l Cumbym-Z (udn1 un2 - u3r u4q)
mbymod  create {M/MOD}  docall (udn1 un2 - un3r udn4q )
 dc.l Cmbymod-Z
mby     create {M/} docall (sm/rem)
 dc.l Cmby-Z             (dn1 n2 - n3r n4q)
ubym    create {U/MOD}  docall
 dc.l Cumod-Z (un1 un2 - un3r un4q)
usby    create {U/} dojump (un1 un2 - un3q)
 dc.l Xusby-Z
bymod   create {/MOD} docall
 dc.l bymodcal-Z        (n1 n2 - n3r n4q)
by      create {/}  Xby (n1 n2 - n3q)
mod     create {MOD} dojump
 dc.l Xmod-Z (n1 n2 - n3r)

uqmbymod create {UD*/MOD} dojump
 dc.l Xuqmbymod-Z (dn1 dn2 dn3 - d4r d5q)
mulbymod create {*/MOD}  docall
 dc.l Cmulbym-Z         (n1 n2 n3 - n4r n5q)
mulby create {*/} dojump
 dc.l Xmulby-Z

voc setstr fp * -- f.p. words -- *

pvi setnum $C0
fliteral create {LITERAL} dojump
 dc.l Xfliteral-Z

fcons create {CONSTANT} docolon
 dc.w create-Z,smudge-Z,comma-Z
 dc.w dcomma-Z,usesgt-Z,dofcons-Z

ffetch create {@} dojump ( addr -- fp )
 dc.l Xffetch-Z
ffl  create {@L} dojump
 dc.l Xffl-Z

fstore create {!} dojump ( fp addr -- )
 dc.l Xfstore-Z
fsl  create {!L} dojump
 dc.l Xfsl-Z

ffs  create {@!} dojump
 dc.l Xffs-Z

flit create {FLIT} dojump V: hidn
 dc.l Xflit-Z

cndtof create {$>F} docall V: fth ( $.addr --- fp 0 <or, on error> 1 )
 dc.l Ccndtof-Z

* fp stack
fdrop   create  {DROP}  dojump
 dc.l Xfdrop-Z
fdup    create  {DUP}   dojump
 dc.l Xfdup-Z
fswap   create  {SWAP}  dojump
 dc.l Xfswap-Z
f2swap  create  {2SWAP} dojump
 dc.l Xf2swap-Z
fover   create  {OVER}  dojump
 dc.l Xfover-Z
fpick   create  {PICK}  docall
 dc.l Cfpick-Z
frot    create  {ROT}   dojump
 dc.l Xfrot-Z
fdrot   create  {-ROT}  dojump
 dc.l Xfdrot-Z
froll   create  {ROLL}  dojump
 dc.l Xfroll-Z
fgreatr create  {>R}    dojump
 dc.l Xfgr-Z
frgreat create  {R>}    dojump
 dc.l Xfrg-Z

riasin  create {ASIN} dorix
        dc.w 32
rifloat create {FLOAT} dorix
        dc.w 8
rinlint create {NLINT} dorix
        dc.w 6
riint   create {INT} dorix
        dc.w 4
rinint  create {NINT} dorix
        dc.w 2
riadd   create {+} dorix
        dc.w 10
risub   create {-} dorix
        dc.w 12
ridiv   create {/} dorix
        dc.w 16
riabs   create {ABS} dorix
        dc.w 18
rineg   create {NEG} dorix
        dc.w 20
ricos   create {COS} dorix
        dc.w 24
risin   create {SIN} dorix
        dc.w 26
ritan   create {TAN} dorix
        dc.w 28
ricot   create {COT} dorix
        dc.w 30
rimul   create {*} dorix
        dc.w 14
ripow   create {^} dorix
        dc.w 48
riexp   create {EXP} dorix
        dc.w 46
rilog10 create {LOG10} dorix
        dc.w 44
riln    create {LN} dorix
        dc.w 42
risqrt  create {SQRT} dorix
        dc.w 40
riacot  create {ACOT} dorix
        dc.w 38
riatan  create {ATAN} dorix
        dc.w 36
riacos  create {ACOS} dorix
        dc.w 34

fmuldiv create {*/} dojump
 dc.l Xfmdiv-Z

ftwodiv create {2/} Xf2div
ftwomul create {2*} Xf2mul

fplds create {+-}  dojump
 dc.l Xfplds-Z

fzeq create {0=} dojump
 dc.l Xfzeq-Z
fzlt    create {0<} dojump
 dc.l Xfzlt-Z
fzgt create {0>} dojump
 dc.l Xfzgt-Z
feq     create {=}  dojump
 dc.l Xfeq-Z
fgt     create {>} dojump
 dc.l Xfgt-Z
flt     create {<} dojump
 dc.l Xflt-Z
fsgn    create {SGN} docall
 dc.l Cfsgn-Z
fcmp    create {CMP} docall
 dc.l Cfcmp-Z

* ( op -- ri.result ) or ( ri.prog ri.mem -nn --  ri.result )
rivec create {RI-EXEC} dojump
 dc.l Xrivec-Z

fdot create {.} dojump
 dc.l Xfdot-Z

fzero create {0} dofscons
  dc.w 0,0
fone  create {1} dofscons
  dc.w $0801,$4000
ftwo  create {2} dofscons
  dc.w $0802,$4000
fthree create {3} dofscons
  dc.w $0802,$6000
fhalVe create {1/2} dofscons
  dc.w $0800,$4000
fqartr create {1/4} dofscons
  dc.w $07ff,$4000
fmone create {-1} dofscons
  dc.w $0800,$8000
fmtwo create {-2} dofscons
  dc.w $0801,$8000
fpi   create {PI} dofcons
  dc.w $0802,$6487,$ED51

voc setstr qdos

srfetch create {SR@} dojump (-- nn) full length statusregister
 dc.l Xsrftc-Z

srstore create {SR!} dojump  (nn --) set P-status
 dc.l Xsrsto-Z

trap0 create {TRAP0} Xtrap0  (-- nn) supv. and ret staturegister

trap0s create {TRAP0S} Xtrap0s enter supv. mode

trap0r create {TRAP0R} dojump safely (return to) user mode
 dc.l Xtrap0r-Z

voc setstr fth * number conversion

bytes create {>|<} dojump (n1 -- c2.lo c3.hi)
 dc.l Xbytes-Z

ddashgreatq create {D->Q} dojump
 dc.l Xddgq-Z
sdashgreatd create {S->D} Xsdgd
cdashgreats create {C->S} Xcdgs

htoa    create {H>A} docall
 dc.l Chasci-Z
atoh    create {A>H} docall
 dc.l Xascih-Z

cfquad  create {Q>F} dojump
 dc.l Xqflt-Z
cflong  create {D>F} dojump
 dc.l CXflong-Z
cfsing  create {S>F} dojump
 dc.l Xfsing-Z
clflt   create {F>D} dojump
 dc.l XXlflt-Z
cqflt   create {F>Q} dojump
 dc.l Xfpq-Z
cnftd   create {F>$} docall (fp -- addr len <or, on err> addr zero)
 dc.l Cftd-Z
ffdot   create {\.}  dojump
 dc.l Xfdot-Z

update  create  {UPDATE}     dojump
 dc.l Xupdate-Z
updtoff create  {UPDATE-OFF} dojump
 dc.l Xupdoff-Z

drzero  create  {DR0}   Xdrzero
drone   create  {DR1}   Xdrone
ediwork create  {DR?} dojump ff=dr0 or tf=dr1
 dc.l Xediwork-Z

blkfetch create {BLK@}  Xblkft
fencef  dc.w Xfencef-Z
lastf   dc.w Xlastf-Z

use     create  {USE}  dovariable
vuse    dc.w    0
prev    create  {PREV} dovariable
vprev   dc.w    0,1 updt enable flag
bupdtb  create {(UPDATE)} docons
 dc.w   vprev+2-Z

rbyw    create  {R/W}   dojump
 dc.l Xrbyw-Z

nxblk create {BLK+} docall V: root ( executing from <nul>
 dc.l Cnxblk-Z

mtybfs create {EMPTY-BUFFERS} dojump
 dc.l Xmtybfs-Z

plusbuf create  {+BUF} docall
 dc.l Cplusbuf-Z

buffer  create  {BUFFER} dodefer
dfdbuffer dc.w Jpbufq-Z,Jpbufq-Z
Jpbufq  dc.w dojump-Z
 dc.l Xpbufq-Z

* n1 -- adr
block   create {BLOCK} dodefer
dfdblock dc.w Jpblockq-Z,Jpblockq-Z
Jpblockq dc.w dojump-Z
 dc.l Xpblockq-Z

* line screen -- adr cnt
plineq create {(LINE)} docolon
 dc.w greatr-Z,cbyl-Z,bbybuf-Z
 dc.w mulbymod-Z,rgreat-Z,bbyscr-Z
 dc.w mul-Z,plus-Z,block-Z
 dc.w plus-Z,cbyl-Z,semis-Z

dotline create {.LINE} docolon
 dc.w plineq-Z,dashtrailing-Z,type-Z,semis-Z

message create {MESSAGE} docolon
    dc.w promptq-Z,fetch-Z,nzbra-Z
    dc.w M37-*,bell-Z,drops-Z
M37 dc.w waf-Z,zbra-Z
    dc.w M36-*,four-Z,offset-Z
    dc.w fetcha-Z,bbyscr-Z,by-Z
    dc.w dash-Z,dotline-Z,semis-Z
M36 dc.w sysmsgq-Z,zdupbra-Z
    dc.w M38-*,pdotquoteq-Z        (.")
    dc.b 5,'msg #'
    dc.w dot-Z
M38 dc.w semis-Z

ld1 dc.w dojump-Z
 dc.l Xld1-Z
ld2 dc.w dojump-Z
 dc.l Xld2-Z

load create {LOAD} dodefer
 dc.w dld-Z,dld-Z
dld dc.w docolon-Z
 dc.w ld1-Z,prompt-Z,fgreatr-Z,lspsto-Z
 dc.w interpret-Z,frgreat-Z,ld2-Z

lspsto dc.w dojump-Z
 dc.l Xlpsto-Z
lspcmp dc.w dojump-Z
 dc.l Xlspcmp-Z
ddg01 dc.w dojump-Z
 dc.l Xdg01-Z
pvi setnum $C0
ddgt create {-->} dodefer
     dc.w bdsdsgt-Z,bdsdsgt-Z

bdsdsgt dc.w docolon-Z
     dc.w qldng-Z,lspcmp-Z,zbra-Z
     dc.w DG01-*,scr-Z,fetcha-Z,dot-Z
     dc.w lit-Z,'::',emit-Z,dot-Z
DG01 dc.w lit-Z,'..',prompt-Z,ddg01-Z

pluscont create {+CONTINUE} docolon (nn --) skip the nxt nn blocks
     dc.w blk-Z,pstoa-Z,x-Z,semis-Z

edifile create {EDIF} dojump (editted file data
 dc.l Xedif-Z
edirw create {E-RO} docons
 dc.w 1
pushfile create {PUSHFILE} docolon (-- c.name count ptr d.id chan)
 dc.w edifile-Z                          (fileptr) filechan
 dc.w greatr-Z,greatrr-Z,fetch-Z         >r >rr @
 dc.w threeplus-Z,twoby-Z,greatrr-Z      3+ 2/ >rr
 dc.w minus-Z,ndrop-Z                    minus ndrop
 dc.w rgreat-Z,rx-Z,spfetch-Z            r> r sp@
 dc.w fourplus-Z,rot-Z,twomul-Z          4+ rot 2*
 dc.w cmove-Z,rgreat-Z,rx-Z              cmove r> r
 dc.w chid-Z,rgreat-Z,semis-Z            ch-id r>

popfile create {POPFILE} docolon   ( c.name count ptr d.id chan --
 dc.w twogtrr-Z,rx-Z                     2>rr r
 dc.w close-Z,setchan-Z,greatr-Z         close set-chan >r
 dc.w fbyn-Z,min-Z,spfetch-Z             f/n min sp@
 dc.w over-Z,twoplus-Z,rx-Z              over 2+ r
 dc.w swapx-Z,cmove-Z,oneplus-Z          swap cmove 1+
 dc.w twoby-Z,ndrop-Z,rgreat-Z           2/ ndrop r>
 dc.w rgreat-Z,rgreat-Z,zgt-Z         r> r> 0>
 dc.w zbra-Z                             IF
 dc.w PF02-*,edirw-Z,swapx-Z                  e-ro swap
 dc.w twogtrr-Z,open-Z,dup-Z,zbra-Z           2>rr open dup IF
 dc.w PF12-*,dirname-Z,fetcha-Z,sixdash-Z,mibra-Z (dir) @ 6- +IF
 dc.w PF12-*,dirname-Z,tworfetch-Z,open-Z,twodrop-Z (dir) 2r open 2drop
PF12 dc.w rdrop-Z,rdrop-Z                              ENDIF ENDIF rdrop
PF02 dc.w twodrop-Z,semis-Z              ENDIF 2drop

sltext create {SLTEXT} dodefer  ( bl -- ) s-load filename to pad+
 dc.w qtext-Z,qtext-Z

lload create {L-LOAD} dodefer
 dc.w sload1-Z,sload1-Z
sload1 dc.w docolon-Z,one-Z,sload-Z
 dc.w bootname-Z,fbyn-Z,dirname-Z,sname-Z,semis-Z

pvi setnum $C0
sload create {S-LOAD} docolon
     dc.w scr-Z,dup-Z,fetcha-Z,greatr-Z      scr dup @ >r !
     dc.w storea-Z,pushfile-Z                pushfile (chars len ptr d.id chan)
     dc.w greatrr-Z,pad-Z,twoplus-Z          >rr pad 2+
     dc.w store-Z,twogreatr-Z,greatrr-Z      ! 2>r >rr     (temp sto chan
     dc.w pad-Z,store-Z,dup-Z                pad ! dup     (and oldname-ptr
     dc.w threeplus-Z,twoby-Z,ngreatr-Z      3+ 2/ n>r
     dc.w in-Z,fetcha-Z                      in @
     dc.w pad-Z,twofetcha-Z,greatr-Z         pad 2@ >r     (push {ptr
     dc.w bl-Z,sltext-Z,pad-z                bl \name pad
     dc.w dup-Z,rgreat-Z,over-Z              dup r> over
     dc.w fetch-Z,twoplus-Z,cmove-Z          @ 2+ cmove    (inst new to oldname
     dc.w one-Z,rot-Z,greatrr-Z              1 rot >rr     (chan
     dc.w open-Z,drop-Z,greatrr-Z            open drop >rr
     dc.w zeq-Z,rx-Z,lit-Z,-9             0= r -9
     dc.w eq-Z,orx-Z,nzbra-Z              = or 0IF
     dc.w PF06-*,in-Z,storea-Z,zero-Z              in ! 0 ENDIF
PF06 dc.w drop-Z,rx-Z                             drop r
     dc.w zbra-Z
     dc.w PF03-*                                    IF
     dc.w rx-Z,sevenplus-Z,nzbra-Z                r 7+
     dc.w PF05-*                                      0IF
     dc.w pad-Z,dup-Z,fbyn-Z,bootname-Z,sname-Z         pad f/n (boot) !name
     dc.w one-Z,rdrop-Z,rx-Z,open-Z                     pad 1 rdrop r open
     dc.w drop-Z,greatrr-Z,zbra-Z                 drop >rr || >r ENDIF
     dc.w PF03-*                                       IF><ENDIF || r  IF ..
PF05 dc.w rx-Z,lit-Z                                    r -9 =/=
     dc.w -9,neq-Z,zbra-Z                         IF
     dc.w PF03-*,scr-Z,quest-Z                           scr ?
     dc.w lit-Z,sload-Z+2,nfa-Z                          ' sload nfa
     dc.w iddot-Z,pad-Z,dashprint-Z                      id. pad -print
     dc.w space-Z,rx-Z,message-Z                         space r message
PF03 dc.w rx-Z,zeq-Z,rgreat-Z             ENDIF ENDIF ENDIF
     dc.w rdrop-Z                            r 0= r> rdrop
     dc.w lit-Z,-9,eq-Z,orx-Z,zbra-Z   -9 = or
     dc.w PF04-*                             IF
     dc.w dirname-Z,fbyn-Z,pad-Z,sname-Z       (dir) f/n pad !name
     dc.w scr-Z,fetcha-Z,load-Z                scr @ load
PF04 dc.w rx-Z,threeplus-Z,twoby-Z           ENDIF r 3+ 2/
     dc.w nrgreat-Z,rgreat-Z,tworgreat-Z     nr> r> 2r>
     dc.w rgreat-Z,popfile-Z,lastf-Z         r> popfile last @
     dc.w iddot-Z,rgreat-Z                   id. r>
     dc.w scr-Z,storea-Z,semis-Z              scr !

qfound dc.w docolon-Z,dashfind-Z,dup-Z,nzbra-Z
     dc.w PF02-*,semis-Z

pvi setnum $C0
iftrue create {IF-TRUE} docolon
     dc.w branch-Z
     dc.w FF03-*

pvi setnum $C0
iffound create {IF-FOUND} docolon
     dc.w qfound-Z
FF03 dc.w dexit-Z
FF02 dc.w dcompile-Z,comments-Z,semis-Z

pvi setnum $C0
ifnfound create {IF-NFOUND} docolon
     dc.w qfound-Z,nzbra-Z
     dc.w FF02-*,semis-Z

tickn dc.w $C1A7            {'}
     dc.w [[voc]lk]-Z
tick dc.w docolon-Z
[voc]lk setstr tickn
     dc.w dashfind-Z,zbra-Z
     dc.w TK01-*,drop-Z,literal-Z,semis-Z
TK01 dc.w here-Z,dashprint-Z,space-Z,zero-Z,statezbra-Z
     dc.w TK02-*,error-Z,semis-Z
TK02 dc.w message-Z,rdrop-Z,semis-Z

pvi setnum $C0
begin create {BEGIN} docolon ;1
 dc.w qcomp-Z,here-Z,one-Z,semis-Z

pvi setnum $C0
endif create {ENDIF} dojump ;2
 dc.l Xendif-Z

pvi setnum $C0
dox create {DO} dojump ;3
 dc.l Xdox-Z

pvi setnum $C0
loop create {LOOP} dojump ;3
 dc.l Xloop-Z

pvi setnum $C0
plusloop create {+LOOP} dojump ;3
 dc.l Xploop-Z

pvi setnum $C0
until create {UNTIL} docolon ;4 1
  dc.w dup-Z,fourdash-Z,nzbra-Z
  dc.w UL01-*,twoswap-Z,dountil-Z,branch-Z
  dc.w UL02-*
dountil dc.w docolon-Z
UL01 dc.w one-Z,qpairs-Z,qzeqbra-Z,back-Z,cmcoff-Z

cmcoff dc.w dojump-Z
 dc.l Xcmcoff-Z

* IF-optimierung
qzeqbra dc.w dojump-Z
 dc.l Xqzeqbra-Z

pvi setnum $C0
again create {AGAIN} dojump ;1
 dc.l Xagain-Z

pvi setnum $C0
repeat create {REPEAT} docolon ;1
     dc.w twoswap-Z,again-Z
UL02 dc.w twodash-Z,endif-Z,semis-Z

pvi setnum $C0
caseq create {CASE?} docall ;2
 dc.l Ccseq-Z

pvi setnum $C0
if create {IF} docall ;2
 dc.l Cif-Z

pvi setnum $C0
else create {ELSE} dojump ;2 + -2
 dc.l Xelse-Z

pvi setnum $C0
while create {WHILE}  docall ;4
 dc.l Cwhile-Z

pvi setnum $C0
nter create {ENTER} dojump ;9
 dc.l Xnter-Z

pvi setnum $C0
ntry create {ENTRY} dojump ;9
 dc.l Xntry-Z

defer create {DEFER} docolon
 dc.w lit-Z,noop-Z,dup-Z
 dc.w constant-Z,comma-Z
 dc.w usesgt-Z,dodefer-Z

colon create {:} docolon
 dc.w qexec-Z,storecsp-Z,current-Z
 dc.w context-Z,s1s-Z,create-Z
 dc.w carb-Z,usesgt-Z,docolon-Z

cfetchl create  {C@L} dojump
 dc.l Xcfetchl-Z
fetchl  create  {@L} dojump
 dc.l Xfetchl-Z
twofl create {2@L}  dojump
 dc.l X2fl-Z
fourfl create {4@L} dojump
 dc.l X4fl-Z

cstorel create  {C!L} dojump
 dc.l Xcstorel-Z
storel  create  {!L}  dojump
 dc.l Xstorel-Z
twostorel create {2!L} dojump
 dc.l X2stol-Z
foursl  create {4!L} dojump
 dc.l X4stol-Z

pstol   create  {+!L} dojump
 dc.l Xpstol-Z
twopstol create {2+!L} dojump
 dc.l Xtwopstol-Z
fourpsl create {4+!L} dojump
 dc.l X4pstol-Z

cstore  create  {C!} dojump
 dc.l Xcsto-Z
store   create  {!}  dojump
 dc.l Xstore-Z
storea  create  {!A} dojump
 dc.l Xstorea-Z
twostore create {2!} dojump
 dc.l Xtwosto-Z
fours   create  {4!} dojump
 dc.l Xfours-Z
tsa create {2!A} dojump
 dc.l X2storea-Z

bpsto   create {+!}  dojump
 dc.l Xbpsto-Z
pstoa create {+!A} dojump ;word aligned
 dc.l Xpstoa-Z
mps     create {M+!} dojump
 dc.l Xmpsto-Z
twopsto create {2+!} dojump
 dc.l Xtwopsto-Z
fourps  create {4+!} dojump
 dc.l X4psto-Z

cfetch  create  {C@} dojump
 dc.l Xcfetch-Z
fetch   create  {@}  dojump
 dc.l Xfetch-Z
twofetch create {2@} dojump
 dc.l Xtwof-Z
fourf   create  {4@} dojump
 dc.l Xfourf-Z
fetcha  create  {@A} dojump
 dc.l Xfetcha-Z
twofetcha create {2@A} dojump
 dc.l X2fetcha-Z

s1s create {@!} dojump
 dc.l Xssto-Z
s2s create {2@!} dojump
 dc.l Xdssto-Z
s4s create {4@!} dojump
 dc.l Xqssto-Z


oneplus   create {1+} doipl
 dc.w 1
twoplus   create 2+ doipl
 dc.w 2
threeplus create 3+ doipl
 dc.w 3
fourplus  create 4+ doipl
 dc.w 4
fiveplus  create 5+ doipl
 dc.w 5
sixplus   create 6+ doipl
 dc.w 6
sevenplus create 7+ doipl
 dc.w 7
eightplus create 8+ doipl
 dc.w 8
onedash   create 1- doipl
 dc.w -1
twodash   create 2- doipl
 dc.w -2
threeds   create 3- doipl
 dc.w -3
fourdash  create 4- doipl
 dc.w -4
fivedash  create 5- doipl
 dc.w -5
sixdash   create 6- doipl
 dc.w -6
sevends   create 7- doipl
 dc.w -7
eightds   create 8- doipl
 dc.w -8
*
d1pl create d1+ dodmpl
 dc.w 1
d2pl create d2+ dodmpl
 dc.w 2
d4pl create d4+ dodmpl
 dc.w 4
d6pl create d6+ dodmpl
 dc.w 6
d8pl create d8+ dodmpl
 dc.w 8
d1ds create d1- dodmpl
 dc.w -1
d2ds create d2- dodmpl
 dc.w -2
d4ds create d4- dodmpl
 dc.w -4
d6ds create d6- dodmpl
 dc.w -6
d8ds create d8- dodmpl
 dc.w -8

fourby  create  {4/}  docallw
 dc.w Xfourby-Z
twoby   create  {2/}  docallw
 dc.w Xtwoby-Z
d4by create  {D4/} docall
 dc.l Cd4by-Z
d2by  create  {D2/} docall
 dc.l Cd2by-Z
q4by create  {Q4/} docall
 dc.l Cq4by-Z
q2by  create  {Q2/} docall
 dc.l Cq2by-Z
mul16   create  {16*} docallw
 dc.w X16mul-Z
tenmul  create  {10*} docallw
 dc.w X10mul-Z
sixmul  create  {6*}  docallw
 dc.w X6mul-Z
fivemul create  {5*}  docallw
 dc.w X5mul-Z
fourmul create  {4*}  docallw
 dc.w Xfourmul-Z
threemul create {3*}  docallw
 dc.w X3mul-Z
twomul  create  {2*}  docallw
 dc.w Xtwomul-Z

d2mul   create {D2*}  Xd2mul
d4mul   create {D4*}  dojump
 dc.l Xd4mul-Z

nnot    create {NOT}  Xnot
orx     create {OR}   Xorx
xor     create {XOR}  Xxor
andx    create {AND}  Xand
twoand  create {2AND} Xtwoand ( dn1 dn2 -- dn)
ors     create {OR!}  dojump asm..
 dc.l Xors-Z
eors    create {XOR!} dojump
 dc.l Xxors-Z
ands    create {AND!} dojump
 dc.l Xands-Z
align   create {ALIGN} dojump
 dc.l CXalign-Z ( n1 n2 -- nn) mask off n1 the lower n2 bits

even create {EVEN}  Xeven
evup create {EVEN+} Xevup

bfs create {BFSET} dojump
 dc.l Xbfs-Z
bfc create {BFCLR} dojump
 dc.l Xbfc-Z
bft create {BFTST} dojump
 dc.l Xbft-Z
bfx create {BFCHG} dojump
 dc.l Xbfx-Z

zneq    create {0=/=} Xzneq
mzeq    create {-0=}  Xmzeq
zeq     create {0=}   Xzeq
dzeq    create {D0=}  Xdzeq
qzeq    create {Q0=}  dojump
 dc.l Xqzeq-Z

zgt  create {0>}   Xzgt

zlt  create {0<}   Xzlt
dzlt create {D0<}  Xdzl
qzl  create {Q0<}  docall
 dc.l Cqzl-Z

eq     create {=}  Xeq
deq    create {D=} Xdeq
qeq    create {Q=} dojump
 dc.l Xqeq-Z

neq    create {=/=} Xneq

less   create {<}   Xless
cless  create {UC<} dojump
 dc.l Xcless-Z
uless  create {U<}  Xuless
dless  create {D<}  Xdless
udless create {DU<} Xduless
qlt   create {Q<}  docall
 dc.l Cqlt-Z
uqlt  create {QU<} dojump
 dc.l Xqult-Z

great  create {>}   Xgreat
udgt   create {DU>} Xdugt
voc setstr hidn
lpl    create {LIT+} dojump
 dc.l Xlplus-Z
voc setstr fth
pvi setnum $C0
oplus   create {+}  dojump
 dc.l Xoplus-Z
pplus  create {++} dojump
 dc.l Xpplus-Z
dplus  create {D+} Xdplus
qplus  create {Q+} docall
 dc.l Cqadd-Z

cds    create {C-} dojump
 dc.l Xcds-Z
dash   create {-}  Xdash
dsub   create {D-} Xddash
qsub   create {Q-} docall
 dc.l Cqsub-Z

minus  create {MINUS}  Xminus
dminus create {DMINUS} Xdminus
qminus create {QMINUS} Xqminus

plds  create {+-}  Xplds  ( n1 n2  -- n1*sgn(n2) )
dplds create {D+-} Xdplds ( dn1 n2 -- dn1*sgn(n2))
qplds create {Q+-} Xqplds

abs  create {ABS}  dojump
 dc.l Xabs-Z
dabs create {DABS} dojump
 dc.l Xdabs-Z
qabs create {QABS} dojump
 dc.l Xqabs-Z

oneabs  create {1ABS} X1abs ( 1's complement +ve )

umax    create {UMAX} dojump
 dc.l Xumax-Z
umin    create {UMIN} dojump
 dc.l Xumin-Z
zmax    create {0MAX} dojump
 dc.l Xmax-Z-2
max     create {MAX}  dojump
 dc.l Xmax-Z
min     create {MIN}  dojump
 dc.l Xmin-Z
sgn     create {SGN}  dojump
 dc.l Xsgn-Z
tsgn    create {2SGN} dojump
 dc.l X2sgn-Z

withinq create {WITHIN?} dojump
 dc.l Xwiq-Z    (n1 n2 n3 -- f) tf if n2<=n1<n3
bounds  create {BOUNDS}  dojump
 dc.l Xbounds-Z (n1 n2 -- n3 n4) n3:=n1+n2, n4:=n1
within  create {WITHIN} docall
 dc.l Cwithin-Z (n1 n2 n3 -- nn )
twowithin create {2WITHIN} docall
 dc.l C2wi-Z    (dn1 dn2 dn3 -- dn4 )
twiq    create {2WITHIN?} dojump
 dc.l X2wiq-Z
wraps   create {WRAPS} dojump
 dc.l Xwraps-Z

coff    create {1OFF} dojump
 dc.l X1off-Z
doff    create {-OFF} dojump
 dc.l Xdoff-Z
off     create {OFF}  dojump
 dc.l Xoff-Z
twoff   create {2OFF} dojump
 dc.l X2off-Z
conx    create {1ON}  dojump
 dc.l X1on-Z
onx     create {ON}   dojump
 dc.l Xon-Z

overdash create {OVER-} Xoverd
o2d     create {2OVER-} Xo2d

sdup     create {SDUP} docall ( n1 n2 -- n2 n1 n1
 dc.l Csdup-Z
sdrop    create {SDROP} Xsdrop ( n1 n2 -- n2 )
twosdrop create {2SDROP} X2sdrop
sover    create {SOVER} dojump
 dc.l Xsover-Z ( n1 n2 -- n2 n1 n2 )
drops    create {DROP;} Xdrops
drop     create {DROP}  Xdrop
twodrop  create {2DROP} Xtwodp
fourdrop create {4DROP} Xfourdp
ndrop    create {NDROP} dojump
 dc.l Xndrop-Z

dashdup  create {-DUP} Xdashd
ddup     create {DDUP} Xddup
dup      create {DUP}  Xdup
twodup   create {2DUP} Xtwodup
fourdup  create {4DUP} X4dup
ndup     create {NDUP} dojump
 dc.l Xndup-Z

depth   create {DEPTH} dojump
 dc.l Xdepth-Z
pick    create {PICK}  dojump
 dc.l Xpick-Z
dpk     create {2PICK} docall
 dc.l Cdpick-Z
qpk     create {4PICK} docall
 dc.l Cqpick-Z
dashrot create {-ROT}  Xdashrot
roll    create {ROLL}  dojump
 dc.l Xroll-Z
drl     create {2ROLL} docall
 dc.l Cdroll-Z
qrl     create {4ROLL} docall
 dc.l Cqroll-Z

swapb   create {><} dojump
 dc.l Xswapb-Z
swapx   create {SWAP} dojump
 dc.l Xswapx-Z
nswap   create {NSWAP} dojump
 dc.l CXnswap-Z
twoswap create {2SWAP} dojump
 dc.l X2swap-Z
qswap   create {4SWAP} dojump
 dc.l Xqswap-Z

over    create {OVER} Xover
twoover create {2OVER} Xtwoover

rot     create {ROT} dojump
 dc.l Xrot-Z
tworot  create {2ROT} dojump
 dc.l Xtworot-Z

spfetch create  {SP@}  Xspfetch
spstore create  {SP!}  Xspsto
cspstore create {CSP!} Xcspsto restore sp from csp

rpstore create  {RP!}  dojump
 dc.l Xrpstore-Z
rpfetch create  {RP@}  Xrpfetch

mrgreat create  {R>M} dojump
 dc.l Xrgreatm-Z
mgreatr create  {M>R} dojump
 dc.l Xmgreatr-Z
rdrop   create  {RDROP} Xrdrop
nrgreat create  {NR>} dojump
 dc.l Xnrgreat-Z
ngreatr create  {N>R} dojump
 dc.l Xngreatr-Z

 dc.b 3!128,'r>','2'!128,0,0
drgreat dc.w Xdrg-Z
 dc.b 2!128,2!128,'r','>'!128,0,0
rgreat  dc.w Xrg-Z
pvi setnum $C0
orgreat create {R>} dojump pop sing
 dc.l Xdoopt-Z,Xrg-Z
 dc.w rgreat-Z,drgreat-Z

 dc.b 2!128,2!128,'>','r'!128,0,0
greatr  dc.w Xgreatr-Z
 dc.b 3!128,'>r','2'!128,0,0
dgreatr dc.w Xdgr-Z
pvi setnum $C0
ogreatr  create {>R} dojump push sing
 dc.l Xdoopt-Z,Xgreatr-Z
 dc.w greatr-Z,dgreatr-Z

greatrr create {>RR} Xgrr copy & push

 dc.b 1!128,'r'!128,0,0
rx  dc.w Xrx-Z
 dc.b 2!128,2!128,'r','r'!128,0,0
drx dc.w Xdrx-Z
pvi setnum $C0
rrx create {R} dojump
 dc.l Xdoopt-Z,Xrx-Z
 dc.w rx-Z,drx-Z

rplus create {R+} dojump
 dc.l Xrplus-Z ; r> dup 2+ >r @

twogreatr create {2>R}  X2gr    push double
twogtrr   create {2>RR} X2grr   copy & push
tworgreat create {2R>}  X2rg    pop
tworfetch create {2R}   Xtworf  read

pvi setnum $C0
ix   create  {I}   docolon
 dc.w rrx-Z,semis-Z

j    create  {J}   Xj
ni   create  {NI}  Xni
lixl create  {L<I} Xlixl  fetch latest d0.l value

     dc.w $C180      the <nul> word
     dc.w [rootlk]-Z lfa
x    dc.w dodefer-Z  cfa
vddonul dc.w donul-Z,donul-Z action & default
rootlk setstr x-4
lastlk  setstr [rootlk]

donul  dc.w dojump-Z
 dc.l Xdonul-Z

 LIST
task create  {TASK} docolon
     dc.w    semis-Z

fthtop  equ [fthlk]
hidntop equ [hidnlk]
qdostop equ [qdoslk]
fptop   equ [fplk]
editop  equ [edilk]
piftop  equ [piflk]
roottop equ [rootlk]
asmtop  equ [asmlk]

voctop  equ [lastvoc]
lastop  equ [lastlk] initial {last}
lktop   equ [ph]-2   initial {fence}
uptop   equ [.ud]
dptop   equ *-Z      initial {here}

dataspace equ $8000-dptop-56 $bc82 max size ./. channel table
        data  dataspace

 END 1st: .hpr'3.9.93 17.10.96
  eof 
